#include "ppemexmx04.header.cxx"
void ppemexmx04_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppemexmx04_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 4 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_emmumepmup";
    subprocess[2] = "uu~_emmumepmup";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 4 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_emmumepmup";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppemexmx04_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppemexmx04_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_emmumepmup";
  subprocess[2] = "uu~_emmumepmup";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppemexmx04_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppemexmx04_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_emmumepmup";
  subprocess[2] = "uu~_emmumepmup";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppemexmx04_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppemexmx04_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emmumepmupd";
  subprocess[2] = "gu_emmumepmupu";
  subprocess[3] = "gd~_emmumepmupd~";
  subprocess[4] = "gu~_emmumepmupu~";
  subprocess[5] = "dd~_emmumepmupg";
  subprocess[6] = "uu~_emmumepmupg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppemexmx04_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppemexmx04_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emmumepmupd";
  subprocess[2] = "gu_emmumepmupu";
  subprocess[3] = "gd~_emmumepmupd~";
  subprocess[4] = "gu~_emmumepmupu~";
  subprocess[5] = "dd~_emmumepmupg";
  subprocess[6] = "uu~_emmumepmupg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppemexmx04_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppemexmx04_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emmumepmupd";
  subprocess[2] = "gu_emmumepmupu";
  subprocess[3] = "gd~_emmumepmupd~";
  subprocess[4] = "gu~_emmumepmupu~";
  subprocess[5] = "dd~_emmumepmupg";
  subprocess[6] = "uu~_emmumepmupg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppemexmx04_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppemexmx04_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_emmumepmupdd~";
  subprocess[2] = "gg_emmumepmupuu~";
  subprocess[3] = "gd_emmumepmupgd";
  subprocess[4] = "gu_emmumepmupgu";
  subprocess[5] = "gd~_emmumepmupgd~";
  subprocess[6] = "gu~_emmumepmupgu~";
  subprocess[7] = "dd_emmumepmupdd";
  subprocess[8] = "du_emmumepmupdu";
  subprocess[9] = "ds_emmumepmupds";
  subprocess[10] = "dc_emmumepmupdc";
  subprocess[11] = "dd~_emmumepmupgg";
  subprocess[12] = "dd~_emmumepmupdd~";
  subprocess[13] = "dd~_emmumepmupuu~";
  subprocess[14] = "dd~_emmumepmupss~";
  subprocess[15] = "dd~_emmumepmupcc~";
  subprocess[16] = "du~_emmumepmupdu~";
  subprocess[17] = "ds~_emmumepmupds~";
  subprocess[18] = "dc~_emmumepmupdc~";
  subprocess[19] = "uu_emmumepmupuu";
  subprocess[20] = "uc_emmumepmupuc";
  subprocess[21] = "ud~_emmumepmupud~";
  subprocess[22] = "uu~_emmumepmupgg";
  subprocess[23] = "uu~_emmumepmupdd~";
  subprocess[24] = "uu~_emmumepmupuu~";
  subprocess[25] = "uu~_emmumepmupss~";
  subprocess[26] = "uu~_emmumepmupcc~";
  subprocess[27] = "us~_emmumepmupus~";
  subprocess[28] = "uc~_emmumepmupuc~";
  subprocess[29] = "d~d~_emmumepmupd~d~";
  subprocess[30] = "d~u~_emmumepmupd~u~";
  subprocess[31] = "d~s~_emmumepmupd~s~";
  subprocess[32] = "d~c~_emmumepmupd~c~";
  subprocess[33] = "u~u~_emmumepmupu~u~";
  subprocess[34] = "u~c~_emmumepmupu~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
