#include "ppexne02.header.cxx"
#include <header/ppll22.amplitude.doublevirtual.h>
int main(int argc, char *argv[]){
  cout << "BEGIN" << endl;

  munich munich(argc, argv, "pp-epve+X");

  if (munich.subprocess != ""){
    // generic functions - relevant for all subcontributions
    munich.generic.particles = & ppexne02_particles;
    munich.generic.cuts = & ppexne02_cuts;
    munich.generic.cuts_test = & ppexne02_cuts_test;
    munich.generic.calculate_dynamic_scale = & ppexne02_calculate_dynamic_scale;
    munich.generic.calculate_dynamic_scale_TSV = & ppexne02_calculate_dynamic_scale_TSV;
    munich.generic.moments = & ppexne02_moments;
    if (munich.csi.type_contribution == "born" || 
        munich.csi.type_contribution == "VA" || 
        munich.csi.type_contribution == "CA" || 
        munich.csi.type_contribution == "VT" || 
        munich.csi.type_contribution == "CT" || 
        munich.csi.type_contribution == "VT2" || 
        munich.csi.type_contribution == "CT2" || 
        munich.csi.type_contribution == "NLL_LO" || 
        munich.csi.type_contribution == "NLL_NLO" || 
        munich.csi.type_contribution == "NNLL_LO" || 
        munich.csi.type_contribution == "NNLL_NLO" || 
        munich.csi.type_contribution == "NNLL_NNLO"){
      // generic functions - relevant for all subcontributions located on born phase-space in order to determine subprocess information
      munich.generic.determination_subprocess_psp = & ppexne02_determination_subprocess_born;
      munich.generic.combination_subprocess_psp = & ppexne02_combination_subprocess_born;
      // generic functions - relevant for all subcontributions located on born phase-space in order to perform phase-space generation
      munich.generic.optimize_minv_psp = & ppexne02_optimize_minv_born;
      munich.generic.determination_MCchannels_psp = & ppexne02_determination_MCchannels_born;
      munich.generic.ax_psp_psp = & ppexne02_ax_psp_born;
      munich.generic.ac_tau_psp_psp = & ppexne02_ac_tau_psp_born;
      munich.generic.ac_psp_psp = & ppexne02_ac_psp_born;
      munich.generic.ag_psp_psp = & ppexne02_ag_psp_born;
      if (munich.csi.type_contribution == "CA"){munich.generic.phasespacepoint_psp = & ppexne02_phasespacepoint_collinear;}
      else {munich.generic.phasespacepoint_psp = & ppexne02_phasespacepoint_born;}
      if (munich.csi.type_contribution == "VT2" || 
          munich.csi.type_contribution == "NNLL_NNLO"){
        munich.generic.calculate_H2 = & ppll22_calculate_H2;
      }
    }

    else if (munich.csi.type_contribution == "RA" || 
             munich.csi.type_contribution == "RT" || 
             munich.csi.type_contribution == "RVA" || 
             munich.csi.type_contribution == "RCA"){
      // generic functions - relevant for all subcontributions located on real phase-space in order to determine subprocess information
      munich.generic.determination_subprocess_psp = & ppexne02_determination_subprocess_real;
      munich.generic.combination_subprocess_psp = & ppexne02_combination_subprocess_real;
      // generic functions - relevant for all subcontributions located on real phase-space in order to perform phase-space generation
      munich.generic.determination_MCchannels_psp = & ppexne02_determination_MCchannels_real;
      munich.generic.optimize_minv_psp = & ppexne02_optimize_minv_real;
      munich.generic.ac_tau_psp_psp = & ppexne02_ac_tau_psp_real;
      munich.generic.ax_psp_psp = & ppexne02_ax_psp_real;
      munich.generic.ac_psp_psp = & ppexne02_ac_psp_real;
      munich.generic.ag_psp_psp = & ppexne02_ag_psp_real;
      munich.generic.calculate_dynamic_scale_RA = & ppexne02_calculate_dynamic_scale_RA;
      munich.generic.determination_no_subprocess_dipole = & ppexne02_determination_no_subprocess_born;
      munich.generic.determination_subprocess_dipole = & ppexne02_determination_subprocess_born;
      munich.generic.determination_MCchannels_dipole = & ppexne02_determination_MCchannels_born;
      munich.generic.ac_tau_psp_dipole = & ppexne02_ac_tau_psp_born;
      munich.generic.ax_psp_dipole = & ppexne02_ax_psp_born;
      munich.generic.ac_psp_dipole = & ppexne02_ac_psp_born;
      munich.generic.ag_psp_dipole = & ppexne02_ag_psp_born;
      if (munich.csi.type_contribution == "RCA"){munich.generic.phasespacepoint_psp = & ppexne02_phasespacepoint_realcollinear;}
      else {munich.generic.phasespacepoint_psp = & ppexne02_phasespacepoint_real;}
    }

    else if (munich.csi.type_contribution == "RRA"){
      // generic functions - relevant for all subcontributions located on doublereal phase-space in order to determine subprocess information
      munich.generic.determination_subprocess_psp = & ppexne02_determination_subprocess_doublereal;
      munich.generic.combination_subprocess_psp = & ppexne02_combination_subprocess_doublereal;
      // generic functions - relevant for all subcontributions located on doublereal phase-space in order to perform phase-space generation
      munich.generic.determination_MCchannels_psp = & ppexne02_determination_MCchannels_doublereal;
      munich.generic.ax_psp_psp = & ppexne02_ax_psp_doublereal;
      munich.generic.ac_tau_psp_psp = & ppexne02_ac_tau_psp_doublereal;
      munich.generic.ac_psp_psp = & ppexne02_ac_psp_doublereal;
      munich.generic.ag_psp_psp = & ppexne02_ag_psp_doublereal;
      munich.generic.optimize_minv_psp = & ppexne02_optimize_minv_doublereal;
      munich.generic.calculate_dynamic_scale_RA = & ppexne02_calculate_dynamic_scale_RA;
      munich.generic.determination_no_subprocess_dipole = & ppexne02_determination_no_subprocess_real;
      munich.generic.determination_subprocess_dipole = & ppexne02_determination_subprocess_real;
      munich.generic.determination_MCchannels_dipole = & ppexne02_determination_MCchannels_real;
      munich.generic.ac_tau_psp_dipole = & ppexne02_ac_tau_psp_real;
      munich.generic.ax_psp_dipole = & ppexne02_ax_psp_real;
      munich.generic.ac_psp_dipole = & ppexne02_ac_psp_real;
      munich.generic.ag_psp_dipole = & ppexne02_ag_psp_real;
      munich.generic.phasespacepoint_psp = & ppexne02_phasespacepoint_doublereal;

      munich.generic.determination_no_subprocess_doubledipole = & ppexne02_determination_no_subprocess_born;
      munich.generic.determination_subprocess_doubledipole = & ppexne02_determination_subprocess_born;
      munich.generic.determination_MCchannels_doubledipole = & ppexne02_determination_MCchannels_born;
      munich.generic.ac_tau_psp_doubledipole = & ppexne02_ac_tau_psp_born;
      munich.generic.ax_psp_doubledipole = & ppexne02_ax_psp_born;
      munich.generic.ac_psp_doubledipole = & ppexne02_ac_psp_born;
      munich.generic.ag_psp_doubledipole = & ppexne02_ag_psp_born;
    }

    munich.run_initialization();
    munich.run_integration();

    cout << "END " << munich.csi.type_contribution << " " << munich.csi.type_correction << endl;
    return 0;
  }
  else {
    munich.generic.list_subprocess_born = & ppexne02_list_subprocess_born;
    munich.generic.list_subprocess_V_QCD = & ppexne02_list_subprocess_V_QCD;
    munich.generic.list_subprocess_C_QCD = & ppexne02_list_subprocess_C_QCD;
    munich.generic.list_subprocess_R_QCD = & ppexne02_list_subprocess_R_QCD;
    munich.generic.list_subprocess_V_QCD = & ppexne02_list_subprocess_V_QCD;
    munich.generic.list_subprocess_C_QCD = & ppexne02_list_subprocess_C_QCD;
    munich.generic.list_subprocess_RV_QCD = & ppexne02_list_subprocess_RV_QCD;
    munich.generic.list_subprocess_RC_QCD = & ppexne02_list_subprocess_RC_QCD;
    munich.generic.list_subprocess_RR_QCD = & ppexne02_list_subprocess_RR_QCD;

    munich.get_summary();

    cout << "END RESULT/DISTRIBUTION" << endl;
    return 0;
  }
}
