#include "ppz01.header.cxx"
void ppz01_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppz01_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 1 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_z";
    subprocess[2] = "uu~_z";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 1 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_z";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppz01_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppz01_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_z";
  subprocess[2] = "uu~_z";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppz01_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppz01_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_z";
  subprocess[2] = "uu~_z";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppz01_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppz01_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_zd";
  subprocess[2] = "gu_zu";
  subprocess[3] = "gd~_zd~";
  subprocess[4] = "gu~_zu~";
  subprocess[5] = "dd~_zg";
  subprocess[6] = "uu~_zg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppz01_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppz01_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_zd";
  subprocess[2] = "gu_zu";
  subprocess[3] = "gd~_zd~";
  subprocess[4] = "gu~_zu~";
  subprocess[5] = "dd~_zg";
  subprocess[6] = "uu~_zg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppz01_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppz01_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_zd";
  subprocess[2] = "gu_zu";
  subprocess[3] = "gd~_zd~";
  subprocess[4] = "gu~_zu~";
  subprocess[5] = "dd~_zg";
  subprocess[6] = "uu~_zg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppz01_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppz01_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_zdd~";
  subprocess[2] = "gg_zuu~";
  subprocess[3] = "gd_zgd";
  subprocess[4] = "gu_zgu";
  subprocess[5] = "gd~_zgd~";
  subprocess[6] = "gu~_zgu~";
  subprocess[7] = "dd_zdd";
  subprocess[8] = "du_zdu";
  subprocess[9] = "ds_zds";
  subprocess[10] = "dc_zdc";
  subprocess[11] = "dd~_zgg";
  subprocess[12] = "dd~_zdd~";
  subprocess[13] = "dd~_zuu~";
  subprocess[14] = "dd~_zss~";
  subprocess[15] = "dd~_zcc~";
  subprocess[16] = "du~_zdu~";
  subprocess[17] = "ds~_zds~";
  subprocess[18] = "dc~_zdc~";
  subprocess[19] = "uu_zuu";
  subprocess[20] = "uc_zuc";
  subprocess[21] = "ud~_zud~";
  subprocess[22] = "uu~_zgg";
  subprocess[23] = "uu~_zdd~";
  subprocess[24] = "uu~_zuu~";
  subprocess[25] = "uu~_zss~";
  subprocess[26] = "uu~_zcc~";
  subprocess[27] = "us~_zus~";
  subprocess[28] = "uc~_zuc~";
  subprocess[29] = "d~d~_zd~d~";
  subprocess[30] = "d~u~_zd~u~";
  subprocess[31] = "d~s~_zd~s~";
  subprocess[32] = "d~c~_zd~c~";
  subprocess[33] = "u~u~_zu~u~";
  subprocess[34] = "u~c~_zu~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
