#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeeexex04/header/ppeeexex04.phasespace.h"
void ppeeexex04_ax_psp_140_uux_ememepepg(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexex04_ax_psp_140_uux_ememepepg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(22);
  psi_needed_v_smin[no_ps].resize(22);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   64,   65,   66,   67,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 40);
  int needed_v_smin_1[] = {   0,    1,    2,    3,   32,   33,   34,   35}; //   8
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {   0,    1,    2,    3,    8,    9,   10,   11,   32,   33,   34,   35,   40,   41,   42,   43}; //  16
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 16);
  int needed_v_smin_3[] = {   4,    5,    6,    7,   36,   37,   38,   39}; //   8
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 8);
  int needed_v_smin_4[] = {   4,    5,    6,    7,   20,   21,   22,   23,   36,   37,   38,   39,   52,   53,   54,   55}; //  16
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 16);
  int needed_v_smin_5[] = {   8,    9,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   46,   47,   68,   69,   70,   71,   72,   73,   74,   75,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 40);
  int needed_v_smin_6[] = {   8,    9,   10,   11,   40,   41,   42,   43}; //   8
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 8);
  int needed_v_smin_7[] = {  12,   13,   14,   15,   44,   45,   46,   47}; //   8
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 8);
  int needed_v_smin_8[] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   60,   61,   62,   63}; //  16
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 16);
  int needed_v_smin_9[] = {  16,   17,   18,   19,   20,   21,   22,   23,   48,   49,   50,   51,   52,   53,   54,   55,   68,   69,   70,   71,   72,   73,   74,   75,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 40);
  int needed_v_smin_10[] = {  16,   17,   18,   19,   48,   49,   50,   51}; //   8
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 8);
  int needed_v_smin_11[] = {  16,   17,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 16);
  int needed_v_smin_12[] = {  20,   21,   22,   23,   52,   53,   54,   55}; //   8
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);
  int needed_v_smin_13[] = {  24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 40);
  int needed_v_smin_14[] = {  24,   25,   26,   27,   56,   57,   58,   59}; //   8
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 8);
  int needed_v_smin_15[] = {  28,   29,   30,   31,   60,   61,   62,   63}; //   8
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 8);
  int needed_v_smin_16[] = {  64,   65,   66,   67,   76,   77,   78,   79,   96,   97,   98,   99,  108,  109,  110,  111}; //  16
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 16);
  int needed_v_smin_17[] = {  68,   69,   70,   71,   72,   73,   74,   75,  100,  101,  102,  103,  104,  105,  106,  107}; //  16
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 16);
  int needed_v_smin_18[] = {  80,   81,   82,   83}; //   4
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 4);
  int needed_v_smin_19[] = {  84,   85,   86,   87}; //   4
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 4);
  int needed_v_smin_20[] = {  88,   89,   90,   91}; //   4
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 4);
  int needed_v_smin_21[] = {  92,   93,   94,   95}; //   4
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 4);

  psi_v_smax[no_ps].resize(17);
  psi_needed_v_smax[no_ps].resize(17);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   64,   65,   66,   67,   80,   81,   82,   83,   96,   97,   98,   99}; //  28
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 28);
  int needed_v_smax_1[] = {   0,    1,    2,    3,    8,    9,   10,   11,   32,   33,   34,   35,   40,   41,   42,   43}; //  16
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 16);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  96
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 96);
  int needed_v_smax_3[] = {   4,    5,    6,    7,   20,   21,   22,   23,   36,   37,   38,   39,   52,   53,   54,   55}; //  16
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 16);
  int needed_v_smax_4[] = {   8,    9,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   46,   47,   68,   69,   70,   71,   84,   85,   86,   87,  100,  101,  102,  103}; //  28
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 28);
  int needed_v_smax_5[] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   60,   61,   62,   63}; //  16
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 16);
  int needed_v_smax_6[] = {  16,   17,   18,   19,   20,   21,   22,   23,   48,   49,   50,   51,   52,   53,   54,   55,   72,   73,   74,   75,   88,   89,   90,   91,  104,  105,  106,  107}; //  28
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 28);
  int needed_v_smax_7[] = {  16,   17,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 16);
  int needed_v_smax_8[] = {  24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63,   76,   77,   78,   79,   92,   93,   94,   95,  108,  109,  110,  111}; //  28
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 28);
  int needed_v_smax_9[] = {  64,   65,   66,   67,   80,   81,   82,   83,   96,   97,   98,   99}; //  12
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 12);
  int needed_v_smax_10[] = {  68,   69,   70,   71,   84,   85,   86,   87,  100,  101,  102,  103}; //  12
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 12);
  int needed_v_smax_11[] = {  72,   73,   74,   75,   88,   89,   90,   91,  104,  105,  106,  107}; //  12
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 12);
  int needed_v_smax_12[] = {  76,   77,   78,   79,   92,   93,   94,   95,  108,  109,  110,  111}; //  12
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 12);
  int needed_v_smax_13[] = {  80,   81,   82,   83}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  84,   85,   86,   87}; //   4
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);
  int needed_v_smax_15[] = {  88,   89,   90,   91}; //   4
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);
  int needed_v_smax_16[] = {  92,   93,   94,   95}; //   4
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(32);
  psi_needed_g_p[no_ps].resize(32);
  int needed_g_p_0[] = {   0,    1,    4,    5,   32,   33,   36,   37,   64,   65,   80,   81,   96,   97}; //  14
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 14);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    2,    3,   32,   33,   34,   35}; //   8
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 8);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    2,    8,   10,   32,   34,   40,   42}; //   8
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 8);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   1,    3,    9,   11,   33,   35,   41,   43}; //   8
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 8);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_4[] = {   2,    3,    6,    7,   34,   35,   38,   39,   66,   67,   82,   83,   98,   99}; //  14
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 14);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_5[] = {   4,    5,    6,    7,   36,   37,   38,   39}; //   8
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 8);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_6[] = {   4,    6,   20,   22,   36,   38,   52,   54}; //   8
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 8);
  psi_container_IS_name.push_back("propagator_0_smin4_smax2");
  int needed_g_p_7[] = {   5,    7,   21,   23,   37,   39,   53,   55}; //   8
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 8);
  psi_container_IS_name.push_back("propagator_23_smin4_smax2");
  int needed_g_p_8[] = {   8,    9,   12,   13,   40,   41,   44,   45,   68,   69,   84,   85,  100,  101}; //  14
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 14);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_9[] = {   8,    9,   10,   11,   40,   41,   42,   43}; //   8
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 8);
  psi_container_IS_name.push_back("propagator_0_smin6_smax1");
  int needed_g_p_10[] = {  10,   11,   14,   15,   42,   43,   46,   47,   70,   71,   86,   87,  102,  103}; //  14
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 14);
  psi_container_IS_name.push_back("propagator_23_smin5_smax4");
  int needed_g_p_11[] = {  12,   13,   14,   15,   44,   45,   46,   47}; //   8
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 8);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_12[] = {  12,   14,   28,   30,   44,   46,   60,   62}; //   8
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 8);
  psi_container_IS_name.push_back("propagator_0_smin8_smax2");
  int needed_g_p_13[] = {  13,   15,   29,   31,   45,   47,   61,   63}; //   8
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 8);
  psi_container_IS_name.push_back("propagator_23_smin8_smax2");
  int needed_g_p_14[] = {  16,   17,   20,   21,   48,   49,   52,   53,   72,   73,   88,   89,  104,  105}; //  14
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 14);
  psi_container_IS_name.push_back("propagator_0_smin9_smax6");
  int needed_g_p_15[] = {  16,   17,   18,   19,   48,   49,   50,   51}; //   8
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 8);
  psi_container_IS_name.push_back("propagator_0_smin10_smax7");
  int needed_g_p_16[] = {  16,   18,   24,   26,   48,   50,   56,   58}; //   8
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 8);
  psi_container_IS_name.push_back("propagator_0_smin11_smax2");
  int needed_g_p_17[] = {  17,   19,   25,   27,   49,   51,   57,   59}; //   8
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 8);
  psi_container_IS_name.push_back("propagator_23_smin11_smax2");
  int needed_g_p_18[] = {  18,   19,   22,   23,   50,   51,   54,   55,   74,   75,   90,   91,  106,  107}; //  14
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 14);
  psi_container_IS_name.push_back("propagator_23_smin9_smax6");
  int needed_g_p_19[] = {  20,   21,   22,   23,   52,   53,   54,   55}; //   8
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 8);
  psi_container_IS_name.push_back("propagator_0_smin12_smax3");
  int needed_g_p_20[] = {  24,   25,   28,   29,   56,   57,   60,   61,   76,   77,   92,   93,  108,  109}; //  14
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 14);
  psi_container_IS_name.push_back("propagator_0_smin13_smax8");
  int needed_g_p_21[] = {  24,   25,   26,   27,   56,   57,   58,   59}; //   8
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 8);
  psi_container_IS_name.push_back("propagator_0_smin14_smax7");
  int needed_g_p_22[] = {  26,   27,   30,   31,   58,   59,   62,   63,   78,   79,   94,   95,  110,  111}; //  14
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 14);
  psi_container_IS_name.push_back("propagator_23_smin13_smax8");
  int needed_g_p_23[] = {  28,   29,   30,   31,   60,   61,   62,   63}; //   8
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 8);
  psi_container_IS_name.push_back("propagator_0_smin15_smax5");
  int needed_g_p_24[] = {  64,   66,   80,   82,   96,   98}; //   6
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 6);
  psi_container_IS_name.push_back("propagator_0_smin13_smax9");
  int needed_g_p_25[] = {  65,   67,   81,   83,   97,   99}; //   6
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 6);
  psi_container_IS_name.push_back("propagator_23_smin13_smax9");
  int needed_g_p_26[] = {  68,   70,   84,   86,  100,  102}; //   6
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 6);
  psi_container_IS_name.push_back("propagator_0_smin9_smax10");
  int needed_g_p_27[] = {  69,   71,   85,   87,  101,  103}; //   6
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 6);
  psi_container_IS_name.push_back("propagator_23_smin9_smax10");
  int needed_g_p_28[] = {  72,   74,   88,   90,  104,  106}; //   6
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 6);
  psi_container_IS_name.push_back("propagator_0_smin5_smax11");
  int needed_g_p_29[] = {  73,   75,   89,   91,  105,  107}; //   6
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 6);
  psi_container_IS_name.push_back("propagator_23_smin5_smax11");
  int needed_g_p_30[] = {  76,   78,   92,   94,  108,  110}; //   6
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 6);
  psi_container_IS_name.push_back("propagator_0_smin0_smax12");
  int needed_g_p_31[] = {  77,   79,   93,   95,  109,  111}; //   6
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 6);
  psi_container_IS_name.push_back("propagator_23_smin0_smax12");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(6);
  psi_needed_g_f[no_ps].resize(6);
  int needed_g_f_0[] = {  64,   65,   66,   67,   76,   77,   78,   79,   96,   97,   98,   99,  108,  109,  110,  111}; //  16
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 16);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax2");
  int needed_g_f_1[] = {  68,   69,   70,   71,   72,   73,   74,   75,  100,  101,  102,  103,  104,  105,  106,  107}; //  16
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 16);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax2");
  int needed_g_f_2[] = {  80,   81,   82,   83}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax13");
  int needed_g_f_3[] = {  84,   85,   86,   87}; //   4
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax14");
  int needed_g_f_4[] = {  88,   89,   90,   91}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax15");
  int needed_g_f_5[] = {  92,   93,   94,   95}; //   4
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin21_smax16");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(18);
  psi_needed_g_t[no_ps].resize(18);
  int needed_g_t_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79}; //  48
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 48);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_1[] = {  32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  48
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 48);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_2[] = {  64,   65,   66,   67}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__36_24");
  int needed_g_t_3[] = {  68,   69,   70,   71}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__20_40");
  int needed_g_t_4[] = {  72,   73,   74,   75}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__40_20");
  int needed_g_t_5[] = {  76,   77,   78,   79}; //   4
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__24_36");
  int needed_g_t_6[] = {  80,   81,   82,   83}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__36_88");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__36_88");
  int needed_g_t_7[] = {  80,   81,   82,   83}; //   4
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_37__24_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_37__24_64");
  int needed_g_t_8[] = {  84,   85,   86,   87}; //   4
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__20_104");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__20_104");
  int needed_g_t_9[] = {  84,   85,   86,   87}; //   4
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__40_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__40_64");
  int needed_g_t_10[] = {  88,   89,   90,   91}; //   4
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__40_84");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__40_84");
  int needed_g_t_11[] = {  88,   89,   90,   91}; //   4
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__20_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__20_64");
  int needed_g_t_12[] = {  92,   93,   94,   95}; //   4
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__24_100");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__24_100");
  int needed_g_t_13[] = {  92,   93,   94,   95}; //   4
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_25__36_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_25__36_64");
  int needed_g_t_14[] = {  96,   97,   98,   99}; //   4
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__24_36");
  int needed_g_t_15[] = { 100,  101,  102,  103}; //   4
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__40_20");
  int needed_g_t_16[] = { 104,  105,  106,  107}; //   4
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__20_40");
  int needed_g_t_17[] = { 108,  109,  110,  111}; //   4
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__36_24");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(16);
  psi_needed_g_d[no_ps].resize(16);
  int needed_g_d_0[] = {   0,    1,    2,    3,    8,    9,   10,   11,   32,   33,   34,   35,   40,   41,   42,   43}; //  16
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,    1,    2,    3,   32,   33,   34,   35}; //   8
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 8);
  psi_container_IS_name.push_back("costheta_of_decay_56__32_24");
  psi_container_IS_name.push_back("phi_of_decay_56__32_24");
  int needed_g_d_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   64,   65,   66,   67,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 40);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {   4,    5,    6,    7,   20,   21,   22,   23,   36,   37,   38,   39,   52,   53,   54,   55}; //  16
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_4[] = {   4,    5,    6,    7,   36,   37,   38,   39}; //   8
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_5[] = {   8,    9,   10,   11,   40,   41,   42,   43}; //   8
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 8);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_6[] = {   8,    9,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   46,   47,   68,   69,   70,   71,   72,   73,   74,   75,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 40);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_7[] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   60,   61,   62,   63}; //  16
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_8[] = {  12,   13,   14,   15,   44,   45,   46,   47}; //   8
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_9[] = {  16,   17,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_10[] = {  16,   17,   18,   19,   48,   49,   50,   51}; //   8
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 8);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_11[] = {  16,   17,   18,   19,   20,   21,   22,   23,   48,   49,   50,   51,   52,   53,   54,   55,   68,   69,   70,   71,   72,   73,   74,   75,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 40);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_12[] = {  20,   21,   22,   23,   52,   53,   54,   55}; //   8
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_13[] = {  24,   25,   26,   27,   56,   57,   58,   59}; //   8
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 8);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_14[] = {  24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 40);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_15[] = {  28,   29,   30,   31,   60,   61,   62,   63}; //   8
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");

  psi_c_p[no_ps].resize(112);
  psi_c_f[no_ps].resize(112);
  psi_c_t[no_ps].resize(112);
  psi_c_d[no_ps].resize(112);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {  0}; //   1
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 1);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {  0}; //   1
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 1);
  int c_d_1[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  4,   1,   2}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {  0}; //   1
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 1);
  int c_d_2[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  4,   1,   3}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {  0}; //   1
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 1);
  int c_d_3[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  0,   5,   6}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  0}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  0,   5,   7}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  0}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  0}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  4,   5,   7}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  0}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  8,   9,   2}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  0}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  8,   9,   3}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  0}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = { 10,   9,   2}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  0}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = { 10,   9,   3}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  8,  11,  12}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  8,  11,  13}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = { 10,  11,  12}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  0}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = { 10,  11,  13}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  0}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  0}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = { 14,  15,  17}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  0}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = { 18,  15,  16}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  0}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = { 18,  15,  17}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  0}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = { 14,  19,   6}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  0}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = { 14,  19,   7}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  0}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = { 18,  19,   6}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  0}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = { 18,  19,   7}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  0}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = { 20,  21,  16}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  0}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = { 20,  21,  17}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  0}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = { 22,  21,  16}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  0}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = { 22,  21,  17}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  0}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = { 20,  23,  12}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  0}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 3);

  int c_p_29[] = { 20,  23,  13}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  0}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 3);

  int c_p_30[] = { 22,  23,  12}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  0}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = { 22,  23,  13}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  0}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  int c_p_32[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {  1}; //   1
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 1);
  int c_d_32[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 3);

  int c_p_33[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {  1}; //   1
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 1);
  int c_d_33[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 3);

  int c_p_34[] = {  4,   1,   2}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {  1}; //   1
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 1);
  int c_d_34[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 3);

  int c_p_35[] = {  4,   1,   3}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {  1}; //   1
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 1);
  int c_d_35[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 3);

  int c_p_36[] = {  0,   5,   6}; //   3
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 3);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {  1}; //   1
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 1);
  int c_d_36[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 3);

  int c_p_37[] = {  0,   5,   7}; //   3
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 3);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {  1}; //   1
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 1);
  int c_d_37[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 3);

  int c_p_38[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 3);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {  1}; //   1
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 1);
  int c_d_38[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 3);

  int c_p_39[] = {  4,   5,   7}; //   3
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 3);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {  1}; //   1
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 1);
  int c_d_39[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 3);

  int c_p_40[] = {  8,   9,   2}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {}; //   0
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 0);
  int c_t_40[] = {  1}; //   1
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 1);
  int c_d_40[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 3);

  int c_p_41[] = {  8,   9,   3}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {}; //   0
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 0);
  int c_t_41[] = {  1}; //   1
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 1);
  int c_d_41[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 3);

  int c_p_42[] = { 10,   9,   2}; //   3
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 3);
  int c_f_42[] = {}; //   0
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 0);
  int c_t_42[] = {  1}; //   1
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 1);
  int c_d_42[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 3);

  int c_p_43[] = { 10,   9,   3}; //   3
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 3);
  int c_f_43[] = {}; //   0
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 0);
  int c_t_43[] = {  1}; //   1
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 1);
  int c_d_43[] = {  0,   5,   6}; //   3
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 3);

  int c_p_44[] = {  8,  11,  12}; //   3
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 3);
  int c_f_44[] = {}; //   0
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 0);
  int c_t_44[] = {  1}; //   1
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 1);
  int c_d_44[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 3);

  int c_p_45[] = {  8,  11,  13}; //   3
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 3);
  int c_f_45[] = {}; //   0
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 0);
  int c_t_45[] = {  1}; //   1
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 1);
  int c_d_45[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 3);

  int c_p_46[] = { 10,  11,  12}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {}; //   0
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 0);
  int c_t_46[] = {  1}; //   1
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 1);
  int c_d_46[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = { 10,  11,  13}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {}; //   0
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 0);
  int c_t_47[] = {  1}; //   1
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 1);
  int c_d_47[] = {  7,   8,   6}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 3);
  int c_f_48[] = {}; //   0
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 0);
  int c_t_48[] = {  1}; //   1
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 1);
  int c_d_48[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = { 14,  15,  17}; //   3
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 3);
  int c_f_49[] = {}; //   0
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 0);
  int c_t_49[] = {  1}; //   1
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 1);
  int c_d_49[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = { 18,  15,  16}; //   3
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 3);
  int c_f_50[] = {}; //   0
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 0);
  int c_t_50[] = {  1}; //   1
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 1);
  int c_d_50[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 3);

  int c_p_51[] = { 18,  15,  17}; //   3
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 3);
  int c_f_51[] = {}; //   0
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 0);
  int c_t_51[] = {  1}; //   1
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 1);
  int c_d_51[] = {  9,  10,  11}; //   3
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 3);

  int c_p_52[] = { 14,  19,   6}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = {  1}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = { 14,  19,   7}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = {  1}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = { 18,  19,   6}; //   3
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 3);
  int c_f_54[] = {}; //   0
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 0);
  int c_t_54[] = {  1}; //   1
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 1);
  int c_d_54[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 3);

  int c_p_55[] = { 18,  19,   7}; //   3
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 3);
  int c_f_55[] = {}; //   0
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 0);
  int c_t_55[] = {  1}; //   1
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 1);
  int c_d_55[] = {  3,  12,  11}; //   3
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 3);

  int c_p_56[] = { 20,  21,  16}; //   3
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 3);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = {  1}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 3);

  int c_p_57[] = { 20,  21,  17}; //   3
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 3);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = {  1}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 3);

  int c_p_58[] = { 22,  21,  16}; //   3
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 3);
  int c_f_58[] = {}; //   0
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 0);
  int c_t_58[] = {  1}; //   1
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 1);
  int c_d_58[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 3);

  int c_p_59[] = { 22,  21,  17}; //   3
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 3);
  int c_f_59[] = {}; //   0
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 0);
  int c_t_59[] = {  1}; //   1
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 1);
  int c_d_59[] = {  9,  13,  14}; //   3
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 3);

  int c_p_60[] = { 20,  23,  12}; //   3
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 3);
  int c_f_60[] = {}; //   0
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 0);
  int c_t_60[] = {  1}; //   1
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 1);
  int c_d_60[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 3);

  int c_p_61[] = { 20,  23,  13}; //   3
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 3);
  int c_f_61[] = {}; //   0
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 0);
  int c_t_61[] = {  1}; //   1
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 1);
  int c_d_61[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 3);

  int c_p_62[] = { 22,  23,  12}; //   3
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 3);
  int c_f_62[] = {}; //   0
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 0);
  int c_t_62[] = {  1}; //   1
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 1);
  int c_d_62[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 3);

  int c_p_63[] = { 22,  23,  13}; //   3
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 3);
  int c_f_63[] = {}; //   0
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 0);
  int c_t_63[] = {  1}; //   1
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 1);
  int c_d_63[] = {  7,  15,  14}; //   3
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 3);

  int c_p_64[] = {  0,  24}; //   2
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 2);
  int c_f_64[] = {  0}; //   1
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 1);
  int c_t_64[] = {  0,   2}; //   2
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 2);
  int c_d_64[] = { 14,   2}; //   2
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 2);

  int c_p_65[] = {  0,  25}; //   2
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 2);
  int c_f_65[] = {  0}; //   1
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 1);
  int c_t_65[] = {  0,   2}; //   2
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 2);
  int c_d_65[] = { 14,   2}; //   2
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 2);

  int c_p_66[] = {  4,  24}; //   2
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 2);
  int c_f_66[] = {  0}; //   1
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 1);
  int c_t_66[] = {  0,   2}; //   2
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 2);
  int c_d_66[] = { 14,   2}; //   2
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 2);

  int c_p_67[] = {  4,  25}; //   2
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 2);
  int c_f_67[] = {  0}; //   1
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 1);
  int c_t_67[] = {  0,   2}; //   2
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 2);
  int c_d_67[] = { 14,   2}; //   2
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 2);

  int c_p_68[] = {  8,  26}; //   2
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 2);
  int c_f_68[] = {  1}; //   1
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 1);
  int c_t_68[] = {  0,   3}; //   2
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 2);
  int c_d_68[] = { 11,   6}; //   2
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 2);

  int c_p_69[] = {  8,  27}; //   2
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 2);
  int c_f_69[] = {  1}; //   1
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 1);
  int c_t_69[] = {  0,   3}; //   2
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 2);
  int c_d_69[] = { 11,   6}; //   2
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 2);

  int c_p_70[] = { 10,  26}; //   2
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 2);
  int c_f_70[] = {  1}; //   1
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 1);
  int c_t_70[] = {  0,   3}; //   2
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 2);
  int c_d_70[] = { 11,   6}; //   2
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 2);

  int c_p_71[] = { 10,  27}; //   2
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 2);
  int c_f_71[] = {  1}; //   1
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 1);
  int c_t_71[] = {  0,   3}; //   2
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 2);
  int c_d_71[] = { 11,   6}; //   2
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 2);

  int c_p_72[] = { 14,  28}; //   2
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 2);
  int c_f_72[] = {  1}; //   1
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 1);
  int c_t_72[] = {  0,   4}; //   2
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 2);
  int c_d_72[] = {  6,  11}; //   2
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 2);

  int c_p_73[] = { 14,  29}; //   2
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 2);
  int c_f_73[] = {  1}; //   1
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 1);
  int c_t_73[] = {  0,   4}; //   2
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 2);
  int c_d_73[] = {  6,  11}; //   2
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 2);

  int c_p_74[] = { 18,  28}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = {  1}; //   1
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 1);
  int c_t_74[] = {  0,   4}; //   2
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 2);
  int c_d_74[] = {  6,  11}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = { 18,  29}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = {  1}; //   1
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 1);
  int c_t_75[] = {  0,   4}; //   2
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 2);
  int c_d_75[] = {  6,  11}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = { 20,  30}; //   2
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 2);
  int c_f_76[] = {  0}; //   1
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 1);
  int c_t_76[] = {  0,   5}; //   2
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 2);
  int c_d_76[] = {  2,  14}; //   2
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 2);

  int c_p_77[] = { 20,  31}; //   2
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 2);
  int c_f_77[] = {  0}; //   1
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 1);
  int c_t_77[] = {  0,   5}; //   2
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 2);
  int c_d_77[] = {  2,  14}; //   2
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 2);

  int c_p_78[] = { 22,  30}; //   2
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 2);
  int c_f_78[] = {  0}; //   1
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 1);
  int c_t_78[] = {  0,   5}; //   2
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 2);
  int c_d_78[] = {  2,  14}; //   2
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 2);

  int c_p_79[] = { 22,  31}; //   2
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 2);
  int c_f_79[] = {  0}; //   1
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 1);
  int c_t_79[] = {  0,   5}; //   2
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 2);
  int c_d_79[] = {  2,  14}; //   2
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 2);

  int c_p_80[] = {  0,  24}; //   2
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 2);
  int c_f_80[] = {  2}; //   1
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 1);
  int c_t_80[] = {  6,   7}; //   2
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 2);
  int c_d_80[] = { 14,   2}; //   2
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 2);

  int c_p_81[] = {  0,  25}; //   2
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 2);
  int c_f_81[] = {  2}; //   1
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 1);
  int c_t_81[] = {  6,   7}; //   2
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 2);
  int c_d_81[] = { 14,   2}; //   2
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 2);

  int c_p_82[] = {  4,  24}; //   2
  psi_c_p[no_ps][82] = get_vector_from_array_int(c_p_82, 2);
  int c_f_82[] = {  2}; //   1
  psi_c_f[no_ps][82] = get_vector_from_array_int(c_f_82, 1);
  int c_t_82[] = {  6,   7}; //   2
  psi_c_t[no_ps][82] = get_vector_from_array_int(c_t_82, 2);
  int c_d_82[] = { 14,   2}; //   2
  psi_c_d[no_ps][82] = get_vector_from_array_int(c_d_82, 2);

  int c_p_83[] = {  4,  25}; //   2
  psi_c_p[no_ps][83] = get_vector_from_array_int(c_p_83, 2);
  int c_f_83[] = {  2}; //   1
  psi_c_f[no_ps][83] = get_vector_from_array_int(c_f_83, 1);
  int c_t_83[] = {  6,   7}; //   2
  psi_c_t[no_ps][83] = get_vector_from_array_int(c_t_83, 2);
  int c_d_83[] = { 14,   2}; //   2
  psi_c_d[no_ps][83] = get_vector_from_array_int(c_d_83, 2);

  int c_p_84[] = {  8,  26}; //   2
  psi_c_p[no_ps][84] = get_vector_from_array_int(c_p_84, 2);
  int c_f_84[] = {  3}; //   1
  psi_c_f[no_ps][84] = get_vector_from_array_int(c_f_84, 1);
  int c_t_84[] = {  8,   9}; //   2
  psi_c_t[no_ps][84] = get_vector_from_array_int(c_t_84, 2);
  int c_d_84[] = { 11,   6}; //   2
  psi_c_d[no_ps][84] = get_vector_from_array_int(c_d_84, 2);

  int c_p_85[] = {  8,  27}; //   2
  psi_c_p[no_ps][85] = get_vector_from_array_int(c_p_85, 2);
  int c_f_85[] = {  3}; //   1
  psi_c_f[no_ps][85] = get_vector_from_array_int(c_f_85, 1);
  int c_t_85[] = {  8,   9}; //   2
  psi_c_t[no_ps][85] = get_vector_from_array_int(c_t_85, 2);
  int c_d_85[] = { 11,   6}; //   2
  psi_c_d[no_ps][85] = get_vector_from_array_int(c_d_85, 2);

  int c_p_86[] = { 10,  26}; //   2
  psi_c_p[no_ps][86] = get_vector_from_array_int(c_p_86, 2);
  int c_f_86[] = {  3}; //   1
  psi_c_f[no_ps][86] = get_vector_from_array_int(c_f_86, 1);
  int c_t_86[] = {  8,   9}; //   2
  psi_c_t[no_ps][86] = get_vector_from_array_int(c_t_86, 2);
  int c_d_86[] = { 11,   6}; //   2
  psi_c_d[no_ps][86] = get_vector_from_array_int(c_d_86, 2);

  int c_p_87[] = { 10,  27}; //   2
  psi_c_p[no_ps][87] = get_vector_from_array_int(c_p_87, 2);
  int c_f_87[] = {  3}; //   1
  psi_c_f[no_ps][87] = get_vector_from_array_int(c_f_87, 1);
  int c_t_87[] = {  8,   9}; //   2
  psi_c_t[no_ps][87] = get_vector_from_array_int(c_t_87, 2);
  int c_d_87[] = { 11,   6}; //   2
  psi_c_d[no_ps][87] = get_vector_from_array_int(c_d_87, 2);

  int c_p_88[] = { 14,  28}; //   2
  psi_c_p[no_ps][88] = get_vector_from_array_int(c_p_88, 2);
  int c_f_88[] = {  4}; //   1
  psi_c_f[no_ps][88] = get_vector_from_array_int(c_f_88, 1);
  int c_t_88[] = { 10,  11}; //   2
  psi_c_t[no_ps][88] = get_vector_from_array_int(c_t_88, 2);
  int c_d_88[] = {  6,  11}; //   2
  psi_c_d[no_ps][88] = get_vector_from_array_int(c_d_88, 2);

  int c_p_89[] = { 14,  29}; //   2
  psi_c_p[no_ps][89] = get_vector_from_array_int(c_p_89, 2);
  int c_f_89[] = {  4}; //   1
  psi_c_f[no_ps][89] = get_vector_from_array_int(c_f_89, 1);
  int c_t_89[] = { 10,  11}; //   2
  psi_c_t[no_ps][89] = get_vector_from_array_int(c_t_89, 2);
  int c_d_89[] = {  6,  11}; //   2
  psi_c_d[no_ps][89] = get_vector_from_array_int(c_d_89, 2);

  int c_p_90[] = { 18,  28}; //   2
  psi_c_p[no_ps][90] = get_vector_from_array_int(c_p_90, 2);
  int c_f_90[] = {  4}; //   1
  psi_c_f[no_ps][90] = get_vector_from_array_int(c_f_90, 1);
  int c_t_90[] = { 10,  11}; //   2
  psi_c_t[no_ps][90] = get_vector_from_array_int(c_t_90, 2);
  int c_d_90[] = {  6,  11}; //   2
  psi_c_d[no_ps][90] = get_vector_from_array_int(c_d_90, 2);

  int c_p_91[] = { 18,  29}; //   2
  psi_c_p[no_ps][91] = get_vector_from_array_int(c_p_91, 2);
  int c_f_91[] = {  4}; //   1
  psi_c_f[no_ps][91] = get_vector_from_array_int(c_f_91, 1);
  int c_t_91[] = { 10,  11}; //   2
  psi_c_t[no_ps][91] = get_vector_from_array_int(c_t_91, 2);
  int c_d_91[] = {  6,  11}; //   2
  psi_c_d[no_ps][91] = get_vector_from_array_int(c_d_91, 2);

  int c_p_92[] = { 20,  30}; //   2
  psi_c_p[no_ps][92] = get_vector_from_array_int(c_p_92, 2);
  int c_f_92[] = {  5}; //   1
  psi_c_f[no_ps][92] = get_vector_from_array_int(c_f_92, 1);
  int c_t_92[] = { 12,  13}; //   2
  psi_c_t[no_ps][92] = get_vector_from_array_int(c_t_92, 2);
  int c_d_92[] = {  2,  14}; //   2
  psi_c_d[no_ps][92] = get_vector_from_array_int(c_d_92, 2);

  int c_p_93[] = { 20,  31}; //   2
  psi_c_p[no_ps][93] = get_vector_from_array_int(c_p_93, 2);
  int c_f_93[] = {  5}; //   1
  psi_c_f[no_ps][93] = get_vector_from_array_int(c_f_93, 1);
  int c_t_93[] = { 12,  13}; //   2
  psi_c_t[no_ps][93] = get_vector_from_array_int(c_t_93, 2);
  int c_d_93[] = {  2,  14}; //   2
  psi_c_d[no_ps][93] = get_vector_from_array_int(c_d_93, 2);

  int c_p_94[] = { 22,  30}; //   2
  psi_c_p[no_ps][94] = get_vector_from_array_int(c_p_94, 2);
  int c_f_94[] = {  5}; //   1
  psi_c_f[no_ps][94] = get_vector_from_array_int(c_f_94, 1);
  int c_t_94[] = { 12,  13}; //   2
  psi_c_t[no_ps][94] = get_vector_from_array_int(c_t_94, 2);
  int c_d_94[] = {  2,  14}; //   2
  psi_c_d[no_ps][94] = get_vector_from_array_int(c_d_94, 2);

  int c_p_95[] = { 22,  31}; //   2
  psi_c_p[no_ps][95] = get_vector_from_array_int(c_p_95, 2);
  int c_f_95[] = {  5}; //   1
  psi_c_f[no_ps][95] = get_vector_from_array_int(c_f_95, 1);
  int c_t_95[] = { 12,  13}; //   2
  psi_c_t[no_ps][95] = get_vector_from_array_int(c_t_95, 2);
  int c_d_95[] = {  2,  14}; //   2
  psi_c_d[no_ps][95] = get_vector_from_array_int(c_d_95, 2);

  int c_p_96[] = {  0,  24}; //   2
  psi_c_p[no_ps][96] = get_vector_from_array_int(c_p_96, 2);
  int c_f_96[] = {  0}; //   1
  psi_c_f[no_ps][96] = get_vector_from_array_int(c_f_96, 1);
  int c_t_96[] = {  1,  14}; //   2
  psi_c_t[no_ps][96] = get_vector_from_array_int(c_t_96, 2);
  int c_d_96[] = { 14,   2}; //   2
  psi_c_d[no_ps][96] = get_vector_from_array_int(c_d_96, 2);

  int c_p_97[] = {  0,  25}; //   2
  psi_c_p[no_ps][97] = get_vector_from_array_int(c_p_97, 2);
  int c_f_97[] = {  0}; //   1
  psi_c_f[no_ps][97] = get_vector_from_array_int(c_f_97, 1);
  int c_t_97[] = {  1,  14}; //   2
  psi_c_t[no_ps][97] = get_vector_from_array_int(c_t_97, 2);
  int c_d_97[] = { 14,   2}; //   2
  psi_c_d[no_ps][97] = get_vector_from_array_int(c_d_97, 2);

  int c_p_98[] = {  4,  24}; //   2
  psi_c_p[no_ps][98] = get_vector_from_array_int(c_p_98, 2);
  int c_f_98[] = {  0}; //   1
  psi_c_f[no_ps][98] = get_vector_from_array_int(c_f_98, 1);
  int c_t_98[] = {  1,  14}; //   2
  psi_c_t[no_ps][98] = get_vector_from_array_int(c_t_98, 2);
  int c_d_98[] = { 14,   2}; //   2
  psi_c_d[no_ps][98] = get_vector_from_array_int(c_d_98, 2);

  int c_p_99[] = {  4,  25}; //   2
  psi_c_p[no_ps][99] = get_vector_from_array_int(c_p_99, 2);
  int c_f_99[] = {  0}; //   1
  psi_c_f[no_ps][99] = get_vector_from_array_int(c_f_99, 1);
  int c_t_99[] = {  1,  14}; //   2
  psi_c_t[no_ps][99] = get_vector_from_array_int(c_t_99, 2);
  int c_d_99[] = { 14,   2}; //   2
  psi_c_d[no_ps][99] = get_vector_from_array_int(c_d_99, 2);

  int c_p_100[] = {  8,  26}; //   2
  psi_c_p[no_ps][100] = get_vector_from_array_int(c_p_100, 2);
  int c_f_100[] = {  1}; //   1
  psi_c_f[no_ps][100] = get_vector_from_array_int(c_f_100, 1);
  int c_t_100[] = {  1,  15}; //   2
  psi_c_t[no_ps][100] = get_vector_from_array_int(c_t_100, 2);
  int c_d_100[] = { 11,   6}; //   2
  psi_c_d[no_ps][100] = get_vector_from_array_int(c_d_100, 2);

  int c_p_101[] = {  8,  27}; //   2
  psi_c_p[no_ps][101] = get_vector_from_array_int(c_p_101, 2);
  int c_f_101[] = {  1}; //   1
  psi_c_f[no_ps][101] = get_vector_from_array_int(c_f_101, 1);
  int c_t_101[] = {  1,  15}; //   2
  psi_c_t[no_ps][101] = get_vector_from_array_int(c_t_101, 2);
  int c_d_101[] = { 11,   6}; //   2
  psi_c_d[no_ps][101] = get_vector_from_array_int(c_d_101, 2);

  int c_p_102[] = { 10,  26}; //   2
  psi_c_p[no_ps][102] = get_vector_from_array_int(c_p_102, 2);
  int c_f_102[] = {  1}; //   1
  psi_c_f[no_ps][102] = get_vector_from_array_int(c_f_102, 1);
  int c_t_102[] = {  1,  15}; //   2
  psi_c_t[no_ps][102] = get_vector_from_array_int(c_t_102, 2);
  int c_d_102[] = { 11,   6}; //   2
  psi_c_d[no_ps][102] = get_vector_from_array_int(c_d_102, 2);

  int c_p_103[] = { 10,  27}; //   2
  psi_c_p[no_ps][103] = get_vector_from_array_int(c_p_103, 2);
  int c_f_103[] = {  1}; //   1
  psi_c_f[no_ps][103] = get_vector_from_array_int(c_f_103, 1);
  int c_t_103[] = {  1,  15}; //   2
  psi_c_t[no_ps][103] = get_vector_from_array_int(c_t_103, 2);
  int c_d_103[] = { 11,   6}; //   2
  psi_c_d[no_ps][103] = get_vector_from_array_int(c_d_103, 2);

  int c_p_104[] = { 14,  28}; //   2
  psi_c_p[no_ps][104] = get_vector_from_array_int(c_p_104, 2);
  int c_f_104[] = {  1}; //   1
  psi_c_f[no_ps][104] = get_vector_from_array_int(c_f_104, 1);
  int c_t_104[] = {  1,  16}; //   2
  psi_c_t[no_ps][104] = get_vector_from_array_int(c_t_104, 2);
  int c_d_104[] = {  6,  11}; //   2
  psi_c_d[no_ps][104] = get_vector_from_array_int(c_d_104, 2);

  int c_p_105[] = { 14,  29}; //   2
  psi_c_p[no_ps][105] = get_vector_from_array_int(c_p_105, 2);
  int c_f_105[] = {  1}; //   1
  psi_c_f[no_ps][105] = get_vector_from_array_int(c_f_105, 1);
  int c_t_105[] = {  1,  16}; //   2
  psi_c_t[no_ps][105] = get_vector_from_array_int(c_t_105, 2);
  int c_d_105[] = {  6,  11}; //   2
  psi_c_d[no_ps][105] = get_vector_from_array_int(c_d_105, 2);

  int c_p_106[] = { 18,  28}; //   2
  psi_c_p[no_ps][106] = get_vector_from_array_int(c_p_106, 2);
  int c_f_106[] = {  1}; //   1
  psi_c_f[no_ps][106] = get_vector_from_array_int(c_f_106, 1);
  int c_t_106[] = {  1,  16}; //   2
  psi_c_t[no_ps][106] = get_vector_from_array_int(c_t_106, 2);
  int c_d_106[] = {  6,  11}; //   2
  psi_c_d[no_ps][106] = get_vector_from_array_int(c_d_106, 2);

  int c_p_107[] = { 18,  29}; //   2
  psi_c_p[no_ps][107] = get_vector_from_array_int(c_p_107, 2);
  int c_f_107[] = {  1}; //   1
  psi_c_f[no_ps][107] = get_vector_from_array_int(c_f_107, 1);
  int c_t_107[] = {  1,  16}; //   2
  psi_c_t[no_ps][107] = get_vector_from_array_int(c_t_107, 2);
  int c_d_107[] = {  6,  11}; //   2
  psi_c_d[no_ps][107] = get_vector_from_array_int(c_d_107, 2);

  int c_p_108[] = { 20,  30}; //   2
  psi_c_p[no_ps][108] = get_vector_from_array_int(c_p_108, 2);
  int c_f_108[] = {  0}; //   1
  psi_c_f[no_ps][108] = get_vector_from_array_int(c_f_108, 1);
  int c_t_108[] = {  1,  17}; //   2
  psi_c_t[no_ps][108] = get_vector_from_array_int(c_t_108, 2);
  int c_d_108[] = {  2,  14}; //   2
  psi_c_d[no_ps][108] = get_vector_from_array_int(c_d_108, 2);

  int c_p_109[] = { 20,  31}; //   2
  psi_c_p[no_ps][109] = get_vector_from_array_int(c_p_109, 2);
  int c_f_109[] = {  0}; //   1
  psi_c_f[no_ps][109] = get_vector_from_array_int(c_f_109, 1);
  int c_t_109[] = {  1,  17}; //   2
  psi_c_t[no_ps][109] = get_vector_from_array_int(c_t_109, 2);
  int c_d_109[] = {  2,  14}; //   2
  psi_c_d[no_ps][109] = get_vector_from_array_int(c_d_109, 2);

  int c_p_110[] = { 22,  30}; //   2
  psi_c_p[no_ps][110] = get_vector_from_array_int(c_p_110, 2);
  int c_f_110[] = {  0}; //   1
  psi_c_f[no_ps][110] = get_vector_from_array_int(c_f_110, 1);
  int c_t_110[] = {  1,  17}; //   2
  psi_c_t[no_ps][110] = get_vector_from_array_int(c_t_110, 2);
  int c_d_110[] = {  2,  14}; //   2
  psi_c_d[no_ps][110] = get_vector_from_array_int(c_d_110, 2);

  int c_p_111[] = { 22,  31}; //   2
  psi_c_p[no_ps][111] = get_vector_from_array_int(c_p_111, 2);
  int c_f_111[] = {  0}; //   1
  psi_c_f[no_ps][111] = get_vector_from_array_int(c_f_111, 1);
  int c_t_111[] = {  1,  17}; //   2
  psi_c_t[no_ps][111] = get_vector_from_array_int(c_t_111, 2);
  int c_d_111[] = {  2,  14}; //   2
  psi_c_d[no_ps][111] = get_vector_from_array_int(c_d_111, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
