#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_ag_psp_230_gg_emepa(int no_ps, int zero, phasespace_set & psi){
  static Logger logger("ppeexa03_ag_psp_230_gg_emepa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_xbp[no_ps][12] == nullvector){psi_xbp[no_ps][12] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8];}
  if (psi_xbs[no_ps][12] == 0.){psi_xbs[no_ps][12] = psi_xbp[no_ps][12].m2();}
  if (psi_xbp[no_ps][17] == nullvector){psi_xbp[no_ps][17] = psi_xbp[no_ps][1] - psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][17] == 0.){psi_xbs[no_ps][17] = psi_xbp[no_ps][17].m2();}
  if (psi_xbp[no_ps][18] == nullvector){psi_xbp[no_ps][18] = psi_xbp[no_ps][2] - psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][18] == 0.){psi_xbs[no_ps][18] = psi_xbp[no_ps][18].m2();}
  if (psi_xbp[no_ps][20] == nullvector){psi_xbp[no_ps][20] = psi_xbp[no_ps][4] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][20] == 0.){psi_xbs[no_ps][20] = psi_xbp[no_ps][20].m2();}
  if (psi_xbp[no_ps][24] == nullvector){psi_xbp[no_ps][24] = psi_xbp[no_ps][8] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][24] == 0.){psi_xbs[no_ps][24] = psi_xbp[no_ps][24].m2();}
  if (psi_xbp[no_ps][28] == nullvector){psi_xbp[no_ps][28] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][28] == 0.){psi_xbs[no_ps][28] = psi_xbp[no_ps][28].m2();}

  psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][12]; // 12 times
  psi_v_smin[no_ps][  1] = psi_smin_opt[no_ps][24]; // 2 times
  psi_v_smin[no_ps][  2] = psi_smin_opt[no_ps][20]; // 2 times

  psi_v_smax[no_ps][  0] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][16], 2); // 12 times
  psi_v_smax[no_ps][  1] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][4], 2); // 2 times
  psi_v_smax[no_ps][  2] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][8], 2); // 2 times

  //  vector<double> g_p(4);
  {psi_g_p[no_ps][  0] = psi.g_propagator(no_ps,   0,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0]); /* npp 2 */} // 6 times
  {psi_g_p[no_ps][  1] = psi.g_propagator(no_ps,  23,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0]); /* npp 2 */} // 6 times
  {psi_g_p[no_ps][  2] = psi.g_propagator(no_ps,   0,  24, psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1]); /* npp 2 */} // 2 times
  {psi_g_p[no_ps][  3] = psi.g_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  2]); /* npp 2 */} // 2 times

  //  vector<double> g_f(0);

  //  vector<double> g_t(4);
  {psi_g_t[no_ps][  0] = psi.g_tchannel_opt(no_ps,   0,  28,   2,   1,  16,  12); /* ntp 0 */} // 2 times
  {psi_g_t[no_ps][  1] = psi.g_tchannel_opt(no_ps,   6,  28,   2,   1,  16,  12); /* ntp 0 */} // 2 times
  {psi_g_t[no_ps][  2] = psi.g_tchannel_opt(no_ps,   0,  28,   1,   2,  16,  12); /* ntp 0 */} // 2 times
  {psi_g_t[no_ps][  3] = psi.g_tchannel_opt(no_ps,   6,  28,   1,   2,  16,  12); /* ntp 0 */} // 2 times

  //  vector<double> g_d(6);
  {psi_g_d[no_ps][  0] = psi.g_decay(no_ps,  12,   4,   8); /* ndp 2 */} // 12 times
  {psi_g_d[no_ps][  1] = psi.g_decay(no_ps,  28,   4,  24); /* ndp 3 */} // 2 times
  {psi_g_d[no_ps][  2] = psi.g_decay(no_ps,  24,   8,  16); /* ndp 2 */} // 2 times
  {psi_g_d[no_ps][  3] = psi.g_decay(no_ps,  28,  16,  12); /* ndp 3 */} // 4 times
  {psi_g_d[no_ps][  4] = psi.g_decay(no_ps,  28,   8,  20); /* ndp 3 */} // 2 times
  {psi_g_d[no_ps][  5] = psi.g_decay(no_ps,  20,   4,  16); /* ndp 2 */} // 2 times


  if (psi_weight_IS == 2 || psi_weight_IS == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(4);
    inv_r[0].resize(4);
    inv_r[1].resize(0);
    inv_r[2].resize(8);
    inv_r[3].resize(12);

    {psi.inv_propagator(no_ps,   0,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], inv_r[0][0]);} // 6 times
    {psi.inv_propagator(no_ps,  23,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], inv_r[0][1]);} // 6 times
    {psi.inv_propagator(no_ps,   0,  24, psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1], inv_r[0][2]);} // 2 times
    {psi.inv_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  2], inv_r[0][3]);} // 2 times


    {psi.inv_tchannel_opt(no_ps,   0,  28,   2,   1,  16,  12, inv_r[2][0], inv_r[2][1]);} // 2 times
    {psi.inv_tchannel_opt(no_ps,   6,  28,   2,   1,  16,  12, inv_r[2][2], inv_r[2][3]);} // 2 times
    {psi.inv_tchannel_opt(no_ps,   0,  28,   1,   2,  16,  12, inv_r[2][4], inv_r[2][5]);} // 2 times
    {psi.inv_tchannel_opt(no_ps,   6,  28,   1,   2,  16,  12, inv_r[2][6], inv_r[2][7]);} // 2 times

    {psi.inv_decay(no_ps,  12,   4,   8, inv_r[3][0], inv_r[3][1]);} // 12 times
    {psi.inv_decay(no_ps,  28,   4,  24, inv_r[3][2], inv_r[3][3]);} // 2 times
    {psi.inv_decay(no_ps,  24,   8,  16, inv_r[3][4], inv_r[3][5]);} // 2 times
    {psi.inv_decay(no_ps,  28,  16,  12, inv_r[3][6], inv_r[3][7]);} // 4 times
    {psi.inv_decay(no_ps,  28,   8,  20, inv_r[3][8], inv_r[3][9]);} // 2 times
    {psi.inv_decay(no_ps,  20,   4,  16, inv_r[3][10], inv_r[3][11]);} // 2 times

    if (psi_weight_IS == 2){
      int n_random = 3 * psi_n_particle - 4;;
      vector<vector<double> > inv_channel_r(16, vector<double> (5));
      vector<double> g_IS(16, 1.);
      for (int i_c = 0; i_c < 16; i_c++){
        int ran = 0;
        if (psi_MC_alpha[zero + i_c] != 0.){
          for (int i_p = 0; i_p < psi_c_p[no_ps][i_c].size(); i_p++){
            inv_channel_r[i_c][i_p] = inv_r[0][psi_c_p[no_ps][i_c][i_p]];
          }
          ran += psi_c_p[no_ps][i_c].size();
          for (int i_f = 0; i_f < psi_c_f[no_ps][i_c].size(); i_f++){
            inv_channel_r[i_c][ran + i_f] = inv_r[1][psi_c_f[no_ps][i_c][i_f]];
          }
          ran += psi_c_f[no_ps][i_c].size();
          for (int i_t = 0; i_t < psi_c_t[no_ps][i_c].size(); i_t++){
            inv_channel_r[i_c][ran + 2 * i_t] = inv_r[2][2 * psi_c_t[no_ps][i_c][i_t]];
            inv_channel_r[i_c][ran + 2 * i_t + 1] = inv_r[2][2 * psi_c_t[no_ps][i_c][i_t] + 1];
          }
          ran += 2 * psi_c_t[no_ps][i_c].size();
          for (int i_d = 0; i_d < psi_c_d[no_ps][i_c].size(); i_d++){
            inv_channel_r[i_c][ran + 2 * i_d] = inv_r[3][2 * psi_c_d[no_ps][i_c][i_d]];
            inv_channel_r[i_c][ran + 2 * i_d + 1] = inv_r[3][2 * psi_c_d[no_ps][i_c][i_d] + 1];
          }
          ran += 2 * psi_c_d[no_ps][i_c].size();
          for (int i_r = 0; i_r < 5; i_r++){
            psi_phasespace_randoms[(zero + i_c) * n_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
            g_IS[i_c] *= g_IS_temp;
          }
        }
      }
      if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = g_IS[  0] * psi_g_p[no_ps][  0] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = g_IS[  1] * psi_g_p[no_ps][  0] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = g_IS[  2] * psi_g_p[no_ps][  1] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = g_IS[  3] * psi_g_p[no_ps][  1] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = g_IS[  4] * psi_g_p[no_ps][  2] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = g_IS[  5] * psi_g_p[no_ps][  2] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
      if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = g_IS[  6] * psi_g_p[no_ps][  0] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = g_IS[  7] * psi_g_p[no_ps][  0] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = g_IS[  8] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = g_IS[  9] * psi_g_p[no_ps][  1] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = g_IS[ 10] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  5];}
      if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = g_IS[ 11] * psi_g_p[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  5];}
      if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = g_IS[ 12] * psi_g_p[no_ps][  0] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = g_IS[ 13] * psi_g_p[no_ps][  0] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = g_IS[ 14] * psi_g_p[no_ps][  1] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = g_IS[ 15] * psi_g_p[no_ps][  1] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  0];}

    }
    else if (psi_weight_IS == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(4, 1.);
      g_IS[1].resize(0, 1.);
      g_IS[2].resize(4, 1.);
      g_IS[3].resize(6, 1.);

      for (int i_m = 0; i_m < 4; i_m++){
        for (int i_r = 0; i_r < inv_r[i_m].size(); i_r++){
          psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][i_m] + i_r]->get_g_IS(inv_r[i_m][i_r], g_IS_temp);
          int i_g = i_r;
          if (i_m > 1){i_g = i_r / 2;}
          g_IS[i_m][i_g] *= g_IS_temp;
        }
      }
      if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_d[no_ps][  1] * g_IS[3][  1] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_d[no_ps][  1] * g_IS[3][  1] * psi_g_d[no_ps][  2] * g_IS[3][  2];}
      if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_d[no_ps][  3] * g_IS[3][  3] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_d[no_ps][  3] * g_IS[3][  3] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_d[no_ps][  3] * g_IS[3][  3] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_d[no_ps][  3] * g_IS[3][  3] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = psi_g_p[no_ps][  3] * g_IS[0][  3] * psi_g_d[no_ps][  4] * g_IS[3][  4] * psi_g_d[no_ps][  5] * g_IS[3][  5];}
      if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = psi_g_p[no_ps][  3] * g_IS[0][  3] * psi_g_d[no_ps][  4] * g_IS[3][  4] * psi_g_d[no_ps][  5] * g_IS[3][  5];}
      if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_t[no_ps][  2] * g_IS[2][  2] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_t[no_ps][  2] * g_IS[2][  2] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
    }
  }

  else {
    if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = psi_g_p[no_ps][  0] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = psi_g_p[no_ps][  0] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = psi_g_p[no_ps][  1] * psi_g_t[no_ps][  0] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = psi_g_p[no_ps][  1] * psi_g_t[no_ps][  1] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = psi_g_p[no_ps][  2] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = psi_g_p[no_ps][  2] * psi_g_d[no_ps][  1] * psi_g_d[no_ps][  2];}
    if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = psi_g_p[no_ps][  0] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = psi_g_p[no_ps][  0] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = psi_g_p[no_ps][  1] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = psi_g_p[no_ps][  1] * psi_g_d[no_ps][  3] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = psi_g_p[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  5];}
    if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = psi_g_p[no_ps][  3] * psi_g_d[no_ps][  4] * psi_g_d[no_ps][  5];}
    if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = psi_g_p[no_ps][  0] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = psi_g_p[no_ps][  0] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = psi_g_p[no_ps][  1] * psi_g_t[no_ps][  2] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = psi_g_p[no_ps][  1] * psi_g_t[no_ps][  3] * psi_g_d[no_ps][  0];}
  }

/*
  if (psi_MC_alpha[   0] != 0.){ag_channel_2v1(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (psi_MC_alpha[   1] != 0.){ag_channel_2v1(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   6, psi);}
  if (psi_MC_alpha[   2] != 0.){ag_channel_2v1(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  if (psi_MC_alpha[   3] != 0.){ag_channel_2v1(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   6, psi);}
  if (psi_MC_alpha[   4] != 0.){ag_channel_3yv(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (psi_MC_alpha[   5] != 0.){ag_channel_3yv(g, 1, 2, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23, psi);}
  if (psi_MC_alpha[   6] != 0.){ag_channel_3yv(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (psi_MC_alpha[   7] != 0.){ag_channel_3yv(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   6, psi);}
  if (psi_MC_alpha[   8] != 0.){ag_channel_3yv(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  if (psi_MC_alpha[   9] != 0.){ag_channel_3yv(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   6, psi);}
  if (psi_MC_alpha[  10] != 0.){ag_channel_3yv(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (psi_MC_alpha[  11] != 0.){ag_channel_3yv(g, 1, 2, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23, psi);}
  if (psi_MC_alpha[  12] != 0.){ag_channel_12v(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0, psi);}
  if (psi_MC_alpha[  13] != 0.){ag_channel_12v(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   6, psi);}
  if (psi_MC_alpha[  14] != 0.){ag_channel_12v(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0, psi);}
  if (psi_MC_alpha[  15] != 0.){ag_channel_12v(g, 1, 2, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   6, psi);}
  // channel    0: 2v1(1, 2, 4, 8, 16;   0,   0)
  // channel    1: 2v1(1, 2, 4, 8, 16;   0,   6)
  // channel    2: 2v1(1, 2, 4, 8, 16;  23,   0)
  // channel    3: 2v1(1, 2, 4, 8, 16;  23,   6)
  // channel    4: 3yv(1, 2, 4, 8, 16;   0,   0)
  // channel    5: 3yv(1, 2, 4, 8, 16;   0,  23)
  // channel    6: 3yv(1, 2, 16, 4, 8;   0,   0)
  // channel    7: 3yv(1, 2, 16, 4, 8;   0,   6)
  // channel    8: 3yv(1, 2, 16, 4, 8;  23,   0)
  // channel    9: 3yv(1, 2, 16, 4, 8;  23,   6)
  // channel   10: 3yv(1, 2, 8, 4, 16;   0,   0)
  // channel   11: 3yv(1, 2, 8, 4, 16;   0,  23)
  // channel   12: 12v(1, 2, 16, 4, 8;   0,   0)
  // channel   13: 12v(1, 2, 16, 4, 8;   0,   6)
  // channel   14: 12v(1, 2, 16, 4, 8;  23,   0)
  // channel   15: 12v(1, 2, 16, 4, 8;  23,   6)
*/

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
