#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_ax_psp_230_gg_emepaddx(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_ax_psp_230_gg_emepaddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(16);
  psi_needed_v_smin[no_ps].resize(16);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19,   24,   25,   26,   27,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  60
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 60);
  int needed_v_smin_1[] = {   0,    1,    8,    9,   26,   27,   36,   37,   58,   59,   74,   75,   80,   81,   84,   85}; //  16
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 16);
  int needed_v_smin_2[] = {   2,    3,   10,   11,   24,   25,   38,   39,   56,   57,   72,   73,   82,   83,   86,   87}; //  16
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 16);
  int needed_v_smin_3[] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 16);
  int needed_v_smin_4[] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 16);
  int needed_v_smin_5[] = {   4,    5,   12,   13,   20,   21,   28,   29,   52,   53,   60,   61,   42,   43,   46,   47,   50,   51,   70,   71}; //  20
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 20);
  int needed_v_smin_6[] = {   6,    7,   14,   15,   22,   23,   30,   31,   54,   55,   62,   63,   40,   41,   44,   45,   48,   49,   68,   69}; //  20
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 20);
  int needed_v_smin_7[] = {   8,    9,   26,   27,   58,   59,    0,    1,   74,   75}; //  10
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 10);
  int needed_v_smin_8[] = {  10,   11,   24,   25,   56,   57,    2,    3,   72,   73}; //  10
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 10);
  int needed_v_smin_9[] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 16);
  int needed_v_smin_10[] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 16);
  int needed_v_smin_11[] = {  16,   17,   32,   33,   36,   37,   64,   65,   78,   79,   80,   81,   84,   85,   88,   89}; //  16
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 16);
  int needed_v_smin_12[] = {  16,   17,   32,   33,   64,   65,   78,   79,   88,   89}; //  10
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 10);
  int needed_v_smin_13[] = {  18,   19,   34,   35,   38,   39,   66,   67,   76,   77,   82,   83,   86,   87,   90,   91}; //  16
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 16);
  int needed_v_smin_14[] = {  18,   19,   34,   35,   66,   67,   76,   77,   90,   91}; //  10
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 10);
  int needed_v_smin_15[] = {  40,   41,   42,   43,   68,   69,   70,   71}; //   8
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 8);

  psi_v_smax[no_ps].resize(18);
  psi_needed_v_smax[no_ps].resize(18);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    8,    9,   10,   11,   24,   25,   26,   27,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83}; //  40
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 40);
  int needed_v_smax_1[] = {   0,    1,    8,    9,   26,   27,   36,   37,   58,   59,   74,   75,   80,   81}; //  14
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 14);
  int needed_v_smax_2[] = {   2,    3,   10,   11,   24,   25,   38,   39,   56,   57,   72,   73,   82,   83}; //  14
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 14);
  int needed_v_smax_3[] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 16);
  int needed_v_smax_4[] = {   4,    5,    6,    7,   12,   13,   14,   15,   20,   21,   22,   23,   28,   29,   30,   31,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   60,   61,   62,   63,   40,   41,   42,   43,   68,   69,   70,   71}; //  40
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 40);
  int needed_v_smax_5[] = {   4,    5,    8,    9,   12,   13,   18,   19,   20,   21,   26,   27,   28,   29,   34,   35,   52,   53,   58,   59,   60,   61,   66,   67,    0,    1,   42,   43,   46,   47,   50,   51,   70,   71,   74,   75,   76,   77,   90,   91}; //  40
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 40);
  int needed_v_smax_6[] = {   6,    7,   10,   11,   14,   15,   16,   17,   22,   23,   24,   25,   30,   31,   32,   33,   54,   55,   56,   57,   62,   63,   64,   65,    2,    3,   40,   41,   44,   45,   48,   49,   68,   69,   72,   73,   78,   79,   88,   89}; //  40
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 40);
  int needed_v_smax_7[] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 16);
  int needed_v_smax_8[] = {  16,   17,   32,   33,   64,   65,   84,   85,   88,   89}; //  10
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 10);
  int needed_v_smax_9[] = {  16,   17,   32,   33,   64,   65,   84,   85,   88,   89}; //  10
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 10);
  int needed_v_smax_10[] = {  18,   19,   34,   35,   66,   67,   86,   87,   90,   91}; //  10
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 10);
  int needed_v_smax_11[] = {  18,   19,   34,   35,   66,   67,   86,   87,   90,   91}; //  10
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 10);
  int needed_v_smax_12[] = {  36,   37,   80,   81}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  38,   39,   82,   83}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  76,   77}; //   2
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);
  int needed_v_smax_15[] = {  78,   79}; //   2
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 2);
  int needed_v_smax_16[] = {  84,   85}; //   2
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 2);
  int needed_v_smax_17[] = {  86,   87}; //   2
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(28);
  psi_needed_g_p[no_ps].resize(28);
  int needed_g_p_0[] = {   0,    2,    8,   10,   24,   26,   36,   38,   40,   42,   56,   58,   68,   70,   72,   74,   76,   78,   80,   82}; //  20
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 20);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    8,    9,   26,   27,   36,   37,   58,   59,   74,   75,   80,   81}; //  14
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 14);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   1,    3,    9,   11,   25,   27,   37,   39,   41,   43,   57,   59,   69,   71,   73,   75,   77,   79,   81,   83}; //  20
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 20);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_3[] = {   2,    3,   10,   11,   24,   25,   38,   39,   56,   57,   72,   73,   82,   83}; //  14
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 14);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_4[] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 16);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {   4,    6,   20,   22,   44,   46,   52,   54}; //   8
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 8);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_6[] = {   4,    5,   12,   13,   20,   21,   28,   29,   52,   53,   60,   61}; //  12
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 12);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_7[] = {   5,    7,   21,   23,   45,   47,   53,   55}; //   8
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 8);
  psi_container_IS_name.push_back("propagator_23_smin4_smax4");
  int needed_g_p_8[] = {   6,    7,   14,   15,   22,   23,   30,   31,   54,   55,   62,   63}; //  12
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 12);
  psi_container_IS_name.push_back("propagator_0_smin6_smax6");
  int needed_g_p_9[] = {   8,    9,   26,   27,   58,   59}; //   6
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 6);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_10[] = {  10,   11,   24,   25,   56,   57}; //   6
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 6);
  psi_container_IS_name.push_back("propagator_0_smin8_smax6");
  int needed_g_p_11[] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 16);
  psi_container_IS_name.push_back("propagator_0_smin9_smax7");
  int needed_g_p_12[] = {  12,   14,   28,   30,   48,   50,   60,   62}; //   8
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 8);
  psi_container_IS_name.push_back("propagator_0_smin10_smax4");
  int needed_g_p_13[] = {  13,   15,   29,   31,   49,   51,   61,   63}; //   8
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 8);
  psi_container_IS_name.push_back("propagator_23_smin10_smax4");
  int needed_g_p_14[] = {  16,   17,   32,   33,   64,   65,   84,   85,   88,   89}; //  10
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 10);
  psi_container_IS_name.push_back("propagator_0_smin11_smax8");
  int needed_g_p_15[] = {  16,   32,   64,   84,   88}; //   5
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 5);
  psi_container_IS_name.push_back("propagator_0_smin0_smax9");
  int needed_g_p_16[] = {  16,   17,   32,   33,   64,   65}; //   6
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 6);
  psi_container_IS_name.push_back("propagator_0_smin12_smax6");
  int needed_g_p_17[] = {  17,   33,   65,   85,   89}; //   5
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 5);
  psi_container_IS_name.push_back("propagator_23_smin0_smax9");
  int needed_g_p_18[] = {  18,   19,   34,   35,   66,   67,   86,   87,   90,   91}; //  10
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 10);
  psi_container_IS_name.push_back("propagator_0_smin13_smax10");
  int needed_g_p_19[] = {  18,   34,   66,   86,   90}; //   5
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 5);
  psi_container_IS_name.push_back("propagator_0_smin0_smax11");
  int needed_g_p_20[] = {  18,   19,   34,   35,   66,   67}; //   6
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 6);
  psi_container_IS_name.push_back("propagator_0_smin14_smax5");
  int needed_g_p_21[] = {  19,   35,   67,   87,   91}; //   5
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 5);
  psi_container_IS_name.push_back("propagator_23_smin0_smax11");
  int needed_g_p_22[] = {  36,   37,   80,   81}; //   4
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax12");
  int needed_g_p_23[] = {  38,   39,   82,   83}; //   4
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 4);
  psi_container_IS_name.push_back("propagator_0_smin13_smax13");
  int needed_g_p_24[] = {  76,   77}; //   2
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax14");
  int needed_g_p_25[] = {  78,   79}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_0_smin11_smax15");
  int needed_g_p_26[] = {  84,   85}; //   2
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax16");
  int needed_g_p_27[] = {  86,   87}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_0_smin2_smax17");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(7);
  psi_needed_g_f[no_ps].resize(7);
  int needed_g_f_0[] = {   0,    1,   74,   75}; //   4
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");
  int needed_g_f_1[] = {   2,    3,   72,   73}; //   4
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax6");
  int needed_g_f_2[] = {  40,   41,   42,   43,   68,   69,   70,   71}; //   8
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax4");
  int needed_g_f_3[] = {  40,   41,   44,   45,   48,   49,   68,   69}; //   8
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax6");
  int needed_g_f_4[] = {  42,   43,   46,   47,   50,   51,   70,   71}; //   8
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax5");
  int needed_g_f_5[] = {  76,   77,   90,   91}; //   4
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax5");
  int needed_g_f_6[] = {  78,   79,   88,   89}; //   4
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax6");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(22);
  psi_needed_g_t[no_ps].resize(22);
  int needed_g_t_0[] = {   0,    1,    4,    5,    8,    9,   12,   13,   18,   19,   76,   77}; //  12
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_92");
  int needed_g_t_1[] = {   0,    1}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__34_1__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__34_1__16_76");
  int needed_g_t_2[] = {   2,    3,    6,    7,   10,   11,   14,   15,   16,   17,   78,   79}; //  12
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_3[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__66_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__66_1__16_44");
  int needed_g_t_4[] = {  40,   41,   44,   45,   48,   49,   54,   55,   56,   57,   62,   63,   64,   65,   68,   69,   72,   73,   88,   89}; //  20
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_5[] = {  40,   41,   44,   45,   48,   49,   68,   69}; //   8
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__32_28");
  int needed_g_t_6[] = {  40,   41}; //   2
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_65__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_65__16_12");
  int needed_g_t_7[] = {  42,   43,   46,   47,   50,   51,   52,   53,   58,   59,   60,   61,   66,   67,   70,   71,   74,   75,   90,   91}; //  20
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_8[] = {  42,   43,   46,   47,   50,   51,   70,   71}; //   8
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__64_28");
  int needed_g_t_9[] = {  42,   43}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_33__16_12");
  int needed_g_t_10[] = {  68,   69}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_34__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_34__16_12");
  int needed_g_t_11[] = {  70,   71}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_66__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_66__16_12");
  int needed_g_t_12[] = {  72,   73}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__65_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__65_2__16_44");
  int needed_g_t_13[] = {  74,   75}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__33_2__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__33_2__16_76");
  int needed_g_t_14[] = {  76,   77}; //   2
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__80_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__80_12");
  int needed_g_t_15[] = {  78,   79}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__48_12");
  int needed_g_t_16[] = {  80,   81}; //   2
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_76");
  int needed_g_t_17[] = {  82,   83}; //   2
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__80_44");
  int needed_g_t_18[] = {  84,   85}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__48_76");
  int needed_g_t_19[] = {  86,   87}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__80_44");
  int needed_g_t_20[] = {  88,   89}; //   2
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__48_12");
  int needed_g_t_21[] = {  90,   91}; //   2
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__80_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__80_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(19);
  psi_needed_g_d[no_ps].resize(19);
  int needed_g_d_0[] = {   0,    1,    8,    9,   26,   27,   36,   37,   58,   59,   74,   75,   80,   81,   84,   85}; //  16
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 16);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_1[] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19,   24,   25,   26,   27,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  60
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 60);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_2[] = {   2,    3,   10,   11,   24,   25,   38,   39,   56,   57,   72,   73,   82,   83,   86,   87}; //  16
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 16);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_3[] = {   4,    5,   12,   13,   20,   21,   28,   29,   52,   53,   60,   61}; //  12
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 12);
  psi_container_IS_name.push_back("costheta_of_decay_92__64_28");
  psi_container_IS_name.push_back("phi_of_decay_92__64_28");
  int needed_g_d_4[] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_5[] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 16);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_6[] = {   6,    7,   14,   15,   22,   23,   30,   31,   54,   55,   62,   63}; //  12
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 12);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_7[] = {   8,    9,   26,   27,   58,   59}; //   6
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 6);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_8[] = {  10,   11,   24,   25,   56,   57}; //   6
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 6);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_9[] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_10[] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 16);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_11[] = {  16,   17,   32,   33,   64,   65}; //   6
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 6);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_12[] = {  16,   17,   32,   33,   36,   37,   64,   65,   78,   79,   80,   81,   84,   85,   88,   89}; //  16
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 16);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_13[] = {  18,   19,   34,   35,   66,   67}; //   6
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 6);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_14[] = {  18,   19,   34,   35,   38,   39,   66,   67,   76,   77,   82,   83,   86,   87,   90,   91}; //  16
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 16);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");
  int needed_g_d_15[] = {  20,   21,   26,   27,   28,   29,   34,   35}; //   8
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 8);
  psi_container_IS_name.push_back("costheta_of_decay_124__32_92");
  psi_container_IS_name.push_back("phi_of_decay_124__32_92");
  int needed_g_d_16[] = {  22,   23,   24,   25,   30,   31,   32,   33}; //   8
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 8);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_17[] = {  36,   37}; //   2
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_18[] = {  38,   39}; //   2
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__80_44");
  psi_container_IS_name.push_back("phi_of_decay_124__80_44");

  psi_c_p[no_ps].resize(92);
  psi_c_f[no_ps].resize(92);
  psi_c_t[no_ps].resize(92);
  psi_c_d[no_ps].resize(92);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1}; //   2
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 2);

  int c_p_1[] = {  2,   1}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {  0}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  0,   1}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  0,   1}; //   2
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 2);

  int c_p_2[] = {  0,   3}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {  1}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  2,   3}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  2,   1}; //   2
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 2);

  int c_p_3[] = {  2,   3}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {  1}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  2,   3}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  2,   1}; //   2
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 2);

  int c_p_4[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  0}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  4,   7,   6}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  0}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  4,   5,   8}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  2}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  6,   4,   5}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  4,   7,   8}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  2}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  6,   4,   5}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  0,   1,   9}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  0}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  7,   0,   1}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  2,   1,   9}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  0}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  7,   0,   1}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  0,   3,  10}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  2}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  8,   2,   1}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  2,   3,  10}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  2}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  8,   2,   1}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = { 11,  12,   6}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  3,   9,  10}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = { 11,  13,   6}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  3,   9,  10}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = { 11,  12,   8}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  2}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  6,   9,  10}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = { 11,  13,   8}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  2}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  6,   9,  10}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  2}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = { 11,   1,  12}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = { 14,  17,  16}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  2}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = { 11,   1,  12}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = { 18,  19,  20}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  0}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = { 13,   1,  14}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = { 18,  21,  20}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  0}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = { 13,   1,  14}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = { 15,   3,   4,   5}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = {  4,   7,   6}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = { 15,   3,   4,   5}; //   4
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 4);

  int c_p_22[] = {  4,   5,   8}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = { 16,   6,   4,   5}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = {  4,   7,   8}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = { 16,   6,   4,   5}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = {  0,   3,  10}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {}; //   0
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 0);
  int c_d_24[] = { 16,   8,   2,   1}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = {  2,   3,  10}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {}; //   0
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 0);
  int c_d_25[] = { 16,   8,   2,   1}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = {  0,   1,   9}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {}; //   0
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 0);
  int c_d_26[] = { 15,   7,   0,   1}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = {  2,   1,   9}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {}; //   0
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 0);
  int c_d_27[] = { 15,   7,   0,   1}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = { 11,  12,   6}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {}; //   0
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 0);
  int c_d_28[] = { 15,   3,   9,  10}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = { 11,  13,   6}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {}; //   0
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 0);
  int c_d_29[] = { 15,   3,   9,  10}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = { 11,  12,   8}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {}; //   0
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 0);
  int c_d_30[] = { 16,   6,   9,  10}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = { 11,  13,   8}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {}; //   0
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 0);
  int c_d_31[] = { 16,   6,   9,  10}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  int c_p_32[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {}; //   0
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 0);
  int c_d_32[] = { 16,  11,   1,  12}; //   4
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 4);

  int c_p_33[] = { 14,  17,  16}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {}; //   0
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 0);
  int c_d_33[] = { 16,  11,   1,  12}; //   4
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 4);

  int c_p_34[] = { 18,  19,  20}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {}; //   0
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 0);
  int c_d_34[] = { 15,  13,   1,  14}; //   4
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 4);

  int c_p_35[] = { 18,  21,  20}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {}; //   0
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 0);
  int c_d_35[] = { 15,  13,   1,  14}; //   4
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 4);

  int c_p_36[] = {  0,   1,  22}; //   3
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 3);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {}; //   0
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 0);
  int c_d_36[] = { 17,  12,   0,   1}; //   4
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 4);

  int c_p_37[] = {  2,   1,  22}; //   3
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 3);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {}; //   0
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 0);
  int c_d_37[] = { 17,  12,   0,   1}; //   4
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 4);

  int c_p_38[] = {  0,   3,  23}; //   3
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 3);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {}; //   0
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 0);
  int c_d_38[] = { 18,  14,   2,   1}; //   4
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 4);

  int c_p_39[] = {  2,   3,  23}; //   3
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 3);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {}; //   0
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 0);
  int c_d_39[] = { 18,  14,   2,   1}; //   4
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 4);

  int c_p_40[] = {  0}; //   1
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 1);
  int c_f_40[] = {  2,   3}; //   2
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 2);
  int c_t_40[] = {  4,   5,   6}; //   3
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 3);
  int c_d_40[] = {  1}; //   1
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 1);

  int c_p_41[] = {  2}; //   1
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 1);
  int c_f_41[] = {  2,   3}; //   2
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 2);
  int c_t_41[] = {  4,   5,   6}; //   3
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 3);
  int c_d_41[] = {  1}; //   1
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 1);

  int c_p_42[] = {  0}; //   1
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 1);
  int c_f_42[] = {  2,   4}; //   2
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 2);
  int c_t_42[] = {  7,   8,   9}; //   3
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 3);
  int c_d_42[] = {  1}; //   1
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 1);

  int c_p_43[] = {  2}; //   1
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 1);
  int c_f_43[] = {  2,   4}; //   2
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 2);
  int c_t_43[] = {  7,   8,   9}; //   3
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 3);
  int c_d_43[] = {  1}; //   1
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 1);

  int c_p_44[] = {  4,   5}; //   2
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 2);
  int c_f_44[] = {  3}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = {  4,   5}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  4,   5}; //   2
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 2);

  int c_p_45[] = {  4,   7}; //   2
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 2);
  int c_f_45[] = {  3}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = {  4,   5}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  4,   5}; //   2
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 2);

  int c_p_46[] = {  4,   5}; //   2
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 2);
  int c_f_46[] = {  4}; //   1
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 1);
  int c_t_46[] = {  7,   8}; //   2
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 2);
  int c_d_46[] = {  4,   5}; //   2
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 2);

  int c_p_47[] = {  4,   7}; //   2
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 2);
  int c_f_47[] = {  4}; //   1
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 1);
  int c_t_47[] = {  7,   8}; //   2
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 2);
  int c_d_47[] = {  4,   5}; //   2
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 2);

  int c_p_48[] = { 11,  12}; //   2
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 2);
  int c_f_48[] = {  3}; //   1
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 1);
  int c_t_48[] = {  4,   5}; //   2
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 2);
  int c_d_48[] = {  9,  10}; //   2
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 2);

  int c_p_49[] = { 11,  13}; //   2
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 2);
  int c_f_49[] = {  3}; //   1
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 1);
  int c_t_49[] = {  4,   5}; //   2
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 2);
  int c_d_49[] = {  9,  10}; //   2
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 2);

  int c_p_50[] = { 11,  12}; //   2
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 2);
  int c_f_50[] = {  4}; //   1
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 1);
  int c_t_50[] = {  7,   8}; //   2
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 2);
  int c_d_50[] = {  9,  10}; //   2
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 2);

  int c_p_51[] = { 11,  13}; //   2
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 2);
  int c_f_51[] = {  4}; //   1
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 1);
  int c_t_51[] = {  7,   8}; //   2
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 2);
  int c_d_51[] = {  9,  10}; //   2
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 2);

  int c_p_52[] = {  4,   5,   6}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = {  7}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = {  4,   7,   6}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = {  7}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = {  4,   5,   8}; //   3
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 3);
  int c_f_54[] = {}; //   0
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 0);
  int c_t_54[] = {  4}; //   1
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 1);
  int c_d_54[] = {  6,   4,   5}; //   3
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 3);

  int c_p_55[] = {  4,   7,   8}; //   3
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 3);
  int c_f_55[] = {}; //   0
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 0);
  int c_t_55[] = {  4}; //   1
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 1);
  int c_d_55[] = {  6,   4,   5}; //   3
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 3);

  int c_p_56[] = {  0,   3,  10}; //   3
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 3);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = {  4}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = {  8,   2,   1}; //   3
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 3);

  int c_p_57[] = {  2,   3,  10}; //   3
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 3);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = {  4}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = {  8,   2,   1}; //   3
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 3);

  int c_p_58[] = {  0,   1,   9}; //   3
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 3);
  int c_f_58[] = {}; //   0
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 0);
  int c_t_58[] = {  7}; //   1
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 1);
  int c_d_58[] = {  7,   0,   1}; //   3
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 3);

  int c_p_59[] = {  2,   1,   9}; //   3
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 3);
  int c_f_59[] = {}; //   0
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 0);
  int c_t_59[] = {  7}; //   1
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 1);
  int c_d_59[] = {  7,   0,   1}; //   3
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 3);

  int c_p_60[] = { 11,  12,   6}; //   3
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 3);
  int c_f_60[] = {}; //   0
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 0);
  int c_t_60[] = {  7}; //   1
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 1);
  int c_d_60[] = {  3,   9,  10}; //   3
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 3);

  int c_p_61[] = { 11,  13,   6}; //   3
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 3);
  int c_f_61[] = {}; //   0
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 0);
  int c_t_61[] = {  7}; //   1
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 1);
  int c_d_61[] = {  3,   9,  10}; //   3
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 3);

  int c_p_62[] = { 11,  12,   8}; //   3
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 3);
  int c_f_62[] = {}; //   0
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 0);
  int c_t_62[] = {  4}; //   1
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 1);
  int c_d_62[] = {  6,   9,  10}; //   3
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 3);

  int c_p_63[] = { 11,  13,   8}; //   3
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 3);
  int c_f_63[] = {}; //   0
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 0);
  int c_t_63[] = {  4}; //   1
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 1);
  int c_d_63[] = {  6,   9,  10}; //   3
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 3);

  int c_p_64[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 3);
  int c_f_64[] = {}; //   0
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 0);
  int c_t_64[] = {  4}; //   1
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 1);
  int c_d_64[] = { 11,   1,  12}; //   3
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 3);

  int c_p_65[] = { 14,  17,  16}; //   3
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 3);
  int c_f_65[] = {}; //   0
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 0);
  int c_t_65[] = {  4}; //   1
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 1);
  int c_d_65[] = { 11,   1,  12}; //   3
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 3);

  int c_p_66[] = { 18,  19,  20}; //   3
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 3);
  int c_f_66[] = {}; //   0
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 0);
  int c_t_66[] = {  7}; //   1
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 1);
  int c_d_66[] = { 13,   1,  14}; //   3
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 3);

  int c_p_67[] = { 18,  21,  20}; //   3
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 3);
  int c_f_67[] = {}; //   0
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 0);
  int c_t_67[] = {  7}; //   1
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 1);
  int c_d_67[] = { 13,   1,  14}; //   3
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 3);

  int c_p_68[] = {  0}; //   1
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 1);
  int c_f_68[] = {  2,   3}; //   2
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 2);
  int c_t_68[] = {  4,   5,  10}; //   3
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 3);
  int c_d_68[] = {  1}; //   1
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 1);

  int c_p_69[] = {  2}; //   1
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 1);
  int c_f_69[] = {  2,   3}; //   2
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 2);
  int c_t_69[] = {  4,   5,  10}; //   3
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 3);
  int c_d_69[] = {  1}; //   1
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 1);

  int c_p_70[] = {  0}; //   1
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 1);
  int c_f_70[] = {  2,   4}; //   2
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 2);
  int c_t_70[] = {  7,   8,  11}; //   3
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 3);
  int c_d_70[] = {  1}; //   1
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 1);

  int c_p_71[] = {  2}; //   1
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 1);
  int c_f_71[] = {  2,   4}; //   2
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 2);
  int c_t_71[] = {  7,   8,  11}; //   3
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 3);
  int c_d_71[] = {  1}; //   1
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 1);

  int c_p_72[] = {  0,   3}; //   2
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 2);
  int c_f_72[] = {  1}; //   1
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 1);
  int c_t_72[] = {  4,  12}; //   2
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 2);
  int c_d_72[] = {  2,   1}; //   2
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 2);

  int c_p_73[] = {  2,   3}; //   2
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 2);
  int c_f_73[] = {  1}; //   1
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 1);
  int c_t_73[] = {  4,  12}; //   2
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 2);
  int c_d_73[] = {  2,   1}; //   2
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 2);

  int c_p_74[] = {  0,   1}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = {  0}; //   1
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 1);
  int c_t_74[] = {  7,  13}; //   2
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 2);
  int c_d_74[] = {  0,   1}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = {  2,   1}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = {  0}; //   1
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 1);
  int c_t_75[] = {  7,  13}; //   2
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 2);
  int c_d_75[] = {  0,   1}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = {  0,  24}; //   2
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 2);
  int c_f_76[] = {  5}; //   1
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 1);
  int c_t_76[] = {  0,  14}; //   2
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 2);
  int c_d_76[] = { 14,   1}; //   2
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 2);

  int c_p_77[] = {  2,  24}; //   2
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 2);
  int c_f_77[] = {  5}; //   1
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 1);
  int c_t_77[] = {  0,  14}; //   2
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 2);
  int c_d_77[] = { 14,   1}; //   2
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 2);

  int c_p_78[] = {  0,  25}; //   2
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 2);
  int c_f_78[] = {  6}; //   1
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 1);
  int c_t_78[] = {  2,  15}; //   2
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 2);
  int c_d_78[] = { 12,   1}; //   2
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 2);

  int c_p_79[] = {  2,  25}; //   2
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 2);
  int c_f_79[] = {  6}; //   1
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 1);
  int c_t_79[] = {  2,  15}; //   2
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 2);
  int c_d_79[] = { 12,   1}; //   2
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 2);

  int c_p_80[] = {  0,   1,  22}; //   3
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 3);
  int c_f_80[] = {}; //   0
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 0);
  int c_t_80[] = { 16}; //   1
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 1);
  int c_d_80[] = { 12,   0,   1}; //   3
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 3);

  int c_p_81[] = {  2,   1,  22}; //   3
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 3);
  int c_f_81[] = {}; //   0
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 0);
  int c_t_81[] = { 16}; //   1
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 1);
  int c_d_81[] = { 12,   0,   1}; //   3
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 3);

  int c_p_82[] = {  0,   3,  23}; //   3
  psi_c_p[no_ps][82] = get_vector_from_array_int(c_p_82, 3);
  int c_f_82[] = {}; //   0
  psi_c_f[no_ps][82] = get_vector_from_array_int(c_f_82, 0);
  int c_t_82[] = { 17}; //   1
  psi_c_t[no_ps][82] = get_vector_from_array_int(c_t_82, 1);
  int c_d_82[] = { 14,   2,   1}; //   3
  psi_c_d[no_ps][82] = get_vector_from_array_int(c_d_82, 3);

  int c_p_83[] = {  2,   3,  23}; //   3
  psi_c_p[no_ps][83] = get_vector_from_array_int(c_p_83, 3);
  int c_f_83[] = {}; //   0
  psi_c_f[no_ps][83] = get_vector_from_array_int(c_f_83, 0);
  int c_t_83[] = { 17}; //   1
  psi_c_t[no_ps][83] = get_vector_from_array_int(c_t_83, 1);
  int c_d_83[] = { 14,   2,   1}; //   3
  psi_c_d[no_ps][83] = get_vector_from_array_int(c_d_83, 3);

  int c_p_84[] = { 14,  15,  26}; //   3
  psi_c_p[no_ps][84] = get_vector_from_array_int(c_p_84, 3);
  int c_f_84[] = {}; //   0
  psi_c_f[no_ps][84] = get_vector_from_array_int(c_f_84, 0);
  int c_t_84[] = { 18}; //   1
  psi_c_t[no_ps][84] = get_vector_from_array_int(c_t_84, 1);
  int c_d_84[] = {  0,   1,  12}; //   3
  psi_c_d[no_ps][84] = get_vector_from_array_int(c_d_84, 3);

  int c_p_85[] = { 14,  17,  26}; //   3
  psi_c_p[no_ps][85] = get_vector_from_array_int(c_p_85, 3);
  int c_f_85[] = {}; //   0
  psi_c_f[no_ps][85] = get_vector_from_array_int(c_f_85, 0);
  int c_t_85[] = { 18}; //   1
  psi_c_t[no_ps][85] = get_vector_from_array_int(c_t_85, 1);
  int c_d_85[] = {  0,   1,  12}; //   3
  psi_c_d[no_ps][85] = get_vector_from_array_int(c_d_85, 3);

  int c_p_86[] = { 18,  19,  27}; //   3
  psi_c_p[no_ps][86] = get_vector_from_array_int(c_p_86, 3);
  int c_f_86[] = {}; //   0
  psi_c_f[no_ps][86] = get_vector_from_array_int(c_f_86, 0);
  int c_t_86[] = { 19}; //   1
  psi_c_t[no_ps][86] = get_vector_from_array_int(c_t_86, 1);
  int c_d_86[] = {  2,   1,  14}; //   3
  psi_c_d[no_ps][86] = get_vector_from_array_int(c_d_86, 3);

  int c_p_87[] = { 18,  21,  27}; //   3
  psi_c_p[no_ps][87] = get_vector_from_array_int(c_p_87, 3);
  int c_f_87[] = {}; //   0
  psi_c_f[no_ps][87] = get_vector_from_array_int(c_f_87, 0);
  int c_t_87[] = { 19}; //   1
  psi_c_t[no_ps][87] = get_vector_from_array_int(c_t_87, 1);
  int c_d_87[] = {  2,   1,  14}; //   3
  psi_c_d[no_ps][87] = get_vector_from_array_int(c_d_87, 3);

  int c_p_88[] = { 14,  15}; //   2
  psi_c_p[no_ps][88] = get_vector_from_array_int(c_p_88, 2);
  int c_f_88[] = {  6}; //   1
  psi_c_f[no_ps][88] = get_vector_from_array_int(c_f_88, 1);
  int c_t_88[] = {  4,  20}; //   2
  psi_c_t[no_ps][88] = get_vector_from_array_int(c_t_88, 2);
  int c_d_88[] = {  1,  12}; //   2
  psi_c_d[no_ps][88] = get_vector_from_array_int(c_d_88, 2);

  int c_p_89[] = { 14,  17}; //   2
  psi_c_p[no_ps][89] = get_vector_from_array_int(c_p_89, 2);
  int c_f_89[] = {  6}; //   1
  psi_c_f[no_ps][89] = get_vector_from_array_int(c_f_89, 1);
  int c_t_89[] = {  4,  20}; //   2
  psi_c_t[no_ps][89] = get_vector_from_array_int(c_t_89, 2);
  int c_d_89[] = {  1,  12}; //   2
  psi_c_d[no_ps][89] = get_vector_from_array_int(c_d_89, 2);

  int c_p_90[] = { 18,  19}; //   2
  psi_c_p[no_ps][90] = get_vector_from_array_int(c_p_90, 2);
  int c_f_90[] = {  5}; //   1
  psi_c_f[no_ps][90] = get_vector_from_array_int(c_f_90, 1);
  int c_t_90[] = {  7,  21}; //   2
  psi_c_t[no_ps][90] = get_vector_from_array_int(c_t_90, 2);
  int c_d_90[] = {  1,  14}; //   2
  psi_c_d[no_ps][90] = get_vector_from_array_int(c_d_90, 2);

  int c_p_91[] = { 18,  21}; //   2
  psi_c_p[no_ps][91] = get_vector_from_array_int(c_p_91, 2);
  int c_f_91[] = {  5}; //   1
  psi_c_f[no_ps][91] = get_vector_from_array_int(c_f_91, 1);
  int c_t_91[] = {  7,  21}; //   2
  psi_c_t[no_ps][91] = get_vector_from_array_int(c_t_91, 2);
  int c_d_91[] = {  1,  14}; //   2
  psi_c_d[no_ps][91] = get_vector_from_array_int(c_d_91, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
