#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_ax_psp_230_gux_emepagux(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_ax_psp_230_gux_emepagux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(21);
  psi_needed_v_smin[no_ps].resize(21);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    6,    7,    8,    9,   12,   13,   14,   15,   18,   19,   20,   21,   24,   25,   26,   27,   28,   29,   30,   31,   36,   37,   38,   39,   42,   43,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  60
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 60);
  int needed_v_smin_1[] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   42,   43,   48,   49,   54,   55}; //  18
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 18);
  int needed_v_smin_2[] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 16);
  int needed_v_smin_3[] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 16);
  int needed_v_smin_4[] = {   4,    5,   10,   11,   16,   17,   22,   23,   46,   47,   50,   51,   60,   61,   64,   65}; //  16
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 16);
  int needed_v_smin_5[] = {   6,    7,   18,   19,    2,    3}; //   6
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 6);
  int needed_v_smin_6[] = {   8,    9,   20,   21,   48,   49,    0,    1,   42,   43,   54,   55}; //  12
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 12);
  int needed_v_smin_7[] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 16);
  int needed_v_smin_8[] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 16);
  int needed_v_smin_9[] = {  12,   13,   24,   25,   30,   31,   52,   53,   76,   77,   82,   83,   88,   89,   90,   91,   70,   71}; //  18
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 18);
  int needed_v_smin_10[] = {  12,   13,   24,   25,   52,   53,   70,   71,   76,   77,   90,   91}; //  12
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 12);
  int needed_v_smin_11[] = {  14,   15,   26,   27,   28,   29,   32,   33,   34,   35,   74,   75,   78,   79,   80,   81,   84,   85,   86,   87}; //  20
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 20);
  int needed_v_smin_12[] = {  14,   15,   26,   27,   74,   75}; //   6
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 6);
  int needed_v_smin_13[] = {  28,   29,   86,   87}; //   4
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 4);
  int needed_v_smin_14[] = {  30,   31,   88,   89}; //   4
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {  36,   37,   58,   59,   84,   85}; //   6
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 6);
  int needed_v_smin_16[] = {  36,   37,   40,   41,   44,   45,   58,   59,   62,   63,   66,   67}; //  12
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 12);
  int needed_v_smin_17[] = {  38,   39,   56,   57,   82,   83}; //   6
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 6);
  int needed_v_smin_18[] = {  38,   39,   56,   57}; //   4
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 4);
  int needed_v_smin_19[] = {  68,   69,   72,   73}; //   4
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 4);
  int needed_v_smin_20[] = {  68,   69,   72,   73}; //   4
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 4);

  psi_v_smax[no_ps].resize(22);
  psi_needed_v_smax[no_ps].resize(22);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   36,   37,   38,   39,   42,   43,   48,   49,   54,   55,   56,   57,   58,   59,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  46
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 46);
  int needed_v_smax_1[] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   42,   43,   48,   49,   54,   55}; //  18
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 18);
  int needed_v_smax_2[] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 16);
  int needed_v_smax_3[] = {   4,    5,   10,   11,   16,   17,   22,   23,   32,   33,   34,   35,   40,   41,   44,   45,   46,   47,   50,   51,   60,   61,   62,   63,   64,   65,   66,   67,   78,   79,   80,   81,   36,   37,   58,   59}; //  36
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 36);
  int needed_v_smax_4[] = {   4,    5,    8,    9,   10,   11,   12,   13,   16,   17,   20,   21,   22,   23,   24,   25,   46,   47,   48,   49,   50,   51,   52,   53,    0,    1,   42,   43,   54,   55,   60,   61,   64,   65,   70,   71,   76,   77,   90,   91}; //  40
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 40);
  int needed_v_smax_5[] = {   6,    7,   14,   15,   18,   19,   26,   27,    2,    3,   74,   75}; //  12
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 12);
  int needed_v_smax_6[] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 16);
  int needed_v_smax_7[] = {  12,   13,   24,   25,   30,   31,   52,   53}; //   8
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 8);
  int needed_v_smax_8[] = {  12,   13,   24,   25,   52,   53}; //   6
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 6);
  int needed_v_smax_9[] = {  14,   15,   26,   27,   28,   29}; //   6
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 6);
  int needed_v_smax_10[] = {  14,   15,   26,   27}; //   4
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 4);
  int needed_v_smax_11[] = {  28,   29,   30,   31}; //   4
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  28,   29,   30,   31}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  32,   33,   34,   35,   78,   79,   80,   81}; //   8
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 8);
  int needed_v_smax_14[] = {  74,   75,   84,   85,   86,   87}; //   6
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 6);
  int needed_v_smax_15[] = {  76,   77,   82,   83,   88,   89,   90,   91,   70,   71}; //  10
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 10);
  int needed_v_smax_16[] = {  86,   87,   88,   89}; //   4
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);
  int needed_v_smax_17[] = {  36,   37,   38,   39,   40,   41,   44,   45,   56,   57,   58,   59,   62,   63,   66,   67,   68,   69,   72,   73}; //  20
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 20);
  int needed_v_smax_18[] = {  38,   39,   56,   57}; //   4
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 4);
  int needed_v_smax_19[] = {  68,   69,   72,   73}; //   4
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 4);
  int needed_v_smax_20[] = {  82,   83}; //   2
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 2);
  int needed_v_smax_21[] = {  84,   85}; //   2
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(29);
  psi_needed_g_p[no_ps].resize(29);
  int needed_g_p_0[] = {   0,    2,    6,    8,   18,   20,   36,   38,   42,   48,   54,   56,   58,   68,   70,   72,   74,   76,   82,   84,   86,   88,   90}; //  23
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 23);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   42,   43,   48,   49}; //  16
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 16);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   1,    3,    7,    9,   19,   21,   37,   39,   43,   49,   55,   57,   59,   69,   71,   73,   75,   77,   83,   85,   87,   89,   91}; //  23
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 23);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_3[] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 16);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_4[] = {   4,   16,   32,   40,   46,   60,   62,   78}; //   8
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 8);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {   4,    5,   10,   11,   16,   17,   22,   23,   46,   47,   50,   51}; //  12
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 12);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_6[] = {   5,   17,   33,   41,   47,   61,   63,   79}; //   8
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 8);
  psi_container_IS_name.push_back("propagator_23_smin3_smax3");
  int needed_g_p_7[] = {   6,    7,   18,   19}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_8[] = {   8,    9,   20,   21,   48,   49}; //   6
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 6);
  psi_container_IS_name.push_back("propagator_0_smin6_smax4");
  int needed_g_p_9[] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 16);
  psi_container_IS_name.push_back("propagator_0_smin7_smax6");
  int needed_g_p_10[] = {  10,   22,   34,   44,   50,   64,   66,   80}; //   8
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 8);
  psi_container_IS_name.push_back("propagator_0_smin8_smax3");
  int needed_g_p_11[] = {  11,   23,   35,   45,   51,   65,   67,   81}; //   8
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 8);
  psi_container_IS_name.push_back("propagator_23_smin8_smax3");
  int needed_g_p_12[] = {  12,   13,   24,   25,   30,   31,   52,   53}; //   8
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 8);
  psi_container_IS_name.push_back("propagator_0_smin9_smax7");
  int needed_g_p_13[] = {  12,   24,   52}; //   3
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax8");
  int needed_g_p_14[] = {  12,   13,   24,   25,   52,   53}; //   6
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 6);
  psi_container_IS_name.push_back("propagator_0_smin10_smax4");
  int needed_g_p_15[] = {  13,   25,   53}; //   3
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 3);
  psi_container_IS_name.push_back("propagator_23_smin0_smax8");
  int needed_g_p_16[] = {  14,   15,   26,   27,   28,   29}; //   6
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 6);
  psi_container_IS_name.push_back("propagator_0_smin11_smax9");
  int needed_g_p_17[] = {  14,   26}; //   2
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax10");
  int needed_g_p_18[] = {  14,   15,   26,   27}; //   4
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 4);
  psi_container_IS_name.push_back("propagator_0_smin12_smax5");
  int needed_g_p_19[] = {  15,   27}; //   2
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax10");
  int needed_g_p_20[] = {  28,   29}; //   2
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax11");
  int needed_g_p_21[] = {  28,   30}; //   2
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax12");
  int needed_g_p_22[] = {  29,   31}; //   2
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax12");
  int needed_g_p_23[] = {  30,   31}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_0_smin14_smax11");
  int needed_g_p_24[] = {  32,   33,   34,   35,   78,   79,   80,   81}; //   8
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 8);
  psi_container_IS_name.push_back("propagator_0_smin11_smax13");
  int needed_g_p_25[] = {  74,   75,   84,   85,   86,   87}; //   6
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 6);
  psi_container_IS_name.push_back("propagator_0_smin11_smax14");
  int needed_g_p_26[] = {  76,   77,   82,   83,   88,   89,   90,   91}; //   8
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 8);
  psi_container_IS_name.push_back("propagator_0_smin9_smax15");
  int needed_g_p_27[] = {  86,   87}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax16");
  int needed_g_p_28[] = {  88,   89}; //   2
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 2);
  psi_container_IS_name.push_back("propagator_0_smin14_smax16");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(15);
  psi_needed_g_f[no_ps].resize(15);
  int needed_g_f_0[] = {   0,    1,   42,   43,   54,   55}; //   6
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax4");
  int needed_g_f_1[] = {   2,    3}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax5");
  int needed_g_f_2[] = {  36,   37,   58,   59}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax3");
  int needed_g_f_3[] = {  36,   37,   40,   41,   44,   45,   58,   59,   62,   63,   66,   67}; //  12
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 12);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax17");
  int needed_g_f_4[] = {  38,   39,   56,   57}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax18");
  int needed_g_f_5[] = {  38,   39,   56,   57}; //   4
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax17");
  int needed_g_f_6[] = {  54,   55}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");
  int needed_g_f_7[] = {  60,   61,   64,   65}; //   4
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax4");
  int needed_g_f_8[] = {  68,   69,   72,   73}; //   4
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax19");
  int needed_g_f_9[] = {  68,   69,   72,   73}; //   4
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax17");
  int needed_g_f_10[] = {  70,   71}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax15");
  int needed_g_f_11[] = {  70,   71,   76,   77,   90,   91}; //   6
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax4");
  int needed_g_f_12[] = {  74,   75}; //   2
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax5");
  int needed_g_f_13[] = {  82,   83}; //   2
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax20");
  int needed_g_f_14[] = {  84,   85}; //   2
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax21");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(28);
  psi_needed_g_t[no_ps].resize(28);
  int needed_g_t_0[] = {   0,    1,    4,    5,    8,    9,   10,   11,   12,   13,   76,   77}; //  12
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_92");
  int needed_g_t_1[] = {   0,    1}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__34_1__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__34_1__16_76");
  int needed_g_t_2[] = {   2,    3,    6,    7,   14,   15,   74,   75}; //   8
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_108");
  int needed_g_t_3[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__18_1__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__18_1__32_76");
  int needed_g_t_4[] = {  36,   37,   38,   39,   40,   41,   44,   45,   56,   57,   58,   59,   62,   63,   66,   67,   68,   69,   72,   73}; //  20
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_5[] = {  36,   37,   40,   41,   44,   45,   58,   59}; //   8
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__32_28");
  int needed_g_t_6[] = {  36,   37}; //   2
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_65__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_65__16_12");
  int needed_g_t_7[] = {  38,   39,   56,   57}; //   4
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__16_44");
  int needed_g_t_8[] = {  38,   39}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_65__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_65__32_12");
  int needed_g_t_9[] = {  42,   43,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   60,   61,   64,   65,   70,   71,   90,   91}; //  20
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_10[] = {  42,   43,   54,   55}; //   4
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_76");
  int needed_g_t_11[] = {  54,   55}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__64_12");
  int needed_g_t_12[] = {  56,   57}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_18__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_18__32_12");
  int needed_g_t_13[] = {  58,   59}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_34__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_34__16_12");
  int needed_g_t_14[] = {  60,   61,   64,   65}; //   4
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__33_2__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__33_2__64_28");
  int needed_g_t_15[] = {  62,   63,   66,   67}; //   4
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__65_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__65_2__32_28");
  int needed_g_t_16[] = {  68,   69,   72,   73}; //   4
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__12_48");
  int needed_g_t_17[] = {  68,   69}; //   2
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_14__16_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_14__16_32");
  int needed_g_t_18[] = {  70,   71,   90,   91}; //   4
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_80");
  int needed_g_t_19[] = {  70,   71}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_14__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_14__64_16");
  int needed_g_t_20[] = {  72,   73}; //   2
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_14__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_14__32_16");
  int needed_g_t_21[] = {  74,   75}; //   2
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__96_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__96_12");
  int needed_g_t_22[] = {  76,   77}; //   2
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__80_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__80_12");
  int needed_g_t_23[] = {  78,   79,   80,   81,   84,   85}; //   6
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__96_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__96_28");
  int needed_g_t_24[] = {  82,   83}; //   2
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__80_44");
  int needed_g_t_25[] = {  82,   83}; //   2
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_81__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_81__12_32");
  int needed_g_t_26[] = {  84,   85}; //   2
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_97__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_97__12_16");
  int needed_g_t_27[] = {  86,   87,   88,   89}; //   4
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__12_112");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(19);
  psi_needed_g_d[no_ps].resize(19);
  int needed_g_d_0[] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   42,   43,   48,   49}; //  16
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 16);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_1[] = {   0,    1,    2,    3,    6,    7,    8,    9,   12,   13,   14,   15,   18,   19,   20,   21,   24,   25,   26,   27,   28,   29,   30,   31,   36,   37,   38,   39,   42,   43,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  60
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 60);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_2[] = {   4,    5,   10,   11,   16,   17,   22,   23,   46,   47,   50,   51}; //  12
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 12);
  psi_container_IS_name.push_back("costheta_of_decay_92__64_28");
  psi_container_IS_name.push_back("phi_of_decay_92__64_28");
  int needed_g_d_3[] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_4[] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 16);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_5[] = {   6,    7,   18,   19}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_108__32_76");
  psi_container_IS_name.push_back("phi_of_decay_108__32_76");
  int needed_g_d_6[] = {   8,    9,   20,   21,   48,   49}; //   6
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 6);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_7[] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_8[] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 16);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_9[] = {  12,   13,   24,   25,   52,   53}; //   6
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 6);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_10[] = {  12,   13,   24,   25,   30,   31,   52,   53,   76,   77,   82,   83,   88,   89,   90,   91}; //  16
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 16);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");
  int needed_g_d_11[] = {  14,   15,   26,   27}; //   4
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 4);
  psi_container_IS_name.push_back("costheta_of_decay_108__12_96");
  psi_container_IS_name.push_back("phi_of_decay_108__12_96");
  int needed_g_d_12[] = {  14,   15,   26,   27,   28,   29,   32,   33,   34,   35,   74,   75,   78,   79,   80,   81,   84,   85,   86,   87}; //  20
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 20);
  psi_container_IS_name.push_back("costheta_of_decay_96__32_64");
  psi_container_IS_name.push_back("phi_of_decay_96__32_64");
  int needed_g_d_13[] = {  16,   17,   20,   21,   22,   23,   24,   25}; //   8
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 8);
  psi_container_IS_name.push_back("costheta_of_decay_124__32_92");
  psi_container_IS_name.push_back("phi_of_decay_124__32_92");
  int needed_g_d_14[] = {  18,   19,   26,   27}; //   4
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__16_108");
  psi_container_IS_name.push_back("phi_of_decay_124__16_108");
  int needed_g_d_15[] = {  28,   29,   30,   31}; //   4
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__12_112");
  psi_container_IS_name.push_back("phi_of_decay_124__12_112");
  int needed_g_d_16[] = {  28,   29,   86,   87}; //   4
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 4);
  psi_container_IS_name.push_back("costheta_of_decay_112__16_96");
  psi_container_IS_name.push_back("phi_of_decay_112__16_96");
  int needed_g_d_17[] = {  30,   31,   88,   89}; //   4
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 4);
  psi_container_IS_name.push_back("costheta_of_decay_112__32_80");
  psi_container_IS_name.push_back("phi_of_decay_112__32_80");
  int needed_g_d_18[] = {  32,   33,   34,   35}; //   4
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__96_28");
  psi_container_IS_name.push_back("phi_of_decay_124__96_28");

  psi_c_p[no_ps].resize(92);
  psi_c_f[no_ps].resize(92);
  psi_c_t[no_ps].resize(92);
  psi_c_d[no_ps].resize(92);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1}; //   2
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 2);

  int c_p_1[] = {  2,   1}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {  0}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  0,   1}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  0,   1}; //   2
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 2);

  int c_p_2[] = {  0,   1}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {  1}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  2,   3}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  0,   1}; //   2
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 2);

  int c_p_3[] = {  2,   1}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {  1}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  2,   3}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  0,   1}; //   2
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 2);

  int c_p_4[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  0}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  2,   3,   4}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  3,   6,   5}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  0}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  2,   3,   4}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  0,   1,   7}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  2}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  5,   0,   1}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  2,   1,   7}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  2}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  5,   0,   1}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  0,   1,   8}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  0}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  6,   0,   1}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  2,   1,   8}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  0}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  6,   0,   1}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  9,  10,   5}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  0}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  2,   7,   8}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  9,  11,   5}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  2,   7,   8}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = { 12,  13,  14}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  9,   1,  10}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = { 12,  15,  14}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  9,   1,  10}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = { 16,  17,  18}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  2}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = { 11,   1,  12}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = { 16,  19,  18}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  2}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = { 11,   1,  12}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = { 13,   2,   3,   4}; //   4
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 4);

  int c_p_17[] = {  3,   6,   5}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = { 13,   2,   3,   4}; //   4
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 4);

  int c_p_18[] = {  0,   1,   7}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = { 14,   5,   0,   1}; //   4
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 4);

  int c_p_19[] = {  2,   1,   7}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = { 14,   5,   0,   1}; //   4
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 4);

  int c_p_20[] = {  0,   1,   8}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = { 13,   6,   0,   1}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = {  2,   1,   8}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = { 13,   6,   0,   1}; //   4
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 4);

  int c_p_22[] = {  9,  10,   5}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = { 13,   2,   7,   8}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = {  9,  11,   5}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = { 13,   2,   7,   8}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = { 12,  13,  14}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {}; //   0
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 0);
  int c_d_24[] = { 13,   9,   1,  10}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = { 12,  15,  14}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {}; //   0
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 0);
  int c_d_25[] = { 13,   9,   1,  10}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = { 16,  17,  18}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {}; //   0
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 0);
  int c_d_26[] = { 14,  11,   1,  12}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = { 16,  19,  18}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {}; //   0
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 0);
  int c_d_27[] = { 14,  11,   1,  12}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = { 16,  20,  21}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {}; //   0
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 0);
  int c_d_28[] = { 15,   1,  16,  12}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = { 16,  20,  22}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {}; //   0
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 0);
  int c_d_29[] = { 15,   1,  16,  12}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = { 12,  23,  21}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {}; //   0
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 0);
  int c_d_30[] = { 15,   1,  17,  10}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = { 12,  23,  22}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {}; //   0
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 0);
  int c_d_31[] = { 15,   1,  17,  10}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  int c_p_32[] = {  3,   4,  24}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {}; //   0
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 0);
  int c_d_32[] = { 18,  12,   3,   4}; //   4
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 4);

  int c_p_33[] = {  3,   6,  24}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {}; //   0
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 0);
  int c_d_33[] = { 18,  12,   3,   4}; //   4
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 4);

  int c_p_34[] = {  9,  10,  24}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {}; //   0
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 0);
  int c_d_34[] = { 18,  12,   7,   8}; //   4
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 4);

  int c_p_35[] = {  9,  11,  24}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {}; //   0
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 0);
  int c_d_35[] = { 18,  12,   7,   8}; //   4
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 4);

  int c_p_36[] = {  0}; //   1
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 1);
  int c_f_36[] = {  2,   3}; //   2
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 2);
  int c_t_36[] = {  4,   5,   6}; //   3
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 3);
  int c_d_36[] = {  1}; //   1
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 1);

  int c_p_37[] = {  2}; //   1
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 1);
  int c_f_37[] = {  2,   3}; //   2
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 2);
  int c_t_37[] = {  4,   5,   6}; //   3
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 3);
  int c_d_37[] = {  1}; //   1
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 1);

  int c_p_38[] = {  0}; //   1
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 1);
  int c_f_38[] = {  4,   5}; //   2
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 2);
  int c_t_38[] = {  4,   7,   8}; //   3
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 3);
  int c_d_38[] = {  1}; //   1
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 1);

  int c_p_39[] = {  2}; //   1
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 1);
  int c_f_39[] = {  4,   5}; //   2
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 2);
  int c_t_39[] = {  4,   7,   8}; //   3
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 3);
  int c_d_39[] = {  1}; //   1
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 1);

  int c_p_40[] = {  3,   4}; //   2
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 2);
  int c_f_40[] = {  3}; //   1
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 1);
  int c_t_40[] = {  4,   5}; //   2
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 2);
  int c_d_40[] = {  3,   4}; //   2
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 2);

  int c_p_41[] = {  3,   6}; //   2
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 2);
  int c_f_41[] = {  3}; //   1
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 1);
  int c_t_41[] = {  4,   5}; //   2
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 2);
  int c_d_41[] = {  3,   4}; //   2
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 2);

  int c_p_42[] = {  0,   1}; //   2
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 2);
  int c_f_42[] = {  0}; //   1
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 1);
  int c_t_42[] = {  9,  10}; //   2
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 2);
  int c_d_42[] = {  0,   1}; //   2
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 2);

  int c_p_43[] = {  2,   1}; //   2
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 2);
  int c_f_43[] = {  0}; //   1
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 1);
  int c_t_43[] = {  9,  10}; //   2
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 2);
  int c_d_43[] = {  0,   1}; //   2
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 2);

  int c_p_44[] = {  9,  10}; //   2
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 2);
  int c_f_44[] = {  3}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = {  4,   5}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  7,   8}; //   2
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 2);

  int c_p_45[] = {  9,  11}; //   2
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 2);
  int c_f_45[] = {  3}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = {  4,   5}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  7,   8}; //   2
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 2);

  int c_p_46[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {}; //   0
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 0);
  int c_t_46[] = {  9}; //   1
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 1);
  int c_d_46[] = {  2,   3,   4}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = {  3,   6,   5}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {}; //   0
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 0);
  int c_t_47[] = {  9}; //   1
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 1);
  int c_d_47[] = {  2,   3,   4}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = {  0,   1,   8}; //   3
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 3);
  int c_f_48[] = {}; //   0
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 0);
  int c_t_48[] = {  9}; //   1
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 1);
  int c_d_48[] = {  6,   0,   1}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = {  2,   1,   8}; //   3
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 3);
  int c_f_49[] = {}; //   0
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 0);
  int c_t_49[] = {  9}; //   1
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 1);
  int c_d_49[] = {  6,   0,   1}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = {  9,  10,   5}; //   3
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 3);
  int c_f_50[] = {}; //   0
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 0);
  int c_t_50[] = {  9}; //   1
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 1);
  int c_d_50[] = {  2,   7,   8}; //   3
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 3);

  int c_p_51[] = {  9,  11,   5}; //   3
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 3);
  int c_f_51[] = {}; //   0
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 0);
  int c_t_51[] = {  9}; //   1
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 1);
  int c_d_51[] = {  2,   7,   8}; //   3
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 3);

  int c_p_52[] = { 12,  13,  14}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = {  9}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = {  9,   1,  10}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = { 12,  15,  14}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = {  9}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = {  9,   1,  10}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = {  0}; //   1
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 1);
  int c_f_54[] = {  6,   0}; //   2
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 2);
  int c_t_54[] = {  9,  10,  11}; //   3
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 3);
  int c_d_54[] = {  1}; //   1
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 1);

  int c_p_55[] = {  2}; //   1
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 1);
  int c_f_55[] = {  6,   0}; //   2
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 2);
  int c_t_55[] = {  9,  10,  11}; //   3
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 3);
  int c_d_55[] = {  1}; //   1
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 1);

  int c_p_56[] = {  0}; //   1
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 1);
  int c_f_56[] = {  4,   5}; //   2
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 2);
  int c_t_56[] = {  4,   7,  12}; //   3
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 3);
  int c_d_56[] = {  1}; //   1
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 1);

  int c_p_57[] = {  2}; //   1
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 1);
  int c_f_57[] = {  4,   5}; //   2
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 2);
  int c_t_57[] = {  4,   7,  12}; //   3
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 3);
  int c_d_57[] = {  1}; //   1
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 1);

  int c_p_58[] = {  0}; //   1
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 1);
  int c_f_58[] = {  2,   3}; //   2
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 2);
  int c_t_58[] = {  4,   5,  13}; //   3
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 3);
  int c_d_58[] = {  1}; //   1
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 1);

  int c_p_59[] = {  2}; //   1
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 1);
  int c_f_59[] = {  2,   3}; //   2
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 2);
  int c_t_59[] = {  4,   5,  13}; //   3
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 3);
  int c_d_59[] = {  1}; //   1
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 1);

  int c_p_60[] = {  3,   4}; //   2
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 2);
  int c_f_60[] = {  7}; //   1
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 1);
  int c_t_60[] = {  9,  14}; //   2
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 2);
  int c_d_60[] = {  3,   4}; //   2
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 2);

  int c_p_61[] = {  3,   6}; //   2
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 2);
  int c_f_61[] = {  7}; //   1
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 1);
  int c_t_61[] = {  9,  14}; //   2
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 2);
  int c_d_61[] = {  3,   4}; //   2
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 2);

  int c_p_62[] = {  3,   4}; //   2
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 2);
  int c_f_62[] = {  3}; //   1
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 1);
  int c_t_62[] = {  4,  15}; //   2
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 2);
  int c_d_62[] = {  3,   4}; //   2
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 2);

  int c_p_63[] = {  3,   6}; //   2
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 2);
  int c_f_63[] = {  3}; //   1
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 1);
  int c_t_63[] = {  4,  15}; //   2
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 2);
  int c_d_63[] = {  3,   4}; //   2
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 2);

  int c_p_64[] = {  9,  10}; //   2
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 2);
  int c_f_64[] = {  7}; //   1
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 1);
  int c_t_64[] = {  9,  14}; //   2
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 2);
  int c_d_64[] = {  7,   8}; //   2
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 2);

  int c_p_65[] = {  9,  11}; //   2
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 2);
  int c_f_65[] = {  7}; //   1
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 1);
  int c_t_65[] = {  9,  14}; //   2
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 2);
  int c_d_65[] = {  7,   8}; //   2
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 2);

  int c_p_66[] = {  9,  10}; //   2
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 2);
  int c_f_66[] = {  3}; //   1
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 1);
  int c_t_66[] = {  4,  15}; //   2
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 2);
  int c_d_66[] = {  7,   8}; //   2
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 2);

  int c_p_67[] = {  9,  11}; //   2
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 2);
  int c_f_67[] = {  3}; //   1
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 1);
  int c_t_67[] = {  4,  15}; //   2
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 2);
  int c_d_67[] = {  7,   8}; //   2
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 2);

  int c_p_68[] = {  0}; //   1
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 1);
  int c_f_68[] = {  8,   9}; //   2
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 2);
  int c_t_68[] = {  4,  16,  17}; //   3
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 3);
  int c_d_68[] = {  1}; //   1
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 1);

  int c_p_69[] = {  2}; //   1
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 1);
  int c_f_69[] = {  8,   9}; //   2
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 2);
  int c_t_69[] = {  4,  16,  17}; //   3
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 3);
  int c_d_69[] = {  1}; //   1
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 1);

  int c_p_70[] = {  0}; //   1
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 1);
  int c_f_70[] = { 10,  11}; //   2
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 2);
  int c_t_70[] = {  9,  18,  19}; //   3
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 3);
  int c_d_70[] = {  1}; //   1
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 1);

  int c_p_71[] = {  2}; //   1
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 1);
  int c_f_71[] = { 10,  11}; //   2
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 2);
  int c_t_71[] = {  9,  18,  19}; //   3
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 3);
  int c_d_71[] = {  1}; //   1
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 1);

  int c_p_72[] = {  0}; //   1
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 1);
  int c_f_72[] = {  8,   9}; //   2
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 2);
  int c_t_72[] = {  4,  16,  20}; //   3
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 3);
  int c_d_72[] = {  1}; //   1
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 1);

  int c_p_73[] = {  2}; //   1
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 1);
  int c_f_73[] = {  8,   9}; //   2
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 2);
  int c_t_73[] = {  4,  16,  20}; //   3
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 3);
  int c_d_73[] = {  1}; //   1
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 1);

  int c_p_74[] = {  0,  25}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = { 12}; //   1
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 1);
  int c_t_74[] = {  2,  21}; //   2
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 2);
  int c_d_74[] = { 12,   1}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = {  2,  25}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = { 12}; //   1
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 1);
  int c_t_75[] = {  2,  21}; //   2
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 2);
  int c_d_75[] = { 12,   1}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = {  0,  26}; //   2
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 2);
  int c_f_76[] = { 11}; //   1
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 1);
  int c_t_76[] = {  0,  22}; //   2
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 2);
  int c_d_76[] = { 10,   1}; //   2
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 2);

  int c_p_77[] = {  2,  26}; //   2
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 2);
  int c_f_77[] = { 11}; //   1
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 1);
  int c_t_77[] = {  0,  22}; //   2
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 2);
  int c_d_77[] = { 10,   1}; //   2
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 2);

  int c_p_78[] = {  3,   4,  24}; //   3
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 3);
  int c_f_78[] = {}; //   0
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 0);
  int c_t_78[] = { 23}; //   1
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 1);
  int c_d_78[] = { 12,   3,   4}; //   3
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 3);

  int c_p_79[] = {  3,   6,  24}; //   3
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 3);
  int c_f_79[] = {}; //   0
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 0);
  int c_t_79[] = { 23}; //   1
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 1);
  int c_d_79[] = { 12,   3,   4}; //   3
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 3);

  int c_p_80[] = {  9,  10,  24}; //   3
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 3);
  int c_f_80[] = {}; //   0
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 0);
  int c_t_80[] = { 23}; //   1
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 1);
  int c_d_80[] = { 12,   7,   8}; //   3
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 3);

  int c_p_81[] = {  9,  11,  24}; //   3
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 3);
  int c_f_81[] = {}; //   0
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 0);
  int c_t_81[] = { 23}; //   1
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 1);
  int c_d_81[] = { 12,   7,   8}; //   3
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 3);

  int c_p_82[] = {  0,  26}; //   2
  psi_c_p[no_ps][82] = get_vector_from_array_int(c_p_82, 2);
  int c_f_82[] = { 13}; //   1
  psi_c_f[no_ps][82] = get_vector_from_array_int(c_f_82, 1);
  int c_t_82[] = { 24,  25}; //   2
  psi_c_t[no_ps][82] = get_vector_from_array_int(c_t_82, 2);
  int c_d_82[] = { 10,   1}; //   2
  psi_c_d[no_ps][82] = get_vector_from_array_int(c_d_82, 2);

  int c_p_83[] = {  2,  26}; //   2
  psi_c_p[no_ps][83] = get_vector_from_array_int(c_p_83, 2);
  int c_f_83[] = { 13}; //   1
  psi_c_f[no_ps][83] = get_vector_from_array_int(c_f_83, 1);
  int c_t_83[] = { 24,  25}; //   2
  psi_c_t[no_ps][83] = get_vector_from_array_int(c_t_83, 2);
  int c_d_83[] = { 10,   1}; //   2
  psi_c_d[no_ps][83] = get_vector_from_array_int(c_d_83, 2);

  int c_p_84[] = {  0,  25}; //   2
  psi_c_p[no_ps][84] = get_vector_from_array_int(c_p_84, 2);
  int c_f_84[] = { 14}; //   1
  psi_c_f[no_ps][84] = get_vector_from_array_int(c_f_84, 1);
  int c_t_84[] = { 23,  26}; //   2
  psi_c_t[no_ps][84] = get_vector_from_array_int(c_t_84, 2);
  int c_d_84[] = { 12,   1}; //   2
  psi_c_d[no_ps][84] = get_vector_from_array_int(c_d_84, 2);

  int c_p_85[] = {  2,  25}; //   2
  psi_c_p[no_ps][85] = get_vector_from_array_int(c_p_85, 2);
  int c_f_85[] = { 14}; //   1
  psi_c_f[no_ps][85] = get_vector_from_array_int(c_f_85, 1);
  int c_t_85[] = { 23,  26}; //   2
  psi_c_t[no_ps][85] = get_vector_from_array_int(c_t_85, 2);
  int c_d_85[] = { 12,   1}; //   2
  psi_c_d[no_ps][85] = get_vector_from_array_int(c_d_85, 2);

  int c_p_86[] = {  0,  25,  27}; //   3
  psi_c_p[no_ps][86] = get_vector_from_array_int(c_p_86, 3);
  int c_f_86[] = {}; //   0
  psi_c_f[no_ps][86] = get_vector_from_array_int(c_f_86, 0);
  int c_t_86[] = { 27}; //   1
  psi_c_t[no_ps][86] = get_vector_from_array_int(c_t_86, 1);
  int c_d_86[] = { 16,  12,   1}; //   3
  psi_c_d[no_ps][86] = get_vector_from_array_int(c_d_86, 3);

  int c_p_87[] = {  2,  25,  27}; //   3
  psi_c_p[no_ps][87] = get_vector_from_array_int(c_p_87, 3);
  int c_f_87[] = {}; //   0
  psi_c_f[no_ps][87] = get_vector_from_array_int(c_f_87, 0);
  int c_t_87[] = { 27}; //   1
  psi_c_t[no_ps][87] = get_vector_from_array_int(c_t_87, 1);
  int c_d_87[] = { 16,  12,   1}; //   3
  psi_c_d[no_ps][87] = get_vector_from_array_int(c_d_87, 3);

  int c_p_88[] = {  0,  26,  28}; //   3
  psi_c_p[no_ps][88] = get_vector_from_array_int(c_p_88, 3);
  int c_f_88[] = {}; //   0
  psi_c_f[no_ps][88] = get_vector_from_array_int(c_f_88, 0);
  int c_t_88[] = { 27}; //   1
  psi_c_t[no_ps][88] = get_vector_from_array_int(c_t_88, 1);
  int c_d_88[] = { 17,  10,   1}; //   3
  psi_c_d[no_ps][88] = get_vector_from_array_int(c_d_88, 3);

  int c_p_89[] = {  2,  26,  28}; //   3
  psi_c_p[no_ps][89] = get_vector_from_array_int(c_p_89, 3);
  int c_f_89[] = {}; //   0
  psi_c_f[no_ps][89] = get_vector_from_array_int(c_f_89, 0);
  int c_t_89[] = { 27}; //   1
  psi_c_t[no_ps][89] = get_vector_from_array_int(c_t_89, 1);
  int c_d_89[] = { 17,  10,   1}; //   3
  psi_c_d[no_ps][89] = get_vector_from_array_int(c_d_89, 3);

  int c_p_90[] = {  0,  26}; //   2
  psi_c_p[no_ps][90] = get_vector_from_array_int(c_p_90, 2);
  int c_f_90[] = { 11}; //   1
  psi_c_f[no_ps][90] = get_vector_from_array_int(c_f_90, 1);
  int c_t_90[] = {  9,  18}; //   2
  psi_c_t[no_ps][90] = get_vector_from_array_int(c_t_90, 2);
  int c_d_90[] = { 10,   1}; //   2
  psi_c_d[no_ps][90] = get_vector_from_array_int(c_d_90, 2);

  int c_p_91[] = {  2,  26}; //   2
  psi_c_p[no_ps][91] = get_vector_from_array_int(c_p_91, 2);
  int c_f_91[] = { 11}; //   1
  psi_c_f[no_ps][91] = get_vector_from_array_int(c_f_91, 1);
  int c_t_91[] = {  9,  18}; //   2
  psi_c_t[no_ps][91] = get_vector_from_array_int(c_t_91, 2);
  int c_d_91[] = { 10,   1}; //   2
  psi_c_d[no_ps][91] = get_vector_from_array_int(c_d_91, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
