#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexexne04/header/ppeexexne04.phasespace.h"
void ppeexexne04_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppeexexne04_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeexexne04_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexexne04_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 524;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 216;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 216;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 216;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 128;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 128;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 64;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 128;}
  else if (psi_no_map[no_ps] == 10){n_channel = 64;}
  else if (psi_no_map[no_ps] == 11){n_channel = 216;}
  else if (psi_no_map[no_ps] == 12){n_channel = 128;}
  else if (psi_no_map[no_ps] == 13){n_channel = 128;}
  else if (psi_no_map[no_ps] == 14){n_channel = 64;}
  else if (psi_no_map[no_ps] == 15){n_channel = 64;}
  else if (psi_no_map[no_ps] == 16){n_channel = 128;}
  else if (psi_no_map[no_ps] == 17){n_channel = 64;}
  else if (psi_no_map[no_ps] == 18){n_channel = 64;}
  else if (psi_no_map[no_ps] == 19){n_channel = 64;}
  else if (psi_no_map[no_ps] == 20){n_channel = 64;}
  else if (psi_no_map[no_ps] == 21){n_channel = 128;}
  else if (psi_no_map[no_ps] == 22){n_channel = 128;}
  else if (psi_no_map[no_ps] == 23){n_channel = 64;}
  else if (psi_no_map[no_ps] == 24){n_channel = 64;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexexne04_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeexexne04_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexexne04_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexexne04_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppeexexne04_ax_psp_240_gg_emepepvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppeexexne04_ax_psp_240_gu_emepepvegd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeexexne04_ax_psp_240_gdx_emepepvegux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeexexne04_ax_psp_240_du_emepepvedd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeexexne04_ax_psp_240_dc_emepepveds(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeexexne04_ax_psp_240_ddx_emepepvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeexexne04_ax_psp_240_ddx_emepepvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeexexne04_ax_psp_240_dsx_emepepvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeexexne04_ax_psp_240_uu_emepepvedu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppeexexne04_ax_psp_240_uc_emepepvedc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppeexexne04_ax_psp_240_udx_emepepvegg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppeexexne04_ax_psp_240_udx_emepepveddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppeexexne04_ax_psp_240_udx_emepepveuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppeexexne04_ax_psp_240_udx_emepepvessx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppeexexne04_ax_psp_240_udx_emepepveccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppeexexne04_ax_psp_240_uux_emepepvedux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppeexexne04_ax_psp_240_uux_emepepvescx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppeexexne04_ax_psp_240_usx_emepepvedsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 19){ppeexexne04_ax_psp_240_usx_emepepveucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppeexexne04_ax_psp_240_ucx_emepepvedcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 21){ppeexexne04_ax_psp_240_dxdx_emepepvedxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppeexexne04_ax_psp_240_dxux_emepepveuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppeexexne04_ax_psp_240_dxsx_emepepvedxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppeexexne04_ax_psp_240_dxcx_emepepveuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
