#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexmxnm04/header/ppeexmxnm04.phasespace.h"
void ppeexmxnm04_ax_psp_240_uc_emepmupvmdc(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexmxnm04_ax_psp_240_uc_emepmupvmdc");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(19);
  psi_needed_v_smin[no_ps].resize(19);
  int needed_v_smin_0[] = {   0,    1,    2,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 30);
  int needed_v_smin_1[] = {   0,    6}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    6}; //   2
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   1,    2,    7,    8}; //   4
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   1,    2,    7,    8}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   3,    4,    5,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 26);
  int needed_v_smin_6[] = {   3,    9}; //   2
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   3,    9}; //   2
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 2);
  int needed_v_smin_8[] = {   4,    5,   10,   11}; //   4
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 4);
  int needed_v_smin_9[] = {   6,    7,    8,    9,   10,   11,    0,    1,    2,    3,    4,    5}; //  12
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 12);
  int needed_v_smin_10[] = {  12,   13,   20,   21,   28,   29,   30,   31,   16,   17}; //  10
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 10);
  int needed_v_smin_11[] = {  12,   13,   16,   17,   20,   21}; //   6
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 6);
  int needed_v_smin_12[] = {  14,   15,   22,   23,   18,   19}; //   6
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 6);
  int needed_v_smin_13[] = {  14,   15,   18,   19,   22,   23}; //   6
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 6);
  int needed_v_smin_14[] = {  24,   25,   28,   29}; //   4
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {  24,   25}; //   2
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 2);
  int needed_v_smin_16[] = {  26,   27}; //   2
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 2);
  int needed_v_smin_17[] = {  26,   27}; //   2
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 2);
  int needed_v_smin_18[] = {  30,   31}; //   2
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 2);

  psi_v_smax[no_ps].resize(21);
  psi_needed_v_smax[no_ps].resize(21);
  int needed_v_smax_0[] = {   0,    1,    2,    6,    7,    8,   14,   15,   18,   19,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  20
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 20);
  int needed_v_smax_1[] = {   0,    6}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 12);
  int needed_v_smax_3[] = {   1,    2,    7,    8}; //   4
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 4);
  int needed_v_smax_4[] = {   3,    4,    5,    9,   10,   11,   12,   13,   16,   17,   20,   21}; //  12
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 12);
  int needed_v_smax_5[] = {   3,    9}; //   2
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {   4,    5,   10,   11,   16,   17}; //   6
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 6);
  int needed_v_smax_7[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,    0,    1,    2,    3,    4,    5,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 24);
  int needed_v_smax_8[] = {  12,   13,   20,   21}; //   4
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 4);
  int needed_v_smax_9[] = {  12,   13,   20,   21}; //   4
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {  14,   15,   22,   23}; //   4
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 4);
  int needed_v_smax_11[] = {  14,   15,   22,   23}; //   4
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  18,   19,   26,   27,   30,   31}; //   6
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 6);
  int needed_v_smax_13[] = {  24,   25,   28,   29}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  24,   25,   28,   29}; //   4
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);
  int needed_v_smax_15[] = {  28,   29}; //   2
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 2);
  int needed_v_smax_16[] = {  30,   31,   16,   17}; //   4
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);
  int needed_v_smax_17[] = {  18,   19}; //   2
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 2);
  int needed_v_smax_18[] = {  24,   25,   26,   27}; //   4
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 4);
  int needed_v_smax_19[] = {  26,   27}; //   2
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 2);
  int needed_v_smax_20[] = {  30,   31}; //   2
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(25);
  psi_needed_g_p[no_ps].resize(25);
  int needed_g_p_0[] = {   0,    2,    6,    8,   15,   19,   23,   25,   27,   29,   31}; //  11
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 11);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_1[] = {   0,    6}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    6}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   1,    7,   14,   18,   22,   24,   26,   28,   30}; //   9
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 9);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_4[] = {   1,    2,    7,    8}; //   4
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {   1,    2,    7,    8}; //   4
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 4);
  psi_container_IS_name.push_back("propagator_24_smin4_smax2");
  int needed_g_p_6[] = {   3,    4,    5,    9,   10,   11,   12,   13,   16,   17,   20,   21}; //  12
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 12);
  psi_container_IS_name.push_back("propagator_24_smin5_smax4");
  int needed_g_p_7[] = {   3,    9}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_8[] = {   3,    9}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax2");
  int needed_g_p_9[] = {   4,   10,   16}; //   3
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax6");
  int needed_g_p_10[] = {   4,    5,   10,   11}; //   4
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 4);
  psi_container_IS_name.push_back("propagator_24_smin8_smax2");
  int needed_g_p_11[] = {   5,   11,   17}; //   3
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 3);
  psi_container_IS_name.push_back("propagator_23_smin0_smax6");
  int needed_g_p_12[] = {   6,    7,    8,    9,   10,   11}; //   6
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 6);
  psi_container_IS_name.push_back("propagator_0_smin9_smax7");
  int needed_g_p_13[] = {  12,   13,   20,   21}; //   4
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 4);
  psi_container_IS_name.push_back("propagator_0_smin10_smax8");
  int needed_g_p_14[] = {  12,   20}; //   2
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax9");
  int needed_g_p_15[] = {  12,   13}; //   2
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 2);
  psi_container_IS_name.push_back("propagator_0_smin11_smax7");
  int needed_g_p_16[] = {  13,   21}; //   2
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax9");
  int needed_g_p_17[] = {  14,   15,   22,   23}; //   4
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 4);
  psi_container_IS_name.push_back("propagator_0_smin12_smax10");
  int needed_g_p_18[] = {  14,   15,   22,   23}; //   4
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 4);
  psi_container_IS_name.push_back("propagator_24_smin5_smax11");
  int needed_g_p_19[] = {  14,   15}; //   2
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax7");
  int needed_g_p_20[] = {  18,   19,   26,   27,   30,   31}; //   6
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 6);
  psi_container_IS_name.push_back("propagator_24_smin5_smax12");
  int needed_g_p_21[] = {  24,   25,   28,   29}; //   4
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 4);
  psi_container_IS_name.push_back("propagator_0_smin14_smax13");
  int needed_g_p_22[] = {  24,   25,   28,   29}; //   4
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 4);
  psi_container_IS_name.push_back("propagator_24_smin5_smax14");
  int needed_g_p_23[] = {  28,   29}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_0_smin10_smax15");
  int needed_g_p_24[] = {  30,   31}; //   2
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 2);
  psi_container_IS_name.push_back("propagator_0_smin10_smax16");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(9);
  psi_needed_g_f[no_ps].resize(9);
  int needed_g_f_0[] = {   0,    1,    2,    3,    4,    5}; //   6
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax7");
  int needed_g_f_1[] = {  16,   17}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax16");
  int needed_g_f_2[] = {  16,   17,   20,   21}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax7");
  int needed_g_f_3[] = {  18,   19}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax17");
  int needed_g_f_4[] = {  18,   19,   22,   23}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax7");
  int needed_g_f_5[] = {  24,   25}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax18");
  int needed_g_f_6[] = {  26,   27}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax19");
  int needed_g_f_7[] = {  26,   27}; //   2
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax18");
  int needed_g_f_8[] = {  30,   31}; //   2
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax20");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(13);
  psi_needed_g_t[no_ps].resize(13);
  int needed_g_t_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 24);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__128_124");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__128_124");
  int needed_g_t_1[] = {   0,    1,    2,    3,    4,    5}; //   6
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__130_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__130_1__64_60");
  int needed_g_t_2[] = {  16,   17,   20,   21}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__12_112");
  int needed_g_t_3[] = {  16,   17}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_13__64_48");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_13__64_48");
  int needed_g_t_4[] = {  18,   19,   22,   23}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__48_76");
  int needed_g_t_5[] = {  18,   19}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_49__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_49__64_12");
  int needed_g_t_6[] = {  24,   25,   26,   27}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_204");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_204");
  int needed_g_t_7[] = {  24,   25}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__140_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__140_64");
  int needed_g_t_8[] = {  26,   27}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_192");
  int needed_g_t_9[] = {  26,   27}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__49_14__64_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__49_14__64_128");
  int needed_g_t_10[] = {  28,   29}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__112_140");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__112_140");
  int needed_g_t_11[] = {  30,   31}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__12_240");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__12_240");
  int needed_g_t_12[] = {  30,   31}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_14__112_128");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_14__112_128");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(15);
  psi_needed_g_d[no_ps].resize(15);
  int needed_g_d_0[] = {   0,    6}; //   2
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_1[] = {   0,    6}; //   2
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_2[] = {   0,    1,    2,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 30);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_3[] = {   1,    2,    7,    8}; //   4
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_4[] = {   1,    2,    7,    8}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_5[] = {   3,    9}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_6[] = {   3,    9}; //   2
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__4_48");
  psi_container_IS_name.push_back("phi_of_decay_52__4_48");
  int needed_g_d_7[] = {   3,    4,    5,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 26);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_8[] = {   4,    5,   10,   11}; //   4
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_9[] = {   6,    7,    8,    9,   10,   11}; //   6
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 6);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_10[] = {  12,   13}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__12_112");
  psi_container_IS_name.push_back("phi_of_decay_124__12_112");
  int needed_g_d_11[] = {  12,   13,   20,   21,   28,   29,   30,   31}; //   8
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 8);
  psi_container_IS_name.push_back("costheta_of_decay_112__64_48");
  psi_container_IS_name.push_back("phi_of_decay_112__64_48");
  int needed_g_d_12[] = {  14,   15}; //   2
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_13[] = {  14,   15,   22,   23}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_14[] = {  24,   25,   28,   29}; //   4
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 4);
  psi_container_IS_name.push_back("costheta_of_decay_140__128_12");
  psi_container_IS_name.push_back("phi_of_decay_140__128_12");

  psi_c_p[no_ps].resize(32);
  psi_c_f[no_ps].resize(32);
  psi_c_t[no_ps].resize(32);
  psi_c_d[no_ps].resize(32);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {  0}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  0,   1}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {  0}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  0,   1}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {  0}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  0,   1}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  6,   9,  10}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {  0}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  0,   1}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  8,   2,   7}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  6,  11,  10}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {  0}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  0,   1}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  8,   2,   7}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  0,   1,   2,  12}; //   4
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 4);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  0}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  9,   0,   1,   2}; //   4
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 4);

  int c_p_7[] = {  3,   4,   5,  12}; //   4
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 4);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  0}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  9,   3,   4,   2}; //   4
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 4);

  int c_p_8[] = {  0,   4,   5,  12}; //   4
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 4);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  0}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  9,   3,   4,   2}; //   4
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 4);

  int c_p_9[] = {  6,   7,   8,  12}; //   4
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 4);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  0}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  9,   5,   6,   7}; //   4
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 4);

  int c_p_10[] = {  6,   9,  10,  12}; //   4
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 4);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  0}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  9,   8,   2,   7}; //   4
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 4);

  int c_p_11[] = {  6,  11,  10,  12}; //   4
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 4);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  0}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  9,   8,   2,   7}; //   4
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 4);

  int c_p_12[] = {  6,  13,  14,  15}; //   4
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 4);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = { 10,   2,  11,   7}; //   4
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 4);

  int c_p_13[] = {  6,  13,  16,  15}; //   4
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 4);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = { 10,   2,  11,   7}; //   4
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 4);

  int c_p_14[] = {  3,  17,  18,  19}; //   4
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 4);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  0}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = { 12,   7,  13,   2}; //   4
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 4);

  int c_p_15[] = {  0,  17,  18,  19}; //   4
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 4);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  0}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = { 12,   7,  13,   2}; //   4
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 4);

  int c_p_16[] = {  6,   9}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {  1,   2}; //   2
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 2);
  int c_t_16[] = {  0,   2,   3}; //   3
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 3);
  int c_d_16[] = {  2,   7}; //   2
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 2);

  int c_p_17[] = {  6,  11}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {  1,   2}; //   2
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 2);
  int c_t_17[] = {  0,   2,   3}; //   3
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 3);
  int c_d_17[] = {  2,   7}; //   2
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 2);

  int c_p_18[] = {  3,  20}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {  3,   4}; //   2
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 2);
  int c_t_18[] = {  0,   4,   5}; //   3
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 3);
  int c_d_18[] = {  7,   2}; //   2
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 2);

  int c_p_19[] = {  0,  20}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {  3,   4}; //   2
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 2);
  int c_t_19[] = {  0,   4,   5}; //   3
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 3);
  int c_d_19[] = {  7,   2}; //   2
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 2);

  int c_p_20[] = {  6,  13,  14}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {  2}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = {  0,   2}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = {  2,  11,   7}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  6,  13,  16}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {  2}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = {  0,   2}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  2,  11,   7}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  3,  17,  18}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {  4}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  0,   4}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  7,  13,   2}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = {  0,  17,  18}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {  4}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = {  0,   4}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  7,  13,   2}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = {  3,  21,  22}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {  5}; //   1
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 1);
  int c_t_24[] = {  6,   7}; //   2
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 2);
  int c_d_24[] = {  7,  14,   2}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  0,  21,  22}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {  5}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  6,   7}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  7,  14,   2}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  3,  20}; //   2
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 2);
  int c_f_26[] = {  6,   7}; //   2
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 2);
  int c_t_26[] = {  6,   8,   9}; //   3
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 3);
  int c_d_26[] = {  7,   2}; //   2
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 2);

  int c_p_27[] = {  0,  20}; //   2
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 2);
  int c_f_27[] = {  6,   7}; //   2
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 2);
  int c_t_27[] = {  6,   8,   9}; //   3
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 3);
  int c_d_27[] = {  7,   2}; //   2
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 2);

  int c_p_28[] = {  3,  21,  22,  23}; //   4
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 4);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = { 10}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = { 11,   7,  14,   2}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = {  0,  21,  22,  23}; //   4
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 4);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = { 10}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = { 11,   7,  14,   2}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = {  3,  20,  24}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {  8}; //   1
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 1);
  int c_t_30[] = { 11,  12}; //   2
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 2);
  int c_d_30[] = { 11,   7,   2}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = {  0,  20,  24}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {  8}; //   1
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 1);
  int c_t_31[] = { 11,  12}; //   2
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 2);
  int c_d_31[] = { 11,   7,   2}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
