#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemexmx04/header/ppemexmx04.phasespace.h"
void ppemexmx04_ax_psp_240_gg_emmumepmup(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexmx04_ax_psp_240_gg_emmumepmup");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(6);
  psi_needed_v_smin[no_ps].resize(6);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  33
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 33);
  int needed_v_smin_1[] = {   0,    1,    2,    3}; //   4
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   4,    5,    6,    7}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  33
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 33);
  int needed_v_smin_4[] = {   8,    9,   10,   11}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {  12,   13,   14,   15}; //   4
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 4);

  psi_v_smax[no_ps].resize(8);
  psi_needed_v_smax[no_ps].resize(8);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  25
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 25);
  int needed_v_smax_1[] = {   0,    1,    2,    3}; //   4
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   4,    5,    6,    7}; //   4
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 4);
  int needed_v_smax_3[] = {   8,    9,   10,   11,   12,   13,   14,   15,   33,   34,   35,   36,   37,   38,   39,   40}; //  16
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 16);
  int needed_v_smax_4[] = {   8,    9,   10,   11}; //   4
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 4);
  int needed_v_smax_5[] = {  12,   13,   14,   15}; //   4
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 4);
  int needed_v_smax_6[] = {  16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  17
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 17);
  int needed_v_smax_7[] = {  33,   34,   35,   36,   37,   38,   39,   40}; //   8
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 8);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(12);
  psi_needed_g_p[no_ps].resize(12);
  int needed_g_p_0[] = {   0,    1,    4,    5,   16,   17,   18,   19,   25,   26,   27,   28}; //  12
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 12);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    2,    3}; //   4
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 4);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   2,    3,    6,    7,   20,   21,   22,   23,   24,   29,   30,   31,   32}; //  13
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 13);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_3[] = {   4,    5,    6,    7}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_4[] = {   8,    9,   12,   13,   33,   34,   35,   36}; //   8
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 8);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {   8,    9,   10,   11}; //   4
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 4);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_6[] = {  10,   11,   14,   15,   37,   38,   39,   40}; //   8
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 8);
  psi_container_IS_name.push_back("propagator_23_smin3_smax3");
  int needed_g_p_7[] = {  12,   13,   14,   15}; //   4
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_8[] = {  16,   17,   20,   21,   25,   26,   29,   30}; //   8
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 8);
  psi_container_IS_name.push_back("propagator_0_smin3_smax6");
  int needed_g_p_9[] = {  18,   19,   22,   23,   24,   27,   28,   31,   32}; //   9
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 9);
  psi_container_IS_name.push_back("propagator_23_smin3_smax6");
  int needed_g_p_10[] = {  33,   34,   37,   38}; //   4
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 4);
  psi_container_IS_name.push_back("propagator_0_smin0_smax7");
  int needed_g_p_11[] = {  35,   36,   39,   40}; //   4
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax7");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(0);
  psi_needed_g_f[no_ps].resize(0);

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(4);
  psi_needed_g_t[no_ps].resize(4);
  int needed_g_t_0[] = {  25,   27,   29,   31}; //   4
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__20_40");
  int needed_g_t_1[] = {  26,   28,   30,   32}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__20_40");
  int needed_g_t_2[] = {  33,   35,   37,   39}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__40_20");
  int needed_g_t_3[] = {  34,   36,   38,   40}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__40_20");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(11);
  psi_needed_g_d[no_ps].resize(11);
  int needed_g_d_0[] = {   0,    1,    2,    3}; //   4
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,    1,    2,    3}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  33
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 33);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_3[] = {   4,    5,    6,    7}; //   4
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_4[] = {   4,    5,    6,    7}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_5[] = {   8,    9,   10,   11}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_6[] = {   8,    9,   10,   11}; //   4
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 4);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_7[] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40}; //  33
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 33);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_8[] = {  12,   13,   14,   15}; //   4
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_9[] = {  12,   13,   14,   15}; //   4
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_10[] = {  16,   17,   18,   19,   20,   21,   22,   23,   24}; //   9
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 9);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");

  psi_c_p[no_ps].resize(41);
  psi_c_f[no_ps].resize(41);
  psi_c_t[no_ps].resize(41);
  psi_c_d[no_ps].resize(41);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {}; //   0
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 0);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   1}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  2,   1}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  2,   1}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  0,   3}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  0,   3}; //   2
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 2);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {}; //   0
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 0);
  int c_d_5[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  2,   3}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {}; //   0
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 0);
  int c_d_6[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  2,   3}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {}; //   0
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 0);
  int c_d_7[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  4,   5}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {}; //   0
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 0);
  int c_d_8[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  4,   5}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {}; //   0
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 0);
  int c_d_9[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  6,   5}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {}; //   0
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 0);
  int c_d_10[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  6,   5}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  4,   7}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {}; //   0
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 0);
  int c_d_12[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  4,   7}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  6,   7}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  6,   7}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  0,   8}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  0,   8}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  0,   9}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  0,   9}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  2,   8}; //   2
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 2);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  2,   8}; //   2
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 2);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {}; //   0
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 0);
  int c_d_21[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  2,   9}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {}; //   0
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 0);
  int c_d_22[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = {  2,   9}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {}; //   0
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 0);
  int c_d_23[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = {  2,   9}; //   2
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 2);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {}; //   0
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 0);
  int c_d_24[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  0,   8}; //   2
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 2);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  0}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  7,   2}; //   2
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 2);

  int c_p_26[] = {  0,   8}; //   2
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 2);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  1}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = {  7,   2}; //   2
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 2);

  int c_p_27[] = {  0,   9}; //   2
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 2);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  0}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  7,   2}; //   2
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 2);

  int c_p_28[] = {  0,   9}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  1}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  7,   2}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  2,   8}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  0}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  7,   2}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  int c_p_30[] = {  2,   8}; //   2
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 2);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  1}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  7,   2}; //   2
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 2);

  int c_p_31[] = {  2,   9}; //   2
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 2);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  0}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = {  7,   2}; //   2
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 2);

  int c_p_32[] = {  2,   9}; //   2
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 2);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {  1}; //   1
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 1);
  int c_d_32[] = {  7,   2}; //   2
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 2);

  int c_p_33[] = {  4,  10}; //   2
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 2);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {  2}; //   1
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 1);
  int c_d_33[] = {  2,   7}; //   2
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 2);

  int c_p_34[] = {  4,  10}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {  3}; //   1
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 1);
  int c_d_34[] = {  2,   7}; //   2
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 2);

  int c_p_35[] = {  4,  11}; //   2
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 2);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {  2}; //   1
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 1);
  int c_d_35[] = {  2,   7}; //   2
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 2);

  int c_p_36[] = {  4,  11}; //   2
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 2);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {  3}; //   1
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 1);
  int c_d_36[] = {  2,   7}; //   2
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 2);

  int c_p_37[] = {  6,  10}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {  2}; //   1
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 1);
  int c_d_37[] = {  2,   7}; //   2
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 2);

  int c_p_38[] = {  6,  10}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {  3}; //   1
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 1);
  int c_d_38[] = {  2,   7}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  int c_p_39[] = {  6,  11}; //   2
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 2);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {  2}; //   1
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 1);
  int c_d_39[] = {  2,   7}; //   2
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 2);

  int c_p_40[] = {  6,  11}; //   2
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 2);
  int c_f_40[] = {}; //   0
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 0);
  int c_t_40[] = {  3}; //   1
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 1);
  int c_d_40[] = {  2,   7}; //   2
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
