#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppenexa03/header/ppenexa03.phasespace.h"
void ppenexa03_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppenexa03_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppenexa03_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppenexa03_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 116;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 46;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 46;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 46;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 28;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 28;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 14;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 14;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 28;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 14;}
  else if (psi_no_map[no_ps] == 10){n_channel = 46;}
  else if (psi_no_map[no_ps] == 11){n_channel = 28;}
  else if (psi_no_map[no_ps] == 12){n_channel = 28;}
  else if (psi_no_map[no_ps] == 13){n_channel = 14;}
  else if (psi_no_map[no_ps] == 14){n_channel = 14;}
  else if (psi_no_map[no_ps] == 15){n_channel = 14;}
  else if (psi_no_map[no_ps] == 16){n_channel = 14;}
  else if (psi_no_map[no_ps] == 17){n_channel = 14;}
  else if (psi_no_map[no_ps] == 18){n_channel = 28;}
  else if (psi_no_map[no_ps] == 19){n_channel = 14;}
  else if (psi_no_map[no_ps] == 20){n_channel = 14;}
  else if (psi_no_map[no_ps] == 21){n_channel = 28;}
  else if (psi_no_map[no_ps] == 22){n_channel = 14;}
  else if (psi_no_map[no_ps] == 23){n_channel = 28;}
  else if (psi_no_map[no_ps] == 24){n_channel = 14;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppenexa03_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppenexa03_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppenexa03_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppenexa03_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppenexa03_ax_psp_230_gg_emvexaudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppenexa03_ax_psp_230_gd_emvexagu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppenexa03_ax_psp_230_gux_emvexagdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppenexa03_ax_psp_230_dd_emvexadu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppenexa03_ax_psp_230_du_emvexauu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppenexa03_ax_psp_230_ds_emvexadc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppenexa03_ax_psp_230_dc_emvexauc(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppenexa03_ax_psp_230_ddx_emvexaudx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppenexa03_ax_psp_230_ddx_emvexacsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppenexa03_ax_psp_230_dux_emvexagg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppenexa03_ax_psp_230_dux_emvexaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppenexa03_ax_psp_230_dux_emvexauux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppenexa03_ax_psp_230_dux_emvexassx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppenexa03_ax_psp_230_dux_emvexaccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppenexa03_ax_psp_230_dsx_emvexausx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppenexa03_ax_psp_230_dcx_emvexadsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppenexa03_ax_psp_230_dcx_emvexaucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppenexa03_ax_psp_230_uux_emvexaudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 19){ppenexa03_ax_psp_230_uux_emvexacsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppenexa03_ax_psp_230_ucx_emvexausx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 21){ppenexa03_ax_psp_230_dxux_emvexadxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppenexa03_ax_psp_230_dxcx_emvexadxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppenexa03_ax_psp_230_uxux_emvexadxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppenexa03_ax_psp_230_uxcx_emvexadxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
