#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppenexa03/header/ppenexa03.phasespace.h"
void ppenexa03_ax_psp_230_ddx_emvexaudx(int no_ps, phasespace_set & psi){
  static Logger logger("ppenexa03_ax_psp_230_ddx_emvexaudx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(19);
  psi_needed_v_smin[no_ps].resize(19);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    5,    6,    7,    8,   10,   11,   12,   13,   14,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 24);
  int needed_v_smin_1[] = {   2,    6,    7,   11,   20,   22,   24,   27,   21}; //   9
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 9);
  int needed_v_smin_2[] = {   3,    8,   13,   14}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   4,    9,   15,   16}; //   4
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   4,    9,   15,   16}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   5,   12,   19,   23}; //   4
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 4);
  int needed_v_smin_6[] = {   5,   23}; //   2
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   6,   24,    2,   21,   22}; //   5
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 5);
  int needed_v_smin_8[] = {   7,   11}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   8,    9,   14,   16,    3,    4}; //   6
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 6);
  int needed_v_smin_10[] = {  10,   17,   19,   25,    0}; //   5
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 5);
  int needed_v_smin_11[] = {  10,   17,    0,   25}; //   4
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 4);
  int needed_v_smin_12[] = {  12}; //   1
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 1);
  int needed_v_smin_13[] = {  13,   15}; //   2
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 2);
  int needed_v_smin_14[] = {  18,   20,   26,   27}; //   4
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {  18}; //   1
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 1);
  int needed_v_smin_16[] = {   1}; //   1
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 1);
  int needed_v_smin_17[] = {   1}; //   1
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 1);
  int needed_v_smin_18[] = {  26}; //   1
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 1);

  psi_v_smax[no_ps].resize(18);
  psi_needed_v_smax[no_ps].resize(18);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    5,    6,    7,    8,   11,   12,   13,   14,   19,   20,   21,   22,   23,   24}; //  18
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 18);
  int needed_v_smax_1[] = {   2,    6,    7,   11,   20,   22,   24,   21}; //   8
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   3,    4,    8,    9,   13,   14,   15,   16}; //   8
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 8);
  int needed_v_smax_3[] = {   4,    9,   15,   16}; //   4
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 4);
  int needed_v_smax_4[] = {   5,   12,   19,   23}; //   4
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 4);
  int needed_v_smax_5[] = {   5,    6,   23,   24,    1,    2,   21,   22}; //   8
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 8);
  int needed_v_smax_6[] = {   7,    8,    9,   10,   11,   14,   16,   17,    0,    3,    4,   25}; //  12
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 12);
  int needed_v_smax_7[] = {  10,   17,   25}; //   3
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 3);
  int needed_v_smax_8[] = {  10,   17,   25}; //   3
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 3);
  int needed_v_smax_9[] = {  12,   13,   15,   18}; //   4
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 4);
  int needed_v_smax_10[] = {  18,   26,   27}; //   3
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 3);
  int needed_v_smax_11[] = {  18,   26,   27}; //   3
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 3);
  int needed_v_smax_12[] = {  19}; //   1
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 1);
  int needed_v_smax_13[] = {  20}; //   1
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 1);
  int needed_v_smax_14[] = {  27}; //   1
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 1);
  int needed_v_smax_15[] = {   0}; //   1
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 1);
  int needed_v_smax_16[] = {   1}; //   1
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 1);
  int needed_v_smax_17[] = {  26}; //   1
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 1);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(21);
  psi_needed_g_p[no_ps].resize(21);
  int needed_g_p_0[] = {   0,    1,    2,    3,    5,    6,    7,    8,   11,   12,   13,   14,   19,   20,   21,   22,   23,   24}; //  18
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 18);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   2,    6,    7,   11,   20,   22,   24}; //   7
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 7);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   3,    8,   13,   14}; //   4
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 4);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   4,    9,   15,   16}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   4,    9,   15,   16}; //   4
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 4);
  psi_container_IS_name.push_back("propagator_24_smin4_smax2");
  int needed_g_p_5[] = {   5,   12,   19,   23}; //   4
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_6[] = {   5,   23}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_7[] = {   6,   24}; //   2
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 2);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_8[] = {   7,   11}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax6");
  int needed_g_p_9[] = {   8,    9,   14,   16}; //   4
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 4);
  psi_container_IS_name.push_back("propagator_0_smin9_smax6");
  int needed_g_p_10[] = {  10,   17,   25}; //   3
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 3);
  psi_container_IS_name.push_back("propagator_0_smin10_smax7");
  int needed_g_p_11[] = {  10,   17,   25}; //   3
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 3);
  psi_container_IS_name.push_back("propagator_24_smin0_smax8");
  int needed_g_p_12[] = {  10,   17}; //   2
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 2);
  psi_container_IS_name.push_back("propagator_0_smin11_smax6");
  int needed_g_p_13[] = {  12}; //   1
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 1);
  psi_container_IS_name.push_back("propagator_0_smin12_smax9");
  int needed_g_p_14[] = {  13,   15}; //   2
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax9");
  int needed_g_p_15[] = {  18,   26,   27}; //   3
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 3);
  psi_container_IS_name.push_back("propagator_0_smin14_smax10");
  int needed_g_p_16[] = {  18,   26,   27}; //   3
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 3);
  psi_container_IS_name.push_back("propagator_24_smin0_smax11");
  int needed_g_p_17[] = {  18}; //   1
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 1);
  psi_container_IS_name.push_back("propagator_0_smin15_smax9");
  int needed_g_p_18[] = {  19}; //   1
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 1);
  psi_container_IS_name.push_back("propagator_0_smin10_smax12");
  int needed_g_p_19[] = {  20}; //   1
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 1);
  psi_container_IS_name.push_back("propagator_0_smin14_smax13");
  int needed_g_p_20[] = {  27}; //   1
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 1);
  psi_container_IS_name.push_back("propagator_0_smin1_smax14");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(8);
  psi_needed_g_f[no_ps].resize(8);
  int needed_g_f_0[] = {   0}; //   1
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax15");
  int needed_g_f_1[] = {   0,   25}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax6");
  int needed_g_f_2[] = {   1}; //   1
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax16");
  int needed_g_f_3[] = {   1}; //   1
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax5");
  int needed_g_f_4[] = {   2,   21,   22}; //   3
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");
  int needed_g_f_5[] = {   3,    4}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax6");
  int needed_g_f_6[] = {  21}; //   1
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");
  int needed_g_f_7[] = {  26}; //   1
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax17");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(14);
  psi_needed_g_t[no_ps].resize(14);
  int needed_g_t_0[] = {   0,    3,    4,    7,    8,    9,   10,   25}; //   8
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_1[] = {   0,   25}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__12_48");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_13__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_13__32_16");
  int needed_g_t_3[] = {   1,    2,    5,    6}; //   4
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_108");
  int needed_g_t_4[] = {   1}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_96");
  int needed_g_t_5[] = {   1}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__64_32");
  int needed_g_t_6[] = {   2}; //   1
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__18_1__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__18_1__64_44");
  int needed_g_t_7[] = {   3,    4}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__66_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__66_1__32_28");
  int needed_g_t_8[] = {  21,   22,   23,   24}; //   4
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_108");
  int needed_g_t_9[] = {  21,   22}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__64_44");
  int needed_g_t_10[] = {  21}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_17__32_12");
  int needed_g_t_11[] = {  26}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_112");
  int needed_g_t_12[] = {  26}; //   1
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__80_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__80_32");
  int needed_g_t_13[] = {  27}; //   1
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__80_44");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(20);
  psi_needed_g_d[no_ps].resize(20);
  int needed_g_d_0[] = {   0,    1,    2,    3,    5,    6,    7,    8,   10,   11,   12,   13,   14,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 24);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {   2,    6,    7,   11,   20,   22,   24,   27}; //   8
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_2[] = {   3,    8,   13,   14}; //   4
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_3[] = {   4,    9,   15,   16}; //   4
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_4[] = {   4,    9,   15,   16}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_5[] = {   5,   23}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_108__32_76");
  psi_container_IS_name.push_back("phi_of_decay_108__32_76");
  int needed_g_d_6[] = {   5,   12,   19,   23}; //   4
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 4);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_7[] = {   6,   24}; //   2
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 2);
  psi_container_IS_name.push_back("costheta_of_decay_108__64_44");
  psi_container_IS_name.push_back("phi_of_decay_108__64_44");
  int needed_g_d_8[] = {   7,   11}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_9[] = {   8,    9,   14,   16}; //   4
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_10[] = {  10,   17}; //   2
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_11[] = {  10,   17,   19,   25}; //   4
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 4);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_12[] = {  11,   14,   16,   17}; //   4
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_13[] = {  12,   13,   15,   18}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_124__32_92");
  psi_container_IS_name.push_back("phi_of_decay_124__32_92");
  int needed_g_d_14[] = {  12}; //   1
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 1);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_15[] = {  13,   15}; //   2
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 2);
  psi_container_IS_name.push_back("costheta_of_decay_92__64_28");
  psi_container_IS_name.push_back("phi_of_decay_92__64_28");
  int needed_g_d_16[] = {  18}; //   1
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 1);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_17[] = {  18,   20,   26,   27}; //   4
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 4);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");
  int needed_g_d_18[] = {  19}; //   1
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 1);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_19[] = {  20}; //   1
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 1);
  psi_container_IS_name.push_back("costheta_of_decay_124__80_44");
  psi_container_IS_name.push_back("phi_of_decay_124__80_44");

  psi_c_p[no_ps].resize(28);
  psi_c_f[no_ps].resize(28);
  psi_c_t[no_ps].resize(28);
  psi_c_d[no_ps].resize(28);

  int c_p_0[] = {  0}; //   1
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 1);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {  0}; //   1
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 1);

  int c_p_1[] = {  0}; //   1
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 1);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {  0}; //   1
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 1);

  int c_p_2[] = {  0,   1}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {  4}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  3,   6}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  1,   0}; //   2
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 2);

  int c_p_3[] = {  0,   2}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {  5}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  0,   7}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  2,   0}; //   2
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 2);

  int c_p_4[] = {  3,   4}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {  5}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  0,   7}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  3,   4}; //   2
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 2);

  int c_p_5[] = {  0,   5,   6}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  3}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  5,   6,   0}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  0,   1,   7}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  3}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  7,   1,   0}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  0,   1,   8}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  0}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  8,   1,   0}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  0,   2,   9}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  0}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  9,   2,   0}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  3,   4,   9}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  0}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  9,   3,   4}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = { 10,  11,  12}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  0}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = { 10,   0,  11}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  0,   1,   8}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {}; //   0
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 0);
  int c_d_11[] = { 12,   8,   1,   0}; //   4
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 4);

  int c_p_12[] = {  0,   5,  13}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {}; //   0
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 0);
  int c_d_12[] = { 13,  14,   6,   0}; //   4
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 4);

  int c_p_13[] = {  0,   2,  14}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {}; //   0
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 0);
  int c_d_13[] = { 13,  15,   2,   0}; //   4
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 4);

  int c_p_14[] = {  0,   2,   9}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {}; //   0
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 0);
  int c_d_14[] = { 12,   9,   2,   0}; //   4
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 4);

  int c_p_15[] = {  3,   4,  14}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {}; //   0
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 0);
  int c_d_15[] = { 13,  15,   3,   4}; //   4
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 4);

  int c_p_16[] = {  3,   4,   9}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {}; //   0
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 0);
  int c_d_16[] = { 12,   9,   3,   4}; //   4
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 4);

  int c_p_17[] = { 10,  11,  12}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {}; //   0
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 0);
  int c_d_17[] = { 12,  10,   0,  11}; //   4
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 4);

  int c_p_18[] = { 15,  16,  17}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {}; //   0
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 0);
  int c_d_18[] = { 13,  16,   0,  17}; //   4
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 4);

  int c_p_19[] = {  0,   5,  18}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {}; //   0
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 0);
  int c_d_19[] = { 18,  11,   6,   0}; //   4
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 4);

  int c_p_20[] = {  0,   1,  19}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {}; //   0
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 0);
  int c_d_20[] = { 19,  17,   1,   0}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = {  0}; //   1
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 1);
  int c_f_21[] = {  6,   4}; //   2
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 2);
  int c_t_21[] = {  8,   9,  10}; //   3
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 3);
  int c_d_21[] = {  0}; //   1
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 1);

  int c_p_22[] = {  0,   1}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {  4}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  8,   9}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  1,   0}; //   2
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 2);

  int c_p_23[] = {  0,   5,   6}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  8}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = {  5,   6,   0}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = {  0,   1,   7}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  8}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = {  7,   1,   0}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = { 10,  11}; //   2
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 2);
  int c_f_25[] = {  1}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  0,   1}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  0,  11}; //   2
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 2);

  int c_p_26[] = { 15,  16}; //   2
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 2);
  int c_f_26[] = {  7}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = { 11,  12}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  0,  17}; //   2
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 2);

  int c_p_27[] = { 15,  16,  20}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = { 13}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  1,   0,  17}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
