#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppexne02/header/ppexne02.phasespace.h"
void ppexne02_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppexne02_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppexne02_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppexne02_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 12;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 2;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 2;}
  else if (psi_no_map[no_ps] == 10){n_channel = 2;}
  else if (psi_no_map[no_ps] == 11){n_channel = 2;}
  else if (psi_no_map[no_ps] == 12){n_channel = 2;}
  else if (psi_no_map[no_ps] == 13){n_channel = 2;}
  else if (psi_no_map[no_ps] == 14){n_channel = 2;}
  else if (psi_no_map[no_ps] == 15){n_channel = 2;}
  else if (psi_no_map[no_ps] == 16){n_channel = 2;}
  else if (psi_no_map[no_ps] == 17){n_channel = 2;}
  else if (psi_no_map[no_ps] == 18){n_channel = 2;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppexne02_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppexne02_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppexne02_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppexne02_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppexne02_ax_psp_120_gu_epved(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppexne02_ax_psp_120_gu_epves(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppexne02_ax_psp_120_gu_epveb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppexne02_ax_psp_120_gc_epved(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppexne02_ax_psp_120_gc_epves(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppexne02_ax_psp_120_gc_epveb(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppexne02_ax_psp_120_gdx_epveux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppexne02_ax_psp_120_gdx_epvecx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppexne02_ax_psp_120_gsx_epveux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppexne02_ax_psp_120_gsx_epvecx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppexne02_ax_psp_120_gbx_epveux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppexne02_ax_psp_120_gbx_epvecx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppexne02_ax_psp_120_udx_epveg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppexne02_ax_psp_120_usx_epveg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppexne02_ax_psp_120_ubx_epveg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppexne02_ax_psp_120_cdx_epveg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppexne02_ax_psp_120_csx_epveg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppexne02_ax_psp_120_cbx_epveg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
