#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppexnea03/header/ppexnea03.phasespace.h"
void ppexnea03_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppexnea03_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppexnea03_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppexnea03_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 116;}
  else if (psi_no_map[no_ps] ==  1){n_channel = 46;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 46;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 46;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 28;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 14;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 28;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 14;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 14;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 28;}
  else if (psi_no_map[no_ps] == 10){n_channel = 14;}
  else if (psi_no_map[no_ps] == 11){n_channel = 46;}
  else if (psi_no_map[no_ps] == 12){n_channel = 28;}
  else if (psi_no_map[no_ps] == 13){n_channel = 28;}
  else if (psi_no_map[no_ps] == 14){n_channel = 14;}
  else if (psi_no_map[no_ps] == 15){n_channel = 14;}
  else if (psi_no_map[no_ps] == 16){n_channel = 28;}
  else if (psi_no_map[no_ps] == 17){n_channel = 14;}
  else if (psi_no_map[no_ps] == 18){n_channel = 14;}
  else if (psi_no_map[no_ps] == 19){n_channel = 14;}
  else if (psi_no_map[no_ps] == 20){n_channel = 14;}
  else if (psi_no_map[no_ps] == 21){n_channel = 28;}
  else if (psi_no_map[no_ps] == 22){n_channel = 28;}
  else if (psi_no_map[no_ps] == 23){n_channel = 14;}
  else if (psi_no_map[no_ps] == 24){n_channel = 14;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppexnea03_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppexnea03_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 12){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 19){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 21){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppexnea03_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppexnea03_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppexnea03_ax_psp_230_gg_epveadux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  2){ppexnea03_ax_psp_230_gu_epveagd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppexnea03_ax_psp_230_gdx_epveagux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppexnea03_ax_psp_230_du_epveadd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppexnea03_ax_psp_230_dc_epveads(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppexnea03_ax_psp_230_ddx_epveadux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppexnea03_ax_psp_230_ddx_epveascx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppexnea03_ax_psp_230_dsx_epveadcx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppexnea03_ax_psp_230_uu_epveadu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppexnea03_ax_psp_230_uc_epveadc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppexnea03_ax_psp_230_udx_epveagg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 12){ppexnea03_ax_psp_230_udx_epveaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppexnea03_ax_psp_230_udx_epveauux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppexnea03_ax_psp_230_udx_epveassx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppexnea03_ax_psp_230_udx_epveaccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppexnea03_ax_psp_230_uux_epveadux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppexnea03_ax_psp_230_uux_epveascx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppexnea03_ax_psp_230_usx_epveadsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 19){ppexnea03_ax_psp_230_usx_epveaucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppexnea03_ax_psp_230_ucx_epveadcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 21){ppexnea03_ax_psp_230_dxdx_epveadxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppexnea03_ax_psp_230_dxux_epveauxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppexnea03_ax_psp_230_dxsx_epveadxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppexnea03_ax_psp_230_dxcx_epveauxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
