#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppexnea03/header/ppexnea03.phasespace.h"
void ppexnea03_ax_psp_130_gu_epvead(int no_ps, phasespace_set & psi){
  static Logger logger("ppexnea03_ax_psp_130_gu_epvead");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(6);
  psi_needed_v_smin[no_ps].resize(6);
  int needed_v_smin_0[] = {   0,    1,    2,    4,    5,    6,    8,    9}; //   8
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 8);
  int needed_v_smin_1[] = {   0,    1}; //   2
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   2,    6,    5,    8}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   3,    7}; //   2
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 2);
  int needed_v_smin_4[] = {   3,    7}; //   2
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {   4,    9}; //   2
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 2);

  psi_v_smax[no_ps].resize(7);
  psi_needed_v_smax[no_ps].resize(7);
  int needed_v_smax_0[] = {   0,    1,    2,    5,    6,    8,    9}; //   7
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 7);
  int needed_v_smax_1[] = {   0,    1}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   2,    3,    6,    7,    5,    8}; //   6
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 6);
  int needed_v_smax_3[] = {   3,    7}; //   2
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 2);
  int needed_v_smax_4[] = {   4}; //   1
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 1);
  int needed_v_smax_5[] = {   4}; //   1
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 1);
  int needed_v_smax_6[] = {   9}; //   1
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 1);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(8);
  psi_needed_g_p[no_ps].resize(8);
  int needed_g_p_0[] = {   0,    1,    2,    5,    6,    8,    9}; //   7
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 7);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   0,    1}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   2,    6}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   3,    7}; //   2
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_4[] = {   3,    7}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_24_smin4_smax2");
  int needed_g_p_5[] = {   4}; //   1
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 1);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_6[] = {   4}; //   1
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 1);
  psi_container_IS_name.push_back("propagator_24_smin0_smax5");
  int needed_g_p_7[] = {   9}; //   1
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 1);
  psi_container_IS_name.push_back("propagator_0_smin5_smax6");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(1);
  psi_needed_g_f[no_ps].resize(1);
  int needed_g_f_0[] = {   5,    8}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(5);
  psi_needed_g_t[no_ps].resize(5);
  int needed_g_t_0[] = {   0}; //   1
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_44");
  int needed_g_t_1[] = {   5,    6,    7,    8}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_28");
  int needed_g_t_2[] = {   5}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_12");
  int needed_g_t_3[] = {   8}; //   1
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_16");
  int needed_g_t_4[] = {   9}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(9);
  psi_needed_g_d[no_ps].resize(9);
  int needed_g_d_0[] = {   0,    1}; //   2
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_1[] = {   0,    1,    2,    4,    5,    6,    8,    9}; //   8
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 8);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_2[] = {   1}; //   1
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_3[] = {   2,    3}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_4[] = {   2,    6}; //   2
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_5[] = {   3,    7}; //   2
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_6[] = {   3,    7}; //   2
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 2);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_7[] = {   4}; //   1
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 1);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_8[] = {   4,    9}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");

  psi_c_p[no_ps].resize(10);
  psi_c_f[no_ps].resize(10);
  psi_c_t[no_ps].resize(10);
  psi_c_d[no_ps].resize(10);

  int c_p_0[] = {  0,   1}; //   2
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 2);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {  0}; //   1
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 1);
  int c_d_0[] = {  0,   1}; //   2
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 2);

  int c_p_1[] = {  0,   1}; //   2
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 2);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {}; //   0
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 0);
  int c_d_1[] = {  2,   0,   1}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  0,   2}; //   2
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 2);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {}; //   0
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 0);
  int c_d_2[] = {  3,   4,   1}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  3,   4}; //   2
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 2);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {}; //   0
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 0);
  int c_d_3[] = {  3,   5,   6}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  5,   6}; //   2
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 2);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {}; //   0
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 0);
  int c_d_4[] = {  7,   1,   8}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  0}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  0}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  1,   2}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  1}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  0,   2}; //   2
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 2);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  1}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  4,   1}; //   2
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 2);

  int c_p_7[] = {  3,   4}; //   2
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 2);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  1}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  5,   6}; //   2
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 2);

  int c_p_8[] = {  0}; //   1
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 1);
  int c_f_8[] = {  0}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  1,   3}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  1}; //   1
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 1);

  int c_p_9[] = {  0,   7}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  4}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  8,   1}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
