#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppnenex02/header/ppnenex02.phasespace.h"
void ppnenex02_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppnenex02_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppnenex02_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenex02_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 3;}
  else if (psi_no_map[no_ps] == 2){n_channel = 2;}
  else if (psi_no_map[no_ps] == 3){n_channel = 2;}
  else if (psi_no_map[no_ps] == 4){n_channel = 2;}
  else if (psi_no_map[no_ps] == 5){n_channel = 2;}
  else if (psi_no_map[no_ps] == 6){n_channel = 2;}
  else if (psi_no_map[no_ps] == 7){n_channel = 2;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenex02_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppnenex02_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenex02_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenex02_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 2){ppnenex02_ax_psp_120_gd_vevexd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppnenex02_ax_psp_120_gu_vevexu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppnenex02_ax_psp_120_gdx_vevexdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppnenex02_ax_psp_120_gux_vevexux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppnenex02_ax_psp_120_ddx_vevexg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){ppnenex02_ax_psp_120_uux_vevexg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
