#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppnenexa03/header/ppnenexa03.phasespace.h"
void ppnenexa03_optimize_minv_born(phasespace_set & psi){
  static Logger logger("ppnenexa03_optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppnenexa03_determination_MCchannels_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenexa03_determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if (psi_phasespace_order_alpha_s[no_ps] == 0 && psi_phasespace_order_alpha_e[no_ps] == 3 && psi_phasespace_order_interference[no_ps] == 0){
    if      (psi_no_map[no_ps] == 0){n_channel = 2;}
    else if (psi_no_map[no_ps] == 2){n_channel = 2;}
    else if (psi_no_map[no_ps] == 3){n_channel = 2;}
  }
  else if (psi_phasespace_order_alpha_s[no_ps] == 2 && psi_phasespace_order_alpha_e[no_ps] == 3 && psi_phasespace_order_interference[no_ps] == 0){
    if      (psi_no_map[no_ps] == 0){n_channel = 0;}
    else if (psi_no_map[no_ps] == 1){n_channel = 6;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenexa03_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppnenexa03_ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (psi.phasespace_order_alpha_s[no_ps] == 0 && psi.phasespace_order_alpha_e[no_ps] == 3 && psi.phasespace_order_interference[no_ps] == 0){
    if      (psi.no_map[no_ps] == 0){}
    else if (psi.no_map[no_ps] == 2){
      tau_MC_map.push_back(0);
    }
    else if (psi.no_map[no_ps] == 3){
      tau_MC_map.push_back(0);
    }
  }
  else if (psi.phasespace_order_alpha_s[no_ps] == 2 && psi.phasespace_order_alpha_e[no_ps] == 3 && psi.phasespace_order_interference[no_ps] == 0){
    if      (psi.no_map[no_ps] == 0){}
    else if (psi.no_map[no_ps] == 1){
      tau_MC_map.push_back(0);
      //  tau_MC_map.push_back(6);
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppnenexa03_ax_psp_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppnenexa03_ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_phasespace_order_alpha_s[no_ps] == 0 && psi_phasespace_order_alpha_e[no_ps] == 3 && psi_phasespace_order_interference[no_ps] == 0){
    if (psi_no_map[no_ps] == 0){}
    else if (psi_no_map[no_ps] == 2){ppnenexa03_ax_psp_030_ddx_vevexa(no_ps, psi);}
    else if (psi_no_map[no_ps] == 3){ppnenexa03_ax_psp_030_uux_vevexa(no_ps, psi);}
  }
  else if (psi_phasespace_order_alpha_s[no_ps] == 2 && psi_phasespace_order_alpha_e[no_ps] == 3 && psi_phasespace_order_interference[no_ps] == 0){
    if (psi_no_map[no_ps] == 0){}
    else if (psi_no_map[no_ps] == 1){ppnenexa03_ax_psp_230_gg_vevexa(no_ps, psi);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
