#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ag_psp_220_ucx_wpwmdsx(int no_ps, int zero, phasespace_set & psi){
  static Logger logger("ppwxw02_ag_psp_220_ucx_wpwmdsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_xbp[no_ps][5] == nullvector){psi_xbp[no_ps][5] = psi_xbp[no_ps][1] - psi_xbp[no_ps][4];}
  if (psi_xbs[no_ps][5] == 0.){psi_xbs[no_ps][5] = psi_xbp[no_ps][5].m2();}
  if (psi_xbp[no_ps][10] == nullvector){psi_xbp[no_ps][10] = psi_xbp[no_ps][2] - psi_xbp[no_ps][8];}
  if (psi_xbs[no_ps][10] == 0.){psi_xbs[no_ps][10] = psi_xbp[no_ps][10].m2();}
  if (psi_xbp[no_ps][20] == nullvector){psi_xbp[no_ps][20] = psi_xbp[no_ps][4] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][20] == 0.){psi_xbs[no_ps][20] = psi_xbp[no_ps][20].m2();}
  if (psi_xbsqrts[no_ps][20] == 0.){psi_xbsqrts[no_ps][20] = sqrt(psi_xbs[no_ps][20]);}
  if (psi_xbp[no_ps][40] == nullvector){psi_xbp[no_ps][40] = psi_xbp[no_ps][8] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][40] == 0.){psi_xbs[no_ps][40] = psi_xbp[no_ps][40].m2();}
  if (psi_xbsqrts[no_ps][40] == 0.){psi_xbsqrts[no_ps][40] = sqrt(psi_xbs[no_ps][40]);}
  if (psi_xbp[no_ps][48] == nullvector){psi_xbp[no_ps][48] = psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][48] == 0.){psi_xbs[no_ps][48] = psi_xbp[no_ps][48].m2();}
  if (psi_xbsqrts[no_ps][48] == 0.){psi_xbsqrts[no_ps][48] = sqrt(psi_xbs[no_ps][48]);}
  if (psi_xbp[no_ps][21] == nullvector){psi_xbp[no_ps][21] = psi_xbp[no_ps][1] - psi_xbp[no_ps][4] - psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][21] == 0.){psi_xbs[no_ps][21] = psi_xbp[no_ps][21].m2();}
  if (psi_xbp[no_ps][42] == nullvector){psi_xbp[no_ps][42] = psi_xbp[no_ps][2] - psi_xbp[no_ps][8] - psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][42] == 0.){psi_xbs[no_ps][42] = psi_xbp[no_ps][42].m2();}
  if (psi_xbp[no_ps][52] == nullvector){psi_xbp[no_ps][52] = psi_xbp[no_ps][4] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][52] == 0.){psi_xbs[no_ps][52] = psi_xbp[no_ps][52].m2();}
  if (psi_xbp[no_ps][56] == nullvector){psi_xbp[no_ps][56] = psi_xbp[no_ps][8] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][56] == 0.){psi_xbs[no_ps][56] = psi_xbp[no_ps][56].m2();}
  if (psi_xbp[no_ps][60] == nullvector){psi_xbp[no_ps][60] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][60] == 0.){psi_xbs[no_ps][60] = psi_xbp[no_ps][60].m2();}

  psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][20]; // 2 times
  psi_v_smin[no_ps][  1] = psi_smin_opt[no_ps][40]; // 2 times
  psi_v_smin[no_ps][  2] = psi_smin_opt[no_ps][48]; // 1 times
  psi_v_smin[no_ps][  3] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][8] + psi_xbsqrts[no_ps][48], 2), psi_smin_opt[no_ps][56]); // 1 times
  psi_v_smin[no_ps][  4] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][20], 2), psi_smin_opt[no_ps][52]); // 1 times
  psi_v_smin[no_ps][  5] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][40], 2), psi_smin_opt[no_ps][56]); // 1 times

  psi_v_smax[no_ps][  0] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][40], 2); // 1 times
  psi_v_smax[no_ps][  1] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][20], 2); // 2 times
  psi_v_smax[no_ps][  2] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][40], 2); // 1 times
  psi_v_smax[no_ps][  3] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][12], 2); // 1 times
  psi_v_smax[no_ps][  4] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][4], 2); // 2 times
  psi_v_smax[no_ps][  5] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][8], 2); // 1 times

  //  vector<double> g_p(3);
  {psi_g_p[no_ps][  0] = psi.g_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0]); /* npp 2 */} // 1 times
  {psi_g_p[no_ps][  1] = psi.g_propagator(no_ps,   0,  40, psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1]); /* npp 2 */} // 2 times
  {psi_g_p[no_ps][  2] = psi.g_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  2]); /* npp 2 */} // 1 times

  //  vector<double> g_f(4);
  {psi_g_f[no_ps][  0] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  3]); /* nfp 2 */} // 1 times
  {psi_g_f[no_ps][  1] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  4]); /* nfp 3 */} // 1 times
  {psi_g_f[no_ps][  2] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  4], psi_v_smax[no_ps][  5]); /* nfp 3 */} // 1 times
  {psi_g_f[no_ps][  3] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  5], psi_v_smax[no_ps][  4]); /* nfp 3 */} // 1 times

  //  vector<double> g_t(7);
  {psi_g_t[no_ps][  0] = psi.g_tchannel_opt(no_ps,   0,  60,   1,   2,   4,  56); /* ntp 0 */} // 2 times
  {psi_g_t[no_ps][  1] = psi.g_tchannel_opt(no_ps,   0,  56,   2,   5,   8,  48); /* ntp 1 */} // 1 times
  {psi_g_t[no_ps][  2] = psi.g_tchannel(no_ps,   0,  48,   5,  10,  16,  32); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][  3] = psi.g_tchannel_opt(no_ps,   0,  60,   2,   1,   8,  52); /* ntp 0 */} // 1 times
  {psi_g_t[no_ps][  4] = psi.g_tchannel_opt(no_ps,   0,  52,   1,  10,  20,  32); /* ntp 1 */} // 1 times
  {psi_g_t[no_ps][  5] = psi.g_tchannel_opt(no_ps,   0,  56,   2,   5,  40,  16); /* ntp 1 */} // 1 times
  {psi_g_t[no_ps][  6] = psi.g_tchannel_opt(no_ps,   0,  60,   1,   2,  20,  40); /* ntp 0 */} // 1 times

  //  vector<double> g_d(2);
  {psi_g_d[no_ps][  0] = psi.g_decay(no_ps,  20,   4,  16); /* ndp 2 */} // 2 times
  {psi_g_d[no_ps][  1] = psi.g_decay(no_ps,  40,   8,  32); /* ndp 2 */} // 2 times


  if (psi_weight_IS == 2 || psi_weight_IS == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(4);
    inv_r[0].resize(3);
    inv_r[1].resize(4);
    inv_r[2].resize(14);
    inv_r[3].resize(4);

    {psi.inv_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], inv_r[0][0]);} // 1 times
    {psi.inv_propagator(no_ps,   0,  40, psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1], inv_r[0][1]);} // 2 times
    {psi.inv_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  2], inv_r[0][2]);} // 1 times

    {psi.inv_timelikeinvariant(no_ps,  48, psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  3], inv_r[1][0]);} // 1 times
    {psi.inv_timelikeinvariant(no_ps,  56, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  4], inv_r[1][1]);} // 1 times
    {psi.inv_timelikeinvariant(no_ps,  52, psi_v_smin[no_ps][  4], psi_v_smax[no_ps][  5], inv_r[1][2]);} // 1 times
    {psi.inv_timelikeinvariant(no_ps,  56, psi_v_smin[no_ps][  5], psi_v_smax[no_ps][  4], inv_r[1][3]);} // 1 times

    {psi.inv_tchannel_opt(no_ps,   0,  60,   1,   2,   4,  56, inv_r[2][0], inv_r[2][1]);} // 2 times
    {psi.inv_tchannel_opt(no_ps,   0,  56,   2,   5,   8,  48, inv_r[2][2], inv_r[2][3]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  48,   5,  10,  16,  32, inv_r[2][4], inv_r[2][5]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  60,   2,   1,   8,  52, inv_r[2][6], inv_r[2][7]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  52,   1,  10,  20,  32, inv_r[2][8], inv_r[2][9]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  56,   2,   5,  40,  16, inv_r[2][10], inv_r[2][11]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  60,   1,   2,  20,  40, inv_r[2][12], inv_r[2][13]);} // 1 times

    {psi.inv_decay(no_ps,  20,   4,  16, inv_r[3][0], inv_r[3][1]);} // 2 times
    {psi.inv_decay(no_ps,  40,   8,  32, inv_r[3][2], inv_r[3][3]);} // 2 times

    if (psi_weight_IS == 2){
      int n_random = 3 * psi_n_particle - 4;;
      vector<vector<double> > inv_channel_r(4, vector<double> (8));
      vector<double> g_IS(4, 1.);
      for (int i_c = 0; i_c < 4; i_c++){
        int ran = 0;
        if (psi_MC_alpha[zero + i_c] != 0.){
          for (int i_p = 0; i_p < psi_c_p[no_ps][i_c].size(); i_p++){
            inv_channel_r[i_c][i_p] = inv_r[0][psi_c_p[no_ps][i_c][i_p]];
          }
          ran += psi_c_p[no_ps][i_c].size();
          for (int i_f = 0; i_f < psi_c_f[no_ps][i_c].size(); i_f++){
            inv_channel_r[i_c][ran + i_f] = inv_r[1][psi_c_f[no_ps][i_c][i_f]];
          }
          ran += psi_c_f[no_ps][i_c].size();
          for (int i_t = 0; i_t < psi_c_t[no_ps][i_c].size(); i_t++){
            inv_channel_r[i_c][ran + 2 * i_t] = inv_r[2][2 * psi_c_t[no_ps][i_c][i_t]];
            inv_channel_r[i_c][ran + 2 * i_t + 1] = inv_r[2][2 * psi_c_t[no_ps][i_c][i_t] + 1];
          }
          ran += 2 * psi_c_t[no_ps][i_c].size();
          for (int i_d = 0; i_d < psi_c_d[no_ps][i_c].size(); i_d++){
            inv_channel_r[i_c][ran + 2 * i_d] = inv_r[3][2 * psi_c_d[no_ps][i_c][i_d]];
            inv_channel_r[i_c][ran + 2 * i_d + 1] = inv_r[3][2 * psi_c_d[no_ps][i_c][i_d] + 1];
          }
          ran += 2 * psi_c_d[no_ps][i_c].size();
          for (int i_r = 0; i_r < 8; i_r++){
            psi_phasespace_randoms[(zero + i_c) * n_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
            g_IS[i_c] *= g_IS_temp;
          }
        }
      }
      if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = g_IS[  0] * psi_g_f[no_ps][  0] * psi_g_f[no_ps][  1] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  1] * psi_g_t[no_ps][  2];}
      if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = g_IS[  1] * psi_g_p[no_ps][  0] * psi_g_f[no_ps][  2] * psi_g_t[no_ps][  3] * psi_g_t[no_ps][  4] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = g_IS[  2] * psi_g_p[no_ps][  1] * psi_g_f[no_ps][  3] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  5] * psi_g_d[no_ps][  1];}
      if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = g_IS[  3] * psi_g_p[no_ps][  1] * psi_g_p[no_ps][  2] * psi_g_t[no_ps][  6] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1];}

    }
    else if (psi_weight_IS == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(3, 1.);
      g_IS[1].resize(4, 1.);
      g_IS[2].resize(7, 1.);
      g_IS[3].resize(2, 1.);

      for (int i_m = 0; i_m < 4; i_m++){
        for (int i_r = 0; i_r < inv_r[i_m].size(); i_r++){
          psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][i_m] + i_r]->get_g_IS(inv_r[i_m][i_r], g_IS_temp);
          int i_g = i_r;
          if (i_m > 1){i_g = i_r / 2;}
          g_IS[i_m][i_g] *= g_IS_temp;
        }
      }
      if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = psi_g_f[no_ps][  0] * g_IS[1][  0] * psi_g_f[no_ps][  1] * g_IS[1][  1] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_t[no_ps][  2] * g_IS[2][  2];}
      if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_f[no_ps][  2] * g_IS[1][  2] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_t[no_ps][  4] * g_IS[2][  4] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_f[no_ps][  3] * g_IS[1][  3] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][  5] * g_IS[2][  5] * psi_g_d[no_ps][  1] * g_IS[3][  1];}
      if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = psi_g_p[no_ps][  1] * g_IS[0][  1] * psi_g_p[no_ps][  2] * g_IS[0][  2] * psi_g_t[no_ps][  6] * g_IS[2][  6] * psi_g_d[no_ps][  0] * g_IS[3][  0] * psi_g_d[no_ps][  1] * g_IS[3][  1];}
    }
  }

  else {
    if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = psi_g_f[no_ps][  0] * psi_g_f[no_ps][  1] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  1] * psi_g_t[no_ps][  2];}
    if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = psi_g_p[no_ps][  0] * psi_g_f[no_ps][  2] * psi_g_t[no_ps][  3] * psi_g_t[no_ps][  4] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = psi_g_p[no_ps][  1] * psi_g_f[no_ps][  3] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  5] * psi_g_d[no_ps][  1];}
    if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = psi_g_p[no_ps][  1] * psi_g_p[no_ps][  2] * psi_g_t[no_ps][  6] * psi_g_d[no_ps][  0] * psi_g_d[no_ps][  1];}
  }

/*
  if (psi_MC_alpha[   0] != 0.){ag_channel_1111(g, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   1] != 0.){ag_channel_2v11(g, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   2] != 0.){ag_channel_112v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   3] != 0.){ag_channel_2v2v(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  // channel    0: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
  // channel    1: 2v11(1, 2, 4, 16, 32, 8;   0,   0,   0)
  // channel    2: 112v(1, 2, 4, 16, 8, 32;   0,   0,   0)
  // channel    3: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
*/

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
