#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ax_psp_220_bxbx_wpwmbxbx(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_220_bxbx_wpwmbxbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(9);
  psi_needed_v_smin[no_ps].resize(9);
  int needed_v_smin_0[] = {   4,    5,    6,    7,    8,    9,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35}; //  24
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 24);
  int needed_v_smin_1[] = {  10,   18,   20,   22,    0,    3}; //   6
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 6);
  int needed_v_smin_2[] = {  10,   22,    3,   20}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {  11,   19,   21,   23,    1,    2}; //   6
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 6);
  int needed_v_smin_4[] = {  11,   23,    2,   21}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {  12,   13,   14,   24,   25,   26,    7,    8,    9,   30,   31,   32}; //  12
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 12);
  int needed_v_smin_6[] = {  15,   16,   17,   27,   28,   29,    4,    5,    6,   33,   34,   35}; //  12
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 12);
  int needed_v_smin_7[] = {   0,   18}; //   2
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 2);
  int needed_v_smin_8[] = {   1,   19}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);

  psi_v_smax[no_ps].resize(6);
  psi_needed_v_smax[no_ps].resize(6);
  int needed_v_smax_0[] = {   4,    5,    6,    7,    8,    9,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35}; //  24
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 24);
  int needed_v_smax_1[] = {  10,   18,   20,   22,    0,    3}; //   6
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 6);
  int needed_v_smax_2[] = {  10,   15,   16,   17,   22,   27,   28,   29,    3,    4,    5,    6,   20,   33,   34,   35}; //  16
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 16);
  int needed_v_smax_3[] = {  11,   19,   21,   23,    1,    2}; //   6
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 6);
  int needed_v_smax_4[] = {  11,   12,   13,   14,   23,   24,   25,   26,    2,    7,    8,    9,   21,   30,   31,   32}; //  16
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 16);
  int needed_v_smax_5[] = {   0,    1,   18,   19}; //   4
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(9);
  psi_needed_g_p[no_ps].resize(9);
  int needed_g_p_0[] = {   4,    7,   12,   15,   24,   27,   30,   33}; //   8
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 8);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   5,    8,   13,   16,   25,   28,   31,   34}; //   8
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 8);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {   6,    9,   14,   17,   26,   29,   32,   35}; //   8
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 8);
  psi_container_IS_name.push_back("propagator_25_smin0_smax0");
  int needed_g_p_3[] = {  10,   18,   20,   22}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_6_smin1_smax1");
  int needed_g_p_4[] = {  10,   22}; //   2
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 2);
  psi_container_IS_name.push_back("propagator_5_smin2_smax2");
  int needed_g_p_5[] = {  11,   19,   21,   23}; //   4
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 4);
  psi_container_IS_name.push_back("propagator_6_smin3_smax3");
  int needed_g_p_6[] = {  11,   23}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_5_smin4_smax4");
  int needed_g_p_7[] = {  12,   13,   14,   24,   25,   26}; //   6
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 6);
  psi_container_IS_name.push_back("propagator_5_smin5_smax4");
  int needed_g_p_8[] = {  15,   16,   17,   27,   28,   29}; //   6
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 6);
  psi_container_IS_name.push_back("propagator_5_smin6_smax2");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(8);
  psi_needed_g_f[no_ps].resize(8);
  int needed_g_f_0[] = {   0,    3}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");
  int needed_g_f_1[] = {   0,   18}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");
  int needed_g_f_2[] = {   1,    2}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_3[] = {   1,   19}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax5");
  int needed_g_f_4[] = {   2,   21}; //   2
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax4");
  int needed_g_f_5[] = {   3,   20}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax2");
  int needed_g_f_6[] = {   4,    5,    6,   33,   34,   35}; //   6
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax2");
  int needed_g_f_7[] = {   7,    8,    9,   30,   31,   32}; //   6
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax4");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(17);
  psi_needed_g_t[no_ps].resize(17);
  int needed_g_t_0[] = {   0,    1,   18,   19}; //   4
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__1_2__4_56");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__1_2__4_56");
  int needed_g_t_1[] = {   0,   18}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__32_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__32_24");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__5_34__8_16");
  psi_container_IS_name.push_back("phi_of_tchannel_5__5_34__8_16");
  int needed_g_t_3[] = {   1,   19}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__16_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__16_40");
  int needed_g_t_4[] = {   1}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__5_18__8_32");
  psi_container_IS_name.push_back("phi_of_tchannel_5__5_18__8_32");
  int needed_g_t_5[] = {   2,   21,   23,   24,   25,   26,   30,   31,   32}; //   9
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_6[] = {   2,   21}; //   2
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_17__4_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_17__4_40");
  int needed_g_t_7[] = {   2}; //   1
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__17_6__32_8");
  psi_container_IS_name.push_back("phi_of_tchannel_5__17_6__32_8");
  int needed_g_t_8[] = {   3,   20,   22,   27,   28,   29,   33,   34,   35}; //   9
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_28");
  int needed_g_t_9[] = {   3,   20}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_6__2_33__4_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_6__2_33__4_24");
  int needed_g_t_10[] = {   3}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_5__33_6__16_8");
  psi_container_IS_name.push_back("phi_of_tchannel_5__33_6__16_8");
  int needed_g_t_11[] = {   4,    5,    6,   10,   15,   16,   17}; //   7
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_28");
  int needed_g_t_12[] = {   4,    5,    6}; //   3
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_34__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_34__12_16");
  int needed_g_t_13[] = {   7,    8,    9,   11,   12,   13,   14}; //   7
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_44");
  int needed_g_t_14[] = {   7,    8,    9}; //   3
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__1_18__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__1_18__12_32");
  int needed_g_t_15[] = {  30,   31,   32}; //   3
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_17__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_17__12_32");
  int needed_g_t_16[] = {  33,   34,   35}; //   3
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_5__2_33__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_5__2_33__12_16");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(7);
  psi_needed_g_d[no_ps].resize(7);
  int needed_g_d_0[] = {   4,    5,    6,    7,    8,    9,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35}; //  24
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 24);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {  10,   22}; //   2
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 2);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_2[] = {  10,   18,   20,   22}; //   4
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 4);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {  11,   23}; //   2
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 2);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_4[] = {  11,   19,   21,   23}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_5[] = {  12,   13,   14,   24,   25,   26}; //   6
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 6);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_6[] = {  15,   16,   17,   27,   28,   29}; //   6
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 6);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");

  psi_c_p[no_ps].resize(36);
  psi_c_f[no_ps].resize(36);
  psi_c_t[no_ps].resize(36);
  psi_c_d[no_ps].resize(36);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  0,   3,   4}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {}; //   0
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 0);
  int c_f_2[] = {  2,   4}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  5,   6,   7}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {}; //   0
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 0);

  int c_p_3[] = {}; //   0
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 0);
  int c_f_3[] = {  0,   5}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  8,   9,  10}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {}; //   0
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 0);

  int c_p_4[] = {  0}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {  6}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = { 11,  12}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  0}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  1}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  6}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = { 11,  12}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  0}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  2}; //   1
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 1);
  int c_f_6[] = {  6}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = { 11,  12}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  0}; //   1
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 1);

  int c_p_7[] = {  0}; //   1
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 1);
  int c_f_7[] = {  7}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = { 13,  14}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  0}; //   1
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 1);

  int c_p_8[] = {  1}; //   1
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 1);
  int c_f_8[] = {  7}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = { 13,  14}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  0}; //   1
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 1);

  int c_p_9[] = {  2}; //   1
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 1);
  int c_f_9[] = {  7}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = { 13,  14}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  0}; //   1
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 1);

  int c_p_10[] = {  3,   4}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = { 11}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = {  1,   2}; //   2
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 2);

  int c_p_11[] = {  5,   6}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = { 13}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = {  3,   4}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  0,   7}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = { 13}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  5,   0}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  1,   7}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = { 13}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  5,   0}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  2,   7}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = { 13}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  5,   0}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  int c_p_15[] = {  0,   8}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = { 11}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  6,   0}; //   2
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 2);

  int c_p_16[] = {  1,   8}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = { 11}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  6,   0}; //   2
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 2);

  int c_p_17[] = {  2,   8}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = { 11}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  6,   0}; //   2
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 2);

  int c_p_18[] = {  3}; //   1
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 1);
  int c_f_18[] = {  1}; //   1
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 1);
  int c_t_18[] = {  0,   1}; //   2
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 2);
  int c_d_18[] = {  2}; //   1
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 1);

  int c_p_19[] = {  5}; //   1
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 1);
  int c_f_19[] = {  3}; //   1
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 1);
  int c_t_19[] = {  0,   3}; //   2
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 2);
  int c_d_19[] = {  4}; //   1
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 1);

  int c_p_20[] = {  3}; //   1
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 1);
  int c_f_20[] = {  5}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = {  8,   9}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = {  2}; //   1
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 1);

  int c_p_21[] = {  5}; //   1
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 1);
  int c_f_21[] = {  4}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = {  5,   6}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  4}; //   1
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 1);

  int c_p_22[] = {  3,   4}; //   2
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 2);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  8}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = {  1,   2}; //   2
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 2);

  int c_p_23[] = {  5,   6}; //   2
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 2);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  5}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = {  3,   4}; //   2
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 2);

  int c_p_24[] = {  0,   7}; //   2
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 2);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  5}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = {  5,   0}; //   2
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 2);

  int c_p_25[] = {  1,   7}; //   2
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 2);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  5}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  5,   0}; //   2
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 2);

  int c_p_26[] = {  2,   7}; //   2
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 2);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  5}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = {  5,   0}; //   2
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 2);

  int c_p_27[] = {  0,   8}; //   2
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 2);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  8}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  6,   0}; //   2
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 2);

  int c_p_28[] = {  1,   8}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  8}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  6,   0}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  2,   8}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  8}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  6,   0}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  int c_p_30[] = {  0}; //   1
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 1);
  int c_f_30[] = {  7}; //   1
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 1);
  int c_t_30[] = {  5,  15}; //   2
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 2);
  int c_d_30[] = {  0}; //   1
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 1);

  int c_p_31[] = {  1}; //   1
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 1);
  int c_f_31[] = {  7}; //   1
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 1);
  int c_t_31[] = {  5,  15}; //   2
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 2);
  int c_d_31[] = {  0}; //   1
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 1);

  int c_p_32[] = {  2}; //   1
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 1);
  int c_f_32[] = {  7}; //   1
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 1);
  int c_t_32[] = {  5,  15}; //   2
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 2);
  int c_d_32[] = {  0}; //   1
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 1);

  int c_p_33[] = {  0}; //   1
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 1);
  int c_f_33[] = {  6}; //   1
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 1);
  int c_t_33[] = {  8,  16}; //   2
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 2);
  int c_d_33[] = {  0}; //   1
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 1);

  int c_p_34[] = {  1}; //   1
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 1);
  int c_f_34[] = {  6}; //   1
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 1);
  int c_t_34[] = {  8,  16}; //   2
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 2);
  int c_d_34[] = {  0}; //   1
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 1);

  int c_p_35[] = {  2}; //   1
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 1);
  int c_f_35[] = {  6}; //   1
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 1);
  int c_t_35[] = {  8,  16}; //   2
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 2);
  int c_d_35[] = {  0}; //   1
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
