#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ax_psp_220_uux_wpwmgg(int no_ps, phasespace_set & psi){
  static Logger logger("ppwxw02_ax_psp_220_uux_wpwmgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(14);
  psi_needed_v_smin[no_ps].resize(14);
  int needed_v_smin_0[] = {  12,   13,   14,   15,   17,   18,   20,   21,   23,   24,   25,   26,   27,   28,   29,   30,    3,    8}; //  18
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 18);
  int needed_v_smin_1[] = {  16,   19,   22,   27,   28,   29,   30,    5,    6}; //   9
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 9);
  int needed_v_smin_2[] = {   0,    4}; //   2
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   0,    4}; //   2
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 2);
  int needed_v_smin_4[] = {   1,    2}; //   2
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {   1,    2}; //   2
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 2);
  int needed_v_smin_6[] = {   3,   12,   13,   17,   18,   25,   26}; //   7
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 7);
  int needed_v_smin_7[] = {   5,    6,   19,   22}; //   4
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 4);
  int needed_v_smin_8[] = {   7,   11}; //   2
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   7,   11}; //   2
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   8,   14,   15,   20,   21,   23,   24}; //   7
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 7);
  int needed_v_smin_11[] = {   9,   10}; //   2
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 2);
  int needed_v_smin_12[] = {   9,   10}; //   2
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 2);
  int needed_v_smin_13[] = {  16}; //   1
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 1);

  psi_v_smax[no_ps].resize(12);
  psi_needed_v_smax[no_ps].resize(12);
  int needed_v_smax_0[] = {  12,   13,   14,   15,   17,   18,   20,   21,   23,   24,   25,   26,   29,   30,    3,    8}; //  16
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 16);
  int needed_v_smax_1[] = {  16,   19,   22,   27,   28,    5,    6}; //   7
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 7);
  int needed_v_smax_2[] = {  27,   28}; //   2
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 2);
  int needed_v_smax_3[] = {  29,   30}; //   2
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 2);
  int needed_v_smax_4[] = {   0,    4}; //   2
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 2);
  int needed_v_smax_5[] = {   0,    1,    2,    4,    5,    6,   19,   22}; //   8
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 8);
  int needed_v_smax_6[] = {   1,    2}; //   2
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 2);
  int needed_v_smax_7[] = {   3,    7,   11,   12,   13,   17,   18,   25,   26}; //   9
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 9);
  int needed_v_smax_8[] = {   7,   11}; //   2
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 2);
  int needed_v_smax_9[] = {   8,    9,   10,   14,   15,   20,   21,   23,   24}; //   9
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 9);
  int needed_v_smax_10[] = {   9,   10}; //   2
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 2);
  int needed_v_smax_11[] = {  16}; //   1
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 1);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(6);
  psi_needed_g_p[no_ps].resize(6);
  int needed_g_p_0[] = {  12,   14,   17,   20,   23,   25,   29}; //   7
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 7);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {  13,   15,   18,   21,   24,   26,   30}; //   7
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 7);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {  16,   19,   22,   27,   28}; //   5
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 5);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_3[] = {  27}; //   1
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 1);
  psi_container_IS_name.push_back("propagator_0_smin0_smax2");
  int needed_g_p_4[] = {  28}; //   1
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 1);
  psi_container_IS_name.push_back("propagator_23_smin0_smax2");
  int needed_g_p_5[] = {  29,   30}; //   2
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax3");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(14);
  psi_needed_g_f[no_ps].resize(14);
  int needed_g_f_0[] = {   0,    4}; //   2
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin2_smax4");
  int needed_g_f_1[] = {   0,    4}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax5");
  int needed_g_f_2[] = {   1,    2}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax6");
  int needed_g_f_3[] = {   1,    2}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax5");
  int needed_g_f_4[] = {   3,    8}; //   2
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin0_smax0");
  int needed_g_f_5[] = {   3,   12,   13,   17,   18,   25,   26}; //   7
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 7);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax7");
  int needed_g_f_6[] = {   5,    6}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");
  int needed_g_f_7[] = {   5,    6,   19,   22}; //   4
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");
  int needed_g_f_8[] = {   7,   11}; //   2
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax8");
  int needed_g_f_9[] = {   7,   11}; //   2
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax7");
  int needed_g_f_10[] = {   8,   14,   15,   20,   21,   23,   24}; //   7
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 7);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax9");
  int needed_g_f_11[] = {   9,   10}; //   2
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax10");
  int needed_g_f_12[] = {   9,   10}; //   2
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax9");
  int needed_g_f_13[] = {  16}; //   1
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax11");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(33);
  psi_needed_g_t[no_ps].resize(33);
  int needed_g_t_0[] = {   0,    1,    2,    4,    5,    6,   19,   22}; //   8
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__4_56");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__4_56");
  int needed_g_t_1[] = {   0,    4}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__32_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__32_24");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__5_34__8_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__5_34__8_16");
  int needed_g_t_3[] = {   1,    2}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__16_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__16_40");
  int needed_g_t_4[] = {   1}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__5_18__8_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__5_18__8_32");
  int needed_g_t_5[] = {   2}; //   1
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__5_18__32_8");
  psi_container_IS_name.push_back("phi_of_tchannel_0__5_18__32_8");
  int needed_g_t_6[] = {   3,    7,   11,   17,   18,   25,   26}; //   7
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_28");
  int needed_g_t_7[] = {   3,   17,   18}; //   3
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_12");
  int needed_g_t_8[] = {   3}; //   1
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__4_8");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__4_8");
  int needed_g_t_9[] = {   4}; //   1
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__5_34__16_8");
  psi_container_IS_name.push_back("phi_of_tchannel_0__5_34__16_8");
  int needed_g_t_10[] = {   5,    6,   19}; //   3
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__8_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__8_48");
  int needed_g_t_11[] = {   5}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__5_10__16_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__5_10__16_32");
  int needed_g_t_12[] = {   6}; //   1
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__5_10__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__5_10__32_16");
  int needed_g_t_13[] = {   7,   11}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__8_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__8_20");
  int needed_g_t_14[] = {   7}; //   1
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_10__4_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_10__4_16");
  int needed_g_t_15[] = {   8,    9,   10,   20,   21,   23,   24}; //   7
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 7);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_16[] = {   8,   20,   21}; //   3
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__32_12");
  int needed_g_t_17[] = {   8}; //   1
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_34__4_8");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_34__4_8");
  int needed_g_t_18[] = {   9,   10}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__8_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__8_36");
  int needed_g_t_19[] = {   9}; //   1
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_10__4_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_10__4_32");
  int needed_g_t_20[] = {  10}; //   1
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_10__32_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_10__32_4");
  int needed_g_t_21[] = {  11}; //   1
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_10__16_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_10__16_4");
  int needed_g_t_22[] = {  12,   13}; //   2
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_28");
  int needed_g_t_23[] = {  12,   13}; //   2
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__12_16");
  int needed_g_t_24[] = {  14,   15}; //   2
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_44");
  int needed_g_t_25[] = {  14,   15}; //   2
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_32");
  int needed_g_t_26[] = {  16}; //   1
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__8_52");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__8_52");
  int needed_g_t_27[] = {  16}; //   1
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_10__48_4");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_10__48_4");
  int needed_g_t_28[] = {  22}; //   1
  psi_needed_g_t[no_ps][28] = get_vector_from_array_int(needed_g_t_28, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__48_8");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__48_8");
  int needed_g_t_29[] = {  23,   24}; //   2
  psi_needed_g_t[no_ps][29] = get_vector_from_array_int(needed_g_t_29, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_32");
  int needed_g_t_30[] = {  25,   26}; //   2
  psi_needed_g_t[no_ps][30] = get_vector_from_array_int(needed_g_t_30, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_16");
  int needed_g_t_31[] = {  27,   28}; //   2
  psi_needed_g_t[no_ps][31] = get_vector_from_array_int(needed_g_t_31, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_48");
  int needed_g_t_32[] = {  29,   30}; //   2
  psi_needed_g_t[no_ps][32] = get_vector_from_array_int(needed_g_t_32, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_12");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(2);
  psi_needed_g_d[no_ps].resize(2);
  int needed_g_d_0[] = {  12,   13,   14,   15,   17,   18,   20,   21,   23,   24,   25,   26,   27,   28,   29,   30}; //  16
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 16);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {  16,   19,   22,   27,   28,   29,   30}; //   7
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 7);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");

  psi_c_p[no_ps].resize(31);
  psi_c_f[no_ps].resize(31);
  psi_c_t[no_ps].resize(31);
  psi_c_d[no_ps].resize(31);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  0,   3,   4}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {}; //   0
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 0);
  int c_f_2[] = {  2,   3}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  0,   3,   5}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {}; //   0
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 0);

  int c_p_3[] = {}; //   0
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 0);
  int c_f_3[] = {  4,   5}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  6,   7,   8}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {}; //   0
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 0);

  int c_p_4[] = {}; //   0
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 0);
  int c_f_4[] = {  0,   1}; //   2
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 2);
  int c_t_4[] = {  0,   1,   9}; //   3
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 3);
  int c_d_4[] = {}; //   0
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 0);

  int c_p_5[] = {}; //   0
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 0);
  int c_f_5[] = {  6,   7}; //   2
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 2);
  int c_t_5[] = {  0,  10,  11}; //   3
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 3);
  int c_d_5[] = {}; //   0
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 0);

  int c_p_6[] = {}; //   0
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 0);
  int c_f_6[] = {  6,   7}; //   2
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 2);
  int c_t_6[] = {  0,  10,  12}; //   3
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 3);
  int c_d_6[] = {}; //   0
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 0);

  int c_p_7[] = {}; //   0
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 0);
  int c_f_7[] = {  8,   9}; //   2
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 2);
  int c_t_7[] = {  6,  13,  14}; //   3
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 3);
  int c_d_7[] = {}; //   0
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 0);

  int c_p_8[] = {}; //   0
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 0);
  int c_f_8[] = {  4,  10}; //   2
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 2);
  int c_t_8[] = { 15,  16,  17}; //   3
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 3);
  int c_d_8[] = {}; //   0
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 0);

  int c_p_9[] = {}; //   0
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 0);
  int c_f_9[] = { 11,  12}; //   2
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 2);
  int c_t_9[] = { 15,  18,  19}; //   3
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 3);
  int c_d_9[] = {}; //   0
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 0);

  int c_p_10[] = {}; //   0
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 0);
  int c_f_10[] = { 11,  12}; //   2
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 2);
  int c_t_10[] = { 15,  18,  20}; //   3
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 3);
  int c_d_10[] = {}; //   0
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 0);

  int c_p_11[] = {}; //   0
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 0);
  int c_f_11[] = {  8,   9}; //   2
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 2);
  int c_t_11[] = {  6,  13,  21}; //   3
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 3);
  int c_d_11[] = {}; //   0
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 0);

  int c_p_12[] = {  0}; //   1
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 1);
  int c_f_12[] = {  5}; //   1
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 1);
  int c_t_12[] = { 22,  23}; //   2
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 2);
  int c_d_12[] = {  0}; //   1
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 1);

  int c_p_13[] = {  1}; //   1
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 1);
  int c_f_13[] = {  5}; //   1
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 1);
  int c_t_13[] = { 22,  23}; //   2
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 2);
  int c_d_13[] = {  0}; //   1
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 1);

  int c_p_14[] = {  0}; //   1
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 1);
  int c_f_14[] = { 10}; //   1
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 1);
  int c_t_14[] = { 24,  25}; //   2
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 2);
  int c_d_14[] = {  0}; //   1
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 1);

  int c_p_15[] = {  1}; //   1
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 1);
  int c_f_15[] = { 10}; //   1
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 1);
  int c_t_15[] = { 24,  25}; //   2
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 2);
  int c_d_15[] = {  0}; //   1
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 1);

  int c_p_16[] = {  2}; //   1
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 1);
  int c_f_16[] = { 13}; //   1
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 1);
  int c_t_16[] = { 26,  27}; //   2
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 2);
  int c_d_16[] = {  1}; //   1
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 1);

  int c_p_17[] = {  0}; //   1
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 1);
  int c_f_17[] = {  5}; //   1
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 1);
  int c_t_17[] = {  6,   7}; //   2
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 2);
  int c_d_17[] = {  0}; //   1
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 1);

  int c_p_18[] = {  1}; //   1
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 1);
  int c_f_18[] = {  5}; //   1
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 1);
  int c_t_18[] = {  6,   7}; //   2
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 2);
  int c_d_18[] = {  0}; //   1
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 1);

  int c_p_19[] = {  2}; //   1
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 1);
  int c_f_19[] = {  7}; //   1
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 1);
  int c_t_19[] = {  0,  10}; //   2
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 2);
  int c_d_19[] = {  1}; //   1
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 1);

  int c_p_20[] = {  0}; //   1
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 1);
  int c_f_20[] = { 10}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = { 15,  16}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = {  0}; //   1
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 1);

  int c_p_21[] = {  1}; //   1
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 1);
  int c_f_21[] = { 10}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = { 15,  16}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  0}; //   1
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 1);

  int c_p_22[] = {  2}; //   1
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 1);
  int c_f_22[] = {  7}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  0,  28}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  1}; //   1
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 1);

  int c_p_23[] = {  0}; //   1
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 1);
  int c_f_23[] = { 10}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = { 15,  29}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  0}; //   1
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 1);

  int c_p_24[] = {  1}; //   1
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 1);
  int c_f_24[] = { 10}; //   1
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 1);
  int c_t_24[] = { 15,  29}; //   2
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 2);
  int c_d_24[] = {  0}; //   1
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 1);

  int c_p_25[] = {  0}; //   1
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 1);
  int c_f_25[] = {  5}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  6,  30}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  0}; //   1
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 1);

  int c_p_26[] = {  1}; //   1
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 1);
  int c_f_26[] = {  5}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = {  6,  30}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  0}; //   1
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 1);

  int c_p_27[] = {  2,   3}; //   2
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 2);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = { 31}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = {  0,   1}; //   2
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 2);

  int c_p_28[] = {  2,   4}; //   2
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 2);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = { 31}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  0,   1}; //   2
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 2);

  int c_p_29[] = {  0,   5}; //   2
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 2);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = { 32}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  1,   0}; //   2
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 2);

  int c_p_30[] = {  1,   5}; //   2
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 2);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = { 32}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  1,   0}; //   2
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
