#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppzz02/header/ppzz02.phasespace.h"
void ppzz02_ax_psp_220_ds_zzds(int no_ps, phasespace_set & psi){
  static Logger logger("ppzz02_ax_psp_220_ds_zzds");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(15);
  psi_needed_v_smin[no_ps].resize(15);
  int needed_v_smin_0[] = {   6,    9,   12,   18,    3}; //   5
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 5);
  int needed_v_smin_1[] = {   7,    8,   10,   19,    0}; //   5
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 5);
  int needed_v_smin_2[] = {   8}; //   1
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 1);
  int needed_v_smin_3[] = {   9}; //   1
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 1);
  int needed_v_smin_4[] = {  11,   15,   17,   19,    2}; //   5
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 5);
  int needed_v_smin_5[] = {  13,   14,   16,   18,    5}; //   5
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 5);
  int needed_v_smin_6[] = {  14,    5,   13}; //   3
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 3);
  int needed_v_smin_7[] = {  15,    2,   11}; //   3
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 3);
  int needed_v_smin_8[] = {   0,    7,   10}; //   3
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 3);
  int needed_v_smin_9[] = {   1,    4}; //   2
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   1}; //   1
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 1);
  int needed_v_smin_11[] = {   3,    6,   12}; //   3
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 3);
  int needed_v_smin_12[] = {   4}; //   1
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 1);
  int needed_v_smin_13[] = {  16}; //   1
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 1);
  int needed_v_smin_14[] = {  17}; //   1
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 1);

  psi_v_smax[no_ps].resize(11);
  psi_needed_v_smax[no_ps].resize(11);
  int needed_v_smax_0[] = {   6,    9,   12,    3}; //   4
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 4);
  int needed_v_smax_1[] = {   7,    8,   10,    0}; //   4
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   8,    9}; //   2
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 2);
  int needed_v_smax_3[] = {  11,   15,   17,   19,    2}; //   5
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 5);
  int needed_v_smax_4[] = {  13,   14,   16,   18,    5}; //   5
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 5);
  int needed_v_smax_5[] = {  14,   15,    2,    5,   11,   13}; //   6
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 6);
  int needed_v_smax_6[] = {  18}; //   1
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 1);
  int needed_v_smax_7[] = {  19}; //   1
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 1);
  int needed_v_smax_8[] = {   0,    1,    7,   10,   16}; //   5
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 5);
  int needed_v_smax_9[] = {   1,    4}; //   2
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 2);
  int needed_v_smax_10[] = {   3,    4,    6,   12,   17}; //   5
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 5);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(10);
  psi_needed_g_p[no_ps].resize(10);
  int needed_g_p_0[] = {   6,    9,   12}; //   3
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   7,    8,   10}; //   3
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 3);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   8}; //   1
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 1);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   9}; //   1
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 1);
  psi_container_IS_name.push_back("propagator_0_smin3_smax2");
  int needed_g_p_4[] = {  11,   15,   17,   19}; //   4
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 4);
  psi_container_IS_name.push_back("propagator_0_smin4_smax3");
  int needed_g_p_5[] = {  13,   14,   16,   18}; //   4
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 4);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_6[] = {  14}; //   1
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 1);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_7[] = {  15}; //   1
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 1);
  psi_container_IS_name.push_back("propagator_0_smin7_smax5");
  int needed_g_p_8[] = {  18}; //   1
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 1);
  psi_container_IS_name.push_back("propagator_0_smin0_smax6");
  int needed_g_p_9[] = {  19}; //   1
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 1);
  psi_container_IS_name.push_back("propagator_0_smin1_smax7");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(13);
  psi_needed_g_f[no_ps].resize(13);
  int needed_g_f_0[] = {   0}; //   1
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin1_smax1");
  int needed_g_f_1[] = {   0,    7,   10}; //   3
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax8");
  int needed_g_f_2[] = {   1,    4}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax9");
  int needed_g_f_3[] = {   1}; //   1
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax8");
  int needed_g_f_4[] = {   2}; //   1
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax3");
  int needed_g_f_5[] = {   2,   11}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax5");
  int needed_g_f_6[] = {   3}; //   1
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin0_smax0");
  int needed_g_f_7[] = {   3,    6,   12}; //   3
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 3);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax10");
  int needed_g_f_8[] = {   4}; //   1
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax10");
  int needed_g_f_9[] = {   5}; //   1
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin5_smax4");
  int needed_g_f_10[] = {   5,   13}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin6_smax5");
  int needed_g_f_11[] = {  16}; //   1
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax8");
  int needed_g_f_12[] = {  17}; //   1
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax10");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(24);
  psi_needed_g_t[no_ps].resize(24);
  int needed_g_t_0[] = {   0,    1,   10,   16}; //   4
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__4_56");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__4_56");
  int needed_g_t_1[] = {   0,   10}; //   2
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__32_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__32_24");
  int needed_g_t_2[] = {   0}; //   1
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__5_34__8_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__5_34__8_16");
  int needed_g_t_3[] = {   1}; //   1
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__8_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__8_48");
  int needed_g_t_4[] = {   1}; //   1
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__5_10__16_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__5_10__16_32");
  int needed_g_t_5[] = {   2,    5,   11,   13,   14,   15}; //   6
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_44");
  int needed_g_t_6[] = {   2,   11}; //   2
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__8_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__8_36");
  int needed_g_t_7[] = {   2}; //   1
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_10__32_4");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_10__32_4");
  int needed_g_t_8[] = {   3,    4,   12,   17}; //   4
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__8_52");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__8_52");
  int needed_g_t_9[] = {   3,   12}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_9__32_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_9__32_20");
  int needed_g_t_10[] = {   3}; //   1
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__9_34__4_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__9_34__4_16");
  int needed_g_t_11[] = {   4}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_9__4_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_9__4_48");
  int needed_g_t_12[] = {   4}; //   1
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__9_6__16_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__9_6__16_32");
  int needed_g_t_13[] = {   5,   13}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__4_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__4_40");
  int needed_g_t_14[] = {   5}; //   1
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_6__32_8");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_6__32_8");
  int needed_g_t_15[] = {   6}; //   1
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__8_52");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__8_52");
  int needed_g_t_16[] = {   6}; //   1
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_10__20_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_10__20_32");
  int needed_g_t_17[] = {   7}; //   1
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__4_56");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__4_56");
  int needed_g_t_18[] = {   7}; //   1
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_6__24_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_6__24_32");
  int needed_g_t_19[] = {   8,    9}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_28");
  int needed_g_t_20[] = {  16}; //   1
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_5__40_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_5__40_16");
  int needed_g_t_21[] = {  17}; //   1
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_9__36_16");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_9__36_16");
  int needed_g_t_22[] = {  18}; //   1
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__20_40");
  int needed_g_t_23[] = {  19}; //   1
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__24_36");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(8);
  psi_needed_g_d[no_ps].resize(8);
  int needed_g_d_0[] = {   6,    9,   12,   18}; //   4
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 4);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_1[] = {   7,    8,   10,   19}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_2[] = {   8}; //   1
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 1);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_3[] = {   9}; //   1
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 1);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_4[] = {  11,   15,   17,   19}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_5[] = {  13,   14,   16,   18}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_6[] = {  14}; //   1
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 1);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_7[] = {  15}; //   1
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 1);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");

  psi_c_p[no_ps].resize(20);
  psi_c_f[no_ps].resize(20);
  psi_c_t[no_ps].resize(20);
  psi_c_d[no_ps].resize(20);

  int c_p_0[] = {}; //   0
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 0);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {}; //   0
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 0);

  int c_p_1[] = {}; //   0
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 0);
  int c_f_1[] = {  2,   3}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  0,   3,   4}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {}; //   0
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 0);

  int c_p_2[] = {}; //   0
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 0);
  int c_f_2[] = {  4,   5}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  5,   6,   7}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {}; //   0
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 0);

  int c_p_3[] = {}; //   0
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 0);
  int c_f_3[] = {  6,   7}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  8,   9,  10}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {}; //   0
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 0);

  int c_p_4[] = {}; //   0
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 0);
  int c_f_4[] = {  2,   8}; //   2
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 2);
  int c_t_4[] = {  8,  11,  12}; //   3
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 3);
  int c_d_4[] = {}; //   0
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 0);

  int c_p_5[] = {}; //   0
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 0);
  int c_f_5[] = {  9,  10}; //   2
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 2);
  int c_t_5[] = {  5,  13,  14}; //   3
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 3);
  int c_d_5[] = {}; //   0
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 0);

  int c_p_6[] = {  0}; //   1
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 1);
  int c_f_6[] = {  7}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = { 15,  16}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  0}; //   1
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 1);

  int c_p_7[] = {  1}; //   1
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 1);
  int c_f_7[] = {  1}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = { 17,  18}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  1}; //   1
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 1);

  int c_p_8[] = {  1,   2}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = { 19}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = {  2,   1}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  0,   3}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = { 19}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = {  3,   0}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  1}; //   1
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 1);
  int c_f_10[] = {  1}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = {  0,   1}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = {  1}; //   1
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 1);

  int c_p_11[] = {  4}; //   1
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 1);
  int c_f_11[] = {  5}; //   1
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 1);
  int c_t_11[] = {  5,   6}; //   2
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 2);
  int c_d_11[] = {  4}; //   1
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 1);

  int c_p_12[] = {  0}; //   1
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 1);
  int c_f_12[] = {  7}; //   1
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 1);
  int c_t_12[] = {  8,   9}; //   2
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 2);
  int c_d_12[] = {  0}; //   1
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 1);

  int c_p_13[] = {  5}; //   1
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 1);
  int c_f_13[] = { 10}; //   1
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 1);
  int c_t_13[] = {  5,  13}; //   2
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 2);
  int c_d_13[] = {  5}; //   1
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 1);

  int c_p_14[] = {  5,   6}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  5}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  6,   5}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  int c_p_15[] = {  4,   7}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  5}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  7,   4}; //   2
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 2);

  int c_p_16[] = {  5}; //   1
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 1);
  int c_f_16[] = { 11}; //   1
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 1);
  int c_t_16[] = {  0,  20}; //   2
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 2);
  int c_d_16[] = {  5}; //   1
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 1);

  int c_p_17[] = {  4}; //   1
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 1);
  int c_f_17[] = { 12}; //   1
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 1);
  int c_t_17[] = {  8,  21}; //   2
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 2);
  int c_d_17[] = {  4}; //   1
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 1);

  int c_p_18[] = {  5,   8}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = { 22}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  0,   5}; //   2
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 2);

  int c_p_19[] = {  4,   9}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = { 23}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  1,   4}; //   2
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
