#include "../include/classes.cxx"

////////////////////
//  constructors  //
////////////////////
contribution_set::contribution_set(){
  fill_code_particle();
  fill_name_particle();

  basic_process_class = "";
  process_class = "";
  decay.resize(0);
  type_perturbative_order = "";
  type_contribution = "";
  type_correction = "";
  contribution_order_alpha_s = 0;
  contribution_order_alpha_e = 0;
  contribution_order_interference = 0;

  basic_subprocess = "";
  subprocess = "";
  type_parton.resize(1);
  n_particle = 0;
  process_type = 0;

  for (int j_l = 1; j_l < 7; j_l++){
    lepton_exchange[10 + j_l] = 10 + j_l;
    lepton_exchange[-10 - j_l] = -10 - j_l;
  }
}

contribution_set::contribution_set(string _process_class, vector<string> _decay, string _type_perturbative_order, string _type_contribution, string _type_correction, int _order_alpha_s, int _order_alpha_e, int _order_interference, string _subprocess){
  Logger logger("contribution_set::contribution_set");
  logger << LOG_DEBUG << "started" << endl;
  //  logger << LOG_DEBUG << "The same information is also contained in observable_set !!!" << endl;

  fill_code_particle();
  fill_name_particle();

  //  basic_process_class = _basic_process_class;
  process_class = _process_class;
  decay = _decay;

  type_perturbative_order = _type_perturbative_order;
  type_contribution = _type_contribution;
  type_correction = _type_correction;

  contribution_order_alpha_s = _order_alpha_s;
  contribution_order_alpha_e = _order_alpha_e;
  contribution_order_interference = _order_interference;

  // ???
  //  basic_subprocess = _basic_subprocess;
  subprocess = _subprocess;

  //  type_parton.resize(1);
  //  subprocess_readin(process_class, subprocess, decay, process_type, n_particle, type_parton);
  readin_subprocess();

  for (int j_l = 1; j_l < 7; j_l++){
    lepton_exchange[10 + j_l] = 10 + j_l;
    lepton_exchange[-10 - j_l] = -10 - j_l;
  }

  logger << LOG_DEBUG << "basic_process_class = " << basic_process_class << endl;
  logger << LOG_DEBUG << "process_class = " << process_class << endl;
  for (int i_v = 0; i_v < decay.size(); i_v++){
    logger << LOG_DEBUG << "decay[" << i_v << "] = " << decay[i_v] << endl;
  }

  logger << LOG_DEBUG << "type_perturbative_order = " << type_perturbative_order << endl;
  logger << LOG_DEBUG << "type_contribution = " << type_contribution << endl;
  logger << LOG_DEBUG << "type_correction = " << type_correction << endl;
  
  logger << LOG_DEBUG << "contribution_order_alpha_s = " << contribution_order_alpha_s << endl;
  logger << LOG_DEBUG << "contribution_order_alpha_e = " << contribution_order_alpha_e << endl;
  logger << LOG_DEBUG << "contribution_order_interference = " << contribution_order_interference << endl;
  
  logger << LOG_DEBUG << "subprocess = " << subprocess << endl;

  logger << LOG_DEBUG << "finished" << endl;
}

/*
void contribution_set::readin_subprocess(){
  Logger logger("contribution_set::readin_subprocess");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  //  basic_type_parton.resize(1);
  //  type_parton.resize(1);
  //  subprocess_readin(csi.process_class, csi.subprocess, csi.decay, csi.process_type, csi.n_particle, csi.type_parton);
  //  determine_basic_subprocess();

  // determine type_parton from basic_type_parton (possibly exchanged leptons):
  determine_subprocess();

  logger << LOG_DEBUG << "finished" << endl;
}
*/
/*
void contribution_set::determine_basic_subprocess(){
  Logger logger("contribution_set::determine_basic_subprocess");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  //  map<string,int> code_particle;
  //  fill_code_particle(code_particle);
  //  map<int,string> name_particle;
  //  fill_name_particle(name_particle);

  logger << LOG_DEBUG << "Partonic process:" << endl;
  vector<vector<string> > particles_name(2);
  //  Logger logger("process readin");
  readin_subprocess_from_name(subprocess, basic_type_parton[0]);
  //  determine_process(subprocess, particles_name, process_type, n_particle, basic_type_parton[0], code_particle);
  logger << LOG_DEBUG << "n_particle = " << n_particle << endl;
  for (int i_p = 1; i_p < basic_type_parton[0].size(); i_p++){logger << LOG_DEBUG << "basic_type_parton[0][" << setw(2) << i_p << "] = " << setw(5) << right << basic_type_parton[0][i_p] << "   " << setw(5) << left << name_particle[basic_type_parton[0][i_p]] << endl;}

  //  int dummy;
  logger << LOG_DEBUG << "Hadronic process:" << endl;
  //  int hadron_n_particle;
  vector<vector<int> > hadron_type_parton(1);
  vector<vector<string> > hadron_particles_name(2);
  logger << LOG_DEBUG << "process_class = " << process_class << endl;

  readin_subprocess_from_name(process_class, hadron_type_parton[0]);
//  determine_process(process_class, hadron_particles_name, dummy, hadron_n_particle, hadron_type_parton[0], code_particle);
//  logger << LOG_DEBUG << "hadron_n_particle = " << hadron_n_particle << endl;

  for (int i_p = 1; i_p < hadron_type_parton[0].size(); i_p++){logger << LOG_DEBUG << "hadron_type_parton[0][" << setw(2) << i_p << "] = " << right << setw(5) << hadron_type_parton[0][i_p] << "   " << setw(5) << left << name_particle[hadron_type_parton[0][i_p]] << endl;}

  logger << LOG_DEBUG << process_class << endl;
  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG << "process_type = " << process_type << endl;

  //  logger << LOG_DEBUG << "process file" << endl;
  logger << LOG_DEBUG << "process_class           = " << process_class << endl;
  logger << LOG_DEBUG << "n_particle              = " << n_particle << endl;
  //  cout << "process_number          = " << process_number << endl;
  if (process_type == 2){
    //  if (basic_type_parton[0][0] == 0){
    for (int i2 = 1; i2 < n_particle + 3; i2++){
      logger << LOG_DEBUG << "basic_type_parton[0][" << i2 << "]                  = " << basic_type_parton[0][i2] << endl;
    }
  }
  else if (process_type == 1){
    for (int i2 = 0; i2 < n_particle + 1; i2++){
      logger << LOG_DEBUG << "basic_type_parton[0][" << i2 << "]                  = " << basic_type_parton[0][i2] << endl;
    }
  }
  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
*/

void contribution_set::readin_subprocess(){
  Logger logger("contribution_set::readin_subprocess");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  logger.newLine(LOG_DEBUG);
    
  logger << LOG_DEBUG << "Basic hadronic process:" << endl;
  vector<vector<int> > basic_hadron_type_parton(1);
  vector<vector<string> > basic_hadron_particles_name(2);
  logger << LOG_DEBUG << "basic_process_class = " << basic_process_class << endl;
  readin_subprocess_from_name(basic_process_class, basic_hadron_type_parton[0]);
  logger << LOG_DEBUG << "n_particle = " << n_particle << "   (temporarily)" << endl;
  logger << LOG_DEBUG << "process_type = " << process_type << "   (temporarily)" << endl;
  for (int i_p = 1; i_p < basic_hadron_type_parton[0].size(); i_p++){
    logger << LOG_DEBUG << "basic_hadron_type_parton[0][" << setw(2) << i_p << "] = " << right << setw(5) << basic_hadron_type_parton[0][i_p] << "   " << setw(5) << left << name_particle[basic_hadron_type_parton[0][i_p]] << endl;
  }

  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG << "Hadronic process:" << endl;
  vector<vector<int> > hadron_type_parton(1);
  vector<vector<string> > hadron_particles_name(2);
  logger << LOG_DEBUG << "process_class = " << process_class << endl;
  readin_subprocess_from_name(process_class, hadron_type_parton[0]);
  logger << LOG_DEBUG << "n_particle = " << n_particle << "   (temporarily)" << endl;
  logger << LOG_DEBUG << "process_type = " << process_type << "   (temporarily)" << endl;
  for (int i_p = 1; i_p < hadron_type_parton[0].size(); i_p++){
    logger << LOG_DEBUG << "hadron_type_parton[0][" << setw(2) << i_p << "] = " << right << setw(5) << hadron_type_parton[0][i_p] << "   " << setw(5) << left << name_particle[hadron_type_parton[0][i_p]] << endl;
  }

  logger.newLine(LOG_DEBUG);
  
  map<int, int> lepton_counter;
  lepton_counter[11] = 1;
  lepton_counter[13] = 2;
  lepton_counter[15] = 3;
  lepton_counter[-11] = 4;
  lepton_counter[-13] = 5;
  lepton_counter[-15] = 6;
  lepton_counter[12] = 7;
  lepton_counter[14] = 8;
  lepton_counter[16] = 9;
  lepton_counter[-12] = 10;
  lepton_counter[-14] = 11;
  lepton_counter[-16] = 12;
  
  map<int, int> lepton_inverse;
  lepton_inverse[1] = 11;
  lepton_inverse[2] = 13;
  lepton_inverse[3] = 15;
  lepton_inverse[4] = -11;
  lepton_inverse[5] = -13;
  lepton_inverse[6] = -15;
  lepton_inverse[7] = 12;
  lepton_inverse[8] = 14;
  lepton_inverse[9] = 16;
  lepton_inverse[10] = -12;
  lepton_inverse[11] = -14;
  lepton_inverse[12] = -16;
  

  //  int use_basic_process = 0;
  
  vector<int> basic_process_counter(13, 0);
  for (int i_p = 1; i_p < basic_hadron_type_parton[0].size(); i_p++){
    basic_process_counter[lepton_counter[basic_hadron_type_parton[0][i_p]]]++;
  }
  /*
    for (int i_l = 0; i_l < 13; i_l++){
      cout << "basic_process_counter[" << setw(2) <<  i_l << "] = " << setw(2) << basic_process_counter[i_l] << endl;
    }
    cout << endl;
  */
  vector<int> process_exchange_counter(13, 0);
  vector<int> process_counter(13, 0);

  map<int, int> lepton_exchange;
  for (int i_l = 0; i_l < 7; i_l++){
    if (i_l == 0){
      for (int j_l = 1; j_l < 7; j_l++){
	lepton_exchange[10 + j_l] = 10 + j_l;
	lepton_exchange[-10 - j_l] = -10 - j_l;
      }
    }
    else if (i_l == 1){
      lepton_exchange[11] = 13;
      lepton_exchange[12] = 14;
      lepton_exchange[13] = 11;
      lepton_exchange[14] = 12;
      lepton_exchange[15] = 15;
      lepton_exchange[16] = 16;
      lepton_exchange[-11] = -13;
      lepton_exchange[-12] = -14;
      lepton_exchange[-13] = -11;
      lepton_exchange[-14] = -12;
      lepton_exchange[-15] = -15;
      lepton_exchange[-16] = -16;
    }
    else if (i_l == 2){
      lepton_exchange[11] = 15;
      lepton_exchange[12] = 16;
      lepton_exchange[13] = 13;
      lepton_exchange[14] = 14;
      lepton_exchange[15] = 11;
      lepton_exchange[16] = 12;
      lepton_exchange[-11] = -15;
      lepton_exchange[-12] = -16;
      lepton_exchange[-13] = -13;
      lepton_exchange[-14] = -14;
      lepton_exchange[-15] = -11;
      lepton_exchange[-16] = -12;
    }
    else if (i_l == 3){
      lepton_exchange[11] = 11;
      lepton_exchange[12] = 12;
      lepton_exchange[13] = 15;
      lepton_exchange[14] = 16;
      lepton_exchange[15] = 13;
      lepton_exchange[16] = 14;
      lepton_exchange[-11] = -11;
      lepton_exchange[-12] = -12;
      lepton_exchange[-13] = -15;
      lepton_exchange[-14] = -16;
      lepton_exchange[-15] = -13;
      lepton_exchange[-16] = -14;
    }
    else if (i_l == 4){
      lepton_exchange[11] = 13;
      lepton_exchange[12] = 14;
      lepton_exchange[13] = 15;
      lepton_exchange[14] = 16;
      lepton_exchange[15] = 11;
      lepton_exchange[16] = 12;
      lepton_exchange[-11] = -13;
      lepton_exchange[-12] = -14;
      lepton_exchange[-13] = -15;
      lepton_exchange[-14] = -16;
      lepton_exchange[-15] = -11;
      lepton_exchange[-16] = -12;
    }
    else if (i_l == 5){
      lepton_exchange[11] = 15;
      lepton_exchange[12] = 16;
      lepton_exchange[13] = 11;
      lepton_exchange[14] = 12;
      lepton_exchange[15] = 13;
      lepton_exchange[16] = 14;
      lepton_exchange[-11] = -15;
      lepton_exchange[-12] = -16;
      lepton_exchange[-13] = -11;
      lepton_exchange[-14] = -12;
      lepton_exchange[-15] = -13;
      lepton_exchange[-16] = -14;
    }
    else if (i_l == 6){
      logger << LOG_FATAL << "No allowed process specified." << endl;
      //      use_basic_process = 1;
      exit(1);
    }
    
    for (int j_l = 0; j_l < 13; j_l++){process_exchange_counter[j_l] = 0;}
    for (int j_l = 0; j_l < 13; j_l++){process_counter[j_l] = 0;}

    for (int i_p = 1; i_p < hadron_type_parton[0].size(); i_p++){
      process_exchange_counter[lepton_counter[lepton_exchange[hadron_type_parton[0][i_p]]]]++;
      process_counter[lepton_counter[hadron_type_parton[0][i_p]]]++;
    }
    
      for (int j_l = 0; j_l < 13; j_l++){
	logger << LOG_DEBUG << "process_exchange_counter[" << setw(2) <<  i_l << "][" << setw(2) <<  j_l << "] = " << setw(2) << process_counter[j_l] << " --- " << setw(2) << basic_process_counter[j_l] << " = basic_process_counter[" << setw(2) <<  j_l << "]" << endl;
      }
      logger.newLine(LOG_DEBUG);
    
    if (process_exchange_counter == basic_process_counter){
      logger << LOG_DEBUG << "Permutation " << i_l << " is chosen:" << endl;
      for (int j_l = 1; j_l < 7; j_l++){
	if (lepton_exchange[10 + j_l] != 10 + j_l){logger << LOG_DEBUG << "lepton_exchange[" << setw(3) << right << 10 + j_l << "] -> " << setw(3) << right << lepton_exchange[10 + j_l] << endl;}
	if (lepton_exchange[10 + j_l] != 10 + j_l){logger << LOG_DEBUG << "lepton_exchange[" << setw(3) << right << -10 - j_l << "] -> " << setw(3) << right << lepton_exchange[-10 - j_l] << endl;}
      }
      break;
    }
  }
  //  }
  



  int first_lepton = 1;
  string new_process_class = "";
  for (int i_p = 1; i_p < hadron_type_parton[0].size(); i_p++){
    if (abs(hadron_type_parton[0][i_p]) > 10 && abs(hadron_type_parton[0][i_p]) < 17){
      if (first_lepton){
	for (int i_l = 1; i_l < 13; i_l++){
	  for (int i_r = 0; i_r < process_counter[i_l]; i_r++){
	    new_process_class = new_process_class + name_particle[lepton_inverse[i_l]]; 
	  //    [lepton_counter[lepton_exchange[hadron_type_parton[0][i_p]]]]++;
	  }
	}
	first_lepton = 0;
      }
      else {
      }
    }
    else {
      new_process_class = new_process_class + name_particle[hadron_type_parton[0][i_p]];
    }
    if ((process_type == 1 && i_p == 1) || (process_type == 2 && i_p == 2)){new_process_class = new_process_class + "-";}
  }
  new_process_class = new_process_class + "+X";

  logger << LOG_DEBUG << "new_process_class = " << new_process_class << endl;
  process_class = new_process_class;

  logger.newLine(LOG_DEBUG);
  
  logger << LOG_DEBUG << "Partonic process:" << endl;
  basic_type_parton.resize(1);
  vector<vector<string> > particles_name(2);
  //  Logger logger("process readin");
  readin_subprocess_from_name(subprocess, basic_type_parton[0]);
  //  determine_process(subprocess, particles_name, process_type, n_particle, basic_type_parton[0], code_particle);
  logger << LOG_DEBUG << "n_particle = " << n_particle << endl;
  logger << LOG_DEBUG << "process_type = " << process_type << endl;
  for (int i_p = 1; i_p < basic_type_parton[0].size(); i_p++){
    logger << LOG_DEBUG << "basic_type_parton[0][" << setw(2) << right << i_p << "] = " << setw(5) << right << basic_type_parton[0][i_p] << "   " << setw(5) << left << name_particle[basic_type_parton[0][i_p]] << endl;
  }
  
  logger.newLine(LOG_DEBUG);
  
  type_parton = basic_type_parton;
  
  for (int i_p = 1; i_p < type_parton[0].size(); i_p++){
    if (abs(type_parton[0][i_p]) > 10 && abs(type_parton[0][i_p]) < 17){
      type_parton[0][i_p] = lepton_exchange[type_parton[0][i_p]];
    } 
    logger << LOG_DEBUG << "type_parton[0][" << setw(2) << right << i_p << "] = " << right << setw(5) << type_parton[0][i_p] << "   " << setw(5) << left << name_particle[type_parton[0][i_p]] << endl;
  }
  
  /*
    map<int, string> datname;
    fill_datname(datname);
    
    string new_subprocess = "";
  if (process_type == 2){
    new_subprocess = datname[type_parton[0][1]] + datname[type_parton[0][2]] + "_";
    for (int i = 3; i < type_parton[0].size(); i++){
      new_subprocess = new_subprocess + datname[type_parton[0][i]];
    }
  }
  else if (process_type == 1){
    new_subprocess = datname[type_parton[0][0]] + "_";
    for (int i = 1; i < type_parton[0].size(); i++){
      new_subprocess = new_subprocess + datname[type_parton[0][i]];
    }
  }
  logger << LOG_DEBUG << "old:subprocess = " << subprocess << endl;
  logger << LOG_DEBUG << "new_subprocess = " << new_subprocess << endl;
  subprocess = new_subprocess;
  */
  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}



void contribution_set::readin_subprocess_from_name(string & this_processname, vector<int> & this_type_parton){
  Logger logger("process readin");
  logger << LOG_DEBUG_VERBOSE << "started" << endl;

  vector<vector<string> > particles_name(2);
  int particle_counter = 0;
  int exit = 0;
  logger << LOG_DEBUG_VERBOSE << "begin 'determine_process' for " << this_processname << endl;
  this_processname = this_processname + "     ";
  for (int i = 0; i < this_processname.size(); i++){
    logger << LOG_DEBUG_VERBOSE << i << "   " << this_processname[i] << "   " << particle_counter << endl;
    if (this_processname[i] == '_' || this_processname[i] == '-'){particle_counter++;}
    else if (this_processname[i] == 'p'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("p~"); i++;}
      else {particles_name[particle_counter].push_back("p");}
    }
    else if (this_processname[i] == 'j'){
      if (this_processname[i + 1] == 'e' && this_processname[i + 2] == 't'){particles_name[particle_counter].push_back("jet"); i += 2;}
      else {exit = 1; break;}
    }
    else if (this_processname[i] == '2'){
      if (this_processname[i + 1] == 'j' && this_processname[i + 2] == 'e' && this_processname[i + 3] == 't' && this_processname[i + 4] == 's'){
	for (int j = 0; j < 2; j++){particles_name[particle_counter].push_back("jet");}
	i += 4;
      }
      else {exit = 1; break;}
    }
    else if (this_processname[i] == '3'){
      if (this_processname[i + 1] == 'j' && this_processname[i + 2] == 'e' && this_processname[i + 3] == 't' && this_processname[i + 4] == 's'){
	for (int j = 0; j < 3; j++){particles_name[particle_counter].push_back("jet");}
	i += 4;
      }
      else {exit = 1; break;}
    }
    else if (this_processname[i] == '4'){
      if (this_processname[i + 1] == 'j' && this_processname[i + 2] == 'e' && this_processname[i + 3] == 't' && this_processname[i + 4] == 's'){
	for (int j = 0; j < 4; j++){particles_name[particle_counter].push_back("jet");}
	i += 4;
      }
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'f'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("f~"); i++;}
      else {particles_name[particle_counter].push_back("f");}
    }

    else if (this_processname[i] == 'd'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("d~"); i++;}
      else {particles_name[particle_counter].push_back("d");}
    }
    else if (this_processname[i] == 'u'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("u~"); i++;}
      else {particles_name[particle_counter].push_back("u");}
    }
    else if (this_processname[i] == 's'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("s~"); i++;}
      else {particles_name[particle_counter].push_back("s");}
    }
    else if (this_processname[i] == 'c'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("c~"); i++;}
      else {particles_name[particle_counter].push_back("c");}
    }
    else if (this_processname[i] == 'b'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("b~"); i++;}
      else {particles_name[particle_counter].push_back("b");}
    }
    else if (this_processname[i] == 't'){
      if (this_processname[i + 1] == '~'){particles_name[particle_counter].push_back("t~"); i++;}
      else if (this_processname[i + 1] == 'a')
	if      (this_processname[i + 2] == 'm'){particles_name[particle_counter].push_back("tam"); i += 2;}
	else if (this_processname[i + 2] == 'p'){particles_name[particle_counter].push_back("tap"); i += 2;}
	else {exit = 1; break;}
      else {particles_name[particle_counter].push_back("t");}
    }
    else if (this_processname[i] == 'e'){
      if      (this_processname[i + 1] == 'm'){particles_name[particle_counter].push_back("em"); i++;}
      else if (this_processname[i + 1] == 'p'){particles_name[particle_counter].push_back("ep"); i++;}
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'm'){
      if      (this_processname[i + 1] == 'u' && this_processname[i + 2] == 'm'){particles_name[particle_counter].push_back("mum"); i += 2;}
      else if (this_processname[i + 1] == 'u' && this_processname[i + 2] == 'p'){particles_name[particle_counter].push_back("mup"); i += 2;}
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'v'){
      if      (this_processname[i + 1] == 'e'){
	if (this_processname[i + 2] == '~'){particles_name[particle_counter].push_back("ve~"); i += 2;}
	else {particles_name[particle_counter].push_back("ve"); i++;}
      }
      else if (this_processname[i + 1] == 'm'){
	if (this_processname[i + 2] == '~'){particles_name[particle_counter].push_back("vm~"); i += 2;}
	else {particles_name[particle_counter].push_back("vm"); i++;}
      }
      else if (this_processname[i + 1] == 't'){
	if (this_processname[i + 2] == '~'){particles_name[particle_counter].push_back("vt~"); i += 2;}
	else {particles_name[particle_counter].push_back("vt"); i++;}
      }
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'g'){particles_name[particle_counter].push_back("g");}
    else if (this_processname[i] == 'w'){
      if      (this_processname[i + 1] == 'm'){particles_name[particle_counter].push_back("wm"); i++;}
      else if (this_processname[i + 1] == 'p'){particles_name[particle_counter].push_back("wp"); i++;}
      else {exit = 1; break;}
    }
    else if (this_processname[i] == 'z'){particles_name[particle_counter].push_back("z");}
    else if (this_processname[i] == 'h'){particles_name[particle_counter].push_back("h");}
    else if (this_processname[i] == 'a'){particles_name[particle_counter].push_back("a");}
    else if (this_processname[i] == ' '){}
    else if (this_processname[i] == '+'){}
    else if (this_processname[i] == 'X'){}
    else {exit = 1; break;}
  }
  if (exit){} // ??? use of exit ???

  logger << LOG_DEBUG_VERBOSE << "particles_name.size() = " << particles_name.size() << endl;
  n_particle = particles_name[1].size();
  logger << LOG_DEBUG_VERBOSE << "n_particle = " << n_particle << endl;
    for (int i = 0; i < particles_name.size(); i++){
      for (int j = 0; j < particles_name[i].size(); j++){
	logger << LOG_DEBUG_VERBOSE << "particles_name[" << i << "][" << j << "] = " << particles_name[i][j] << endl;
      }
    }
  logger << LOG_DEBUG_VERBOSE << "particles_name[0].size() = " << particles_name[0].size() << endl;
  if (particles_name[0].size() == 1){}
  else if (particles_name[0].size() == 2){this_type_parton.push_back(0);}
  logger << LOG_DEBUG_VERBOSE << "particles_name[0].size() = " << particles_name[0].size() << endl;
  //  else {exit = 1; break;}
  process_type = particles_name[0].size();
  logger << LOG_DEBUG_VERBOSE << "process_type = " << process_type << endl;
  for (int i = 0; i < 2; i++){
    logger << LOG_DEBUG_VERBOSE << "particles_name[" << i << "].size() = " << particles_name[i].size() << endl;
    for (int j = 0; j < particles_name[i].size(); j++){
    logger << LOG_DEBUG_VERBOSE << i << "   " << j << endl;
      this_type_parton.push_back(code_particle[particles_name[i][j]]);
      logger << LOG_DEBUG_VERBOSE << "particles_name[" << right << setw(2) << i << "][" << setw(2) << j << "] = " << left << setw(5) << particles_name[i][j] << "   code_particle = " << right << setw(4) << code_particle[particles_name[i][j]] << endl;
    }
  }
  if (particles_name[0].size() == 1){for (int p = 0; p < this_type_parton.size(); p++){logger << LOG_DEBUG_VERBOSE << "this_type_parton[" << right << setw(2) << p << "] = " << right << this_type_parton[p] << endl;}}
  else if (particles_name[0].size() == 2){for (int p = 1; p < this_type_parton.size(); p++){logger << LOG_DEBUG_VERBOSE << "this_type_parton[" << right << setw(2) << p << "] = " << right << this_type_parton[p] << endl;}}
  this_processname.erase(this_processname.end() - 5, this_processname.end());
  logger << LOG_DEBUG_VERBOSE << "end 'determine_process' for " << this_processname << endl;
}

void contribution_set::fill_code_particle(){
  code_particle["d"]   = 1;
  code_particle["u"]   = 2;
  code_particle["s"]   = 3;
  code_particle["c"]   = 4;
  code_particle["b"]   = 5;
  code_particle["t"]   = 6;
  code_particle["d~"]  = -1;
  code_particle["u~"]  = -2;
  code_particle["s~"]  = -3;
  code_particle["c~"]  = -4;
  code_particle["b~"]  = -5;
  code_particle["t~"]  = -6;
  code_particle["em"]  = 11;
  code_particle["mum"] = 13;
  code_particle["tam"] = 15;
  code_particle["ep"]  = -11;
  code_particle["mup"] = -13;
  code_particle["tap"] = -15;
  code_particle["ve"]  = 12;
  code_particle["vm"]  = 14;
  code_particle["vt"]  = 16;
  code_particle["ve~"] = -12;
  code_particle["vm~"] = -14;
  code_particle["vt~"] = -16;
  code_particle["g"]   = 0;
  code_particle["a"]   = 22;
  code_particle["wp"]  = -24;
  code_particle["wm"]  = 24;
  code_particle["z"]   = 23;
  code_particle["h"]   = 25;
  code_particle["p"]  = 101;
  code_particle["p~"]  = -101;
  code_particle["jet"]  = 100;
}

void contribution_set::fill_name_particle(){
  name_particle[  0] = "g";
  name_particle[ 22] = "a";
  name_particle[-24] = "wp";
  name_particle[ 24] = "wm";
  name_particle[ 23] = "z";
  name_particle[ 25] = "h";
  name_particle[  1] = "d";
  name_particle[  2] = "u";
  name_particle[  3] = "s";
  name_particle[  4] = "c";
  name_particle[  5] = "b";
  name_particle[  6] = "t";
  name_particle[ -1] = "d~";
  name_particle[ -2] = "u~";
  name_particle[ -3] = "s~";
  name_particle[ -4] = "c~";
  name_particle[ -5] = "b~";
  name_particle[ -6] = "t~";
  name_particle[ 11] = "em";
  name_particle[ 12] = "ve";
  name_particle[ 13] = "mum";
  name_particle[ 14] = "vm";
  name_particle[ 15] = "tam";
  name_particle[ 16] = "vt";
  name_particle[-11] = "ep";
  name_particle[-12] = "ve~";
  name_particle[-13] = "mup";
  name_particle[-14] = "vm~";
  name_particle[-15] = "tap";
  name_particle[-16] = "vt~";
  name_particle[101] = "p";
  name_particle[-101] = "p~";
  name_particle[100] = "jet";
}
