#include "../include/classes.cxx"
void phasespace_set::initialization_mapping_parameter(inputparameter_set & isi){
  Logger logger("phasespace_set::initialization_parameter (isi)");
  logger << LOG_DEBUG << "started" << endl;

  MC_channel = 0;
  MC_channel_phasespace = 0;
  tau_channel = 0;
  x1x2_channel = 0;

  coll_choice = isi.coll_choice;
  //  smin_opt = isi.smin_opt;
  //  sqrtsmin_opt = isi.sqrtsmin_opt;

  E = isi.E;
  s_had = pow(2 * E, 2);

  switch_qTcut = isi.switch_qTcut;
  min_qTcut = isi.min_qTcut;
  

  //  mapping_cut_pT = isi.mapping_cut_pT;
  // !!! no input parameter !!!

  nu = isi.nu;
  nuxs = isi.nuxs;
  nuxt = isi.nuxt;
  exp_pdf = isi.exp_pdf;
  exp_pT = isi.exp_pT;
  exp_y = isi.exp_y;
  exp_ij_k_y = isi.exp_ij_k_y;
  exp_ij_k_z = isi.exp_ij_k_z;
  exp_ij_a_x = isi.exp_ij_a_x;
  exp_ij_a_z = isi.exp_ij_a_z;
  exp_ai_k_x = isi.exp_ai_k_x;
  exp_ai_k_u = isi.exp_ai_k_u;
  exp_ai_b_x = isi.exp_ai_b_x;
  exp_ai_b_v = isi.exp_ai_b_v;
  map_technical_s = isi.map_technical_s;
  map_technical_t = isi.map_technical_t;
  map_technical_x = isi.map_technical_x;
  mass0 = isi.mass0;

  cut2_pT = pow(min_qTcut, 2.);
  //  cut_pT_lep = pow(mapping_cut_pT[11], 2.);
  // !!! not use any longer ???

  //  g_onshell_decay = 1.;
  //  g_onshell_decay = isi.g_onshell_decay;
  // !!! set elsewhere !!!

  cut_technical = isi.cut_technical;

  switch_console_output_phasespace_issue = isi.switch_console_output_phasespace_issue;

  logger << LOG_DEBUG << "finished" << endl;
}

// !!! temporary !!!
void phasespace_set::initialization_minimum_tau(inputparameter_set & isi){
  Logger logger("phasespace_set::initialization_minimum_tau (isi)");
  logger << LOG_DEBUG << "started" << endl;

  ////////////////////////////////////////
  //  minimum CMS-energy determination  //
  ////////////////////////////////////////
  
  // !!! should be completely worked out anew and shifted elsewhere !!!
  // !!! shoud be here, but worked out completely anew !!!

  // extend to be used also with define_ET

  double minEjet = 0.;
  // minimum energy required for jet (including b-jet (and c-jet)) system
  //  if (isi.esi.pda[isi.esi.observed_object["ljet"]].n_observed_min > 0){
  //  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["ljet"]].n_observed_min; i++){minEljet.push_back(isi.esi.pda[isi.esi.observed_object["ljet"]].define_pT);}
  vector<double> minEljet(isi.esi.pda[isi.esi.observed_object["ljet"]].n_partonlevel, 0.);
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["ljet"]].n_observed_min; i++){minEljet[i] = isi.esi.pda[isi.esi.observed_object["ljet"]].define_pT;}
  //  }
  //  vector<double> minEbjet;
  //  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel; i++){minEbjet.push_back(M[5]);}
  vector<double> minEbjet(isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel, M[5]);
  if (isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel < isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min){} // cross-section contribution is zero
  if (isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min){for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel; i++){minEbjet[i] = sqrt(M2[5] + pow(isi.esi.pda[isi.esi.observed_object["bjet"]].define_pT, 2));}}
  //  else if (isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min){minEjet += isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min * sqrt(M2[5] + pow(isi.esi.pda[isi.esi.observed_object["bjet"]].define_pT, 2));}
  else if ((isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel > isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min) && (isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min > 0)){
    int min_bs_per_bjet = isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel / isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min;
    int n_more_bs_per_bjet = isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel - isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min * min_bs_per_bjet;
    for (int i = 0; i < min_bs_per_bjet * (isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min - n_more_bs_per_bjet); i++){
      if (i < min_bs_per_bjet * (isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min - n_more_bs_per_bjet)){minEbjet[i] = sqrt(M2[5] + pow(isi.esi.pda[isi.esi.observed_object["bjet"]].define_pT / min_bs_per_bjet, 2));}
      else {minEbjet[i] = sqrt(M2[5] + pow(isi.esi.pda[isi.esi.observed_object["bjet"]].define_pT / (min_bs_per_bjet + 1), 2));}
    }
  }
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["ljet"]].n_partonlevel; i++){logger << LOG_INFO << "minEljet[" << i << "] = " << minEljet[i] << endl;}
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel; i++){logger << LOG_INFO << "minEbjet[" << i << "] = " << minEbjet[i] << endl;}
  minEjet = accumulate(minEljet.begin(), minEljet.end(), 0.) + accumulate(minEbjet.begin(), minEbjet.end(), 0.);
  logger << LOG_INFO << "minEjet = " << minEjet << endl;
  if (user.switch_value[user.switch_map["M_jetjet"]] == 1 &&
      isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel + isi.esi.pda[isi.esi.observed_object["ljet"]].n_partonlevel >= 2){
    if (minEjet < user.cut_value[user.cut_map["M_jetjet"]]){
      minEjet = user.cut_value[user.cut_map["M_jetjet"]];
    }
  }
  logger << LOG_INFO << "minEjet = " << minEjet << endl;


  double minElep = 0.;
  vector<double> minEe(isi.esi.pda[isi.esi.observed_object["e"]].n_partonlevel, 0.);
  vector<double> minEmu(isi.esi.pda[isi.esi.observed_object["mu"]].n_partonlevel, 0.);
  vector<double> minEtau(isi.esi.pda[isi.esi.observed_object["tau"]].n_partonlevel, 0.);
  vector<double> minEalep(isi.esi.pda[isi.esi.observed_object["lep"]].n_partonlevel, 0.);
  
//  cout << "osi_observed_object[lep] = " << osi_observed_object["lep"] << endl;
  cout << "isi.esi.pda[lep]].n_observed_min = " << isi.esi.pda[isi.esi.observed_object["lep"]].n_observed_min << endl;
  cout << "isi.esi.pda[lep]].n_partonlevel = " << isi.esi.pda[isi.esi.observed_object["lep"]].n_partonlevel << endl;
  cout << "minEalep.size() = " << minEalep.size() << endl;

  if (isi.esi.pda[isi.esi.observed_object["lep"]].n_partonlevel != 0){
    for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["lep"]].n_observed_min; i++){minEalep[i] = isi.esi.pda[isi.esi.observed_object["lep"]].define_pT;}
    for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["lep"]].n_partonlevel; i++){logger << LOG_INFO << "minEalep[" << i << "] = " << minEalep[i] << endl;}
    minElep = accumulate(minEalep.begin(), minEalep.end(), 0.);
    logger << LOG_INFO << "minElep = " << minElep << endl;
    
    if (user.switch_value[user.switch_map["M_Zrec"]] == 1 &&
	isi.esi.pda[isi.esi.observed_object["lep"]].n_partonlevel >= 2){
      if (minElep < user.cut_value[user.cut_map["min_M_Zrec"]]){
	minElep = user.cut_value[user.cut_map["min_M_Zrec"]];
      }
    }

    if (user.switch_value[user.switch_map["delta_M_Zrec_MZ "]] == 1 &&
	isi.esi.pda[isi.esi.observed_object["lep"]].n_partonlevel >= 2){
      if (minElep < M[23] - user.cut_value[user.cut_map["max_delta_M_Zrec_MZ"]]){
	minElep = M[23] - user.cut_value[user.cut_map["max_delta_M_Zrec_MZ"]];
      }
    }

    if (user.switch_value[user.switch_map["M_leplep"]] == 1 &&
	isi.esi.pda[isi.esi.observed_object["lep"]].n_partonlevel >= 2){
      if (minElep < user.cut_value[user.cut_map["min_M_leplep"]]){
	minElep = user.cut_value[user.cut_map["min_M_leplep"]];
      }
    }

    if (user.switch_value[user.switch_map["M_emep"]] == 1 &&
	isi.esi.pda[isi.esi.observed_object["e"]].n_partonlevel >= 2){
      if (minElep < user.cut_value[user.cut_map["min_M_emep"]]){
	minElep = user.cut_value[user.cut_map["min_M_emep"]];
      }
    }

    if (user.switch_value[user.switch_map["M_mummup"]] == 1 &&
	isi.esi.pda[isi.esi.observed_object["mu"]].n_partonlevel >= 2){
      if (minElep < user.cut_value[user.cut_map["min_M_mummup"]]){
	minElep = user.cut_value[user.cut_map["min_M_mummup"]];
      }
    }

    if (user.switch_value[user.switch_map["M_leplep"]] == 1 &&
	isi.esi.pda[isi.esi.observed_object["lep"]].n_partonlevel >= 4){
      if (minElep < 2 * user.cut_value[user.cut_map["min_M_leplep"]]){
	minElep = 2 * user.cut_value[user.cut_map["min_M_leplep"]];
      }
    }
  }
  logger << LOG_INFO << "minElep = " << minElep << endl;

  double minEwp = 0.;
  vector<double> minEawp(isi.esi.pda[isi.esi.observed_object["wp"]].n_partonlevel, 0.);
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["wp"]].n_observed_min; i++){minEawp[i] = sqrt(M2[24] + pow(isi.esi.pda[isi.esi.observed_object["wp"]].define_pT, 2));}
  for (int i = isi.esi.pda[isi.esi.observed_object["wp"]].n_observed_min; i < isi.esi.pda[isi.esi.observed_object["wp"]].n_partonlevel; i++){minEawp[i] = M[24];}
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["wp"]].n_partonlevel; i++){logger << LOG_INFO << "minEawp[" << i << "] = " << minEawp[i] << endl;}
  minEwp = accumulate(minEawp.begin(), minEawp.end(), 0.);
  logger << LOG_INFO << "minEwp = " << minEwp << endl;

  double minEwm = 0.;
  vector<double> minEawm(isi.esi.pda[isi.esi.observed_object["wm"]].n_partonlevel, 0.);
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["wm"]].n_observed_min; i++){minEawm[i] = sqrt(M2[24] + pow(isi.esi.pda[isi.esi.observed_object["wm"]].define_pT, 2));}
  for (int i = isi.esi.pda[isi.esi.observed_object["wm"]].n_observed_min; i < isi.esi.pda[isi.esi.observed_object["wm"]].n_partonlevel; i++){minEawm[i] = M[24];}
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["wm"]].n_partonlevel; i++){logger << LOG_INFO << "minEawm[" << i << "] = " << minEawm[i] << endl;}
  minEwm = accumulate(minEawm.begin(), minEawm.end(), 0.);
  logger << LOG_INFO << "minEwm = " << minEwm << endl;


  // !!! simplified so far !!!
  // no individual cuts on different leptons

  double minEphoton = 0.;
  vector<double> minEaphoton(isi.esi.pda[isi.esi.observed_object["photon"]].n_partonlevel, 0.);
  logger << LOG_INFO << "before minEphoton = " << minEphoton << endl;
//  cout << "osi_observed_object[photon] = " << osi_observed_object["photon"] << endl;
//  cout << "osi_n_observed_min.n_observed_min.size() = " <<  osi_n_observed_min.n_observed_min.size() << endl;
//  cout << "osi_n_partonlevel.n_partonlevel.size() = " << .n_partonlevel osi_n_partonlevel.size() << endl;
  cout << "minEaphoton.size() = " << minEaphoton.size() << endl;
  cout << "isi.esi.pda[photon]].n_observed_min = " << isi.esi.pda[isi.esi.observed_object["photon"]].n_observed_min << endl;
  cout << "isi.esi.pda[photon]].define_pT = " << isi.esi.pda[isi.esi.observed_object["photon"]].define_pT << endl;

  //  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["photon"]].n_observed_min; i++){
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["photon"]].n_observed_min; i++){minEaphoton[i] = isi.esi.pda[isi.esi.observed_object["photon"]].define_pT;}
  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["photon"]].n_partonlevel; i++){logger << LOG_INFO << "minEaphoton[" << i << "] = " << minEaphoton[i] << endl;}
  //  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["photon"]].n_partonlevel; i++){minEaphoton[i] = isi.esi.pda[isi.esi.observed_object["photon"]].define_pT;}
  logger << LOG_INFO << "after minEphoton = " << minEphoton << endl;
  //  for (int i = 0; i < isi.esi.pda[isi.esi.observed_object["photon"]].n_partonlevel; i++){logger << LOG_INFO << "minEaphoton[" << i << "] = " << minEaphoton[i] << endl;}
  logger << LOG_INFO << "before minEphoton = " << minEphoton << endl;
  minEphoton = accumulate(minEaphoton.begin(), minEaphoton.end(), 0.);
  logger << LOG_INFO << "minEphoton = " << minEphoton << endl;

  double minEmissing = 0.;
  minEmissing = isi.esi.pda[isi.esi.observed_object["missing"]].define_pT;

  double add_masses = 0.;
  for (int i = 3; i < isi.csi.type_parton[0].size(); i++){
    if (abs(isi.csi.type_parton[0][i]) == 6){add_masses += M[6];}
    else if (abs(isi.csi.type_parton[0][i]) == 23){add_masses += M[23];}
    //    else if (abs(isi.csi.type_parton[0][i]) == 24){add_masses += M[24];}
    else if (abs(isi.csi.type_parton[0][i]) == 25){add_masses += M[25];}
  }


  
  //  logger << LOG_DEBUG << "add_masses + minEjet + minElep + minEphoton + cut_pT_miss = " << add_masses + minEjet + minElep + minEphoton + cut_pT_miss << endl;
  //  double sqrts_min_tau_0 = add_masses + minEjet + minElep + minEphoton + minEwp + minEwm + cut_pT_miss;
  
  logger << LOG_INFO << "add_masses = " << add_masses << endl;
  logger << LOG_INFO << "minEjet = " << minEjet << endl;
  logger << LOG_INFO << "minElep = " << minElep << endl;
  logger << LOG_INFO << "minEphoton = " << minEphoton << endl;
  logger << LOG_INFO << "minEwp = " << minEwp << endl;
  logger << LOG_INFO << "minEwm = " << minEwm << endl;
  logger << LOG_INFO << "minEmissing = " << minEmissing << endl;
  double sqrts_min_tau_0 = add_masses + minEjet + minElep + minEphoton + minEwp + minEwm + minEmissing;
  logger << LOG_INFO << "sqrts_min_tau_0 = " << sqrts_min_tau_0 << endl;
  if (user.switch_value[user.switch_map["HT_all"]] == 1){
    if (sqrts_min_tau_0 < user.cut_value[user.cut_map["min_HT_all"]]){
      sqrts_min_tau_0 = user.cut_value[user.cut_map["min_HT_all"]];
    }
  }

  if (user.switch_value[user.switch_map["HT_jet"]] == 1){
    if (sqrts_min_tau_0 < user.cut_value[user.cut_map["min_HT_jet"]]){
      sqrts_min_tau_0 = user.cut_value[user.cut_map["min_HT_jet"]];
    }
  }

  if (user.switch_value[user.switch_map["pT_jet_1st"]] == 1){
    if (sqrts_min_tau_0 < user.cut_value[user.cut_map["min_pT_jet_1st"]]){
      sqrts_min_tau_0 = 2 * user.cut_value[user.cut_map["min_pT_jet_1st"]];
    }
  }

  if (user.switch_value[user.switch_map["pT_w"]] == 1){
    if (sqrts_min_tau_0 < user.cut_value[user.cut_map["min_pT_w"]]){
      sqrts_min_tau_0 = 2 * user.cut_value[user.cut_map["min_pT_w"]];
    }
  }

  if (user.switch_value[user.switch_map["optimize_sqrts_min"]] == 1){
    if (sqrts_min_tau_0 < user.double_value[user.double_map["optimize_sqrts_min"]]){
      sqrts_min_tau_0 = user.double_value[user.double_map["optimize_sqrts_min"]];
    }
  }

  logger << LOG_INFO << "sqrts_min_tau_0 = " << sqrts_min_tau_0 << "   (after HT-cut)" << endl;

  tau_0 = pow((sqrts_min_tau_0) / (2 * E), 2);
  logger << LOG_INFO << "tau_0 = " << tau_0 << endl;

  if (tau_0 == 0.){tau_0 = 1.E-07; logger << LOG_INFO << "tau_0 = " << tau_0 << endl;}
  //  if (tau_0 == 0.){tau_0 = 1.E-06; logger << LOG_INFO << "tau_0 = " << tau_0 << endl;}
  
  
  /////////////////////////////////////////////////
  //  minimum CMS-energy determination finished  //
  /////////////////////////////////////////////////

  /*
  tau_0 = isi.tau_0;
  */
  tau_0_s_had = tau_0 * s_had;
  
  logger << LOG_DEBUG << "finished" << endl;
}

// !!! should be completely worked out anew and shifted elsewhere !!!
void phasespace_set::initialization_minimum_phasespacecut(inputparameter_set & isi){
  Logger logger("phasespace_set::initialization_minimum_phasespacecut (isi)");
  logger << LOG_DEBUG << "started" << endl;

  mapping_cut_pT.resize(26, 0.);
  
  if (isi.csi.type_contribution != "RA" && 
      isi.csi.type_contribution != "RRA"){
    // only applied in configuration where each parton must become a jet:
    if (isi.esi.pda[isi.esi.observed_object["jet"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["jet"]].n_observed_min){
      double temp_pT2_jet = pow(isi.esi.pda[isi.esi.observed_object["jet"]].define_pT, 2);
      mapping_cut_pT[0] = temp_pT2_jet;
      mapping_cut_pT[1] = temp_pT2_jet;
      mapping_cut_pT[2] = temp_pT2_jet;
      mapping_cut_pT[3] = temp_pT2_jet;
      mapping_cut_pT[4] = temp_pT2_jet;
      mapping_cut_pT[5] = temp_pT2_jet;
    }
    if (isi.esi.pda[isi.esi.observed_object["ljet"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["ljet"]].n_observed_min){
      double temp_pT2_ljet = pow( isi.esi.pda[isi.esi.observed_object["ljet"]].define_pT, 2);
      if (temp_pT2_ljet > mapping_cut_pT[0]){mapping_cut_pT[0] = temp_pT2_ljet;}
      if (temp_pT2_ljet > mapping_cut_pT[0]){mapping_cut_pT[1] = temp_pT2_ljet;}
      if (temp_pT2_ljet > mapping_cut_pT[0]){mapping_cut_pT[2] = temp_pT2_ljet;}
      if (temp_pT2_ljet > mapping_cut_pT[0]){mapping_cut_pT[3] = temp_pT2_ljet;}
      if (temp_pT2_ljet > mapping_cut_pT[0]){mapping_cut_pT[4] = temp_pT2_ljet;}
    }
    if (isi.esi.pda[isi.esi.observed_object["bjet"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["bjet"]].n_observed_min){
      double temp_pT2_bjet = pow(isi.esi.pda[isi.esi.observed_object["bjet"]].define_pT, 2);
      if (temp_pT2_bjet > mapping_cut_pT[5]){mapping_cut_pT[5] = temp_pT2_bjet;}
    }
  }
  if (isi.csi.type_contribution != "RA" && 
      isi.csi.type_contribution != "RRA"){
    if (isi.esi.pda[isi.esi.observed_object["e"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["e"]].n_observed_min){mapping_cut_pT[11] = pow(isi.esi.pda[isi.esi.observed_object["e"]].define_pT, 2);}
    if (isi.esi.pda[isi.esi.observed_object["mu"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["mu"]].n_observed_min){mapping_cut_pT[13] = pow(isi.esi.pda[isi.esi.observed_object["mu"]].define_pT, 2);}
    if (isi.esi.pda[isi.esi.observed_object["tau"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["tau"]].n_observed_min){mapping_cut_pT[15] = pow(isi.esi.pda[isi.esi.observed_object["tau"]].define_pT, 2);}
    if (isi.esi.pda[isi.esi.observed_object["photon"]].n_partonlevel == isi.esi.pda[isi.esi.observed_object["photon"]].n_observed_min){mapping_cut_pT[22] = pow(isi.esi.pda[isi.esi.observed_object["photon"]].define_pT, 2);}
    if (isi.esi.n_parton_nu == 1){
      mapping_cut_pT[12] = pow(isi.esi.pda[isi.esi.observed_object["missing"]].define_pT, 2);
      mapping_cut_pT[14] = pow(isi.esi.pda[isi.esi.observed_object["missing"]].define_pT, 2);
      mapping_cut_pT[16] = pow(isi.esi.pda[isi.esi.observed_object["missing"]].define_pT, 2);
    }
  }

  for (int i = 0; i < mapping_cut_pT.size(); i++){logger << LOG_INFO << "mapping_cut_pT[" << setw(2) << i << "] = " << mapping_cut_pT[i] << endl;}

  /////////////////////////////////////////////////////
  //  minimum phasespace-cut determination finished  //
  /////////////////////////////////////////////////////

  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_contribution_order(contribution_set & _csi){
  Logger logger("phasespace_set::initialization_contribution_order (isi)");
  logger << LOG_DEBUG << "started" << endl;

  //  psi.csi & = csi;
  csi = &_csi;

  logger << LOG_DEBUG << "The same information is also contained in observable_set !!!" << endl;
  // Should be removed, as csi is accessible via psi:
  process_class = _csi.process_class;
  subprocess = _csi.subprocess;
  type_perturbative_order = _csi.type_perturbative_order;
  type_contribution = _csi.type_contribution;
  type_correction = _csi.type_correction;
  //

  if (csi->type_contribution == "born" || 
      csi->type_contribution == "L2I" || 
      csi->type_contribution == "loop"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
  }
  else if (csi->type_contribution == "CA" || 
	   csi->type_contribution == "L2CA"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    if (csi->type_correction == "QCD"){
      phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 1);
      phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
      phasespace_order_interference.resize(1, csi->contribution_order_interference);
    }
    else if (csi->type_correction == "QEW"){
      phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
      phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e - 1);
      phasespace_order_interference.resize(1, csi->contribution_order_interference);
    }
    else if (csi->type_correction == "MIX"){
      logger << LOG_FATAL << "Contribution CA.MIX is not defined!" << endl;
      exit(1);
    }
  }
  else if (csi->type_contribution == "VA" || 
	   csi->type_contribution == "L2VA"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    if (csi->type_correction == "QCD"){
      phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 1);
      phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
      phasespace_order_interference.resize(1, csi->contribution_order_interference);
    }
    else if (csi->type_correction == "QEW"){
      phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
      phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e - 1);
      phasespace_order_interference.resize(1, csi->contribution_order_interference);
    }
    else if (csi->type_correction == "MIX"){
      phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
      phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e - 1);
      phasespace_order_interference.resize(1, csi->contribution_order_interference);
      logger << LOG_INFO << "Phase-space is taken according to involved QEW correction! (could be improved later...)" << endl;
    }
  }
  else if (csi->type_contribution == "RA" || 
	   csi->type_contribution == "L2RA"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
    logger << LOG_INFO << "Information on dipole phase-spaces is supplied after dipole determination..." << endl;
  }

  else if (csi->type_contribution == "VT" || 
	   csi->type_contribution == "L2VT" || 
	   csi->type_contribution == "NLL_LO" || 
	   csi->type_contribution == "NLL_NLO" || 
	   csi->type_contribution == "NNLL_LO" || 
	   csi->type_contribution == "NNLL_NLO"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 1);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
  }
  else if (csi->type_contribution == "CT" || 
	   csi->type_contribution == "L2CT"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 1);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
  }
  else if (csi->type_contribution == "RT" || 
	   csi->type_contribution == "L2RT"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
  }
  /*
  else if (csi->type_contribution == "loop" || csi->type_contribution == "L2I"){
    // temporary !!! later: use 'phasespace_order' indices to combine loop-level contributions wit tree-level contributions without overlap (no '- 2' !!!)
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
    //    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 2);
  }
  */
  else if (csi->type_contribution == "VT2" || 
	   csi->type_contribution == "NNLL_NNLO"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 2);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
  }
  else if (csi->type_contribution == "CT2"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 2);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
  }
  else if (csi->type_contribution == "RVA"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 1);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
  }
  else if (csi->type_contribution == "RCA"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s - 1);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
  }
  else if (csi->type_contribution == "RRA"){
    contribution_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    contribution_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    contribution_order_interference.resize(1, csi->contribution_order_interference);
    phasespace_order_alpha_s.resize(1, csi->contribution_order_alpha_s);
    phasespace_order_alpha_e.resize(1, csi->contribution_order_alpha_e);
    phasespace_order_interference.resize(1, csi->contribution_order_interference);
    logger << LOG_INFO << "Information on dipole phase-spaces is supplied after dipole determination..." << endl;
  }


  else {
    logger << LOG_FATAL << "Contribution " << csi->type_contribution << "." << csi->type_correction << " has not been defined yet!" << endl;
      exit(1);
  }

  /*
  contribution_order_alpha_s = csi->contribution_order_alpha_s;
  contribution_order_alpha_e = csi->contribution_order_alpha_e;
  contribution_order_interference = csi->contribution_order_interference;
  */
  logger << LOG_DEBUG << "before contribution output" << endl;

  logger << LOG_DEBUG << "process_class = " << process_class << endl;
  logger << LOG_DEBUG << "subprocess = " << subprocess << endl;
  logger << LOG_DEBUG << "type_perturbative_order = " << type_perturbative_order << endl;
  logger << LOG_DEBUG << "type_contribution = " << type_contribution << endl;
  logger << LOG_DEBUG << "type_correction = " << type_correction << endl;
  
  logger << LOG_DEBUG << "csi->contribution_order_alpha_s = " << csi->contribution_order_alpha_s << endl;
  logger << LOG_DEBUG << "csi->contribution_order_alpha_e = " << csi->contribution_order_alpha_e << endl;
  logger << LOG_DEBUG << "csi->contribution_order_interference = " << csi->contribution_order_interference << endl;
  logger << LOG_DEBUG << "contribution_order_alpha_s = " << contribution_order_alpha_s[0] << endl;
  logger << LOG_DEBUG << "contribution_order_alpha_e = " << contribution_order_alpha_e[0] << endl;
  logger << LOG_DEBUG << "contribution_order_interference = " << contribution_order_interference[0] << endl;
  logger << LOG_DEBUG << "phasespace_order_alpha_s = " << phasespace_order_alpha_s[0] << endl;
  logger << LOG_DEBUG << "phasespace_order_alpha_e = " << phasespace_order_alpha_e[0] << endl;
  logger << LOG_DEBUG << "phasespace_order_interference = " << phasespace_order_interference[0] << endl;
  
  logger << LOG_DEBUG << "after contribution output" << endl;

  no_map.resize(1);
  o_map.resize(1);
  no_prc.resize(1);
  o_prc.resize(1);
  MC_n_channel_phasespace.resize(1);
  MC_sum_channel_phasespace.resize(1);

  logger << LOG_DEBUG << "finished" << endl;
}


void phasespace_set::initialization_optimization(inputparameter_set & isi){
  Logger logger("phasespace_set::initialization_optimization (isi)");
  logger << LOG_DEBUG << "started" << endl;

  n_alpha_steps = isi.n_alpha_steps;
  n_alpha_events = isi.n_alpha_events;
  n_alpha_epc = isi.n_alpha_epc;
  n_tau_steps = isi.n_tau_steps;
  n_tau_events = isi.n_tau_events;
  n_tau_bins = isi.n_tau_bins;
  n_x1x2_steps = isi.n_x1x2_steps;
  n_x1x2_events = isi.n_x1x2_events;
  n_x1x2_bins = isi.n_x1x2_bins;
  n_z1z2_steps = isi.n_z1z2_steps;
  n_z1z2_events = isi.n_z1z2_events;
  n_z1z2_bins = isi.n_z1z2_bins;
  n_IS_events = isi.n_IS_events;
  n_IS_events_factor = isi.n_IS_events_factor;
  n_IS_steps = isi.n_IS_steps;
  n_IS_gridsize = isi.n_IS_gridsize;
  n_IS_gridsize_p = isi.n_IS_gridsize_p;
  n_IS_gridsize_f = isi.n_IS_gridsize_f;
  n_IS_gridsize_t_t = isi.n_IS_gridsize_t_t;
  n_IS_gridsize_t_phi = isi.n_IS_gridsize_t_phi;
  n_IS_gridsize_d_cth = isi.n_IS_gridsize_d_cth;
  n_IS_gridsize_d_phi = isi.n_IS_gridsize_d_phi;
  n_IS_gridsize_xy = isi.n_IS_gridsize_xy;
  n_IS_gridsize_zuv = isi.n_IS_gridsize_zuv;
  n_events_max = isi.n_events_max;
  n_events_min = isi.n_events_min;
  n_step = isi.n_step;
  
  n_events_MC_opt = 0;
  opt_n_events_min = isi.n_events_min;

  //  MC_n_channel = isi.MC_n_channel;
  logger << LOG_DEBUG << "MC_n_channel = " << MC_n_channel << " has been directly set before !!!" << endl;


  logger << LOG_DEBUG << "Values set via input in file_parameter.dat:" << endl;
  logger << LOG_DEBUG << "n_alpha_events = " << isi.n_alpha_events << endl;
  logger << LOG_DEBUG << "n_IS_events = " << isi.n_IS_events << endl;
  logger << LOG_DEBUG << "n_tau_events = " << isi.n_tau_events << endl;
  logger << LOG_DEBUG << "n_x1x2_events = " << isi.n_x1x2_events << endl;
  logger << LOG_DEBUG << "n_step = " << isi.n_step << endl;
 
  if (n_alpha_events < n_step){
    n_alpha_events = n_step;
    logger << LOG_INFO << "n_alpha_events is set to n_step:   " << n_alpha_events << endl;
  }
  
  if (n_tau_events < n_step){
    n_tau_events = n_step;
    logger << LOG_INFO << "n_tau_events is set to n_step:   " << n_tau_events << endl;
  }
  
  if (n_x1x2_events < n_step){
    n_x1x2_events = n_step;
    logger << LOG_INFO << "n_x1x2_events is set to n_step:   " << n_x1x2_events << endl;
  }
  
  if (n_IS_events < n_step){
    n_IS_events = n_step;
    logger << LOG_INFO << "n_IS_events is set to n_step:   " << n_IS_events << endl;
  }
 
  if (type_contribution == "CA" || 
      type_contribution == "RCA"){
    if (n_z1z2_events < n_step){
      n_z1z2_events = n_step;
      logger << LOG_INFO << "n_z1z2_events is set to n_step:   " << n_z1z2_events << endl;
    }
  }
  
  //double temp = MC_n_channel * n_alpha_epc;
  logger << LOG_DEBUG << "n_alpha_events             = " << n_alpha_events << endl;
  logger << LOG_DEBUG << "MC_n_channel * n_alpha_epc = " << MC_n_channel * n_alpha_epc << endl;
  if (MC_n_channel * n_alpha_epc > n_alpha_events){
    n_alpha_events = (MC_n_channel * n_alpha_epc) - (MC_n_channel * n_alpha_epc) % n_step + 1 * n_step;
    logger << LOG_INFO << "n_alpha_events is increased due to n_alpha_epc:   " << n_alpha_events << endl;
  }
  
  logger << LOG_DEBUG << "n_IS_events                         = " << n_IS_events << endl;
  logger << LOG_DEBUG << "n_alpha_events * n_IS_events_factor = " << n_alpha_events * n_IS_events_factor << endl;
  if (n_alpha_events * n_IS_events_factor > n_IS_events){
    n_IS_events = n_alpha_events * n_IS_events_factor;
    logger << LOG_INFO << "n_IS_events is increased due to n_IS_events_factor:   " << n_IS_events << endl;
  }
  
  
  
  logger << LOG_DEBUG << "n_alpha_events = " << n_alpha_events << endl;
  logger << LOG_DEBUG << "n_IS_events = " << n_IS_events << endl;
  logger << LOG_DEBUG << "n_tau_events  = " << n_tau_events << endl;
  logger << LOG_DEBUG << "n_x1x2_events  = " << n_x1x2_events << endl;
  if (type_contribution == "CA" || 
      type_contribution == "RCA"){
    logger << LOG_DEBUG << "n_z1z2_events  = " << n_z1z2_events << endl;
  }




  if (switch_MC == 1 || switch_MC == 3){
    if (n_alpha_steps * n_alpha_events > n_events_MC_opt){n_events_MC_opt = n_alpha_steps * n_alpha_events;}
  }
  if (switch_IS_MC == 1 || switch_IS_MC == 3){
    if (n_IS_events * n_IS_steps > n_events_MC_opt){n_events_MC_opt = n_IS_events * n_IS_steps;}
  }


  if ((switch_MC == 1 || switch_MC == 3) || (switch_IS_MC == 1 || switch_IS_MC == 3)){
    n_tau_steps = n_tau_steps + n_events_MC_opt / n_tau_events;
    //  n_tau_events = n_tau_events + n_events_MC_opt;
    logger << LOG_INFO << "n_tau_steps is increased due to MC weight optimization:   " << n_tau_steps << endl;
    
    n_x1x2_steps = n_x1x2_steps + n_events_MC_opt / n_x1x2_events;
    //  n_x1x2_events = n_x1x2_events + n_events_MC_opt;
    logger << LOG_INFO << "n_x1x2_steps is increased due to MC weight optimization:   " << n_x1x2_steps << endl;

    if (type_contribution == "CA" || 
	type_contribution == "RCA"){
      n_z1z2_steps = n_z1z2_steps + n_events_MC_opt / n_z1z2_events;
      //  n_z1z2_events = n_z1z2_events + n_events_MC_opt;
      logger << LOG_INFO << "n_z1z2_steps is increased due to MC weight optimization:   " << n_z1z2_steps << endl;
    }
  }
  
  if ((switch_MC == 1 || switch_MC == 3) && (n_events_MC_opt > opt_n_events_min)){opt_n_events_min = n_events_MC_opt;}
  if ((switch_IS_MC == 1 || switch_IS_MC == 3) && (n_events_MC_opt > opt_n_events_min)){opt_n_events_min = n_events_MC_opt;}
  if ((switch_IS_tau == 1 || switch_IS_tau == 3) && (n_tau_steps * n_tau_events > opt_n_events_min)){opt_n_events_min = n_tau_steps * n_tau_events;}
  if ((switch_IS_x1x2 == 1 || switch_IS_x1x2 == 3) && (n_x1x2_steps * n_x1x2_events > opt_n_events_min)){opt_n_events_min = n_x1x2_steps * n_x1x2_events;}
  if (type_contribution == "CA" || 
      type_contribution == "RCA"){
    if ((switch_IS_z1z2 == 1 || switch_IS_z1z2 == 3) && (n_z1z2_steps * n_z1z2_events > opt_n_events_min)){opt_n_events_min = n_z1z2_steps * n_z1z2_events;}
  }
  logger << LOG_INFO << "opt_n_events_min:   " << opt_n_events_min << endl;
  //  switch_n_events_opt = isi.switch_n_events_opt;
  if (switch_n_events_opt == 0){}
  else if (switch_n_events_opt == 1){
    n_events_min = opt_n_events_min;
    logger << LOG_INFO << "n_events_min is increased so that optimization phase is always finished:   " << n_events_min << endl;
  }
  else if (switch_n_events_opt == 2){
    n_events_min = opt_n_events_min;
    n_events_max = opt_n_events_min;
    logger << LOG_INFO << "n_events_min is increased so that optimization phase is always finished:   " << n_events_min << endl;
    logger << LOG_INFO << "n_events_max is set to finish of optimization phase:   " << n_events_max << endl;
  }
  else if (switch_n_events_opt == 3){
    n_events_min = opt_n_events_min;
    //    n_warmup = opt_n_events_min;
    //    warmup = 1;
    logger << LOG_INFO << "n_events_min is increased so that optimization phase is always finished:   " << n_events_min << endl;
    //    logger << LOG_INFO << "n_warmup is set to finish of optimization phase:   " << n_warmup << endl;
  }
  else {
    logger << LOG_FATAL << "switch_n_events_opt ==" << switch_n_events_opt << " is deprecated!" << endl;
    assert(false);
  }
  
  logger.newLine(LOG_INFO);
  logger << LOG_INFO << "Run values:" << endl;
  logger.newLine(LOG_INFO);
  logger << LOG_INFO << "n_alpha_events   = " << setw(10) << n_alpha_events << " in " << "n_alpha_events = " << setw(10) << n_alpha_steps << " steps" << endl;
  logger << LOG_INFO << "n_IS_events      = " << setw(10) << n_IS_events << " in " << "n_IS_events    = " << setw(10) << n_IS_steps << " steps" << endl;
  logger << LOG_INFO << "n_tau_events     = " << setw(10) << n_tau_events << " in " << "n_tau_events   = " << setw(10) << n_tau_steps << " steps" << endl;
  logger << LOG_INFO << "n_x1x2_events    = " << setw(10) << n_x1x2_events << " in " << "n_x1x2_events  = " << setw(10) << n_x1x2_steps << " steps" << endl;
  if (type_contribution == "CA" || 
      type_contribution == "RCA"){
    logger << LOG_INFO << "n_z1z2_events    = " << setw(10) << n_z1z2_events << " in " << "n_z1z2_events  = " << setw(10) << n_z1z2_steps << " steps" << endl;
  }
  logger.newLine(LOG_INFO);
  logger << LOG_INFO << "opt_n_events_min = " << setw(10) << opt_n_events_min << endl;
  logger.newLine(LOG_INFO);
  
  //alpha_it.resize(n_alpha_steps, vector<double> (MC_n_channel, 0.));
  // if MC optimization finishes after the warmup phase is over, we have to extend this vector.
  // alternative: take n_alpha_steps at face value and finish after exactly steps*events points have been collected, but then we are inconsistent with what we do for the other IS optimizations. Opinions?
  /*
  if (warmup && n_alpha_steps*n_alpha_events>n_warmup) {
    alpha_it.resize(n_alpha_steps+n_warmup/n_alpha_events, vector<double> (MC_n_channel, 0.));
  } else {
    alpha_it.resize(n_alpha_steps, vector<double> (MC_n_channel, 0.));
  }
  */
  alpha_it.resize(n_alpha_steps, vector<double> (MC_n_channel, 0.));
  diff_w.resize(n_alpha_steps, 0.);

  i_alpha_it = 0;



  //  weight_opt = isi.weight_opt;
  weight_IS = isi.MCweight_IS;
  weight_in_contribution = isi.MCweight_in_contribution;
  weight_in_directory = isi.MCweight_in_directory;
  weight_min = isi.MCweight_min;
  weight_limit_min = isi.MCweight_limit_min;
  weight_limit_max = isi.MCweight_limit_max;



  //  logger << LOG_DEBUG << "before initialization of phasespace_set psi" << endl;
  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_filename(inputparameter_set & isi){
  Logger logger("phasespace_set::initialization_filename");
  logger << LOG_DEBUG << "started" << endl;

  string isi_dir_MCweights_in_contribution = "../../../../" + isi.MCweight_in_directory + "/weights";
  // not clear yet !!!



  int switch_output_weights = 1; // temporary !!!

  string prozessdatname;
  map<int, string> datname;
  fill_datname(datname);

  /*
  if (isi.csi.process_type == 2){
    prozessdatname = datname[isi.csi.type_parton[0][1]] + datname[isi.csi.type_parton[0][2]] + "_";
    for (int i = 3; i < isi.csi.type_parton[0].size(); i++){
      prozessdatname = prozessdatname + datname[isi.csi.type_parton[0][i]];
    }
  }
  else if (isi.csi.process_type == 1){
    prozessdatname = datname[isi.csi.type_parton[0][0]] + "_";
    for (int i = 1; i < isi.csi.type_parton[0].size(); i++){
      prozessdatname = prozessdatname + datname[isi.csi.type_parton[0][i]];
    }
  }

  logger << LOG_DEBUG << "old: prozessdatname = " << prozessdatname << endl;
*/
  prozessdatname = isi.csi.subprocess;
  //  logger << LOG_DEBUG << "new: prozessdatname = " << prozessdatname << endl;


  string dir_MCweights = "weights";

  filename_MCweight = dir_MCweights + "/weights_MC_" + prozessdatname + ".dat";
  filename_tauweight = dir_MCweights + "/weights_tau_" + prozessdatname + ".dat";
  filename_x1x2weight = dir_MCweights + "/weights_x1x2_" + prozessdatname + ".dat";
  filename_z1z2weight.resize(3);
  filename_z1z2weight[1] = dir_MCweights + "/weights_z1_" + prozessdatname + ".dat";
  filename_z1z2weight[2] = dir_MCweights + "/weights_z2_" + prozessdatname + ".dat";

  //  string dir_MCweights_in_contribution = "../../../../" + MCweight_in_directory + "/weights";

  filename_MCweight_in_contribution = isi_dir_MCweights_in_contribution + "/weights_MC_" + prozessdatname + ".dat";
  filename_tauweight_in_contribution = isi_dir_MCweights_in_contribution + "/weights_tau_" + prozessdatname + ".dat";
  filename_x1x2weight_in_contribution = isi_dir_MCweights_in_contribution + "/weights_x1x2_" + prozessdatname + ".dat";
  filename_z1z2weight_in_contribution.resize(3);
  filename_z1z2weight_in_contribution[1] = isi_dir_MCweights_in_contribution + "/weights_z1_" + prozessdatname + ".dat";
  filename_z1z2weight_in_contribution[2] = isi_dir_MCweights_in_contribution + "/weights_z2_" + prozessdatname + ".dat";

  if (switch_output_weights){system_execute(logger, "mkdir " + dir_MCweights);}

  logger << LOG_DEBUG << "filename_MCweight   = " << filename_MCweight << endl;
  logger << LOG_DEBUG << "filename_tauweight  = " << filename_tauweight << endl;
  logger << LOG_DEBUG << "filename_x1x2weight = " << filename_x1x2weight << endl;
  logger << LOG_DEBUG << "filename_MCweight_in_contribution   = " << filename_MCweight_in_contribution << endl;
  logger << LOG_DEBUG << "filename_tauweight_in_contribution  = " << filename_tauweight_in_contribution << endl;
  logger << LOG_DEBUG << "filename_x1x2weight_in_contribution = " << filename_x1x2weight_in_contribution << endl;

  logger << LOG_DEBUG << "filenames created" << endl;

  logger << LOG_DEBUG << "finished" << endl;
}























void phasespace_set::initialization_masses(model_set & msi){
  Logger logger("phasespace_set::initialization_masses");
  logger << LOG_DEBUG << "started" << endl;

  g_global_NWA = 1.; // temporarily !!! does not belong here !!!

  M = msi.M;
  M2 = msi.M2;
  Gamma = msi.Gamma;
  cM2 = msi.cM2;
  map_Gamma = msi.map_Gamma;
  reg_Gamma = msi.reg_Gamma;

  logger << LOG_DEBUG << "M.size() = " << M.size() << endl;
  logger << LOG_DEBUG << "M2.size() = " << M2.size() << endl;
  logger << LOG_DEBUG << "cM2.size() = " << cM2.size() << endl;
  logger << LOG_DEBUG << "Gamma.size() = " << Gamma.size() << endl;
  logger << LOG_DEBUG << "map_Gamma.size() = " << map_Gamma.size() << endl;
  logger << LOG_DEBUG << "reg_Gamma.size() = " << reg_Gamma.size() << endl;

  for (int i = 0; i < 26; i++){logger << LOG_DEBUG << "M[" << setw(2) << i << "]  = " << right << setprecision(15) << setw(23) << M[i] << "   Gamma[" << setw(2) << i << "]  = " << right << setprecision(15) << setw(23) << Gamma[i] << "   map = " << right << setprecision(8) << setw(8) << map_Gamma[i] << "   reg = " << right << setprecision(8) << setw(8) << reg_Gamma[i] << endl;}

  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_masses(vector<double> _M, vector<double> _M2, vector<double> _Gamma, vector<double_complex> _cM2, vector<double> _map_Gamma, vector<double> _reg_Gamma){
  Logger logger("phasespace_set::initialization_masses");
  logger << LOG_DEBUG << "started" << endl;

  g_global_NWA = 1.; // temporarily !!! does not belong here !!!

  M = _M;
  M2 = _M2;
  Gamma = _Gamma;
  cM2 = _cM2;
  map_Gamma = _map_Gamma;
  reg_Gamma = _reg_Gamma;

  logger << LOG_DEBUG << "M.size() = " << M.size() << endl;
  logger << LOG_DEBUG << "M2.size() = " << M2.size() << endl;
  logger << LOG_DEBUG << "cM2.size() = " << cM2.size() << endl;
  logger << LOG_DEBUG << "Gamma.size() = " << Gamma.size() << endl;
  logger << LOG_DEBUG << "map_Gamma.size() = " << map_Gamma.size() << endl;
  logger << LOG_DEBUG << "reg_Gamma.size() = " << reg_Gamma.size() << endl;

  for (int i = 0; i < 26; i++){logger << LOG_DEBUG << "M[" << setw(2) << i << "]  = " << right << setprecision(15) << setw(23) << M[i] << "   Gamma[" << setw(2) << i << "]  = " << right << setprecision(15) << setw(23) << Gamma[i] << "   map = " << right << setprecision(8) << setw(8) << map_Gamma[i] << "   reg = " << right << setprecision(8) << setw(8) << reg_Gamma[i] << endl;}

  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_born(){
  Logger logger("phasespace_set::initialization_phasespace_born");
  logger << LOG_DEBUG << "started" << endl;

  n_dipoles = 1;

  container_IS_startvalue.resize(1, vector<int> (4));

  c_p.resize(1);
  c_f.resize(1);
  c_t.resize(1);
  c_d.resize(1);

  v_smin.resize(1);
  v_smax.resize(1);

  g_p.resize(1);
  g_f.resize(1);
  g_t.resize(1);
  g_d.resize(1);

  needed_v_smin.resize(1);
  needed_v_smax.resize(1);
  needed_g_p.resize(1);
  
  needed_g_f.resize(1);
  needed_g_t.resize(1);
  needed_g_d.resize(1);
  
  //  g_IS_all_RA.resize(1);

  // from initialization.particles.QEW.RA.cxx
  start_xbp_all.resize(1);
  start_xbs_all.resize(1);
  start_xbsqrts_all.resize(1);

  MC_optswitch = 1;

  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_RA(int _n_dipoles, vector<dipole_set> _dipole){
  Logger logger("phasespace_set::initialization_phasespace_RA");
  logger << LOG_DEBUG << "started" << endl;

  logger << LOG_DEBUG << "before filling of dipole entries:" << endl;
  logger << LOG_DEBUG << "no_map.size() = " << no_map.size() << endl;
  logger << LOG_DEBUG << "o_map.size() = " << o_map.size() << endl;
  logger << LOG_DEBUG << "no_prc.size() = " << no_prc.size() << endl;
  logger << LOG_DEBUG << "o_prc.size() = " << o_prc.size() << endl;
  for (int i_a = 0; i_a < no_map.size(); i_a++){
    stringstream temp_map;
    temp_map << "no_map[" << i_a << "] = " << no_map[i_a] << "     ";
    temp_map << "o_map[" << i_a << "] = ";
    for (int i_p = 0; i_p < o_map[i_a].size(); i_p++){
      temp_map << o_map[i_a][i_p] << "  ";
    }
    logger << LOG_DEBUG << temp_map.str() << endl;
    stringstream temp_prc;
    temp_prc << "no_prc[" << i_a << "] = " << no_prc[i_a] << "     ";
    temp_prc << "o_prc[" << i_a << "] = ";
    for (int i_p = 0; i_p < o_prc[i_a].size(); i_p++){
      temp_prc << o_prc[i_a][i_p] << "  ";
    }
    logger << LOG_DEBUG << temp_prc.str() << endl;
  }
  logger << LOG_DEBUG << endl;
  
  n_dipoles = _n_dipoles;

  no_map.resize(_n_dipoles);
  o_map.resize(_n_dipoles);
  no_prc.resize(_n_dipoles);
  o_prc.resize(_n_dipoles);
  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    no_map[i_a] = _dipole[i_a].no_map();
    o_map[i_a] = _dipole[i_a].o_map();
    no_prc[i_a] = _dipole[i_a].no_prc();
    o_prc[i_a] = _dipole[i_a].o_prc();
  }
  logger << LOG_DEBUG << "after filling of dipole entries:" << endl;
  logger << LOG_DEBUG << "no_map.size() = " << no_map.size() << endl;
  logger << LOG_DEBUG << "o_map.size() = " << o_map.size() << endl;
  logger << LOG_DEBUG << "no_prc.size() = " << no_prc.size() << endl;
  logger << LOG_DEBUG << "o_prc.size() = " << o_prc.size() << endl;
  for (int i_a = 0; i_a < no_map.size(); i_a++){
    stringstream temp_map;
    temp_map << "no_map[" << i_a << "] = " << no_map[i_a] << "     ";
    temp_map << "o_map[" << i_a << "] = ";
    for (int i_p = 0; i_p < o_map[i_a].size(); i_p++){
      temp_map << o_map[i_a][i_p] << "  ";
    }
    logger << LOG_DEBUG << temp_map.str() << endl;
    stringstream temp_prc;
    temp_prc << "no_prc[" << i_a << "] = " << no_prc[i_a] << "     ";
    temp_prc << "o_prc[" << i_a << "] = ";
    for (int i_p = 0; i_p < o_prc[i_a].size(); i_p++){
      temp_prc << o_prc[i_a][i_p] << "  ";
    }
    logger << LOG_DEBUG << temp_prc.str() << endl;
  }

  logger << LOG_DEBUG << endl;

  container_IS_name.resize(0);
  container_IS_switch.resize(0);

  container_IS_startvalue.resize(_n_dipoles, vector<int> (7));
  container_IS_startvalue[0].resize(4);
  c_p.resize(_n_dipoles);
  c_f.resize(_n_dipoles);
  c_t.resize(_n_dipoles);
  c_d.resize(_n_dipoles);

  v_smin.resize(_n_dipoles);
  v_smax.resize(_n_dipoles);

  g_p.resize(_n_dipoles);
  g_f.resize(_n_dipoles);
  g_t.resize(_n_dipoles);
  g_d.resize(_n_dipoles);

  needed_v_smin.resize(_n_dipoles);
  needed_v_smax.resize(_n_dipoles);
  needed_g_p.resize(_n_dipoles);
  
  needed_g_f.resize(_n_dipoles);
  needed_g_t.resize(_n_dipoles);
  needed_g_d.resize(_n_dipoles);
  
  //  g_IS_all_RA.resize(_n_dipoles);

  // from initialization.particles.QEW.RA.cxx
  start_xbp_all.resize(_n_dipoles);
  start_xbs_all.resize(_n_dipoles);
  start_xbsqrts_all.resize(_n_dipoles);

  MC_x_dipole_mapping.resize(_n_dipoles);

  dipole_sinx_min.resize(_n_dipoles, 0.);
  dipole_x.resize(_n_dipoles, 0.);

  no_random_dipole.resize(3);
  no_random_dipole[0] = 3 * n_particle - 4 - 2;
  no_random_dipole[1] = 3 * n_particle - 4 - 1;
  no_random_dipole[2] = 3 * n_particle - 4;

  MC_optswitch = 0;

  //  logger << LOG_DEBUG << "MC_n_channel = " << MC_n_channel << endl;
  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    logger << LOG_DEBUG << "MC_n_channel_phasespace[" << setw(2) << i_a << "] = " << setw(4) << MC_n_channel_phasespace[i_a] << "   MC_sum_channel_phasespace[" << setw(2) << i_a << "] = " << setw(4) << MC_sum_channel_phasespace[i_a] << endl;
  }
  MC_n_channel = MC_sum_channel_phasespace[_n_dipoles - 1];
  /*
  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    MC_n_channel += _dipole[i_a].n_channel();
    logger << LOG_DEBUG << "dipole[" << setw(2) << i_a << "].n_channel() = " << _dipole[i_a].n_channel() << endl;
  }
  */
  logger << LOG_DEBUG << "MC_n_channel = " << MC_n_channel << endl;
  
  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_subprocess(){
  Logger logger("phasespace_set::initialization_phasespace_subprocess");
  logger << LOG_DEBUG << "started" << endl;
  // temporary - check if needed elsewhere !!!
  //  double s_hat;
  //  double sqrt_s_hat;
  //  int tau_channel;

  //  int coll_choice = 1;
  logger << LOG_DEBUG << "started" << endl;

  x_pdf.resize(3);
  vector<double> pdf_factor(3);
  /*
  vector<double> p_2(3 + n_particle);
  vector<double> sqp_2(3 + n_particle);
  */

  logger << LOG_DEBUG_VERBOSE << "start_xbp_all.size() = " << start_xbp_all.size() << endl;
  logger << LOG_DEBUG_VERBOSE << "start_xbs_all.size() = " << start_xbs_all.size() << endl;
  logger << LOG_DEBUG_VERBOSE << "start_xbsqrts_all.size() = " << start_xbsqrts_all.size() << endl;

  start_xbp_all[0].resize(xb_max);
  start_xbs_all[0].resize(xb_max);
  start_xbsqrts_all[0].resize(xb_max);


  if (coll_choice == 0){
    fourvector p1(E, 0, 0, E), p2(E, 0, 0, -E);
    start_xbp_all[0][0] = p1 + p2;
    start_xbp_all[0][1] = p1;
    start_xbp_all[0][2] = p2;
    //    s_hat = 4. * pow(E, 2);
    //    sqrt_s_hat = 2. * E;
    for (int i = 0; i < 3; i++){x_pdf[i] = 1.;}
  }
  /*
  logger << LOG_DEBUG_VERBOSE << "p_2.size() = " << p_2.size() << endl;
  logger << LOG_DEBUG_VERBOSE << "sqp_2.size() = " << sqp_2.size() << endl;
  logger << LOG_DEBUG_VERBOSE << "M2.size() = " << M2.size() << endl;
  logger << LOG_DEBUG_VERBOSE << "M.size() = " << M.size() << endl;
  //for (int i = 1; i < n_particle + 3; i++){
  for (int i = 1; i < type_parton.size(); i++){
    p_2[i] = M2[abs(type_parton[i])];
    sqp_2[i] = M[abs(type_parton[i])];
  }
  sqp_2[0] = accumulate(sqp_2.begin(), sqp_2.end(), 0.); // ppwwbb
  p_2[0] = pow(sqp_2[0], 2);
*/
  //  double s_hadronic = 4. * pow(E, 2);
  logger << LOG_DEBUG << "definitions of particle momenta and masses" << endl;

  // **************************************************************************
  // *                                                                        *
  // *  definitions for automatized phase-space generation                    *
  // *                                                                        *
  // **************************************************************************
  //  int xb_max = intpow(2, n_particle + 2);
  /*
fourvector largevector(0., 0., 0., 0.);
double larges = 0.;
double largesqrts = 0.;
vector<fourvector> start_xbp(xb_max, largevector);
vector<double> start_xbs(xb_max, larges);
vector<double> start_xbsqrts(xb_max, largesqrts);
  */
  if (n_particle > 0){
    for (int xi = 1; xi <= n_particle + 2; xi++){
      start_xbs_all[0][intpow(2, xi - 1)] = M2[abs(type_parton[xi])];
      start_xbsqrts_all[0][intpow(2, xi - 1)] = M[abs(type_parton[xi])];
    }
    if (coll_choice == 0){
      start_xbs_all[0][0] = start_xbp_all[0][0].m2();
      start_xbsqrts_all[0][0] = sqrt(start_xbs_all[0][0]);
      /*
      start_xbp_all[0] = start_xbp_all[0][0];
      start_xbp_all[1] = start_xbp_all[0][1];
      start_xbp_all[2] = start_xbp_all[0][2];
      */
      start_xbp_all[0][xb_max - 4] = start_xbp_all[0][0];
      start_xbs_all[0][xb_max - 4] = start_xbs_all[0][0];
      start_xbsqrts_all[0][xb_max - 4] = start_xbsqrts_all[0][0];
      start_xbp_all[0][3] = start_xbp_all[0][0];
      start_xbs_all[0][3] = start_xbs_all[0][0];
      start_xbsqrts_all[0][3] = start_xbsqrts_all[0][0];
      pdf_factor[0] = 1.;
      pdf_factor[1] = 1.;
      pdf_factor[2] = 0.;
      tau_channel = 0;
    }
  }
  sqrtsmin_opt = start_xbsqrts_all; // = start_xbsqrts;
  smin_opt = start_xbs_all; // = start_xbs;

  /*
  vector<double> xbsmin_opt = start_xbs_all[0];
  vector<double> xbsqrtsmin_opt = start_xbsqrts_all[0];
  // new:
  vector<vector<double> > xbsqrtsmin_opt_all(n_ps, xbsqrtsmin_opt);
  vector<vector<double> > xbsmin_opt_all(n_ps, xbsmin_opt);
  // new.
  */
  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_subprocess_optimization(){
  Logger logger("phasespace_set::initialization_phasespace_subprocess_optimization");
  logger << LOG_DEBUG << "started" << endl;

  for (int ix = 4; ix < sqrtsmin_opt[0].size(); ix += 4){
    if (sqrtsmin_opt[0][ix] == start_xbsqrts_all[0][ix]){}
    else if (sqrtsmin_opt[0][ix] < start_xbsqrts_all[0][ix]){sqrtsmin_opt[0][ix] = start_xbsqrts_all[0][ix];}
    else if (sqrtsmin_opt[0][ix] > start_xbsqrts_all[0][ix] && vectorbinary_from_binary(ix).size() == 1){
      cout << "phase-space cut is in contradiction to on-shell conditions of intermediate particle " << ix << "!" << endl;
      exit(1);
    }
  }

  for (int ix = 4; ix < sqrtsmin_opt[0].size(); ix += 4){
    if (vectorbinary_from_binary(ix).size() > 1){
      double temp_sqrts_opt = max_subset_from_binary(sqrtsmin_opt[0], ix);
      if (temp_sqrts_opt > sqrtsmin_opt[0][ix]){sqrtsmin_opt[0][ix] = temp_sqrts_opt;}
      smin_opt[0][ix] = pow(sqrtsmin_opt[0][ix], 2);
    }
  }

  //cout << "smin_opt[0] before adding invariant-mass cuts:" << endl;
  for (int i = 4; i < smin_opt[0].size(); i += 4){
    //  logger << LOG_INFO << "sqrtsmin_opt[0][" << setw(3) << right << i << "] = " << setdl << sqrtsmin_opt[0][i] << "   smin_opt[0][" << setw(3) << right << i << "] = " << setdl << smin_opt[0][i] << endl;
    stringstream temp_ss;
    temp_ss << "sqrtsmin_opt[0][" << setw(3) << i << "] = " << setw(15) << setprecision(8) << sqrtsmin_opt[0][i] << "   smin_opt[0][" << setw(3) << i << "] = " << setw(15) << setprecision(8) << smin_opt[0][i] << "   ---   ";// << endl;
    vector<int> temp_vb = vectorbinary_from_binary(i);
    if (temp_vb.size() > 1){
      for (int j = 0; j < temp_vb.size(); j++){
	temp_ss << "[" << setw(3) << temp_vb[j] << "] = " << setw(15) << setprecision(8) << sqrtsmin_opt[0][temp_vb[j]] << "   ";
      }
    }
    temp_ss << endl;
    logger << LOG_DEBUG << temp_ss.str();
  }
  logger.newLine(LOG_INFO);
  
  for (int i = 0; i < start_xbp_all[0].size(); i++){
    if (start_xbs_all[0][i] != 0. || start_xbsqrts_all[0][i] != 0.){
      logger << LOG_INFO << "xbs[" << setw(3) << right << i << "] = " << start_xbs_all[0][i] << "   " << "xbsqrts[" << setw(3) << right << i << "] = " << start_xbsqrts_all[0][i] << "   " << endl;
    }
  }
  logger.newLine(LOG_INFO);

  logger << LOG_DEBUG << "tau_0 = " << tau_0 << "   -> sqrt(s^_min) = " << 2 * sqrt(tau_0) * E << endl;
  if (tau_0 < smin_opt[0][smin_opt[0].size() - 4] / (4 * pow(E, 2))){tau_0 = smin_opt[0][smin_opt[0].size() - 4] / (4 * pow(E, 2));}
  //  if (tau_0 < pow(cut_Mjetjet, 2) / (4 * pow(E, 2))){tau_0 = pow(cut_Mjetjet, 2) / (4 * pow(E, 2));}
//if (tau_0 < pow(100., 2) / (4 * pow(E, 2))){tau_0 = pow(100., 2) / (4 * pow(E, 2));}
logger << LOG_DEBUG << "tau_0 = " << tau_0 << "   -> sqrt(s^_min) = " << 2 * sqrt(tau_0) * E << endl;



/*
  // shifted elsewhere
 cout << "tau_MC_tau_gamma.size() = " << tau_MC_tau_gamma.size() << endl;
for (int j = 0; j < tau_MC_tau_gamma[0].size(); j++){
 cout << "tau_MC_tau_gamma[0].size() = " << tau_MC_tau_gamma[0].size() << endl;
  double random_tau = (double(j + 1)) / double(tau_MC_tau_beta[0].size());
  tau_MC_tau_gamma[0][j] = h_propto_pot(random_tau, tau_0, exp_pdf);
  //  cout << "tau_MC_tau_gamma[0][" << setw(3) << j << "] = " << tau_MC_tau_gamma[0][j] << endl;
 }
*/
 
  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_subprocess_dipole_IS_RA(int _n_dipoles, vector<dipole_set> _dipole){
  Logger logger("phasespace_set::initialization_phasespace_subprocess_dipole_RA");
  logger << LOG_DEBUG << "started" << endl;

  for (int i_a = 1; i_a < _n_dipoles; i_a++){
    container_IS_startvalue[i_a][4] = container_IS_name.size();
    container_IS_name.push_back("x of dipole " + _dipole[i_a].name());
    container_IS_startvalue[i_a][5] = container_IS_name.size();
    container_IS_name.push_back("z of dipole " + _dipole[i_a].name());
    container_IS_startvalue[i_a][6] = container_IS_name.size();
    container_IS_name.push_back("phi of dipole " + _dipole[i_a].name());
  }
  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_subprocess_dipole_RA(int _n_dipoles, vector<dipole_set> _dipole){
  Logger logger("phasespace_set::initialization_phasespace_subprocess_dipole_RA");
  logger << LOG_DEBUG << "started" << endl;
  /*
  for (int i_a = 1; i_a < _n_dipoles; i_a++){
    container_IS_startvalue[i_a][4] = container_IS_name.size();
    container_IS_name.push_back("x of dipole " + _dipole[i_a].name());
    container_IS_startvalue[i_a][5] = container_IS_name.size();
    container_IS_name.push_back("z of dipole " + _dipole[i_a].name());
    container_IS_startvalue[i_a][6] = container_IS_name.size();
    container_IS_name.push_back("phi of dipole " + _dipole[i_a].name());
  }
  */
  // from initialization.particles.QEW.RA.cxx
  // temporary - check if needed elsewhere !!!
  //  double s_hat;
  //  double sqrt_s_hat;
  //  int max_particles;
  //  int tau_channel;
  //  int coll_choice = 1;

  x_pdf.resize(3);
  vector<double> pdf_factor(3);
  vector<double> p_2(3 + n_particle);
  vector<double> sqp_2(3 + n_particle);
  /*  
  vector<vector<double> > p_2_RA(_n_dipoles);
  vector<vector<double> > sqp_2_RA(_n_dipoles);
  */
  vector<vector<vector<double> > > dx_s_RA(_n_dipoles);
  vector<vector<vector<double> > > dx_sqrts_RA(_n_dipoles);
  for (int i_a = 0; i_a < dx_s_RA.size(); i_a++){
    dx_s_RA[i_a].resize(_dipole[i_a].type_parton().size(), vector<double> (1));
    dx_sqrts_RA[i_a].resize(_dipole[i_a].type_parton().size(), vector<double> (1));
  }
  logger << LOG_DEBUG << "x_s_RA started" << endl;



  start_xbp_all[0].resize(xb_max);
  start_xbs_all[0].resize(xb_max);
  start_xbsqrts_all[0].resize(xb_max);
//  logger << LOG_DEBUG << "   _n_dipoles = " << _n_dipoles << endl;
  for (int c = 1; c < _n_dipoles; c++){
    start_xbp_all[c].resize(xb_max_dipoles);
    start_xbs_all[c].resize(xb_max_dipoles);
    start_xbsqrts_all[c].resize(xb_max_dipoles);
  }



  p_2.resize(3 + n_particle);
  sqp_2.resize(3 + n_particle);
  for (int i = 1; i < n_particle + 3; i++){
    logger << LOG_DEBUG << "i = " << i << endl;
    logger << LOG_DEBUG << "_dipole[0].type_parton().size() = " << _dipole[0].type_parton().size() << endl;
    logger << LOG_DEBUG << "_dipole[0].type_parton()[" << i << "] = " << _dipole[0].type_parton()[i] << endl;
    logger << LOG_DEBUG << "M.size() = " << M.size() << endl;
    logger << LOG_DEBUG << "M2.size() = " << M2.size() << endl;
    logger << LOG_DEBUG << "M[abs(_dipole[0].type_parton()[" << i << ")] = " << _dipole[0].type_parton()[i] << "] = " << setw(23) << setprecision(15) << M[abs(_dipole[0].type_parton()[i])] << endl;
    logger << LOG_DEBUG << "M2[abs(_dipole[0].type_parton()[" << i << ")] = " << _dipole[0].type_parton()[i] << "] = " << setw(23) << setprecision(15) << M2[abs(_dipole[0].type_parton()[i])] << endl;
    
    p_2[i] = M2[abs(_dipole[0].type_parton()[i])];
    sqp_2[i] = M[abs(_dipole[0].type_parton()[i])];
    //    p_2[i] = M2[abs(type_parton[i])];
    //    sqp_2[i] = M[abs(type_parton[i])];
  }
  sqp_2[0] = accumulate(sqp_2.begin(), sqp_2.end(), 0.); // ppwwbb
  p_2[0] = pow(sqp_2[0], 2);
   
  logger << LOG_DEBUG << "p_2 started" << endl;
    
  for (int i_a = 0; i_a < dx_s_RA.size(); i_a++){
    for (int i_b = 1; i_b < dx_s_RA[i_a].size(); i_b++){
      if (dx_s_RA[i_a][i_b].size() == 1){
	dx_s_RA[i_a][i_b][0] = M2[abs(_dipole[i_a].type_parton()[i_b])];
	dx_sqrts_RA[i_a][i_b][0] = M[abs(_dipole[i_a].type_parton()[i_b])];
      }
    }
  }
 




  logger << LOG_INFO << "definitions of particle momenta and masses" << endl;
// **************************************************************************
// *                                                                        *
// *  definitions for automatized phase-space generation                    *
// *                                                                        *
// **************************************************************************
  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    for (int xbi = 0; xbi < start_xbp_all[i_a].size(); xbi++){
      start_xbp_all[i_a][xbi] = nullvector;
      //      start_xbs_all[i_a][xbi] = sqrt(-1.);
      //      start_xbsqrts_all[i_a][xbi] = sqrt(-1.);
      start_xbs_all[i_a][xbi] = 0.;
      start_xbsqrts_all[i_a][xbi] = 0.;
    }
    int max_particles;
    if (i_a == 0){max_particles = n_particle + 2 + 1;}
    else {max_particles = n_particle + 2;}
    for (int xbi = 1; xbi < max_particles; xbi++){
      start_xbs_all[i_a][intpow(2, xbi - 1)] = dx_s_RA[i_a][xbi][0];
      start_xbsqrts_all[i_a][intpow(2, xbi - 1)] = dx_sqrts_RA[i_a][xbi][0];
      /*
      start_xbs_all[i_a][intpow(2, xbi - 1)] = p_2[xbi];
      start_xbsqrts_all[i_a][intpow(2, xbi - 1)] = sqp_2[xbi];
      */
    }
  }

  if (coll_choice == 0){
    logger << LOG_DEBUG << "coll_choice == 0" << endl;
    fourvector p1(E, 0, 0, E), p2(E, 0, 0, -E);
    //    s_hat = 4. * pow(E, 2);
    //    sqrt_s_hat = 2. * E;
    for (int i = 0; i < 3; i++){x_pdf[i] = 1.;}

    for (int i_a = 0; i_a < _n_dipoles; i_a++){
      logger << LOG_DEBUG << i_a << endl;
      start_xbp_all[i_a][0] = p1 + p2;
      start_xbp_all[i_a][1] = p1;
      start_xbp_all[i_a][2] = p2;
      start_xbs_all[i_a][0] = start_xbp_all[0][0].m2();
      start_xbsqrts_all[i_a][0] = sqrt(start_xbs_all[i_a][0]);
      start_xbp_all[i_a][3] = start_xbp_all[i_a][0];
      start_xbs_all[i_a][3] = start_xbs_all[i_a][0];
      start_xbsqrts_all[i_a][3] = start_xbsqrts_all[i_a][0];
      //      for (int i_p = 0; i_p < 3; i_p++){start_xbp_all[i_a][i_p] = start_xbp_all[0][i_p];}
      if (i_a == 0){
	start_xbp_all[i_a][xb_max - 4] = start_xbp_all[i_a][0];
	start_xbs_all[i_a][xb_max - 4] = start_xbs_all[i_a][0];
	start_xbsqrts_all[i_a][xb_max - 4] = start_xbsqrts_all[i_a][0];
      }
      else {
	start_xbp_all[i_a][xb_max_dipoles - 4] = start_xbp_all[i_a][0];
	start_xbs_all[i_a][xb_max_dipoles - 4] = start_xbs_all[i_a][0];
	start_xbsqrts_all[i_a][xb_max_dipoles - 4] = start_xbsqrts_all[i_a][0];
      }
    }
    pdf_factor[0] = 1.;
    pdf_factor[1] = 1.;
    pdf_factor[2] = 0.;
    tau_channel = 0;
  }
  
  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    for (int i_x = 4; i_x < start_xbs_all[i_a].size(); i_x += 4){
      vector<int> temp_vb = vectorbinary_from_binary(i_x);
      logger << LOG_DEBUG << "start_xbsqrts_all[" << setw(2) << i_a << "][" << setw(3) << i_x << "] = " << left << setw(23) << setprecision(15) << start_xbsqrts_all[i_a][i_x] << "   start_xbs_all[" << setw(2) << i_a << "][" << setw(3) << i_x << "] = " << left << setw(23) << setprecision(15) << start_xbs_all[i_a][i_x] << endl;
      if (temp_vb.size() == 1 || start_xbs_all[i_a][i_x] != 0. || start_xbsqrts_all[i_a][i_x] != 0.){
	logger << LOG_DEBUG << "start_xbsqrts_all[" << setw(2) << i_a << "][" << setw(3) << i_x << "] = " << left << setw(23) << setprecision(15) << start_xbsqrts_all[i_a][i_x] << "   start_xbs_all[" << setw(2) << i_a << "][" << setw(3) << i_x << "] = " << left << setw(23) << setprecision(15) << start_xbs_all[i_a][i_x] << endl;
      }
    }
  }
 
  
  sqrtsmin_opt = start_xbsqrts_all; // = start_xbsqrts;
  smin_opt = start_xbs_all; // = start_xbs;

  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_subprocess_optimization_dipole_RA(int _n_dipoles, vector<dipole_set> _dipole){
  Logger logger("phasespace_set::initialization_phasespace_subprocess_dipole_optimization_RA");
  logger << LOG_DEBUG << "started" << endl;

  // temporary - check if needed elsewhere !!!
  //  vector<double> dipole_sinx_min(_n_dipoles, 0.);

  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    for (int i_x = 4; i_x < sqrtsmin_opt[i_a].size(); i_x += 4){
      if (sqrtsmin_opt[i_a][i_x] == start_xbsqrts_all[i_a][i_x]){}
      else if (sqrtsmin_opt[i_a][i_x] < start_xbsqrts_all[i_a][i_x]){sqrtsmin_opt[i_a][i_x] = start_xbsqrts_all[i_a][i_x];} 
      else if (sqrtsmin_opt[i_a][i_x] > start_xbsqrts_all[i_a][i_x]){
	if (vectorbinary_from_binary(i_x).size() == 1){
	  logger << LOG_FATAL << "phase-space cut is in contradiction to on-shell conditions of intermediate particle " << i_x << "!" << endl;
	  exit(1);
	}
      }
    }
  }
  
  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    for (int i_x = 4; i_x < sqrtsmin_opt[i_a].size(); i_x += 4){
      if (vectorbinary_from_binary(i_x).size() > 1){
	//      double temp_sqrts = max_subset_from_binary(start_xbsqrts_all[i_a], i_x);
	double temp_sqrts_opt = max_subset_from_binary(sqrtsmin_opt[i_a], i_x);
	if (temp_sqrts_opt > sqrtsmin_opt[i_a][i_x]){sqrtsmin_opt[i_a][i_x] = temp_sqrts_opt;}
	smin_opt[i_a][i_x] = pow(sqrtsmin_opt[i_a][i_x], 2);
      }
    }
  }
  
  
  
  
  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    for (int i = 4; i < smin_opt[i_a].size(); i += 4){
      stringstream temp_ss;
      temp_ss << "sqrtsmin_opt[" << setw(2) << i_a << "][" << setw(3) << i << "] = " << setw(15) << setprecision(8) << sqrtsmin_opt[i_a][i] << "   smin_opt[" << setw(2) << i_a << "][" << setw(3) << i << "] = " << setw(15) << setprecision(8) << smin_opt[i_a][i] << "   ---   " << endl;
      vector<int> temp_vb = vectorbinary_from_binary(i);
      if (temp_vb.size() > 1){
	for (int j = 0; j < temp_vb.size(); j++){
	  temp_ss << "[" << setw(2) << i_a << "][" << setw(3) << i << "] = " << setw(15) << setprecision(8) << sqrtsmin_opt[i_a][i] << "   ";
	}
      }
      temp_ss << endl;
      logger << LOG_DEBUG << temp_ss.str();
    }
  }
  logger.newLine(LOG_DEBUG);
  
  
  for (int i_a = 0; i_a < _n_dipoles; i_a++){
    for (int i_x = 4; i_x < smin_opt[i_a].size(); i_x += 4){
      vector<int> temp_vb = vectorbinary_from_binary(i_x);
      if (temp_vb.size() == 1 || start_xbs_all[i_a][i_x] != 0. || start_xbsqrts_all[i_a][i_x] != 0.){
	logger << LOG_DEBUG << "start_xbsqrts_all[" << setw(2) << i_a << "][" << setw(3) << i_x << "] = " << left << setw(23) << setprecision(15) << start_xbsqrts_all[i_a][i_x] << "   start_xbs_all[" << setw(2) << i_a << "][" << setw(3) << i_x << "] = " << left << setw(23) << setprecision(15) << start_xbs_all[i_a][i_x] << endl;
      }
    }
  }
  logger.newLine(LOG_DEBUG);
  
  vector<vector<vector<double> > > dx_s_RA(_n_dipoles);
  vector<vector<vector<double> > > dx_sqrts_RA(_n_dipoles);
  for (int i_a = 0; i_a < dx_s_RA.size(); i_a++){
    dx_s_RA[i_a].resize(_dipole[i_a].type_parton().size(), vector<double> (1));
    dx_sqrts_RA[i_a].resize(_dipole[i_a].type_parton().size(), vector<double> (1));
  }
  for (int i_a = 0; i_a < dx_s_RA.size(); i_a++){
    for (int i_b = 1; i_b < dx_s_RA[i_a].size(); i_b++){
      if (dx_s_RA[i_a][i_b].size() == 1){
	dx_s_RA[i_a][i_b][0] = M2[abs(_dipole[i_a].type_parton()[i_b])];
	dx_sqrts_RA[i_a][i_b][0] = M[abs(_dipole[i_a].type_parton()[i_b])];
      }
    }
  }

  
  for (int i_a = 0; i_a < dx_s_RA.size(); i_a++){
    //  cout << "i_a = " << i_a << "   dx_s_RA[" << i_a << "].size() = " << dx_s_RA[i_a].size() << endl;
    for (int ib = 3; ib < dx_s_RA[i_a].size(); ib++){
      dipole_sinx_min[i_a] += M[abs(_dipole[i_a].type_parton()[ib])];
      //    cout << "M[abs(_dipole[" << i_a << "].type_parton()[" << ib << "])] = " << M[abs(_dipole[i_a].type_parton()[ib])] << endl;
      //    cout << "_dipole[" << i_a << "].type_parton()[" << ib << "] = " << _dipole[i_a].type_parton()[ib] << endl;
    }
    dipole_sinx_min[i_a] = pow(dipole_sinx_min[i_a], 2);
    logger << LOG_DEBUG << "smin_opt (only from masses):   dipole_sinx_min[" << setw(2) << i_a << "] = " << dipole_sinx_min[i_a] << endl;
    dipole_sinx_min[i_a] = smin_opt[i_a][smin_opt[i_a].size() - 4];
    logger << LOG_DEBUG << "smin_opt (from smin_opt[" << i_a << "][" << smin_opt[i_a].size() - 4 << "]):    dipole_sinx_min[" << setw(2) << i_a << "] = " << dipole_sinx_min[i_a] << endl;
  }
    
  logger << LOG_DEBUG << "tau_0 = " << tau_0 << "   -> sqrt(s^_min) = " << 2 * sqrt(tau_0) * E << endl;
  
  if (tau_0 < smin_opt[0][smin_opt[0].size() - 4] / (4 * pow(E, 2))){tau_0 = smin_opt[0][smin_opt[0].size() - 4] / (4 * pow(E, 2));}
  
  logger << LOG_DEBUG << "tau_0 = " << tau_0 << "   -> sqrt(s^_min) = " << 2 * sqrt(tau_0) * E << endl;
  logger.newLine(LOG_DEBUG);

  // shifted elsewhere
  /*
  for (int j = 0; j < tau_MC_tau_gamma[0].size(); j++){
    double random_tau = (double(j + 1)) / double(tau_MC_tau_beta[0].size());
    tau_MC_tau_gamma[0][j] = h_propto_pot(random_tau, tau_0, exp_pdf);
    logger << LOG_DEBUG << "tau_MC_tau_gamma[0][" << setw(3) << j << "] = " << tau_MC_tau_gamma[0][j] << endl;
  }
  */  
  
  xbp_all = start_xbp_all;
  xbs_all = start_xbs_all;
  xbsqrts_all = start_xbsqrts_all;
  
  corrected_xbp_all = start_xbp_all;
  corrected_xbs_all = start_xbs_all;
  corrected_xbsqrts_all = start_xbsqrts_all;

  logger << LOG_DEBUG << "finished" << endl;
}


void phasespace_set::initialization_phasespace_MC_tau(){
  Logger logger("phasespace_set::initialization_phasespace_MC_tau");
  logger << LOG_DEBUG << "started" << endl;
  /*
  logger << LOG_INFO << "psi_start_xbs_all.size() = " << start_xbs_all.size() << endl;
  logger << LOG_INFO << "psi_start_xbs_all[0].size() = " << start_xbs_all[0].size() << endl;
  logger << LOG_INFO << "psi_start_xbs_all[0][0] = " << start_xbs_all[0][0] << endl;
  */
  logger << LOG_INFO << "2 * sqrt(tau_0) * E = " << 2 * sqrt(tau_0) * E << endl;

  logger << LOG_INFO << "tau_MC_map.size() = " << tau_MC_map.size() << endl;


  for (int i_m = tau_MC_map.size() - 1; i_m > 0; i_m--){
    logger << LOG_INFO << "tau_MC_map[" << i_m << "] = " << tau_MC_map[i_m] << endl;

    logger << LOG_INFO << "psi_M[" << abs(tau_MC_map[i_m]) << "] = " << M[abs(tau_MC_map[i_m])] << endl;
    logger << LOG_INFO << "psi_Gamma[" << abs(tau_MC_map[i_m]) << "] = " << Gamma[abs(tau_MC_map[i_m])] << endl;
    logger << LOG_INFO << "psi_map_Gamma[" << abs(tau_MC_map[i_m]) << "] = " << map_Gamma[abs(tau_MC_map[i_m])] << endl;
    if (map_Gamma[abs(tau_MC_map[i_m])] == 0.){tau_MC_map.erase(tau_MC_map.begin() + i_m);}
    else if (2 * sqrt(tau_0) * E > M[abs(tau_MC_map[i_m])]){tau_MC_map.erase(tau_MC_map.begin() + i_m);}

    // leads to problems if M_res < smin !!!
    //    else if (2 * sqrt(tau_0) * E > M[abs(tau_MC_map[i_m])] + 5 * map_Gamma[abs(tau_MC_map[i_m])]){tau_MC_map.erase(tau_MC_map.begin() + i_m);}


  }

  logger << LOG_INFO << "tau_MC_map.size() = " << tau_MC_map.size() << endl;


  n_tau_MC_channel = tau_MC_map.size();
  /*
  logger << LOG_DEBUG << "n_tau_MC_channel = " << n_tau_MC_channel << endl;
  tau_MC_alpha.resize(n_tau_MC_channel, 1. / double(n_tau_MC_channel));
  // should be modified and set in a process-dependent way !!!
  tau_MC_beta.resize(n_tau_MC_channel);
  tau_MC_tau_channel.resize(n_tau_MC_channel, vector<int> (n_tau_bins, 0));
  tau_MC_tau_alpha.resize(n_tau_MC_channel, vector<double> (n_tau_bins, 1. / double(n_tau_bins)));
  tau_MC_tau_beta.resize(n_tau_MC_channel, vector<double> (n_tau_bins));
  */
  tau_MC_tau_gamma.resize(n_tau_MC_channel, vector<double> (n_tau_bins));
  /*
  tau_MC_tau_counts_channel.resize(n_tau_MC_channel, vector<int> (n_tau_bins, 0));
  tau_MC_tau_cuts_channel.resize(n_tau_MC_channel, vector<int> (n_tau_bins, 0));
  sum_tau_MC_tau_channel_weight.resize(n_tau_MC_channel, vector<double> (n_tau_bins, 0.));
  sum_tau_MC_tau_channel_weight2.resize(n_tau_MC_channel, vector<double> (n_tau_bins, 0.));
  
  for (int ib = 0; ib < tau_MC_tau_beta.size(); ib++){
    if (n_tau_bins > 0){
      tau_MC_tau_beta[ib][0] = tau_MC_tau_alpha[ib][0];
      for (int ic = 1; ic < tau_MC_tau_beta[ib].size(); ic++){
	tau_MC_tau_beta[ib][ic] = tau_MC_tau_beta[ib][ic - 1] + tau_MC_tau_alpha[ib][ic];
      }
    }
  }
  */
  if (switch_MC_tau == -1){tau_MC_map.resize(1);}

  // !!! input !!!
  int switch_minimum_weight = 1;
  double limit_minimum_weight = 0.1;
  double reserved_minimum_weight = 0.1;
  //  double limit_minimum_weight = 1.e-4;
  //  double reserved_minimum_weight = 1.e-3;

  logger << LOG_DEBUG << "tau_MC_map.size() = " << tau_MC_map.size() << endl;

  MC_tau = multichannel_set("MC_tau", tau_MC_map.size(), n_alpha_events, n_alpha_steps, switch_minimum_weight, limit_minimum_weight, reserved_minimum_weight, 0, 0);

  if (switch_MC_tau == 0 || switch_MC_tau == 2){MC_tau.active_optimization = 0;}
  else if (switch_MC_tau == 1 || switch_MC_tau == 3){MC_tau.active_optimization = 1;}
  logger << LOG_DEBUG << "MC_tau.active_optimization = " << MC_tau.active_optimization << endl;


  // shifted from elsewhere


  /* cout << "tau_MC_tau_gamma.size() = " << tau_MC_tau_gamma.size() << endl;
for (int j = 0; j < tau_MC_tau_gamma[0].size(); j++){
 cout << "tau_MC_tau_gamma[0].size() = " << tau_MC_tau_gamma[0].size() << endl;
  double random_tau = (double(j + 1)) / double(MC_tau.beta[0].size());
  tau_MC_tau_gamma[0][j] = h_propto_pot(random_tau, tau_0, exp_pdf);
  //  cout << "tau_MC_tau_gamma[0][" << setw(3) << j << "] = " << tau_MC_tau_gamma[0][j] << endl;
 }
  */
  logger << LOG_DEBUG << "MC_tau.n_channel = " << MC_tau.n_channel << endl;
  for (int i_c = 0; i_c < MC_tau.n_channel; i_c++){
    logger << LOG_DEBUG << "tau_MC_map  [" << i_c << "] = " << tau_MC_map[i_c] << endl;
    logger << LOG_DEBUG << "MC_tau.alpha[" << i_c << "] = " << MC_tau.alpha[i_c] << endl;
    logger << LOG_DEBUG << "MC_tau.beta [" << i_c << "] = " << MC_tau.beta[i_c] << endl;
  }

  logger << LOG_DEBUG << "finished" << endl;
}

/*
void phasespace_set::initialization_phasespace_MC_x_dipole(){
  Logger logger("phasespace_set::initialization_phasespace_MC_x_dipole");
  logger << LOG_DEBUG << "started" << endl;
  
  logger << LOG_INFO << "2 * sqrt(tau_0) * E = " << 2 * sqrt(tau_0) * E << endl;

  logger << LOG_INFO << "tau_MC_map.size() = " << tau_MC_map.size() << endl;


  for (int i_a = 0; i_a < n_dipoles; i_a++){
    //    for (int i_m = 0; i_m < MC_x_dipole_mapping[i_a].size(); i_m++){
    for (int i_m = MC_x_dipole_mapping[i_a].size() - 1; i_m > 0; i_m--){
      logger << LOG_INFO << "MC_x_dipole_mapping[" << i_a << "][" << i_m << "] = " << MC_x_dipole_mapping[i_a][i_m] << endl;
      
      logger << LOG_INFO << "psi_M[" << abs(MC_x_dipole_mapping[i_a][i_m]) << "] = " << M[abs(MC_x_dipole_mapping[i_a][i_m])] << endl;
      logger << LOG_INFO << "psi_Gamma[" << abs(MC_x_dipole_mapping[i_a][i_m]) << "] = " << Gamma[abs(MC_x_dipole_mapping[i_a][i_m])] << endl;
      logger << LOG_INFO << "psi_map_Gamma[" << abs(MC_x_dipole_mapping[i_a][i_m]) << "] = " << map_Gamma[abs(MC_x_dipole_mapping[i_a][i_m])] << endl;
      if (map_Gamma[abs(MC_x_dipole_mapping[i_a][i_m])] == 0.){MC_x_dipole_mapping[i_a].erase(MC_x_dipole_mapping[i_a].begin() + i_m);}
      else if (2 * sqrt(tau_0) * E > M[abs(MC_x_dipole_mapping[i_a][i_m])] + 5 * map_Gamma[abs(MC_x_dipole_mapping[i_a][i_m])]){MC_x_dipole_mapping[i_a].erase(MC_x_dipole_mapping[i_a].begin() + i_m);}
    }
  }

  /*

  logger << LOG_INFO << "tau_MC_map.size() = " << tau_MC_map.size() << endl;

  n_tau_MC_channel = tau_MC_map.size();
  tau_MC_tau_gamma.resize(n_tau_MC_channel, vector<double> (n_tau_bins));
  if (switch_MC_tau == -1){tau_MC_map.resize(1);}

  // !!! input !!!
  int switch_minimum_weight = 1;
  double limit_minimum_weight = 0.1;
  double reserved_minimum_weight = 0.1;
  //  double limit_minimum_weight = 1.e-4;
  //  double reserved_minimum_weight = 1.e-3;

  logger << LOG_DEBUG << "tau_MC_map.size() = " << tau_MC_map.size() << endl;

  MC_tau = multichannel_set("MC_tau", tau_MC_map.size(), n_alpha_events, n_alpha_steps, switch_minimum_weight, limit_minimum_weight, reserved_minimum_weight, 0, 0);

  if (switch_MC_tau == 0 || switch_MC_tau == 2){MC_tau.active_optimization = 0;}
  else if (switch_MC_tau == 1 || switch_MC_tau == 3){MC_tau.active_optimization = 1;}
  logger << LOG_DEBUG << "MC_tau.active_optimization = " << MC_tau.active_optimization << endl;

  logger << LOG_DEBUG << "MC_tau.n_channel = " << MC_tau.n_channel << endl;
  for (int i_c = 0; i_c < MC_tau.n_channel; i_c++){
    logger << LOG_DEBUG << "tau_MC_map  [" << i_c << "] = " << tau_MC_map[i_c] << endl;
    logger << LOG_DEBUG << "MC_tau.alpha[" << i_c << "] = " << MC_tau.alpha[i_c] << endl;
    logger << LOG_DEBUG << "MC_tau.beta [" << i_c << "] = " << MC_tau.beta[i_c] << endl;
  }
  *//*

  logger << LOG_DEBUG << "finished" << endl;
}
*/




void phasespace_set::initialization_phasespace_MC_x_dipole_RA(){
  Logger logger("phasespace_set::initialization_phasespace_MC_x_dipole_RA");
  logger << LOG_DEBUG << "started" << endl;
  /*
  tau_IS_MC_alpha_phasespace.resize(n_dipoles);
  tau_IS_MC_beta_phasespace.resize(n_dipoles);
  tau_IS_MC_n_acc_channel.resize(n_dipoles);
  tau_IS_MC_n_rej_channel.resize(n_dipoles);
  */
  // determine tau_MC_map from MC_x_dipole_mapping (including 0!)
  for (int i_a = 0; i_a < n_dipoles; i_a++){

    for (int i_m = MC_x_dipole_mapping[i_a].size() - 1; i_m > 0; i_m--){
      logger << LOG_INFO << "MC_x_dipole_mapping[" << i_a << "][" << i_m << "] = " << MC_x_dipole_mapping[i_a][i_m] << endl;
      logger << LOG_INFO << "psi_M[" << abs(MC_x_dipole_mapping[i_a][i_m]) << "] = " << M[abs(MC_x_dipole_mapping[i_a][i_m])] << endl;
      logger << LOG_INFO << "psi_Gamma[" << abs(MC_x_dipole_mapping[i_a][i_m]) << "] = " << Gamma[abs(MC_x_dipole_mapping[i_a][i_m])] << endl;
      logger << LOG_INFO << "psi_map_Gamma[" << abs(MC_x_dipole_mapping[i_a][i_m]) << "] = " << map_Gamma[abs(MC_x_dipole_mapping[i_a][i_m])] << endl;
      if (map_Gamma[abs(MC_x_dipole_mapping[i_a][i_m])] == 0.){MC_x_dipole_mapping[i_a].erase(MC_x_dipole_mapping[i_a].begin() + i_m);}
      else if (2 * sqrt(tau_0) * E > M[abs(MC_x_dipole_mapping[i_a][i_m])]){MC_x_dipole_mapping[i_a].erase(MC_x_dipole_mapping[i_a].begin() + i_m);}
      // leads to problems if M_res < smin !!!
      //      else if (2 * sqrt(tau_0) * E > M[abs(MC_x_dipole_mapping[i_a][i_m])] + 5 * map_Gamma[abs(MC_x_dipole_mapping[i_a][i_m])]){MC_x_dipole_mapping[i_a].erase(MC_x_dipole_mapping[i_a].begin() + i_m);}
    }


    for (int i_m = 0; i_m < MC_x_dipole_mapping[i_a].size(); i_m++){
      int flag = tau_MC_map.size();
      for (int j_m = 0; j_m < tau_MC_map.size(); j_m++){
	logger << LOG_DEBUG_VERBOSE << "i_a = " << i_a << "   i_m = " << i_m << "   j_m = " << j_m << endl;
 	if (MC_x_dipole_mapping[i_a][i_m] == tau_MC_map[j_m]){flag = j_m; break;}
      }
      if (flag == tau_MC_map.size()){tau_MC_map.push_back(MC_x_dipole_mapping[i_a][i_m]);}
    }
  }

  //  MC_x_dipole_mapping[0] = tau_MC_map;

  // output of tau_MC_map and MC_x_dipole_mapping
  stringstream temp_ss;
  temp_ss << "tau_MC_map = ";
  for (int i_m = 0; i_m < tau_MC_map.size(); i_m++){temp_ss << setw(4) << tau_MC_map[i_m];}
  logger << LOG_DEBUG << temp_ss.str() << endl;
  for (int i_a = 0; i_a < n_dipoles; i_a++){
    stringstream temp_ss;
    temp_ss << "MC_x_dipole_mapping[" << setw(2) << i_a << "] = ";
    for (int i_m = 0; i_m < MC_x_dipole_mapping[i_a].size(); i_m++){temp_ss << setw(4) << MC_x_dipole_mapping[i_a][i_m];}
    logger << LOG_DEBUG << temp_ss.str() << endl;
  }

  int switch_minimum_weight = 1;
  double limit_minimum_weight = 0.01;
  double reserved_minimum_weight = 0.01;
  MC_x_dipole.resize(n_dipoles);
  for (int i_a = 1; i_a < n_dipoles; i_a++){

    if (switch_MC_x_dipole == -1){MC_x_dipole_mapping[i_a].resize(1);}

    stringstream temp_ss;
    temp_ss << "MC_x_dipole_" << i_a;
    //    MC_x_dipole_mapping[i_a].resize(1); // switch off extra mappings !!!
    MC_x_dipole[i_a] = multichannel_set(temp_ss.str(), MC_x_dipole_mapping[i_a].size(), n_alpha_events, n_alpha_steps, switch_minimum_weight, limit_minimum_weight, reserved_minimum_weight, 0, 0);
    MC_x_dipole[i_a].active_optimization = 0;
    //    MC_x_dipole[i_a].end_optimization = 1;

    /*
    tau_IS_MC_alpha_phasespace[i_a].resize(MC_x_dipole_mapping[i_a].size(), 1. / double (MC_x_dipole_mapping[i_a].size()));
    tau_IS_MC_beta_phasespace[i_a].resize(MC_x_dipole_mapping[i_a].size(), 0.);

    tau_IS_MC_beta_phasespace[i_a][0] = tau_IS_MC_alpha_phasespace[i_a][0];
    for (int i = 1; i < tau_IS_MC_beta_phasespace[i_a].size(); i++){tau_IS_MC_beta_phasespace[i_a][i] = tau_IS_MC_beta_phasespace[i_a][i - 1] + tau_IS_MC_alpha_phasespace[i_a][i];}
    tau_IS_MC_n_acc_channel_phasespace[i_a].resize(MC_x_dipole_mapping[i_a].size(), 0);
    tau_IS_MC_n_rej_channel_phasespace[i_a].resize(MC_x_dipole_mapping[i_a].size(), 0);
    
    tau_IS_MC_g_channel_phasespace.resize(MC_x_dipole_mapping[i_a].size(), 0.);
    tau_IS_MC_g_IS_channel_phasespace.resize(MC_x_dipole_mapping[i_a].size(), 0.);

    tau_IS_MC_temp_sum_w_channel_phasespace.resize(MC_x_dipole_mapping[i_a].size(), 0.);
    tau_IS_MC_sum_w_channel_phasespace.resize(MC_x_dipole_mapping[i_a].size(), 0.);
    tau_IS_MC_MC_sum_w_channel_phasespace.resize(MC_x_dipole_mapping[i_a].size(), 0.);
    // ???
    tau_IS_MC_w_channel_av_phasespace.resize(MC_x_dipole_mapping[i_a].size(), 0.);
    */
  }

  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_IS(){
  Logger logger("phasespace_set::initialization_phasespace_IS");
  logger << LOG_DEBUG << "started" << endl;

  g_z_coll.resize(3); // could be deleted later... !!!

  z1z2_opt_end = -1; // not needed here - only in CA (or qTsubtraction)

  // initialization of importance-samling (IS) related tau parameters
  logger << LOG_DEBUG << "n_tau_bins = " << n_tau_bins << endl;
  tau_channel = 0;
  tau_alpha.resize(n_tau_bins, 1. / double(n_tau_bins));
  tau_beta.resize(n_tau_bins);
  if (n_tau_bins > 0){
    tau_beta[0] = tau_alpha[0];
    for (int i = 1; i < tau_beta.size(); i++){tau_beta[i] = tau_beta[i - 1] + tau_alpha[i];}
  }
  tau_counts_channel.resize(n_tau_bins);
  tau_cuts_channel.resize(n_tau_bins);
  //vector<vector<double> > tau_channel_weight.resize(n_tau_bins);
  //vector<vector<double> > tau_channel_weight2.resize(n_tau_bins);
  sum_tau_channel_weight.resize(n_tau_bins);
  sum_tau_channel_weight2.resize(n_tau_bins);



  // initialization of initial-state multichannel (MC) related tau parameters
  // to be shifted elsewhere
  n_tau_MC_channel = tau_MC_map.size();
  logger << LOG_DEBUG << "n_tau_MC_channel = " << n_tau_MC_channel << endl;
  
  tau_MC_tau_alpha.resize(n_tau_MC_channel, vector<double> (n_tau_bins, 1. / double(n_tau_bins)));
  tau_MC_tau_beta.resize(n_tau_MC_channel, vector<double> (n_tau_bins));
  tau_MC_tau_gamma.resize(n_tau_MC_channel, vector<double> (n_tau_bins));
  
  logger << LOG_DEBUG << "tau_MC_tau_gamma.size() = " << tau_MC_tau_gamma.size() << endl;
  logger << LOG_DEBUG << "tau_MC_tau_gamma[0].size() = " << tau_MC_tau_gamma[0].size() << endl;
  for (int j = 0; j < tau_MC_tau_gamma[0].size(); j++){
    double random_tau = (double(j + 1)) / double(tau_MC_tau_beta[0].size());
    tau_MC_tau_gamma[0][j] = h_propto_pot(random_tau, tau_0, exp_pdf);
    //  cout << "tau_MC_tau_gamma[0][" << setw(3) << j << "] = " << tau_MC_tau_gamma[0][j] << endl;
  }

  // could be extended for IS on top of BW mappings
  
  // old version - can be erased later... (together with variables)
  for (int ib = 0; ib < tau_MC_tau_beta.size(); ib++){
    if (n_tau_bins > 0){
      tau_MC_tau_beta[ib][0] = tau_MC_tau_alpha[ib][0];
      for (int ic = 1; ic < tau_MC_tau_beta[ib].size(); ic++){
	tau_MC_tau_beta[ib][ic] = tau_MC_tau_beta[ib][ic - 1] + tau_MC_tau_alpha[ib][ic];
      }
    }
  }
  
  // to be shifted elsewhere - used so far somewhere...
  if (switch_MC_tau == -1){tau_MC_map.resize(1);}

  // should become input !!!
  int switch_minimum_weight = 1;
  double limit_minimum_weight = 0.1;
  double reserved_minimum_weight = 0.1;
  //  double limit_minimum_weight = 1.e-4;
  //  double reserved_minimum_weight = 1.e-3;

  MC_tau = multichannel_set("MC_tau", tau_MC_map.size(), n_alpha_events, n_alpha_steps, switch_minimum_weight, limit_minimum_weight, reserved_minimum_weight, 0, 0);

  if (switch_MC_tau == 0 || switch_MC_tau == 2){MC_tau.active_optimization = 0;}
  else if (switch_MC_tau == 1 || switch_MC_tau == 3){MC_tau.active_optimization = 1;}
  logger << LOG_DEBUG << "MC_tau.active_optimization = " << MC_tau.active_optimization << endl;
  



  x1x2_opt_end = 0;
  
  x1x2_channel = 0;
  //vector<double> temp_sum_x1x2_channel_weight(n_x1x2_bins);
  //vector<double> temp_sum_x1x2_channel_weight2(n_x1x2_bins);
  
  x1x2_alpha.resize(n_x1x2_bins, 1. / double(n_x1x2_bins));
  x1x2_beta.resize(n_x1x2_bins);
  x1x2_counts_channel.resize(n_x1x2_bins);
  x1x2_cuts_channel.resize(n_x1x2_bins);
  //vector<vector<double> > x1x2_channel_weight(n_x1x2_bins);
  //vector<vector<double> > x1x2_channel_weight2(n_x1x2_bins);
  sum_x1x2_channel_weight.resize(n_x1x2_bins);
  sum_x1x2_channel_weight2.resize(n_x1x2_bins);
  
  
  if (n_x1x2_bins > 0){
    x1x2_beta[0] = x1x2_alpha[0];
    for (int i = 1; i < x1x2_beta.size(); i++){x1x2_beta[i] = x1x2_beta[i - 1] + x1x2_alpha[i];}
  }
  
  logger << LOG_DEBUG << "finished" << endl;
}

// !!! could later be replaced by CX version (once collinear has been merged to multicollinear (ncollinear) !!!
void phasespace_set::initialization_phasespace_IS_CA(){
  Logger logger("phasespace_set::initialization_IS_CA");
  logger << LOG_DEBUG << "started" << endl;

  z1z2_opt_end = 0;

  z1z2_channel.resize(3, 0);

  if (switch_IS_z1z2 == 0 && n_z1z2_bins == 0) {
    cout << "z1z2 input incomplete, but optimization turned off anyway" << endl;
    n_z1z2_bins = 1;
  }

  z1z2_alpha.resize(3, vector<double> (n_z1z2_bins, 1. / double(n_z1z2_bins)));
  z1z2_beta.resize(3, vector<double> (n_z1z2_bins));
  for (int ic = 1; ic < 3; ic++){
    z1z2_beta[ic][0] = z1z2_alpha[ic][0];
    for (int i = 1; i < z1z2_beta[ic].size(); i++){z1z2_beta[ic][i] = z1z2_beta[ic][i - 1] + z1z2_alpha[ic][i];}
  }
  z1z2_counts_channel.resize(3, vector<int> (n_z1z2_bins));
  z1z2_cuts_channel.resize(3, vector<int> (n_z1z2_bins));
  sum_z1z2_channel_weight.resize(3, vector<double> (n_z1z2_bins));
  sum_z1z2_channel_weight2.resize(3, vector<double> (n_z1z2_bins));
  

  z_coll.resize(3);
  all_xz_coll_pdf.resize(3, vector<double> (3));
  g_z_coll.resize(3);

  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_IS_CX(){
  Logger logger("phasespace_set::initialization_phasespace_IS_CX");
  logger << LOG_DEBUG << "started" << endl;

  z1z2_opt_end = 0;

  z1z2_channel.resize(3, 0);

  // FIXME: not needed if randommanager takes care of the z1z2 optimization

  if (switch_IS_z1z2 == 0 && n_z1z2_bins == 0) {
    cout << "z1z2 input incomplete, but optimization turned off anyway" << endl;
    n_z1z2_bins = 1;
  }
  z1z2_alpha.resize(3, vector<double> (n_z1z2_bins, 1. / double(n_z1z2_bins)));
  z1z2_beta.resize(3, vector<double> (n_z1z2_bins));
  for (int ic = 1; ic < 3; ic++){
    z1z2_beta[ic][0] = z1z2_alpha[ic][0];
    for (int i = 1; i < z1z2_beta[ic].size(); i++){z1z2_beta[ic][i] = z1z2_beta[ic][i - 1] + z1z2_alpha[ic][i];}
  }
  z1z2_counts_channel.resize(3, vector<int> (n_z1z2_bins));
  z1z2_cuts_channel.resize(3, vector<int> (n_z1z2_bins));
  sum_z1z2_channel_weight.resize(3, vector<double> (n_z1z2_bins));
  sum_z1z2_channel_weight2.resize(3, vector<double> (n_z1z2_bins));
  
  QT_eps = 0;
  QT_random_IS = 0.;

  QT_random_z.resize(3);
  for (int i_z = 1; i_z < 3; i_z++){
    stringstream temp;
    temp << "z[" << i_z << "]";
    QT_random_z[i_z] = new randomvariable(n_z1z2_events, switch_IS_z1z2, n_z1z2_steps, n_z1z2_bins, temp.str());
    random_manager.register_variable(QT_random_z[i_z], true);
  }

  z_coll.resize(3);
  g_z_coll.resize(3);

  logger << LOG_DEBUG << "finished" << endl;
}

void phasespace_set::initialization_phasespace_IS_QT(){
  Logger logger("phasespace_set::initialization_phasespace_IS_QT");
  logger << LOG_DEBUG << "started" << endl;

  QT_eps = 0;
  QT_random_IS = 0.;

  QT_qt2 = 0.;
  QT_jacqt2 = 0.;
  QT_random_qt2 = 0.;

  QT_random_qt = new randomvariable(n_z1z2_events, switch_IS_z1z2, n_z1z2_steps, n_z1z2_bins, "qt2");
  random_manager.register_variable(QT_random_qt, true);

  logger << LOG_DEBUG << "finished" << endl;
}




//#include "OV.phasespace.initialization.cpp"
//#include "OV2.phasespace.initialization.cpp"



//void phasespace_set::initialization_MC(randommanager _random_manager){
void phasespace_set::initialization_MC(){
  Logger logger("phasespace_set::initialization_MC");
  logger << LOG_DEBUG << "started" << endl;

  //  random_manager = _random_manager;

  logger << LOG_DEBUG << "MC_n_channel = " << MC_n_channel << endl;

  g_tot = 0.;
  g_MC = 0.;
  if (coll_choice){
    g_pdf = 0.;
    g_tau = 0.;
    g_x1x2 = 0.;
  }
  else {
    g_pdf = 1.;
    g_tau = 1.;
    g_x1x2 = 1.;
  }
  //  g_global_NWA = 1.;

  MC_g_IS_global = 1.;
  
  temp_sum_w_channel.resize(MC_n_channel, 0.);
  sum_w_channel.resize(MC_n_channel, 0.);
  MC_sum_w_channel.resize(MC_n_channel, 0.);
  w_channel_av.resize(MC_n_channel, 0.);
  MC_alpha.resize(MC_n_channel, 1. / double(MC_n_channel));
  MC_beta.resize(MC_n_channel, 0.);
  MC_g_channel.resize(MC_n_channel, 0.);
  MC_g_IS_channel.resize(MC_n_channel, 0.);

  cuts_channel.resize(MC_n_channel, 0); // to be removed ???
  MC_n_rej_channel.resize(MC_n_channel, 0);
  
  counts_channel.resize(MC_n_channel, 0); // to be removed ???
  MC_n_acc_channel.resize(MC_n_channel, 0);







  logger << LOG_DEBUG << "weight_IS = " << weight_IS << endl;
  if (weight_IS == 1 || weight_IS == 2){
    // create random variables for phase space integration with grids for each variable in each channel (MC_n_channel * (3n - 4))
    phasespace_randoms.resize(no_random * MC_n_channel);
    string tmp_name;
    ostringstream convert;
    for (int i = 0; i < no_random * MC_n_channel; i++) {
      convert.str(string());
      convert << "r" << i;
      tmp_name = convert.str();
      logger << LOG_DEBUG << "initialize randomvariable " << i << endl; 
      phasespace_randoms[i] = new randomvariable(n_IS_events, switch_IS_MC, n_IS_steps, n_IS_gridsize, tmp_name);
      random_manager.register_variable(phasespace_randoms[i], true);
    }
    container_IS_switch.resize(container_IS_name.size(), 0);
    //    psi.phasespace_randoms=&phasespace_randoms;
  }
  else if (weight_IS == 3 || weight_IS == 4){
    // create random variables for phase space integration with one grid only for each mapping (propagator, t channel, etc.)
    phasespace_randoms.resize(container_IS_name.size());
    // later: only one file for all grids
    string tmp_name;
    ostringstream convert;
    logger << LOG_DEBUG_VERBOSE << "phasespace_randoms.size() = " << phasespace_randoms.size() << endl; 
    for (int i = 0; i < phasespace_randoms.size(); i++) {
      convert.str(string());
      convert << "yr" << i;
      //    tmp_name = convert.str();
      tmp_name = convert.str() + "_" + container_IS_name[i];
      logger << LOG_DEBUG_VERBOSE << "initialize randomvariable " << i << endl; 
      phasespace_randoms[i] = new randomvariable(n_IS_events, switch_IS_MC, n_IS_steps, n_IS_gridsize, tmp_name);

      //    phasespace_randoms[i] = new randomvariable(n_events_factor*n_z1z2_events,n_z1z2_steps,n_r_bins,tmp_name);
      logger << LOG_DEBUG_VERBOSE << container_IS_name[i] << "   n_IS_events = " << n_IS_events << "   n_IS_steps = " << n_IS_steps << "   n_IS_gridsize = " << n_IS_gridsize << endl;
      random_manager.register_variable(phasespace_randoms[i], true);
    }
    container_IS_switch.resize(container_IS_name.size(), 1);
    //    psi.phasespace_randoms=&phasespace_randoms;
  }
  else {
    container_IS_switch.resize(container_IS_name.size(), 0);
  }
  logger << LOG_DEBUG << "definitions of integration variables" << endl;



// switch_MC !!! check if completely realized !!!

// switch_MC
// switch_MC = 0: No optimization of MCweights.
// switch_MC = 1: Basic MCweights (alpha[i] = 1 / n_channel) are taken; optimization is done according to parameters ...
// switch_MC = 2: MCweights read in from 'filename_MCweight_in_contribution'; no further optimization
// switch_MC = 3: MCweights read in from 'filename_MCweight_in_contribution'; further optimization according to parameters ...
  logger << LOG_DEBUG << "switch_MC = " << switch_MC << endl;
  if (switch_MC == 2 || switch_MC == 3){
    /*
    ifstream in_MCweights(filename_MCweight_in_contribution.c_str());
    int MCweight_y = 0;
    double y;
    while (in_MCweights >> y){
      MC_alpha[MCweight_y] = y;
      MCweight_y++;
    }
    in_MCweights.close();
    */

    ifstream in_MCweights(filename_MCweight_in_contribution.c_str());
    //    int MCweight_y = 0;
    vector<string> readin;
    char LineBuffer[128];
    while (in_MCweights.getline(LineBuffer, 128)){readin.push_back(LineBuffer);}
    in_MCweights.close();
    for (int i = readin.size() - 1; i >=0; i--){
      if (readin[i][0] == '#'){
	cout << readin[i] << endl;
	readin.erase(readin.begin() + i);
      }
      else {logger << LOG_DEBUG << "readin[" << setw(4) << i << "] = " << readin[i] << endl;}
    }
    cout << "in_MCweights size: " << readin.size() << endl;
    
    int default_input_length = 0.;
    default_input_length += MC_alpha.size();
    //    if (MC_tau.end_optimization == 0){default_input_length += MC_tau.n_channel;}
    if (switch_MC_tau != -1){default_input_length += MC_tau.n_channel;}
    if ((switch_MC_x_dipole != -1) && (type_contribution == "RA" || 
				       type_contribution == "RRA")){
      //    if (type_contribution == "RA" || type_contribution == "RRA"){
      // MC_x_dipole[i_a] - multichannel for partonic CMS energy in dipole kinematics
      for (int i_a = 1; i_a < MC_x_dipole.size(); i_a++){
	//      for (int i_a = 1; i_a < n_dipoles; i_a++){
	default_input_length += MC_x_dipole[i_a].n_channel;
      //	if (MC_x_dipole[i_a].end_optimization == 0){default_input_length += MC_x_dipole[i_a].n_channel;}
      }
    }


    if (default_input_length < readin.size()){
       logger << LOG_FATAL << "MC input is too long: try to ignore the last entries: " << readin.size() << " > " << default_input_length << endl;
    }
    else if (default_input_length != readin.size()){
      logger << LOG_FATAL << "MC input length is not as expected: " << readin.size() << " != " << default_input_length << endl;
      logger << LOG_FATAL << "MC_alpha.size()           = " << MC_alpha.size() << endl;
      logger << LOG_FATAL << "MC_tau.n_channel          = " << MC_tau.n_channel << endl;
      for (int i_a = 1; i_a < n_dipoles; i_a++){
	logger << LOG_FATAL << "MC_x_dipole[" << setw(2) << i_a << "].n_channel = " << MC_x_dipole[i_a].n_channel << endl;
      }
      exit(1);
    }
  /*
  double y;
    while (in_MCweights >> y){
      MC_alpha[MCweight_y] = y;
      MCweight_y++;
    }
    in_MCweights.close();
  */
    int start = 0;
    for (int i = 0; i < MC_alpha.size(); i++){
      MC_alpha[i] = atof(readin[start + i].c_str());
      logger << LOG_DEBUG << "MC_alpha[" << setw(4) << i << "] = " << MC_alpha[i] << endl;
    }
    start += MC_alpha.size();

    //    if (MC_tau.end_optimization == 0){
    if (switch_MC_tau == 2 || switch_MC_tau == 3){
      for (int i = 0; i < MC_tau.n_channel; i++){
	MC_tau.alpha[i] = atof(readin[start + i].c_str());
	logger << LOG_DEBUG << "MC_tau.alpha[" << setw(4) << i << "] = " << MC_tau.alpha[i] << endl;
	// could be done later !!!
	/*
	if (i == 0){MC_tau.beta[i] = MC_tau.alpha[i];}
	else {MC_tau.beta[i] = MC_tau.beta[i - 1] + MC_tau.alpha[i];}
*/
      }
      start += MC_tau.n_channel;
    }

    if (switch_MC_x_dipole == 2 || switch_MC_x_dipole == 3){
      for (int i_a = 1; i_a < n_dipoles; i_a++){
	//      if (MC_x_dipole[i_a].end_optimization == 0){
	for (int i = 0; i < MC_x_dipole[i_a].n_channel; i++){
	  MC_x_dipole[i_a].alpha[i] = atof(readin[start + i].c_str());
	  logger << LOG_DEBUG << "MC_x_dipole[" << setw(2) << i_a << "].alpha[" << setw(4) << i << "] = " << MC_x_dipole[i_a].alpha[i] << endl;
	}
	start += MC_x_dipole[i_a].n_channel;
      }
    }

  //if (MCweight_y == 0){logger << LOG_FATAL <<"No MCweights to be read in are available in " << filename_MCweight_in_contribution << " !" << endl; exit(1);}
    for (int j = 0; j < MC_alpha.size(); j++){logger << LOG_DEBUG <<"read in: channel " << setw(2) << j + 1 << ": " << setprecision(15) << MC_alpha[j] << endl;}
    logger << LOG_INFO <<"MCweights (MC_alpha) have been be read in from " << filename_MCweight_in_contribution << " ." << endl;
    if (switch_MC == 2){
      /*
      // to avoid output of a-priori weights "alpha" if no further optimization is performed.
      ofstream out_MCweights(filename_MCweight.c_str());
      out_MCweights << "# " << "MC" << endl;
      for (int j = 0; j < MC_alpha.size(); j++){out_MCweights << setprecision(15) << MC_alpha[j] << endl;}
      out_MCweights.close();
      logger << LOG_INFO <<"MCweights (MC_alpha) have been written to " << filename_MCweight << " ." << endl;

      MC_tau.output_MCweight_optimization(filename_MCweight);
      logger << LOG_INFO <<"MCweights (MC_tau) have been written to " << filename_MCweight << " ." << endl;

      for (int i_a = 1; i_a < MC_x_dipole.size(); i_a++){
	//      for (int i_a = 1; i_a < n_dipoles; i_a++){
	MC_x_dipole[i_a].output_MCweight_optimization(filename_MCweight);
	logger << LOG_INFO <<"MCweights (MC_x_dipole[" << i_a << "]) have been written to " << filename_MCweight << " ." << endl;
      }
      */
    }
  }
  logger << LOG_DEBUG << "MC_alpha.size() = " << MC_alpha.size() << endl;
  logger << LOG_DEBUG << "MC_beta.size() = " << MC_beta.size() << endl;

  MC_beta[0] = MC_alpha[0];
  for (int i = 1; i < MC_beta.size(); i++){MC_beta[i] = MC_beta[i - 1] + MC_alpha[i];}

  if (switch_MC_tau){
    MC_tau.beta[0] = MC_tau.alpha[0];
    for (int i = 1; i < MC_tau.n_channel; i++){MC_tau.beta[i] = MC_tau.beta[i - 1] + MC_tau.alpha[i];}
  }

  if (switch_MC_x_dipole){
    //    for (int i_a = 1; i_a < n_dipoles; i_a++){
    for (int i_a = 1; i_a < MC_x_dipole.size(); i_a++){
      MC_x_dipole[i_a].beta[0] = MC_x_dipole[i_a].alpha[0];
      for (int i = 1; i < MC_x_dipole[i_a].n_channel; i++){MC_x_dipole[i_a].beta[i] = MC_x_dipole[i_a].beta[i - 1] + MC_x_dipole[i_a].alpha[i];}
    }
  }


  logger << LOG_DEBUG <<"MCweights (MC_alpha, MC_beta) have been determinded." << endl;
  logger << LOG_DEBUG <<"initialization of MCweight optimization finished" << endl;
  



  // switch_IS_tau
  // switch_IS_tau = 0: No IS optimization of partonic CMS energy.
  // switch_IS_tau = 1: Basic tauweights are taken; optimization is done according to parameters ...
  // switch_IS_tau = 2: tauweights read in from 'filename_tauweight_in_contribution'; no further optimization
  // switch_IS_tau = 3: tauweights read in from 'filename_tauweight_in_contribution'; further optimization according to parameters ...
  if (switch_IS_tau == 2 || switch_IS_tau == 3){
    ifstream in_tauweights(filename_tauweight_in_contribution.c_str());
    int tauweight_y = 0;
    double y;
    while (in_tauweights >> y){
      tau_alpha[tauweight_y] = y;
      tauweight_y++;
    }
    in_tauweights.close();
    for (int j = 0; j < tau_alpha.size(); j++){logger << LOG_DEBUG << "read in: tau_alpha[" << setw(3) << j << "] = " << setprecision(15) << tau_alpha[j] << endl;}
    if (tauweight_y == 0){logger << LOG_FATAL << "No tauweights to be read in are available in " << filename_tauweight_in_contribution << " !" << endl; exit(1);}
    if (switch_IS_tau == 2){
      /*
      // to avoid output of "tau" if no further optimization is performed.
      output_weight_vegas(filename_tauweight, tau_alpha);
      */
    }
  }
  else if (switch_IS_tau == 4){
    //    double optimize_sqrts_min = 2000.; // !!! osi_user_double_value[osi_user_double_map["optimize_sqrts_min"]];
    double optimize_sqrts_min = 20000.; // !!! osi_user_double_value[osi_user_double_map["optimize_sqrts_min"]];

    // only for exp_pdf == 1 at the moment !!!
    tau_beta[0] = tau_alpha[0];
    for (int i = 1; i < tau_beta.size(); i++){tau_beta[i] = tau_beta[i - 1] + tau_alpha[i];}
    for (int j = 0; j < tau_alpha.size(); j++){logger << LOG_DEBUG <<"read in: sqrt(S) = " << setprecision(8) << setw(15) << sqrt(h_propto_pot(tau_beta[j], tau_0, exp_pdf)) * 2 * E << "   tau_alpha[" << setw(3) << j << "] = " << setprecision(15) << tau_alpha[j] << endl;}
    
    int min_tau_alpha = 0;
    for (int j = 0; j < tau_alpha.size(); j++){
      cout << "j = " << setw(3) << j << "   " << setprecision(8) << setw(15) << sqrt(h_propto_pot(double(j) / tau_beta.size(), tau_0, exp_pdf)) * 2 * E << "   " << setprecision(8) << setw(15) << optimize_sqrts_min << endl;
      if (sqrt(h_propto_pot(double(j) / tau_beta.size(), tau_0, exp_pdf)) * 2 * E < optimize_sqrts_min){tau_alpha[j] = 0.; min_tau_alpha = j;}
      //    else {tau_alpha[j] = 1. / (log10(sqrt(h_propto_pot(double(j) / tau_beta.size(), tau_0, exp_pdf))) - log10(sqrt(h_propto_pot(double(j - 1) / tau_beta.size(), tau_0, exp_pdf))));}
      else {tau_alpha[j] = 1. * ((sqrt(h_propto_pot(double(j) / tau_beta.size(), tau_0, exp_pdf))) - (sqrt(h_propto_pot(double(j - 1) / tau_beta.size(), tau_0, exp_pdf))));}
    }
    double normalization = 1. - (min_tau_alpha + 1) * 5.e-6;
    double collect_alpha = 0.;
    for (int j = 0; j < tau_alpha.size(); j++){
      if (j <= min_tau_alpha){}
      else {collect_alpha += tau_alpha[j];}
    }
    normalization = collect_alpha / normalization;
    
    for (int j = 0; j < tau_alpha.size(); j++){
      if (j <= min_tau_alpha){tau_alpha[j] = 5.e-6;}
      else {tau_alpha[j] = tau_alpha[j] / normalization;}
    }
    tau_beta[0] = tau_alpha[0];
    for (int i = 1; i < tau_beta.size(); i++){tau_beta[i] = tau_beta[i - 1] + tau_alpha[i];}
    
  }
  
  
  
  logger << LOG_DEBUG << "tau_alpha.size() = " << tau_alpha.size() << endl;
  logger << LOG_DEBUG << "tau_beta.size() = " << tau_beta.size() << endl;
  if (tau_alpha.size() > 0){
    tau_beta[0] = tau_alpha[0];
    for (int i = 1; i < tau_beta.size(); i++){tau_beta[i] = tau_beta[i - 1] + tau_alpha[i];}
    logger << LOG_DEBUG <<"tauweights (tau_alpha, tau_beta) have been determined." << endl;
  }
  
  for (int j = 0; j < tau_alpha.size(); j++){logger << LOG_DEBUG <<"read in: sqrt(S) = " << setprecision(8) << setw(15) << sqrt(h_propto_pot(double(j) / tau_beta.size(), tau_0, exp_pdf)) * 2 * E << "   tau_alpha[" << setw(3) << j << "] = " << setprecision(15) << tau_alpha[j] << "   tau_beta[" << setw(3) << j << "] = " << setprecision(15) << tau_beta[j] << endl;}
  
  for (int j = 0; j < tau_alpha.size(); j++){logger << LOG_DEBUG <<"read in: sqrt(S) = " << setprecision(8) << setw(15) << sqrt(h_propto_pot(double(j) / tau_beta.size(), tau_0, exp_pdf)) * 2 * E << "   tau_alpha[" << setw(3) << j << "] = " << setprecision(15) << tau_alpha[j] << "   log: " << setprecision(8) << setw(15) << log10((sqrt(h_propto_pot(double(j) / tau_beta.size(), tau_0, exp_pdf)) - sqrt(h_propto_pot(double(j - 1) / tau_beta.size(), tau_0, exp_pdf))) * 2 * E) << "   alpha * log: " << setprecision(8) << setw(15) << log10((sqrt(h_propto_pot(double(j) / tau_beta.size(), tau_0, exp_pdf)) - sqrt(h_propto_pot(double(j - 1) / tau_beta.size(), tau_0, exp_pdf))) * 2 * E) * tau_alpha[j] << endl;}
  logger << LOG_DEBUG << "initialization of tauweight optimization finished" << endl;
  


  // switch_IS_x1x2
  // switch_IS_x1x2 = 0: No IS optimization of x1x2 mappings.
  // switch_IS_x1x2 = 1: Basic x1x2weights are taken; optimization is done according to parameters ...
  // switch_IS_x1x2 = 2: x1x2weights read in from 'filename_x1x2weight_in_contribution'; no further optimization
  // switch_IS_x1x2 = 3: x1x2weights read in from 'filename_x1x2weight_in_contribution'; further optimization according to parameters ...
  if (switch_IS_x1x2 == 2 || switch_IS_x1x2 == 3){
    ifstream in_x1x2weights(filename_x1x2weight_in_contribution.c_str());
    int x1x2weight_y = 0;
    double y;
    while (in_x1x2weights >> y){
      x1x2_alpha[x1x2weight_y] = y;
      x1x2weight_y++;
    }
    in_x1x2weights.close();
    for (int j = 0; j < x1x2_alpha.size(); j++){logger << LOG_DEBUG << "read in: x1x2_alpha[" << setw(3) << j << "] = " << setprecision(15) << x1x2_alpha[j] << endl;}
    if (x1x2weight_y == 0){logger << LOG_FATAL << "No x1x2weights to be read in are available!" << endl; exit(1);}
    if (switch_IS_x1x2 == 2){
      /*
      // to avoid output of "x1x2" if no further optimization is performed.
      output_weight_vegas(filename_x1x2weight, x1x2_alpha);
      */
    }
  }
  logger << LOG_DEBUG << "x1x2_alpha.size() = " << x1x2_alpha.size() << endl;
  logger << LOG_DEBUG << "x1x2_beta.size() = " << x1x2_beta.size() << endl;
  if (x1x2_alpha.size() > 0){
    x1x2_beta[0] = x1x2_alpha[0];
    for (int i = 1; i < x1x2_beta.size(); i++){x1x2_beta[i] = x1x2_beta[i - 1] + x1x2_alpha[i];}
    logger << LOG_DEBUG <<"x1x2weights (x1x2_alpha, x1x2_beta) have been determinded." << endl;
  }
  logger << LOG_DEBUG << "initialization of x1x2weight optimization finished" << endl;
  
  
  

  if ((switch_MC == 2 || switch_MC == 3) && (switch_IS_MC == 2 || switch_IS_MC == 3)){
    //if (switch_MC == 2 || switch_MC == 3){
    logger << LOG_DEBUG << "randommanager is called with the following input:" << endl;
    logger << LOG_DEBUG << "weight_in_contribution = " << weight_in_contribution << endl;
    logger << LOG_DEBUG << "weight_in_directory = " << weight_in_directory << endl;
    
    // Weights are read in elsewhere !!!
    //    random_manager.readin_weights(weight_in_contribution, weight_in_directory);
    
    if (switch_IS_MC == 2){
      /*
      // to avoid output of IS grids if no further optimization is performed.
      random_manager.writeout_weights();
      */
    }

    logger << LOG_DEBUG << "randommanager-call has been finished." << endl;
  }
  
  if (switch_MC == 0 || switch_MC == 2){MC_opt_end = 2;}
  else {MC_opt_end = 0;}
  if (switch_IS_tau == 0 || switch_IS_tau == 2){tau_opt_end = 2;}
  else {tau_opt_end = 0;}
  if (switch_IS_x1x2 == 0 || switch_IS_x1x2 == 2){x1x2_opt_end = 2;}
  else {x1x2_opt_end = 0;}
  if (switch_IS_MC == 0 || switch_IS_MC == 2){IS_opt_end = 2;}
  else {IS_opt_end = 0;}
  
  if (switch_IS_tau == 4){tau_opt_end = 2;}
  
  logger << LOG_DEBUG << "../include/initialization.MCweight.optimization.cxx   ended" << endl;

 
  logger << LOG_DEBUG << "finished" << endl;
}
