#include "../include/classes.cxx"
/*
#include "header/randommanager.h"

#include <cstdlib>
#include <iomanip>
#include <iostream>
#include <math.h>
#include <numeric>
#include <sstream>

#include <assert.h>

using namespace std;
*/
// **************************************************************************
void vegasgrid_average_temp(vector<double> & alpha, double averaging=1.0){
  double tmp=alpha[0],tmp2;
//  alpha[0] = 0.5*(averaging+2)/(1+averaging) * alpha[0] + 0.5/(1+averaging) * alpha[1];
//  for (int j = 1; j < alpha.size() - 1; j++){
////    alpha_new[j] = .5 * alpha[j] + .25 * alpha[j - 1] + .25 * alpha[j + 1];
//      tmp2=alpha[j];
//      alpha[j] = 1.0/(1+averaging) * alpha[j] + 0.5/(1+averaging) * tmp + 0.5/(1+averaging) * alpha[j + 1];
//      tmp=tmp2;
//  }
//  alpha[alpha.size() - 1] = 0.5*(averaging+2)/(1+averaging) * alpha[alpha.size() - 1] + 0.5/(1+averaging) * tmp;

  alpha[0] = .75 * alpha[0] + .25 * alpha[1];
  for (int j = 1; j < alpha.size() - 1; j++){
//    alpha_new[j] = .5 * alpha[j] + .25 * alpha[j - 1] + .25 * alpha[j + 1];
      tmp2=alpha[j];
      alpha[j] = .5 * alpha[j] + .25 * tmp + .25 * alpha[j + 1];
      tmp=tmp2;
  }
  alpha[alpha.size() - 1] = .75 * alpha[alpha.size() - 1] + .25 * tmp;
}
void vegasgrid_calculation_temp(vector<double> & alpha, vector<double> & beta, vector<int> & cuts_channel, vector<int> & count_channel, vector<double> & sum_channel_weight){
  static Logger logger("vegasgrid_calculation_temp");
  logger << LOG_DEBUG_VERBOSE << "started" << endl;

  for (int j = 0; j < alpha.size(); j++){
    if (count_channel[j] + cuts_channel[j] != 0){
      alpha[j] = sum_channel_weight[j] / (count_channel[j] + cuts_channel[j]);
    }
    else {
      alpha[j] = 0.;
    }
  }

  double sum_value = std::accumulate(alpha.begin(), alpha.end(), 0.);

  if (sum_value == 0.){logger << LOG_DEBUG << "1st: sum_value = 0." << endl;}
  if (sum_value == 0.){
    for (int j = 0; j < alpha.size(); j++){
      alpha[j] = 1. / alpha.size();
      sum_value = 1.;
    }
  }

  for (int j = 0; j < alpha.size(); j++){alpha[j] = alpha[j] / sum_value;}

  int MCweight_lc_min = 0;
  vector<int> MCweights_set_to_min(alpha.size());

  double MCweight_limit_min = 1.e-2 / alpha.size();
  sum_value=0.0;
  for (int j = 0; j < alpha.size(); j++){
    if (alpha[j] < MCweight_limit_min){
      MCweight_lc_min++;
      MCweights_set_to_min[j] = 1;
    }
    else {
      sum_value+=alpha[j];
    }
  }
  if (sum_value == 0.){logger << LOG_DEBUG << "2nd: sum_value = 0." << endl;}

  double normalization = (1. - MCweight_lc_min * MCweight_limit_min) / sum_value;
  if (normalization != normalization){logger << LOG_WARN << "normalization != normalization" << endl;}
  if (normalization > 1.e200){logger << LOG_WARN << "normalization = +-inf" << endl;}

  for (int j = 0; j < alpha.size(); j++){
    if (MCweights_set_to_min[j] == 1){alpha[j] = MCweight_limit_min;}
    else {alpha[j] = alpha[j] * normalization;}
  }

  vegasgrid_average_temp(alpha);

  beta[0] = alpha[0];
  for (int i = 1; i < beta.size(); i++){beta[i] = beta[i - 1] + alpha[i];}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

double ran_temp(vector<double> & s){
  // TODO: maybe do something more clever here.. e.g. make s static and don't bother with the random seed anywhere else
  // problem: how to seed initially? simply incrementing zwahl times will lead to a periodicity if there are too many parallel computations

  assert(s[0]+s[1]+s[2]>0);
  assert(s[0]>=0);
  assert(s[0]<=1);
  assert(s[1]>=0);
  assert(s[1]<=1);
  assert(s[2]>=0);
  assert(s[2]<=1);

  s[0] = fmod(s[0] + s[1] + s[2], 1.);
  s[1] = fmod(s[0] + s[1] + s[2], 1.);
  s[2] = fmod(s[0] + s[1] + s[2], 1.);

//  return rand()/double(RAND_MAX);
  return s[0];
}

randomvariable::randomvariable(int _n_events, int _switch_IS_MC, int _n_steps, int _n_bins, const string &_name) {
  static Logger logger("randomvariable::randomvariable(int, int, int , int , const string");
  logger << LOG_DEBUG_VERBOSE << "started" << endl;

  logger << LOG_DEBUG << "initialize " << _name << "(" << _n_events << ", " << _switch_IS_MC << ", " << _n_steps << ", " << _n_bins << ")" << endl;
  //  cout << "init " << "/weights_" << _name << ".dat" << endl;
  init(_n_events,_switch_IS_MC,_n_steps,_n_bins,_name);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void randomvariable::init(int _n_events, int _switch_IS_MC, int _n_steps, int _n_bins, const string & _name) {
  n_events=_n_events;
  switch_IS_MC = _switch_IS_MC;
  n_steps=_n_steps;
  n_bins=_n_bins;
  name=_name;

  if (switch_IS_MC == 0 && n_bins == 0) {
    cout << "z1z2 input incomplete, but optimization turned off anyway" << endl;
    n_bins = 1;
  }

  assert(n_bins>0);

  alpha.resize(n_bins, 1. / double(n_bins));
  beta.resize(n_bins);

  if (switch_IS_MC == 0 || switch_IS_MC == 2){opt_end = 1;}
  else if (switch_IS_MC == 1 || switch_IS_MC == 3){opt_end = 0;}

  channel=0;

  imp_sampling=true;

  used=false;

  beta[0] = alpha[0];
  for (int i = 1; i < beta.size(); i++){beta[i] = beta[i - 1] + alpha[i];}

  counts_channel.resize(n_bins,0);
  cuts_channel.resize(n_bins,0);
  sum_channel_weight.resize(n_bins,0.0);
  sum_channel_weight2.resize(n_bins,0.0);

  s.resize(3);
  s[0]=0;
  s[1]=0;
  s[2]=0;

  manager=NULL;

  proceeding_save();
}

void randomvariable::optimize(const double psp_weight) {
  if (!imp_sampling || !used)
    return;

  // TODO: stop recording if opt_end==1?

  counts_channel[channel]++;
  sum_channel_weight[channel] += fabs(psp_weight);
  //sum_channel_weight2[channel] += psp_weight*psp_weight;
  //cout << "RV: channel = " << channel << endl;
  // cout << "RV: counts_channel[" << setw(3) << channel << "] = " << counts_channel[channel] << endl;

  used=false;
}

int randomvariable::do_optimization_step(int events) {
  static Logger logger("do_optimization_step");
  logger << LOG_DEBUG_VERBOSE << "started" << endl;

  if (!imp_sampling)
    return 2;

  if (opt_end == 0){
    if (events % n_events == 0 && events != 0){
      //logger << LOG_DEBUG << name << " vegasgrid_calculation @ " << events << " events" << "(" << accumulate(counts_channel.begin(),counts_channel.end(),0)+accumulate(cuts_channel.begin(),cuts_channel.end(),0) << " events used)" << endl;
      vegasgrid_calculation_temp(alpha, beta, cuts_channel, counts_channel, sum_channel_weight);
      logger << LOG_DEBUG << left << setw(50) << name << ": vegasgrid_calculation @ " << events << " events" << "(" << accumulate(counts_channel.begin(),counts_channel.end(),0)+accumulate(cuts_channel.begin(),cuts_channel.end(),0) << " events used)" << "; variation is " << calc_variation() << endl;
      /*
      for (int is = 0; is < alpha.size(); is++){
	logger << LOG_DEBUG << "alpha[" << right << setw(4) << is << "] = " << left << setw(15) << setprecision(8) << alpha[is] << "   beta[" << right << setw(4) << is << "] = " << left << setw(15) << setprecision(8) << beta[is] << endl;
      }
      */

      if (events == n_events * n_steps){
        logger << LOG_DEBUG << "sampled random variable " << setw(50) << left << name << ":" << endl;
        for (int is = 0; is < alpha.size(); is++){
	  logger << LOG_DEBUG << "alpha[" << right << setw(4) << is << "] = " << left << setw(15) << setprecision(8) << alpha[is] << "   beta[" << right << setw(4) << is << "] = " << left << setw(15) << setprecision(8) << beta[is] << endl;
        }
        opt_end = 1;

        logger << LOG_DEBUG << setw(50) << left << name << ": variation is " << calc_variation() << endl;
        return 1;
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
  return 0;
}

void randomvariable::get_random(double &x, double &g_IS, vector<double> &s) {
  if (used && !opt_end) {
    cout << "randomvariable::get_random  (" << name << " used && !opt_end)!" << endl;
//    assert(false);
  }

//  assert(!used || opt_end);

//
// TODO: make sure that the quality of random numbers is sufficient
  //double random=rand()/double(RAND_MAX);
  double random=ran_temp(s);

  if (!imp_sampling) {
    x=random;
    g_IS=1.0;
    return;
  }

  used=true;

  //double random_channel=rand()/double(RAND_MAX);
  double random_channel=ran_temp(s);

  // TODO: Intervallschachtelung?
  int j;
  for (j = 0; j < beta.size(); j++){if (random_channel <= beta[j]){
    channel = j;
     break;}}

//  int left=0,middle;
//  channel=beta.size()-1;
//  do {
//  // cout << left << ", " << channel << ", " << right << endl;
//    middle=(left+channel)/2;
//   if (random_channel<=beta[middle]) {
//      if (channel==middle)
//        break;
//      channel=middle; }
//    else {
//     if (left==middle)
//       break;
//     left=middle;
//    }
//
//  } while(1);
//  assert(j==channel);

  x = (double(channel) + random) / double(beta.size());
  g_IS=alpha[channel] * alpha.size();

//  cout << name << ": " << channel << ", " << beta.size() << endl;

  //  logger << LOG_DEBUG_VERBOSE << setw(40) << name << " rch = " << setw(15) << setprecision(8) << random_channel << " r = " << setw(15) << setprecision(8) << random << " ch = " << setw(2) << channel << " alpha.size() = " << setw(2) << alpha.size() << "   a[ch] = " << setw(15) << setprecision(8) << alpha[channel] << "   g_IS = " << setw(15) << setprecision(8) << g_IS << endl;
//  cout << random_channel << ", " << random << ", " << channel << endl;
}

void randomvariable::get_random(double &x, double &g_IS) {
  static Logger logger("randomvariable::get_random(x, g_IS)");
  logger << LOG_DEBUG_VERBOSE << "started" << endl;

  /*
  logger << LOG_DEBUG_VERBOSE << name << endl;
  for (int i = 0; i < s.size(); i++){
    logger << LOG_DEBUG_VERBOSE << "before: s[" << i << "] = " << s[i] << endl;
  }
  logger << LOG_DEBUG_VERBOSE << "before: x = " << x << endl;
  */
  //  logger << LOG_DEBUG_VERBOSE << setw(40) << name << " get_random ";
  get_random(x,g_IS,s);

  /*
  for (int i = 0; i < s.size(); i++){
    logger << LOG_DEBUG_VERBOSE << "after:  s[" << i << "] = " << s[i] << endl;
  }
  logger << LOG_DEBUG_VERBOSE << "after:  x = " << x << endl;
  */
  if (!opt_end) {
    // tell manager that this variable has been used
    if (manager!=NULL){
      manager->add_var_to_queue(this);
      //      logger << LOG_DEBUG_VERBOSE << "has been used.";
    }
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void randomvariable::get_g_IS(double r, double &g_IS) {
  /*
  if (r < 0.0 || r > 1.0 || r != r){
    logger << LOG_DEBUG << setw(40) << name << " r = " << setw(15) << setprecision(8) << r << " ch = " << setw(2) << channel << " alpha.size() = " << setw(2) << alpha.size() << "   a[ch] = " << setw(15) << setprecision(8) << alpha[channel] << "   g_IS = " << setw(15) << setprecision(8) << g_IS << endl;
  }
  */
  /*
  assert(r>=0.0);
  assert(r<=1.0);
  */
  //  double temp_channel = (int)(r*(double)beta.size());
  int temp_channel = (int)(r*(double)beta.size());
  if (r < 0.0 || r > 1.0 || r != r){temp_channel = 0;}

  g_IS = alpha[temp_channel] * alpha.size();
  if (r < 0.0 || r > 1.0 || r != r){g_IS = sqrt(-1.);}
  //  logger << LOG_DEBUG_VERBOSE << setw(40) << name << " tch = " << setw(2) << temp_channel << " r = " << setw(15) << setprecision(8) << r << " ch = " << setw(2) << channel << " alpha.size() = " << setw(2) << alpha.size() << "   a[ch] = " << setw(15) << setprecision(8) << alpha[channel] << "   g_IS = " << setw(15) << setprecision(8) << g_IS << endl;
}

void randomvariable::multiply_g_IS(double r, double & g_IS) {
  if (r < 0.0 || r > 1.0 || r != r){
    cout << left << setw(40) << name << "r = " << setw(15) << setprecision(8) << r << " alpha.size() = " << setw(2) << alpha.size() << "   a[" << setw(2) << channel << "] = " << setw(15) << setprecision(8) << alpha[channel] << "   g_IS = " << setw(15) << setprecision(8) << g_IS << endl;
  }
  /*
  assert(r >= 0.);
  assert(r <= 1.);
  */
  int temp_channel = (int)(r * (double)beta.size());
  if (r < 0.0 || r > 1.0 || r != r){temp_channel = 0;}

  g_IS *= alpha[temp_channel] * alpha.size();
  if (r < 0.0 || r > 1.0 || r != r){g_IS = sqrt(-1.);}
}

double randomvariable::calc_variation() {
  double average=0;
  average=accumulate(alpha.begin(),alpha.end(),0.0);
  average/=alpha.size();

  double variation=0.0;
  for (int i=0; i<alpha.size(); i++) {
    variation+=pow(alpha[i]-average,2);
  }

  if (variation == 0.){variation = 1.;} // in this case, this channel has not been called at all! 0 might be problematic...

  // variation should be invariant under rescaling
  variation*=alpha.size();

  if (sqrt(variation) != sqrt(variation)){
    cout << "alpha.size() = " << alpha.size() << endl;
    for (int i_a = 0; i_a < alpha.size(); i_a++){
      cout << "alpha[" << i_a << "] = " << alpha[i_a] << endl;
    }
    cout << "variation = " << variation << endl;
    cout << "average 1st = " << accumulate(alpha.begin(),alpha.end(),0.0) << endl;
    cout << "average 2nd = " << accumulate(alpha.begin(),alpha.end(),0.0) / alpha.size() << endl;
  }


  return sqrt(variation);
}

void randomvariable::proceeding_out(ofstream &out_proceeding) {
  // TODO: handle imp_sampling!
//  out_proceeding << "random variable " << name << endl;
  out_proceeding << save_opt_end << endl;
  if (opt_end != -1){
    
    // save random seed
    //    out_proceeding << setprecision(16) << save_s[0] << endl;
    //    out_proceeding << setprecision(16) << save_s[1] << endl;
    //    out_proceeding << setprecision(16) << save_s[2] << endl;
    out_proceeding << "# " << name << endl;
    for (int i = 0; i < 3; i++){out_proceeding << double2hexastr(save_s[i]) << endl;}
    // SK: better only once for randommanager ???
    out_proceeding << "# " << name << " alpha(" << alpha.size() << " - " << n_bins << ")" << endl;

    for (int j = 0; j < n_bins; j++){
      //    for (int j = 0; j < alpha.size(); j++){
      out_proceeding << double2hexastr(save_alpha[j]) << endl;
      //      out_proceeding << setprecision(16) << save_alpha[j] << endl;
//      out_proceeding << setprecision(16) << save_beta[j] << endl;
//      cout << "alpha[" << setw(4) << j << "] = " << alpha[j] << "   beta[" << setw(4) << j << "] = " << beta[j] << endl;
    }
  }
  if (opt_end == 0){
    for (int j = 0; j < alpha.size(); j++){
      out_proceeding << save_counts_channel[j] << endl;
      out_proceeding << save_cuts_channel[j] << endl;
      //setprecision(16) << 
      out_proceeding << setprecision(16) << save_sum_channel_weight[j] << endl;
//      out_proceeding << setprecision(16) << save_sum_channel_weight2[j] << endl;
    }
  }
}

void randomvariable::proceeding_size(int & proc) {
  proc += 1;
  if (opt_end != -1){
    proc += 3;
    proc += n_bins;
  }
  if (opt_end == 0){
    proc += 3 * n_bins;
  }
}

void randomvariable::proceeding_size(vector<int> & size_proceeding) {
  size_proceeding[0] += 1;
  if (opt_end != -1){
    size_proceeding[0] += 3;
    size_proceeding[0] += n_bins;
  }
  if (opt_end == 0){
    size_proceeding[5] += 3 * n_bins;
  }
}

void randomvariable::proceeding_in(int &proc, vector<string> &readin) {
  static Logger logger("randommanager::proceeding_in");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  opt_end = atoi(readin[proc].c_str());
  proc += 1;
  if (opt_end != -1){
    //    s[0] = atof(readin[proc].c_str());
    //    s[1] = atof(readin[proc+1].c_str());
    //    s[2] = atof(readin[proc+2].c_str());
    for (int i = 0; i < 3; i++){s[i] = hexastr2double(readin[proc + i]);}
    proc += 3;
    for (int i = 0; i < 3; i++){logger << LOG_DEBUG << "s[" << i << "] = " << s[i] << endl;}

    for (int i = 0; i < n_bins; i++){
      alpha[i] = hexastr2double(readin[proc + 1 * i]);
      //      alpha[i] = atof(readin[proc + 1 * i].c_str());
//      beta[i] = atof(readin[proc + 2 * i + 1].c_str());
//      logger << LOG_DEBUG << "alpha[" << setw(4) << i << "] = " << alpha[i] << "   beta[" << setw(4) << i << "] = " << beta[i] << endl;
    }
    logger << LOG_DEBUG << name << endl;
    beta[0] = alpha[0];
    for (int i = 0; i < n_bins; i++){
      if (i > 0){beta[i] = beta[i-1] + alpha[i];}
      logger << LOG_DEBUG << "alpha[" << setw(4) << i << "] = " << setprecision(15) << setw(23) << alpha[i] << "   beta[" << setw(4) << i << "] = " << setprecision(15) << setw(23) << beta[i] << endl;
    }
    proc += n_bins;
  }
  if (opt_end == 0){
    for (int i = 0; i < n_bins; i++){
      counts_channel[i] = atoi(readin[proc + 3 * i].c_str());
      cuts_channel[i] = atoi(readin[proc + 3 * i + 1].c_str());
      //      counts_channel[i] = atof(readin[proc + 3 * i].c_str());
      //      cuts_channel[i] = atof(readin[proc + 3 * i + 1].c_str());
      sum_channel_weight[i] = atof(readin[proc + 3 * i + 2].c_str());
//      sum_channel_weight2[i] = atof(readin[proc + 4 * i + 3].c_str());
    }
    proc += 3 * n_bins;
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void randomvariable::check_proceeding_in(int &int_end, int &temp_check_size, vector<string> &readin) {
  static Logger logger("randommanager::proceeding_in");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  opt_end = atoi(readin[temp_check_size].c_str());
  logger << LOG_DEBUG << "opt_end = " << opt_end << endl;
  temp_check_size += 1;
      if (temp_check_size > readin.size()){int_end = 2; logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endl; return;}
      else{logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  if (opt_end != -1){
    //    for (int i = 0; i < 3; i++){s[i] = hexastr2double(readin[temp_check_size + i]);}

    temp_check_size += 3;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endl; return;}
    else{logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
    //    for (int i = 0; i < 3; i++){logger << LOG_DEBUG << "s[" << i << "] = " << s[i] << endl;}
    /*
    for (int i = 0; i < n_bins; i++){
      alpha[i] = hexastr2double(readin[temp_check_size + 1 * i]);
      //      alpha[i] = atof(readin[temp_check_size + 1 * i].c_str());
//      beta[i] = atof(readin[temp_check_size + 2 * i + 1].c_str());
//      logger << LOG_DEBUG << "alpha[" << setw(4) << i << "] = " << alpha[i] << "   beta[" << setw(4) << i << "] = " << beta[i] << endl;
    }
    logger << LOG_DEBUG << name << endl;
    beta[0] = alpha[0];
    for (int i = 0; i < n_bins; i++){
      if (i > 0){beta[i] = beta[i-1] + alpha[i];}
      logger << LOG_DEBUG << "alpha[" << setw(4) << i << "] = " << setprecision(15) << setw(23) << alpha[i] << "   beta[" << setw(4) << i << "] = " << setprecision(15) << setw(23) << beta[i] << endl;
    }
    */
    temp_check_size += n_bins;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endl; return;}
    else{logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  }
  if (opt_end == 0){
    /*
    for (int i = 0; i < n_bins; i++){
      counts_channel[i] = atoi(readin[temp_check_size + 3 * i].c_str());
      cuts_channel[i] = atoi(readin[temp_check_size + 3 * i + 1].c_str());
      //      counts_channel[i] = atof(readin[temp_check_size + 3 * i].c_str());
      //      cuts_channel[i] = atof(readin[temp_check_size + 3 * i + 1].c_str());
      sum_channel_weight[i] = atof(readin[temp_check_size + 3 * i + 2].c_str());
//      sum_channel_weight2[i] = atof(readin[temp_check_size + 4 * i + 3].c_str());
    }
    */
    temp_check_size += 3 * n_bins;
    if (temp_check_size > readin.size()){int_end = 2; logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endl; return;}
    else{logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void randomvariable::proceeding_save() {
  save_opt_end = opt_end;
  save_alpha = alpha;
  save_beta = beta;
  save_counts_channel = counts_channel;
  save_cuts_channel = cuts_channel;
  save_sum_channel_weight = sum_channel_weight;
//  save_sum_channel_weight2 = sum_channel_weight2;
  save_s = s;
}

void randomvariable::save_weights(ofstream &out_weights) {
  out_weights << "variable " << setw(50) << name << endl;

  for (int j = 0; j < alpha.size(); j++){
    out_weights << setprecision(8) << alpha[j] << endl;
  }
}

int randomvariable::readin_weights(vector<string> &readin) {
  static Logger logger("randommanager::readin_weights");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (switch_IS_MC != 2 && switch_IS_MC != 3) {
    // nothing to be read in
    return 0;
  }

  // find the correct section in the weights file
  int proc;
  for (proc=0; proc<readin.size(); proc++) {
    size_t pos=readin[proc].find("variable ");
    if (pos != string::npos) {
      pos += 9;
      string var_name=readin[proc].substr(pos,string::npos);
      int start_index = 0;
      for (int i = 0; i < var_name.size(); i++){
        if (var_name[i] != ' '){start_index = i; break;}
      }
      var_name=var_name.substr(start_index, var_name.size() - start_index);
      if (var_name == name) {
        logger << LOG_DEBUG << "weights found for " << var_name << endl;
        break;
      }
    }
  }

  if (proc == readin.size()) {
    logger << LOG_ERROR << "could not read in weights for " << name << endl;
    assert(false);
    return 1;
  }

  logger << LOG_DEBUG << "reading weights for " << readin[proc] << endl;
  proc++;

  for (int i = 0; i < alpha.size(); i++){
    alpha[i] = atof(readin[proc].c_str());
    proc++;
    logger << LOG_DEBUG << "alpha[" << setw(4) << i << "] = " << setw(23) << setprecision(15) << alpha[i] << endl;
  }
  //  if (switch_IS_MC == 0 || switch_IS_MC == 2){logger << LOG_DEBUG << readin[proc] << " is not further optimized." << endl;}
  //  else if (switch_IS_MC == 1 || switch_IS_MC == 3){logger << LOG_DEBUG << readin[proc] << " is further optimized." << endl;}

  beta[0] = alpha[0];
  for (int i = 1; i < beta.size(); i++){beta[i] = beta[i - 1] + alpha[i];}
  if (fabs(beta[beta.size()-1]-1)>1e-6) {
        for (int i = 0; i < n_bins; i++){
        logger << LOG_DEBUG << "alpha[" << setw(4) << i << "] = " << alpha[i] << "   beta[" << setw(4) << i << "] = " << beta[i] << endl;
    }


    logger << LOG_ERROR << setw(50) << name << ": something went wrong in weight readin, aborting.." << endl;
    exit(1);

    logger << LOG_DEBUG_VERBOSE << "finished   return value: 1" << endl;
    return 1;
  }

  logger << LOG_DEBUG_VERBOSE << "finished   return value: 0" << endl;
  return 0;
}

randommanager::randommanager() : logger(Logger("random manager")) {}


randommanager::randommanager(vector<double> sran, string _weightdir, string _processname) : logger(Logger("random manager")) {
  static Logger logger("randommanager::randommanager");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;


  s=sran;

  for (int i = 0; i < s.size(); i++){logger << LOG_DEBUG_VERBOSE << "s[" << i << "] = " << s[i] << endl;}

  // hack to get uncorrelated PRN
  s[0]/=2;
  s[1]/=3;
  s[2]/=4;

  for (int i = 0; i < s.size(); i++){logger << LOG_DEBUG_VERBOSE << "s[" << i << "] = " << s[i] << endl;}

  weightdir=_weightdir;
  processname=_processname;

  opt_end=true;

  used_queue.resize(0);
  queue_counter=0;
  queue_threshold=1e2;

  proceeding_save();

  logger << LOG_DEBUG << "weightdir = " << weightdir << endl;

  readin_weights();

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

randommanager::~randommanager() {
  for (int i=0; i<random_variables.size(); i++) {
    // FIXME: should the random manager be responsible for deleting the variables it manages?
    // If so, we have to be careful that they actually still exists at this point
//     delete random_variables[i];
  }
}

void randommanager::register_variable(randomvariable* new_var, bool imp_sampling) {
  static Logger logger("randommanager::register_variable");
  logger << LOG_DEBUG << "called" << endl;
  ostringstream convert;

  for (int i = 0; i < s.size(); i++){logger << LOG_DEBUG_VERBOSE << "s[" << i << "] = " << s[i] << endl;}

  if (new_var->name=="") {
    convert << "random_var" << random_variables.size();
    new_var->name = convert.str();
  }

  new_var->imp_sampling=imp_sampling;

  // decorrelate random sequences
  // TODO: seed uniformly!
  new_var->s[0] = (new_var->s[0]+s[0])/4*(1+cos(random_variables.size()+2));
  new_var->s[1] = (new_var->s[1]+s[1])/4*(1+cos(random_variables.size()+2));
  new_var->s[2] = (new_var->s[2]+s[2])/4*(1+cos(random_variables.size()+2));

  for (int i = 0; i < new_var->s.size(); i++){logger << LOG_DEBUG_VERBOSE << "new_var->s[" << i << "] = " << new_var->s[i] << endl;}

  new_var->proceeding_save();

  new_var->manager=this;

  new_var->readin_weights(readin);

  random_variables.push_back(new_var);

  logger << LOG_DEBUG << "new random variable registered " << setw(50) << new_var->name << ": " << new_var->n_events << ", " << new_var->switch_IS_MC << ", " << new_var->n_steps << ", " << new_var->n_bins << ", " << new_var->imp_sampling << endl;

  opt_end=false;
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void randommanager::optimize(const double psp_weight, const double psp_weight2) {
  static Logger logger("randommanager::optimize");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (opt_end)
    return;

  opt_end=true;

  if (random_variables.size()>queue_threshold) {
    //    logger << LOG_DEBUG << "random_variables.size() > queue_threshold" << endl;
    for (int i=0; i<queue_counter; i++) {
      used_queue[i]->optimize(psp_weight);
      if (used_queue[i]->opt_end == 0) {
        opt_end=false;
	//        logger << LOG_DEBUG << "opt: set " << i << "(" << used_queue[i]->name << ") to unused" << endl;
      }
    }
  }
  else {
    //    logger << LOG_DEBUG << "random_variables.size() <= queue_threshold" << endl;
    int first=0;
    int last=random_variables.size()-1;

    for (int i=first; i<last+1; i++) {
      random_variables[i]->optimize(psp_weight);
      if (random_variables[i]->opt_end == 0) {
        opt_end=false;
      }
    }
  }

  queue_counter=0;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void randommanager::increase_cut_counter() {
  if (opt_end)
    return;

  if (random_variables.size()>queue_threshold) {
    for (int i=0; i<queue_counter; i++) {
      used_queue[i]->cuts_channel[used_queue[i]->channel]++;
      if (used_queue[i]->opt_end == 0) {
        used_queue[i]->used=false;
      }
    }
  }
  else {
    int first=0;
    int last=random_variables.size()-1;

    for (int i=first; i<last+1; i++) {
      if (random_variables[i]->used) {
        random_variables[i]->cuts_channel[random_variables[i]->channel]++;
        random_variables[i]->used=false;
      }
    }
  }

  queue_counter=0;
}

void randommanager::do_optimization_step(int events) {
  if (opt_end)
    return;

  int finished;
  bool writeout=false;
  //  cout << "events = " << events << endl;
  for (int i=0; i<random_variables.size(); i++) {
    //    cout << "random_variables[i]->do_optimization_step(events) = " << random_variables[i]->do_optimization_step(events) << endl;
    finished=random_variables[i]->do_optimization_step(events);
    if (finished==1)
      writeout=true;
  }

  if (writeout) {
    writeout_weights();
//    //ofstream out_weights(("weights/weights_IS_MC_" + processname + ".dat").c_str());
//    ofstream out_weights(("weights/weights_IS_MC_" + processname + ".dat").c_str());
//
//    for (int i=0; i<random_variables.size(); i++) {
//      random_variables[i]->save_weights(out_weights);
//    }
  }
}

void randommanager::proceeding_out(ofstream &out_proceeding) {
  // save random seed
  /*
  out_proceeding << setprecision(16) << save_s[0] << endl;
  out_proceeding << setprecision(16) << save_s[1] << endl;
  out_proceeding << setprecision(16) << save_s[2] << endl;
  */
  for (int i = 0; i < 3; i++){out_proceeding << double2hexastr(save_s[i]) << endl;}

  for (int i=0; i<random_variables.size(); i++) {
    random_variables[i]->proceeding_out(out_proceeding);
  }
}

void randommanager::proceeding_in(int &proc, vector<string> &readin) {
  /*
  s[0] = atof(readin[proc].c_str());
  s[1] = atof(readin[proc+1].c_str());
  s[2] = atof(readin[proc+2].c_str());
  */
  for (int i = 0; i < 3; i++){s[i] = hexastr2double(readin[proc + i]);}
  //  cout << "randomseed: " << s[0] << ", " << s[1] << ", " << s[2] << endl;
  proc += 3;

  for (int i=0; i<random_variables.size(); i++) {
    random_variables[i]->proceeding_in(proc, readin);
  }
}

void randommanager::check_proceeding_in(int &int_end, int &temp_check_size, vector<string> &readin) {
  logger << LOG_DEBUG << "int_end = " << int_end << endl;
  logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << endl;
  logger << LOG_DEBUG << "readin.size() = " << readin.size() << endl;
  /*
  s[0] = atof(readin[temp_check_size].c_str());
  s[1] = atof(readin[temp_check_size+1].c_str());
  s[2] = atof(readin[temp_check_size+2].c_str());
  */
  //  for (int i = 0; i < 3; i++){s[i] = hexastr2double(readin[temp_check_size + i]);}
  //  cout << "randomseed: " << s[0] << ", " << s[1] << ", " << s[2] << endl;
  temp_check_size += 3;
  if (temp_check_size > readin.size()){int_end = 2; logger << LOG_DEBUG << "int_end = 2   temp_check_size = " << temp_check_size << " > " << readin.size() << " = readin.size()" << endl; return;}
  else{logger << LOG_DEBUG << "temp_check_size = " << temp_check_size << " <= " << readin.size() << " = readin.size()" << endl;}

  logger << LOG_DEBUG << "random_variables.size() = " << random_variables.size() << endl;
  
  for (int i=0; i<random_variables.size(); i++) {
    logger << LOG_DEBUG << "random_variables[" << i << "] = " << random_variables[i]->name << "   n_bins = " << random_variables[i]->n_bins << endl;
    random_variables[i]->check_proceeding_in(int_end, temp_check_size, readin);
  }
}

void randommanager::proceeding_size(int &proc){
  proc += 3;
  for (int i=0; i<random_variables.size(); i++) {
    random_variables[i]->proceeding_size(proc);
  }
}

void randommanager::proceeding_size(vector<int> & size_proceeding){
  size_proceeding[0] += 3;
  for (int i = 0; i < random_variables.size(); i++) {
    random_variables[i]->proceeding_size(size_proceeding);
  }
}

void randommanager::proceeding_save() {
  save_s = s;

  for (int i=0; i<random_variables.size(); i++) {
    random_variables[i]->proceeding_save();
  }
}

void randommanager::readin_weights() {
  logger << LOG_DEBUG << "start weight readin" << endl;

//  // check if we need to readin weights
//  bool bool_readin=false;
//  for (int i=0; i<random_variables.size(); i++) {
//    if (random_variables[i]->switch_IS_MC == 2 || random_variables[i]->switch_IS_MC == 3)
//      bool_readin=true;
//  }
//
//  if (!bool_readin) {
//    logger << LOG_DEBUG << "no weights need to be read" << endl;
//    return;
//  }

  string in_path = weightdir + "/weights_IS_MC_" + processname + ".dat";
  logger << LOG_DEBUG << "weight readin in_path = " << in_path << endl;
  ifstream readin_weights(in_path.c_str());

  if (!readin_weights) {
    logger << LOG_INFO << "weight file " << in_path << " could not be opened" << endl;
    readin_weights.close();
    return;
  }

  char LineBuffer[128];
  while (readin_weights.getline(LineBuffer, 128)) {readin.push_back(LineBuffer);}
  readin_weights.close();

//  vector<bool> successfully_readin(random_variables.size(),false);
//
//  for (int proc=0; proc<readin.size(); proc++) {
//    size_t pos=readin[proc].find("variable ");
//    if (pos != string::npos) {
//      pos += 9;
//      string var_name=readin[proc].substr(pos,string::npos);
//      //      logger << LOG_DEBUG << "weight readin var_name = " << var_name << endl;
//      int start_index = 0;
//      for (int i = 0; i < var_name.size(); i++){
//        if (var_name[i] != ' '){start_index = i; break;}
//      }
//      var_name=var_name.substr(start_index, var_name.size() - start_index);
//      logger << LOG_INFO << "weights found for " << var_name << endl;
//
//      for (int i=0; i<random_variables.size(); i++) {
//	//	logger << LOG_DEBUG << "weight readin var_name = " << random_variables[i]->name << endl;
//      if (var_name==random_variables[i]->name) {
//        if (random_variables[i]->readin_weights(proc,readin)) {
//          logger << LOG_FATAL << "weight readin failed for variable " << random_variables[i]->name << ", check if ok!" << endl;
//	        exit(1);
//        } else {
//            successfully_readin[i]=true;
//          }
//        }
//      }
//    }
//  }
//
//  // verify that every variable with has successfully readin its weights
//  for (int i=0; i<random_variables.size(); i++) {
//    logger << LOG_DEBUG << "checking " << random_variables[i]->name << endl;
//    if ((random_variables[i]->switch_IS_MC == 2 || random_variables[i]->switch_IS_MC == 3) && !successfully_readin[i]) {
//      logger << LOG_FATAL << "weight readin failed for variable " << random_variables[i]->name << ", check if ok!" << endl;
//      //exit(1);
//    }
//  }
//


  logger << LOG_DEBUG << "weight readin finished" << endl;
}

void randommanager::writeout_weights() {
  logger << LOG_DEBUG << "weight writeout started" << endl;

  ofstream out_weights(("weights/weights_IS_MC_" + processname + ".dat").c_str());
  for (int i = 0; i < random_variables.size(); i++) {
    random_variables[i]->save_weights(out_weights);
  }
  
  logger << LOG_DEBUG << "weight writeout finished" << endl;
}


void randommanager::add_var_to_queue(randomvariable* variable) {
  if (opt_end)
    return;

  if (queue_counter>=used_queue.size()) {
    used_queue.push_back(variable);
  }
  else {
    used_queue[queue_counter]=variable;
  }
  queue_counter++;
}
/*
void randommanager::nancut(bool count_as_cut) {
  for (int i=0; i<random_variables.size(); i++) {
    if (random_variables[i]->used) {
      if (count_as_cut) {
        random_variables[i]->cuts_channel[random_variables[i]->channel]++;
      }
      random_variables[i]->used=false;
    }
  }
  queue_counter=0;
}
*/
void randommanager::nancut() {
  for (int i=0; i<random_variables.size(); i++) {
    if (random_variables[i]->used) {
      random_variables[i]->used=false;
    }
  }
  queue_counter=0;
}
