#include "../include/classes.cxx"
//#include "../include/definitions.cxx"
#include "../include/definitions.phasespace.set.cxx"
void ac_psp_RA_group_ij_k(vector<double> & r, int channel, vector<dipole_set> & dipole, int i_a, double & g_IS_channel, phasespace_set & psi, call_generic & generic){
  static Logger logger("ac_psp_RA_group_ij_k");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  static int xb_all_out = intpow(2, psi_n_particle + 1) - 4;
  /*
  static int no_random_1 = 3 * psi_n_particle - 4 - 2;
  static int no_random_2 = 3 * psi_n_particle - 4 - 1;
  static int no_random_3 = 3 * psi_n_particle - 4;
  */
  double g_IS_temp;
  if (psi_weight_IS == 3 || psi_weight_IS == 4){
    for (int j = 2; j < 3; j++){ // manually switched of x and z IS
      if (psi_container_IS_switch[psi_container_IS_startvalue[i_a][4 + j]] == 1){psi_phasespace_randoms[psi_container_IS_startvalue[i_a][4 + j]]->get_random(r[psi_no_random_dipole[j]], g_IS_temp);}
      g_IS_channel *= g_IS_temp;
    }
  }
  for (int i = 0; i < 3; i++){psi_xbp[i_a][i] = psi_xbp[0][i];}
  psi_xbs[i_a][0] = psi_xbs[0][0];
  psi_xbsqrts[i_a][0] = psi_xbsqrts[0][0];
  psi_xbp[i_a][xb_all_out] = psi_xbp[i_a][0];
  psi_xbs[i_a][xb_all_out] = psi_xbs[i_a][0];
  psi_xbsqrts[i_a][xb_all_out] = psi_xbsqrts[i_a][0];
  generic.ac_psp_dipole(i_a, channel - dipole[i_a - 1].sum_channel(), psi);
  int bp_i = dipole[i_a].binary_R_emitter_1();
  int bp_j = dipole[i_a].binary_R_emitter_2();
  int bp_k = dipole[i_a].binary_R_spectator();
  int bpt_ij = dipole[i_a].binary_A_emitter();
  int bpt_k = dipole[i_a].binary_A_spectator();
  fourvector temp_p_ijk = psi_xbp[i_a][bpt_ij] + psi_xbp[i_a][bpt_k];
  fourvector temp_p_k_boost = psi_xbp[i_a][bpt_k].boost(temp_p_ijk);
  double sqrt_p2_ijk = temp_p_ijk.m();
  double y_ij_k = h_propto_pot(r[psi_no_random_dipole[0]], 0., 1., psi_exp_ij_k_y, psi_map_technical_x);
  double one_minus_y_ij_k = 1. - y_ij_k;
  double one_minus_z_i = h_propto_pot(r[psi_no_random_dipole[1]], 0., 1., psi_exp_ij_k_z, psi_map_technical_x);
  double z_i = 1. - one_minus_z_i;
  double phi_k_perp = c_phi(r[psi_no_random_dipole[2]]);
  double f2 = y_ij_k * z_i / one_minus_z_i;
  double f = sqrt(f2);
  fourvector khat_perp(-f2 * sqrt_p2_ijk, f * sqrt_p2_ijk * cos(phi_k_perp), f * sqrt_p2_ijk * sin(phi_k_perp), -f2 * sqrt_p2_ijk);
  fourvector k_perp = (khat_perp.rotateback(temp_p_k_boost)).boost(temp_p_ijk.Pinv());

  psi_xbp[0][bp_i] = y_ij_k * (1. + z_i) * psi_xbp[i_a][bpt_k] + z_i  * psi_xbp[i_a][bpt_ij] + one_minus_z_i * k_perp;
  psi_xbp[0][bp_j] = one_minus_z_i * (psi_xbp[i_a][bpt_ij] - k_perp) - y_ij_k * z_i * psi_xbp[i_a][bpt_k];
  psi_xbp[0][bp_k] = one_minus_y_ij_k * psi_xbp[i_a][bpt_k];
  for (int xbi = 4; xbi < psi_xbp[0].size(); xbi = xbi * 2){
    if      (xbi == bp_i){}
    else if (xbi == bp_j){}
    else if (xbi == bp_k){}
    else if (xbi <  bp_j){psi_xbp[0][xbi] = psi_xbp[i_a][xbi];}
    else if (xbi >  bp_j){psi_xbp[0][xbi] = psi_xbp[i_a][xbi / 2];}
    else {cout << "Should not happen!" << endl;}
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ag_psp_RA_group_ij_k(vector<dipole_set> & dipole, int i_a, phasespace_set & psi, call_generic & generic){
  static Logger logger("ag_psp_RA_group_ij_k");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  //  static int xb_all_out = intpow(2, psi_n_particle + 1) - 4;
  int bp_i = dipole[i_a].binary_R_emitter_1();
  int bp_j = dipole[i_a].binary_R_emitter_2();
  int bp_k = dipole[i_a].binary_R_spectator();
  int bpt_ij = dipole[i_a].binary_A_emitter();
  int bpt_k = dipole[i_a].binary_A_spectator();
  if (psi_xbs[0][bp_i + bp_j] == 0.){psi_xbs[0][bp_i + bp_j] = (psi_xbp[0][bp_i] + psi_xbp[0][bp_j]).m2();}
  double p_kp_ij = 2. * (psi_xbp[0][bp_k] * (psi_xbp[0][bp_i] + psi_xbp[0][bp_j]));
  double y_ij_k = 1. / (1. + p_kp_ij / psi_xbs[0][bp_i + bp_j]);
  //  double one_minus_y_ij_k = 1. - y_ij_k;
  double z_i = (psi_xbp[0][bp_i] * psi_xbp[0][bp_k]) / (psi_xbp[0][bp_i] * psi_xbp[0][bp_k] + psi_xbp[0][bp_j] * psi_xbp[0][bp_k]);
  double one_minus_z_i = (psi_xbp[0][bp_j] * psi_xbp[0][bp_k]) / (psi_xbp[0][bp_i] * psi_xbp[0][bp_k] + psi_xbp[0][bp_j] * psi_xbp[0][bp_k]);
  double g_alpha = g_propto_pot(y_ij_k, 0., 1., psi_exp_ij_k_y, psi_map_technical_x) * g_propto_pot(one_minus_z_i, 0., 1., psi_exp_ij_k_z, psi_map_technical_x) / (pi * (psi_xbp[i_a][bpt_ij] * psi_xbp[i_a][bpt_k]) * (1. - y_ij_k));
  if (psi_xbs[i_a][0] == 0.){psi_xbs[i_a][0] = psi_xbs[0][0];}
  if (psi_xbsqrts[i_a][0] == 0.){psi_xbsqrts[i_a][0] = psi_xbsqrts[0][0];}
  generic.ag_psp_dipole(i_a, dipole[i_a - 1].sum_channel(), psi);
  for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){psi_MC_g_channel[i] = psi_MC_g_channel[i] * g_alpha;}
  // invert mappings for VAMP implementation
  if (psi_weight_IS == 2 || psi_weight_IS == 4){
    //  static vector<double> inv_r(3);
    vector<double> inv_r(3);
    inv_r[0] = inv_propto_pot(y_ij_k, 0., 1., psi_exp_ij_k_y, psi_map_technical_x);
    inv_r[1] = inv_propto_pot(one_minus_z_i, 0., 1., psi_exp_ij_k_z, psi_map_technical_x);
    fourvector k_perp = psi_xbp[0][bp_j] + y_ij_k * z_i * psi_xbp[i_a][bpt_k];
    k_perp = -(k_perp - psi_xbp[i_a][bpt_ij])/one_minus_z_i;
    fourvector temp_p_ijk = psi_xbp[i_a][bpt_ij] + psi_xbp[i_a][bpt_k];
    fourvector temp_p_k_boost = psi_xbp[i_a][bpt_k].boost(temp_p_ijk);
    k_perp = (k_perp.boost(temp_p_ijk)).rotateback_inverse(temp_p_k_boost);
    double phi = atan2(k_perp.x2(),k_perp.x1());
    if (phi < 0){phi += 2 * M_PI;}
    inv_r[2] = inv_phi(phi);
    if (!(inv_r[2] >= 0) || inv_r[2] > 1){
      cout << "inv_r[2] not in [0; 1] in ppeexa03_ag_psp_RA_group_ij_k !   r = " << inv_r[2] <<"; k_perp.x,y,z=" << k_perp.x1() << ", " << k_perp.x2() << ", " << k_perp.x3() << endl;
      if (!(inv_r[2] >= 0)){inv_r[2] = 0.;}
      if (inv_r[2] > 1){inv_r[2] = 1.;}
    }
    if (psi_weight_IS == 2){
      for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){
        double g_IS_temp;
        double g_IS = 1.;
        for (int j = 0; j < 3; j++){
          psi_phasespace_randoms[(i + 1) * 8 - 3 + j]->get_g_IS(inv_r[j], g_IS_temp);
          g_IS *= g_IS_temp;
        }
        psi_MC_g_channel[i] *= g_IS;
      }
    }
    else if (psi_weight_IS == 4){
      double g_IS_temp;
      double g_IS = 1.;
      for (int j = 2; j < 3; j++){ // manually switched of x and z IS
        psi_phasespace_randoms[psi_container_IS_startvalue[i_a][4 + j]]->get_g_IS(inv_r[j], g_IS_temp);
        g_IS *= g_IS_temp;
      }
      for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){psi_MC_g_channel[i] *= g_IS;}
    }
    //  cout << "reconstr " << i_a << ": " << inv_r[0] << ", " << inv_r[1] << ", " << inv_r[2] << endl;
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ac_psp_RA_group_ij_a(vector<double> & r, int channel, vector<dipole_set> & dipole, double & sinx_ij_a_min, int i_a, double & g_IS_channel, phasespace_set & psi, call_generic & generic){
  static Logger logger("ac_psp_RA_group_ij_a");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  static int xb_all_out = intpow(2, psi_n_particle + 1) - 4;
  /*
  static int no_random_1 = 3 * psi_n_particle - 4 - 2;
  static int no_random_2 = 3 * psi_n_particle - 4 - 1;
  static int no_random_3 = 3 * psi_n_particle - 4;
  */
  double g_IS_temp;
  if (psi_weight_IS == 3 || psi_weight_IS == 4){
    for (int j = 2; j < 3; j++){ // manually switched of x and z IS
      if (psi_container_IS_switch[psi_container_IS_startvalue[i_a][4 + j]] == 1){psi_phasespace_randoms[psi_container_IS_startvalue[i_a][4 + j]]->get_random(r[psi_no_random_dipole[j]], g_IS_temp);}
      g_IS_channel *= g_IS_temp;
    }
  }
  int bp_i = dipole[i_a].binary_R_emitter_1();
  int bp_j = dipole[i_a].binary_R_emitter_2();
  int bp_a = dipole[i_a].binary_R_spectator();
  int bpt_ij = dipole[i_a].binary_A_emitter();
  //  int bpt_a = dipole[i_a].binary_A_spectator(); // always bp_a == bpt_a
  int bp_b = bp_a % 2 + 1;

  /*
  double one_minus_x_ij_a_min = 1. - sinx_ij_a_min / psi_xbs[0][0];
  double one_minus_x_ij_a = h_propto_pot(r[psi_no_random_dipole[0]], 0., one_minus_x_ij_a_min, psi_exp_ij_a_x, psi_map_technical_x);
  double x_ij_a = 1. - one_minus_x_ij_a;
  */
  // multi-channel, where channel 0 reproduces the original version, and channels >0 map potential IS resonances...
  double one_minus_x_ij_a_min = 1. - sinx_ij_a_min / psi_xbs[0][0];
  double x_ij_a = 1.;
  double one_minus_x_ij_a = 0.;
  // random_MC_tau[1] -> increase number in calculate_intial_tau_IS_x1x2_IS !!!
  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].beta.size(); i_c++){
    logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].beta[" << i_c << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].beta[i_c] << endl;
  }
  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].beta.size(); i_c++){if (psi_random_MC_tau[1] <= psi_MC_x_dipole[i_a].beta[i_c]){psi_MC_x_dipole[i_a].channel = i_c; break;}}
  logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].channel = " << psi_MC_x_dipole[i_a].channel << endl;

  if (psi_MC_x_dipole[i_a].channel == 0){
    one_minus_x_ij_a = h_propto_pot(r[psi_no_random_dipole[0]], 0., one_minus_x_ij_a_min, psi_exp_ij_a_x, psi_map_technical_x);
    x_ij_a = 1. - one_minus_x_ij_a;
  }
  else {
    if (psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel] < 0){
      x_ij_a = psi.c_propagator_Breit_Wigner(r[psi_no_random_dipole[0]], -psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel], sinx_ij_a_min, psi_xbs[0][0]) / psi_xbs[0][0];
      one_minus_x_ij_a = 1. - x_ij_a;
      logger << LOG_DEBUG_VERBOSE << "s_dipole = " << setw(23) << setprecision(15) << sqrt(x_ij_a * psi_xbs[0][0]) << "   " << "x_ij_a = " << setw(23) << setprecision(15) << x_ij_a << "   " << "psi_xbs[0][0] = " << setw(23) << setprecision(15) << psi_xbs[0][0] << endl;
    }
  }


  psi_xbp[i_a][bp_a] = x_ij_a * psi_xbp[0][bp_a];
  psi_xbp[i_a][bp_b] = psi_xbp[0][bp_b];
  psi_xbp[i_a][0] = psi_xbp[i_a][bp_a] + psi_xbp[i_a][bp_b];
  psi_xbs[i_a][0] = x_ij_a * psi_xbs[0][0];
  psi_xbsqrts[i_a][0] = sqrt(psi_xbs[i_a][0]);
  psi_xbp[i_a][xb_all_out] = psi_xbp[i_a][0];
  psi_xbs[i_a][xb_all_out] = psi_xbs[i_a][0];
  psi_xbsqrts[i_a][xb_all_out] = psi_xbsqrts[i_a][0];
  generic.ac_psp_dipole(i_a, channel - dipole[i_a - 1].sum_channel(), psi);
  fourvector temp_p_ija = psi_xbp[i_a][bpt_ij] + psi_xbp[i_a][bp_a];
  fourvector temp_p_a_boost = psi_xbp[i_a][bp_a].boost(temp_p_ija);
  double sqrt_p2_ija = temp_p_ija.m();
  double one_minus_z_i = h_propto_pot(r[psi_no_random_dipole[1]], 0., 1., psi_exp_ij_a_z, psi_map_technical_x);
  double z_i = 1. - one_minus_z_i;
  double phi_a_perp = c_phi(r[psi_no_random_dipole[2]]);
  double f2 = z_i * one_minus_x_ij_a / (one_minus_z_i * x_ij_a);
  double f = sqrt(f2);
  fourvector khat_perp(-f2 * sqrt_p2_ija, f * sqrt_p2_ija * cos(phi_a_perp), f * sqrt_p2_ija * sin(phi_a_perp), -f2 * sqrt_p2_ija);
  fourvector k_perp = (khat_perp.rotateback(temp_p_a_boost)).boost(temp_p_ija.Pinv());

  psi_xbp[0][bp_i] = one_minus_x_ij_a / x_ij_a * (1. + z_i) * psi_xbp[i_a][bp_a] + z_i * psi_xbp[i_a][bpt_ij] + one_minus_z_i * k_perp;
  psi_xbp[0][bp_j] = one_minus_z_i * (psi_xbp[i_a][bpt_ij] - k_perp) - one_minus_x_ij_a / x_ij_a * z_i * psi_xbp[i_a][bp_a];
  psi_xbp[0][bp_a] = psi_xbp[i_a][bp_a] / x_ij_a;
  for (int xbi = 4; xbi < psi_xbp[0].size(); xbi = xbi * 2){
    if      (xbi == bp_i){}
    else if (xbi == bp_j){}
    else if (xbi < bp_j){psi_xbp[0][xbi] = psi_xbp[i_a][xbi];}
    else if (xbi > bp_j){psi_xbp[0][xbi] = psi_xbp[i_a][xbi / 2];}
    else {cout << "Should not happen!" << endl;}
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ag_psp_RA_group_ij_a(double & sinx_ij_a_min, vector<dipole_set> & dipole, int i_a, phasespace_set & psi, call_generic & generic){
  static Logger logger("ag_psp_RA_group_ij_a");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  //  static int xb_all_out = intpow(2, psi_n_particle + 1) - 4;
  int bp_i = dipole[i_a].binary_R_emitter_1();
  int bp_j = dipole[i_a].binary_R_emitter_2();
  int bp_a = dipole[i_a].binary_R_spectator(); // bp_b not needed !!!
  int bpt_ij = dipole[i_a].binary_A_emitter();
  //  int bpt_a = dipole[i_a].binary_A_spectator(); // always bp_a == bpt_a
  if (psi_xbs[0][bp_i + bp_j] == 0.){psi_xbs[0][bp_i + bp_j] = (psi_xbp[0][bp_i] + psi_xbp[0][bp_j]).m2();}
  double pa_p12 = 2. * (psi_xbp[0][bp_a] * (psi_xbp[0][bp_i] + psi_xbp[0][bp_j]));

  double one_minus_x_ij_a_min = 1. - sinx_ij_a_min / psi_xbs[0][0];
  double one_minus_x_ij_a = psi_xbs[0][bp_i + bp_j] / pa_p12;
  double x_ij_a = 1. - one_minus_x_ij_a;

  // multi-channel, where channel 0 reproduces the original version, and channels >0 map potential IS resonances...
  double g_x_ij_a = g_propto_pot(one_minus_x_ij_a, 0., one_minus_x_ij_a_min, psi_exp_ij_a_x, psi_map_technical_x);
  double x_ij_a_s_part = x_ij_a * psi_xbs[0][0];
  logger << LOG_DEBUG_VERBOSE << "x_ij_a_s_part = " << x_ij_a_s_part << "   sqrt -> " << sqrt(x_ij_a_s_part) << endl;
  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].g_channel.size(); i_c++){
    if (i_c == 0){
      psi_MC_x_dipole[i_a].g_channel[i_c] = g_propto_pot_mod(one_minus_x_ij_a, 0., one_minus_x_ij_a_min, psi_exp_ij_a_x, psi_map_technical_x);
    }
    else {
      if (psi_MC_x_dipole_mapping[i_a][i_c] < 0){psi_MC_x_dipole[i_a].g_channel[i_c] = psi_xbs[0][0] * psi.g_propagator_Breit_Wigner(x_ij_a_s_part, -psi_MC_x_dipole_mapping[i_a][i_c], sinx_ij_a_min, psi_xbs[0][0]);}
      logger << LOG_DEBUG_VERBOSE << "sinx_ij_a_min = " << setw(23) << setprecision(15) << sinx_ij_a_min << endl;
      logger << LOG_DEBUG_VERBOSE << "x_ij_a_s_part = " << setw(23) << setprecision(15) << x_ij_a_s_part << endl;
      logger << LOG_DEBUG_VERBOSE << "psi_xbs[0][0] = " << setw(23) << setprecision(15) << psi_xbs[0][0] << endl;
      logger << LOG_DEBUG_VERBOSE << "-psi_MC_x_dipole_mapping[i_a][i_c] = " << setw(23) << setprecision(15) << -psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel] << endl;
      logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[i_a].g_channel[i_c] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].g_channel[i_c] << endl;
      ///      else if (tau_MC_map[i_c] > 0){psi_MC_x_dipole[i_a].g_channel[i_c] = s_had * g_propagator_vanishing_width(x_ij_a_s_part, M2[tau_MC_map[i_c]], tau_0_s_had, s_had, nuxs);}
    }
  }
  g_x_ij_a = 0.;
  for (int i = 0; i < psi_MC_x_dipole[i_a].g_channel.size(); i++){
    logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].alpha[" << i << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].alpha[i] << "   " << "psi_MC_x_dipole[" << i_a << "].g_channel[" << i << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].g_channel[i] << endl;
  }
  for (int i = 0; i < psi_MC_x_dipole[i_a].g_channel.size(); i++){g_x_ij_a += psi_MC_x_dipole[i_a].alpha[i] * psi_MC_x_dipole[i_a].g_channel[i];}
  logger << LOG_DEBUG_VERBOSE << "g_x_ij_a = " << g_x_ij_a << endl;

  double z_i = (psi_xbp[0][bp_i] * psi_xbp[0][bp_a]) / (psi_xbp[0][bp_i] * psi_xbp[0][bp_a] + psi_xbp[0][bp_j] * psi_xbp[0][bp_a]);
  double one_minus_z_i = (psi_xbp[0][bp_j] * psi_xbp[0][bp_a]) / (psi_xbp[0][bp_i] * psi_xbp[0][bp_a] + psi_xbp[0][bp_j] * psi_xbp[0][bp_a]);
  double g_alpha = g_x_ij_a * g_propto_pot(one_minus_z_i, 0., 1., psi_exp_ij_a_z, psi_map_technical_x) / (pi * (psi_xbp[i_a][bpt_ij] * psi_xbp[0][bp_a]));
  //  double g_alpha = g_propto_pot(one_minus_x_ij_a, 0., one_minus_x_ij_a_min, psi_exp_ij_a_x, psi_map_technical_x) * g_propto_pot(one_minus_z_i, 0., 1., psi_exp_ij_a_z, psi_map_technical_x) / (pi * (psi_xbp[i_a][bpt_ij] * psi_xbp[0][bp_a]));
  if (psi_xbs[i_a][0] == 0.){psi_xbs[i_a][0] = x_ij_a * psi_xbs[0][0];}
  if (psi_xbsqrts[i_a][0] == 0.){psi_xbsqrts[i_a][0] = sqrt(psi_xbs[i_a][0]);}
  generic.ag_psp_dipole(i_a, dipole[i_a - 1].sum_channel(), psi);
  for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){psi_MC_g_channel[i] = psi_MC_g_channel[i] * g_alpha;}
  // invert mappings for VAMP implementation
  if (psi_weight_IS == 2 || psi_weight_IS == 4){
    //  static vector<double> inv_r(3);
    vector<double> inv_r(3);
    inv_r[0] = inv_propto_pot(one_minus_x_ij_a, 0., one_minus_x_ij_a_min, psi_exp_ij_a_x, psi_map_technical_x);
    inv_r[1] = inv_propto_pot(one_minus_z_i, 0., 1., psi_exp_ij_a_z, psi_map_technical_x);
    fourvector k_perp = psi_xbp[0][bp_j] + one_minus_x_ij_a / x_ij_a * z_i * psi_xbp[i_a][bp_a];
    k_perp = -(k_perp - psi_xbp[i_a][bpt_ij])/one_minus_z_i;
    fourvector temp_p_ija = psi_xbp[i_a][bpt_ij] + psi_xbp[i_a][bp_a];
    fourvector temp_p_a_boost = psi_xbp[i_a][bp_a].boost(temp_p_ija);
    k_perp = (k_perp.boost(temp_p_ija)).rotateback_inverse(temp_p_a_boost);
    double phi = atan2(k_perp.x2(),k_perp.x1());
    if (phi < 0){phi += 2 * M_PI;}
    inv_r[2] = inv_phi(phi);
    if (!(inv_r[2] >= 0) || inv_r[2] > 1){
      cout << "inv_r[2] not in [0; 1] in ppeexa03_ag_psp_RA_group_ij_a !   r = " << inv_r[2] <<"; k_perp.x,y,z=" << k_perp.x1() << ", " << k_perp.x2() << ", " << k_perp.x3() << endl;
      if (!(inv_r[2] >= 0)){inv_r[2] = 0.;}
      if (inv_r[2] > 1){inv_r[2] = 1.;}
    }
    if (psi_weight_IS == 2){
      for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){
        double g_IS_temp;
        double g_IS = 1.;
        for (int j = 0; j < 3; j++){
          psi_phasespace_randoms[(i + 1) * 8 - 3 + j]->get_g_IS(inv_r[j], g_IS_temp);
          g_IS *= g_IS_temp;
        }
        psi_MC_g_channel[i] *= g_IS;
      }
    }
    else if (psi_weight_IS == 4){
      double g_IS_temp;
      double g_IS = 1.;
      for (int j = 2; j < 3; j++){ // manually switched of x and z IS
        psi_phasespace_randoms[psi_container_IS_startvalue[i_a][4 + j]]->get_g_IS(inv_r[j], g_IS_temp);
        g_IS *= g_IS_temp;
      }
      for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){psi_MC_g_channel[i] *= g_IS;}
    }
    //  cout << "reconstr " << i_a << ": " << inv_r[0] << ", " << inv_r[1] << ", " << inv_r[2] << endl;
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ac_psp_RA_group_ai_k(vector<double> & r, int channel, vector<dipole_set> & dipole, double & sinx_ik_a_min, int i_a, double & g_IS_channel, phasespace_set & psi, call_generic & generic){
  static Logger logger("ac_psp_RA_group_ai_k");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  static int xb_all_out = intpow(2, psi_n_particle + 1) - 4;
  /*
  static int no_random_1 = 3 * psi_n_particle - 4 - 2;
  static int no_random_2 = 3 * psi_n_particle - 4 - 1;
  static int no_random_3 = 3 * psi_n_particle - 4;
  */
  double g_IS_temp;
  if (psi_weight_IS == 3 || psi_weight_IS == 4){
    for (int j = 2; j < 3; j++){ // manually switched of x and z IS
      if (psi_container_IS_switch[psi_container_IS_startvalue[i_a][4 + j]] == 1){psi_phasespace_randoms[psi_container_IS_startvalue[i_a][4 + j]]->get_random(r[psi_no_random_dipole[j]], g_IS_temp);}
      g_IS_channel *= g_IS_temp;
    }
  }
  int bp_a = dipole[i_a].binary_R_emitter_1();
  int bp_i = dipole[i_a].binary_R_emitter_2();
  int bp_k = dipole[i_a].binary_R_spectator();
  //  int bpt_ai = dipole[i_a].binary_A_emitter();
  int bpt_k = dipole[i_a].binary_A_spectator();
  int bp_b = bp_a % 2 + 1;



  /*
  double one_minus_x_ik_a_min = 1. - sinx_ik_a_min / psi_xbs[0][0];
  double one_minus_x_ik_a = h_propto_pot(r[psi_no_random_dipole[0]], 0., one_minus_x_ik_a_min, psi_exp_ai_k_x, psi_map_technical_x);
  double x_ik_a = 1. - one_minus_x_ik_a;
  */
  // multi-channel, where channel 0 reproduces the original version, and channels >0 map potential IS resonances...
  double one_minus_x_ik_a_min = 1. - sinx_ik_a_min / psi_xbs[0][0];
  double x_ik_a = 1.;
  double one_minus_x_ik_a = 0.;
  // random_MC_tau[1] -> increase number in calculate_intial_tau_IS_x1x2_IS !!!
  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].beta.size(); i_c++){
    logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].beta[" << i_c << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].beta[i_c] << endl;
  }
  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].beta.size(); i_c++){if (psi_random_MC_tau[1] <= psi_MC_x_dipole[i_a].beta[i_c]){psi_MC_x_dipole[i_a].channel = i_c; break;}}
  logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].channel = " << psi_MC_x_dipole[i_a].channel << endl;

  if (psi_MC_x_dipole[i_a].channel == 0){
    one_minus_x_ik_a = h_propto_pot(r[psi_no_random_dipole[0]], 0., one_minus_x_ik_a_min, psi_exp_ai_k_x, psi_map_technical_x);
    x_ik_a = 1. - one_minus_x_ik_a;
  }
  else {
    if (psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel] < 0){
      x_ik_a = psi.c_propagator_Breit_Wigner(r[psi_no_random_dipole[0]], -psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel], sinx_ik_a_min, psi_xbs[0][0]) / psi_xbs[0][0];
      one_minus_x_ik_a = 1. - x_ik_a;
      logger << LOG_DEBUG_VERBOSE << "s_dipole = " << setw(23) << setprecision(15) << sqrt(x_ik_a * psi_xbs[0][0]) << "   " << "x_ik_a = " << setw(23) << setprecision(15) << x_ik_a << "   " << "psi_xbs[0][0] = " << setw(23) << setprecision(15) << psi_xbs[0][0] << endl;
    }
  }
  
  psi_xbp[i_a][bp_a] = x_ik_a * psi_xbp[0][bp_a];
  psi_xbp[i_a][bp_b] = psi_xbp[0][bp_b];
  psi_xbp[i_a][0] = psi_xbp[i_a][bp_a] + psi_xbp[i_a][bp_b];
  psi_xbs[i_a][0] = x_ik_a * psi_xbs[0][0];
  psi_xbsqrts[i_a][0] = sqrt(psi_xbs[i_a][0]);
  psi_xbp[i_a][xb_all_out] = psi_xbp[i_a][0];
  psi_xbs[i_a][xb_all_out] = psi_xbs[i_a][0];
  psi_xbsqrts[i_a][xb_all_out] = psi_xbsqrts[i_a][0];
  generic.ac_psp_dipole(i_a, channel - dipole[i_a - 1].sum_channel(), psi);
  fourvector temp_p_aik = psi_xbp[i_a][bp_a] + psi_xbp[i_a][bpt_k];
  fourvector temp_p_k_boost = psi_xbp[i_a][bp_a].boost(temp_p_aik);
  double sqrt_p2_aik = temp_p_aik.m();
  double u_i = h_propto_pot(r[psi_no_random_dipole[1]], 0., 1., psi_exp_ai_k_u, psi_map_technical_x);
  double one_minus_u_i = 1. - u_i;
  double phi_k_perp = c_phi(r[psi_no_random_dipole[2]]);
  double f2 = u_i * one_minus_x_ik_a / (one_minus_u_i * x_ik_a);
  double f = sqrt(f2);
  fourvector khat_perp(-f2 * sqrt_p2_aik, f * sqrt_p2_aik * cos(phi_k_perp), f * sqrt_p2_aik * sin(phi_k_perp), -f2 * sqrt_p2_aik);
  fourvector k_perp = (khat_perp.rotateback(temp_p_k_boost)).boost(temp_p_aik.Pinv());

  psi_xbp[0][bp_i] = one_minus_x_ik_a / x_ik_a * (1. + u_i) * psi_xbp[i_a][bp_a] + u_i * psi_xbp[i_a][bpt_k] + one_minus_u_i * k_perp;
  psi_xbp[0][bp_k] = one_minus_u_i * (psi_xbp[i_a][bpt_k] - k_perp) - one_minus_x_ik_a / x_ik_a * u_i * psi_xbp[i_a][bp_a];
  psi_xbp[0][bp_a] = psi_xbp[i_a][bp_a] / x_ik_a;
  for (int xbi = 4; xbi < psi_xbp[0].size(); xbi = xbi * 2){
    if      (xbi == bp_i){}
    else if (xbi == bp_k){}
    else if (xbi < bp_i){psi_xbp[0][xbi] = psi_xbp[i_a][xbi];}
    else if (xbi > bp_i){psi_xbp[0][xbi] = psi_xbp[i_a][xbi / 2];}
    else {cout << "Should not happen!" << endl;}

  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ag_psp_RA_group_ai_k(double & sinx_ik_a_min, vector<dipole_set> & dipole, int i_a, phasespace_set & psi, call_generic & generic){
  static Logger logger("ag_psp_RA_group_ai_k");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  //  static int xb_all_out = intpow(2, psi_n_particle + 1) - 4;
  int bp_a = dipole[i_a].binary_R_emitter_1();
  int bp_i = dipole[i_a].binary_R_emitter_2();
  int bp_k = dipole[i_a].binary_R_spectator();
  //  int bpt_ai = dipole[i_a].binary_A_emitter();
  int bpt_k = dipole[i_a].binary_A_spectator();
  //  int bp_b = bp_a % 2 + 1;
  if (psi_xbs[0][bp_i + bp_k] == 0.){psi_xbs[0][bp_i + bp_k] = (psi_xbp[0][bp_i] + psi_xbp[0][bp_k]).m2();}
  double pa_p12 = 2. * (psi_xbp[0][bp_a] * (psi_xbp[0][bp_i] + psi_xbp[0][bp_k]));

  double one_minus_x_ik_a_min = 1. - sinx_ik_a_min / psi_xbs[0][0];
  double one_minus_x_ik_a = psi_xbs[0][bp_i + bp_k] / pa_p12;
  double x_ik_a = 1. - one_minus_x_ik_a;

  // multi-channel, where channel 0 reproduces the original version, and channels >0 map potential IS resonances...
  double g_x_ik_a = g_propto_pot(one_minus_x_ik_a, 0., one_minus_x_ik_a_min, psi_exp_ai_k_x, psi_map_technical_x);
  double x_ik_a_s_part = x_ik_a * psi_xbs[0][0];
  logger << LOG_DEBUG_VERBOSE << "x_ik_a_s_part = " << x_ik_a_s_part << "   sqrt -> " << sqrt(x_ik_a_s_part) << endl;
  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].g_channel.size(); i_c++){
    if (i_c == 0){
      psi_MC_x_dipole[i_a].g_channel[i_c] = g_propto_pot_mod(one_minus_x_ik_a, 0., one_minus_x_ik_a_min, psi_exp_ai_k_x, psi_map_technical_x);
    }
    else {
      if (psi_MC_x_dipole_mapping[i_a][i_c] < 0){psi_MC_x_dipole[i_a].g_channel[i_c] = psi_xbs[0][0] * psi.g_propagator_Breit_Wigner(x_ik_a_s_part, -psi_MC_x_dipole_mapping[i_a][i_c], sinx_ik_a_min, psi_xbs[0][0]);}
      logger << LOG_DEBUG_VERBOSE << "sinx_ik_a_min = " << setw(23) << setprecision(15) << sinx_ik_a_min << endl;
      logger << LOG_DEBUG_VERBOSE << "x_ik_a_s_part = " << setw(23) << setprecision(15) << x_ik_a_s_part << endl;
      logger << LOG_DEBUG_VERBOSE << "psi_xbs[0][0] = " << setw(23) << setprecision(15) << psi_xbs[0][0] << endl;
      logger << LOG_DEBUG_VERBOSE << "-psi_MC_x_dipole_mapping[i_a][i_c] = " << setw(23) << setprecision(15) << -psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel] << endl;
      logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[i_a].g_channel[i_c] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].g_channel[i_c] << endl;
      ///      else if (tau_MC_map[i_c] > 0){psi_MC_x_dipole[i_a].g_channel[i_c] = s_had * g_propagator_vanishing_width(x_ik_a_s_part, M2[tau_MC_map[i_c]], tau_0_s_had, s_had, nuxs);}
    }
  }
  g_x_ik_a = 0.;
  for (int i = 0; i < psi_MC_x_dipole[i_a].g_channel.size(); i++){
    logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].alpha[" << i << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].alpha[i] << "   " << "psi_MC_x_dipole[" << i_a << "].g_channel[" << i << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].g_channel[i] << endl;
  }
  for (int i = 0; i < psi_MC_x_dipole[i_a].g_channel.size(); i++){g_x_ik_a += psi_MC_x_dipole[i_a].alpha[i] * psi_MC_x_dipole[i_a].g_channel[i];}
  logger << LOG_DEBUG_VERBOSE << "g_x_ik_a = " << g_x_ik_a << endl;

  double u_i = (psi_xbp[0][bp_i] * psi_xbp[0][bp_a]) / (psi_xbp[0][bp_i] * psi_xbp[0][bp_a] + psi_xbp[0][bp_k] * psi_xbp[0][bp_a]);
  double one_minus_u_i = 1. - u_i;
  double g_alpha = g_x_ik_a * g_propto_pot(u_i, 0., 1., psi_exp_ai_k_u, psi_map_technical_x) / (pi * (psi_xbp[i_a][bpt_k] * psi_xbp[0][bp_a]));
  //  double g_alpha = g_propto_pot(one_minus_x_ik_a, 0., one_minus_x_ik_a_min, psi_exp_ai_k_x, psi_map_technical_x) * g_propto_pot(u_i, 0., 1., psi_exp_ai_k_u, psi_map_technical_x) / (pi * (psi_xbp[i_a][bpt_k] * psi_xbp[0][bp_a]));
  if (psi_xbs[i_a][0] == 0.){psi_xbs[i_a][0] = x_ik_a * psi_xbs[0][0];}
  if (psi_xbsqrts[i_a][0] == 0.){psi_xbsqrts[i_a][0] = sqrt(psi_xbs[i_a][0]);}
  generic.ag_psp_dipole(i_a, dipole[i_a - 1].sum_channel(), psi);
  for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){psi_MC_g_channel[i] = psi_MC_g_channel[i] * g_alpha;}
  // invert mappings for VAMP implementation
  if (psi_weight_IS == 2 || psi_weight_IS == 4){
    //  static vector<double> inv_r(3);
    vector<double> inv_r(3);
    inv_r[0] = inv_propto_pot(one_minus_x_ik_a, 0., one_minus_x_ik_a_min, psi_exp_ai_k_x, psi_map_technical_x);
    // !! extension needed if IS for x_ik_a is activated !!!
    inv_r[1] = inv_propto_pot(u_i, 0., 1., psi_exp_ai_k_u, psi_map_technical_x);
    fourvector k_perp = psi_xbp[0][bp_k] + one_minus_x_ik_a / x_ik_a * u_i * psi_xbp[i_a][bp_a];
    k_perp = -(k_perp - psi_xbp[i_a][bpt_k])/one_minus_u_i;
    fourvector temp_p_aik = psi_xbp[i_a][bp_a] + psi_xbp[i_a][bpt_k];
    fourvector temp_p_k_boost = psi_xbp[i_a][bp_a].boost(temp_p_aik);
    k_perp = (k_perp.boost(temp_p_aik)).rotateback_inverse(temp_p_k_boost);
    double phi = atan2(k_perp.x2(),k_perp.x1());
    if (phi < 0){phi += 2 * M_PI;}
    inv_r[2] = inv_phi(phi);
    if (!(inv_r[2] >= 0) || inv_r[2] > 1){
      cout << "inv_r[2] not in [0; 1] in ppeexa03_ag_psp_RA_group_ai_k !   r = " << inv_r[2] <<"; k_perp.x,y,z=" << k_perp.x1() << ", " << k_perp.x2() << ", " << k_perp.x3() << endl;
      if (!(inv_r[2] >= 0)){inv_r[2] = 0.;}
      if (inv_r[2] > 1){inv_r[2] = 1.;}
    }
    if (psi_weight_IS == 2){
      for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){
        double g_IS_temp;
        double g_IS = 1.;
        for (int j = 0; j < 3; j++){
          psi_phasespace_randoms[(i + 1) * 8 - 3 + j]->get_g_IS(inv_r[j], g_IS_temp);
          g_IS *= g_IS_temp;
        }
        psi_MC_g_channel[i] *= g_IS;
      }
    }
    else if (psi_weight_IS == 4){
      double g_IS_temp;
      double g_IS = 1.;
      for (int j = 2; j < 3; j++){ // manually switched of x and z IS
        psi_phasespace_randoms[psi_container_IS_startvalue[i_a][4 + j]]->get_g_IS(inv_r[j], g_IS_temp);
        g_IS *= g_IS_temp;
      }
      for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){psi_MC_g_channel[i] *= g_IS;}
    }
    //  cout << "reconstr " << i_a << ": " << inv_r[0] << ", " << inv_r[1] << ", " << inv_r[2] << endl;
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ac_psp_RA_group_ai_b(vector<double> & r, int channel, vector<dipole_set> & dipole, double & sinx_i_ab_min, int i_a, double & g_IS_channel, phasespace_set & psi, call_generic & generic){
  static Logger logger("ac_psp_RA_group_ai_b");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  static int xb_all_out = intpow(2, psi_n_particle + 1) - 4;
  /*
  static int no_random_1 = 3 * psi_n_particle - 4 - 2;
  static int no_random_2 = 3 * psi_n_particle - 4 - 1;
  static int no_random_3 = 3 * psi_n_particle - 4;
  */
  double g_IS_temp;
  if (psi_weight_IS == 3 || psi_weight_IS == 4){
    for (int j = 2; j < 3; j++){ // manually switched of x and z IS
      if (psi_container_IS_switch[psi_container_IS_startvalue[i_a][4 + j]] == 1){psi_phasespace_randoms[psi_container_IS_startvalue[i_a][4 + j]]->get_random(r[psi_no_random_dipole[j]], g_IS_temp);}
      g_IS_channel *= g_IS_temp;
    }
  }
  int bp_a = dipole[i_a].binary_R_emitter_1();
  int bp_i = dipole[i_a].binary_R_emitter_2();
  int bp_b = dipole[i_a].binary_R_spectator();
  //  int bpt_ai = dipole[i_a].binary_A_emitter(); // always bpt_ai == bp_a
  //  int bpt_b = dipole[i_a].binary_A_spectator(); // always bpt_b == bp_b


  /*
  double one_minus_x_i_ab_min = 1. - sinx_i_ab_min / psi_xbs[0][0];
  double one_minus_x_i_ab = h_propto_pot_mod(r[psi_no_random_dipole[0]], 0., one_minus_x_i_ab_min, psi_exp_ai_b_x, psi_map_technical_x);
  double x_i_ab = 1. - one_minus_x_i_ab;
  */
  // multi-channel, where channel 0 reproduces the original version, and channels >0 map potential IS resonances...
  double one_minus_x_i_ab_min = 1. - sinx_i_ab_min / psi_xbs[0][0];
  double x_i_ab = 1.;
  double one_minus_x_i_ab = 0.;
  // random_MC_tau[1] -> increase number in calculate_intial_tau_IS_x1x2_IS !!!
  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].beta.size(); i_c++){
    logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].beta[" << i_c << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].beta[i_c] << endl;
  }
  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].beta.size(); i_c++){if (psi_random_MC_tau[1] <= psi_MC_x_dipole[i_a].beta[i_c]){psi_MC_x_dipole[i_a].channel = i_c; break;}}
  logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].channel = " << psi_MC_x_dipole[i_a].channel << endl;

  if (psi_MC_x_dipole[i_a].channel == 0){
    one_minus_x_i_ab = h_propto_pot_mod(r[psi_no_random_dipole[0]], 0., one_minus_x_i_ab_min, psi_exp_ai_b_x, psi_map_technical_x);
    x_i_ab = 1. - one_minus_x_i_ab;
    //    one_minus_x_ik_a = h_propto_pot(r[psi_no_random_dipole[0]], 0., one_minus_x_ik_a_min, psi_exp_ai_k_x, psi_map_technical_x);
    ////////////////////7    x_ik_a = 1. - one_minus_x_ik_a;
  }
  else {
    if (psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel] < 0){
      //      double sinx_i_ab_min_s_part = sinx_i_ab_min / psi_xbs[0][0];
      //      x_pdf[0]
      x_i_ab = psi.c_propagator_Breit_Wigner(r[psi_no_random_dipole[0]], -psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel], sinx_i_ab_min, psi_xbs[0][0]) / psi_xbs[0][0];
      one_minus_x_i_ab = 1. - x_i_ab;
      logger << LOG_DEBUG_VERBOSE << "s_dipole = " << setw(23) << setprecision(15) << sqrt(x_i_ab * psi_xbs[0][0]) << "   " << "x_i_ab = " << setw(23) << setprecision(15) << x_i_ab << "   " << "psi_xbs[0][0] = " << setw(23) << setprecision(15) << psi_xbs[0][0] << endl;
    }
  }
  logger << LOG_DEBUG_VERBOSE << "x_i_ab = " << x_i_ab << endl;
  logger << LOG_DEBUG_VERBOSE << "one_minus_x_i_ab = " << one_minus_x_i_ab << endl;

  if (x_i_ab != x_i_ab){logger << LOG_DEBUG_VERBOSE << "x_i_ab = " << x_i_ab << endl;}
  psi_xbp[i_a][bp_a] = x_i_ab * psi_xbp[0][bp_a];
  psi_xbp[i_a][bp_b] = psi_xbp[0][bp_b];
  psi_xbp[i_a][0] = psi_xbp[i_a][bp_a] + psi_xbp[i_a][bp_b];
  psi_xbs[i_a][0] = x_i_ab * psi_xbs[0][0];
  psi_xbsqrts[i_a][0] = sqrt(psi_xbs[i_a][0]);
  psi_xbp[i_a][xb_all_out] = psi_xbp[i_a][0];
  psi_xbs[i_a][xb_all_out] = psi_xbs[i_a][0];
  psi_xbsqrts[i_a][xb_all_out] = psi_xbsqrts[i_a][0];
  fourvector temp_p_aib = psi_xbp[i_a][bp_a] + psi_xbp[i_a][bp_b];
  fourvector temp_p_a_boost = psi_xbp[i_a][bp_a].boost(temp_p_aib);
  double sqrt_p2_aib = temp_p_aib.m();
  double v_i = h_propto_pot_mod(r[psi_no_random_dipole[1]], 0., one_minus_x_i_ab, psi_exp_ai_b_v, psi_map_technical_x);
logger << LOG_DEBUG_VERBOSE << "v_i = " << v_i << endl;
  if (v_i != v_i){logger << LOG_DEBUG_VERBOSE << "v_i = " << v_i << endl;}
  double one_minus_v_i = 1. - v_i;
  logger << LOG_DEBUG_VERBOSE << "psi_no_random_dipole[2] = " << psi_no_random_dipole[2] << endl;
  logger << LOG_DEBUG_VERBOSE << "r[psi_no_random_dipole[2]] = " << r[psi_no_random_dipole[2]] << endl;
  double phi_k_perp = c_phi(r[psi_no_random_dipole[2]]);
  logger << LOG_DEBUG_VERBOSE << "phi_k_perp = " << phi_k_perp << endl;
  if (phi_k_perp != phi_k_perp){logger << LOG_DEBUG_VERBOSE << "phi_k_perp = " << phi_k_perp << endl;}
  double f2 = v_i * (one_minus_x_i_ab - v_i) / x_i_ab;
  double f = sqrt(f2);
  fourvector khat_perp(0., f * sqrt_p2_aib * cos(phi_k_perp), f * sqrt_p2_aib * sin(phi_k_perp), 0.);
  fourvector k_perp = (khat_perp.rotateback(temp_p_a_boost)).boost(temp_p_aib.Pinv());
  fourvector K = (x_i_ab + v_i) / x_i_ab * psi_xbp[i_a][bp_a] + one_minus_v_i * psi_xbp[i_a][bp_b] - k_perp;
  if (K != K){logger << LOG_DEBUG_VERBOSE << "K = " << K << endl;}
  fourvector Kt = psi_xbp[i_a][bp_a] + psi_xbp[i_a][bp_b];
  if (Kt != Kt){logger << LOG_DEBUG_VERBOSE << "Kt = " << Kt << endl;}
  fourvector KKt = K + Kt;
  psi_xbp[0][bp_i] = v_i * psi_xbp[i_a][bp_b] + (one_minus_x_i_ab - v_i) / x_i_ab * psi_xbp[i_a][bp_a] + k_perp;
  psi_xbp[0][bp_a] = psi_xbp[i_a][bp_a] / x_i_ab;
  psi_xbp[0][bp_b] = psi_xbp[i_a][bp_b];
  
  logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << bp_a << "] = " << psi_xbp[i_a][bp_a] << endl;
  logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << bp_b << "] = " << psi_xbp[i_a][bp_b] << endl;
  for (int xbi = 4; xbi < psi_xbp[i_a].size(); xbi = xbi * 2){
    logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << xbi << "] = " << psi_xbp[i_a][xbi] << endl;
  }
  logger << LOG_DEBUG_VERBOSE << "xb_all_out = " << xb_all_out << endl;
  logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << xb_all_out << "] = " << psi_xbp[i_a][xb_all_out] << endl;
  logger << LOG_DEBUG_VERBOSE << "psi_xbs[" << i_a << "][" << xb_all_out << "] = " << psi_xbs[i_a][xb_all_out] << endl;
  
  generic.ac_psp_dipole(i_a, channel - dipole[i_a - 1].sum_channel(), psi);
  /*
  logger << LOG_DEBUG_VERBOSE << "channel - dipole[" << i_a - 1 << "].sum_channel() = " << channel - dipole[i_a - 1].sum_channel() << endl;
  logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << bp_a << "] = " << psi_xbp[i_a][bp_a] << endl;
  logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << bp_b << "] = " << psi_xbp[i_a][bp_b] << endl;
  for (int xbi = 4; xbi < psi_xbp[i_a].size(); xbi = xbi * 2){
    logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << xbi << "] = " << psi_xbp[i_a][xbi] << endl;
  }
  */
  double prod_em_sp = psi_xbp[i_a][bp_a] * psi_xbp[i_a][bp_b];
  logger << LOG_DEBUG_VERBOSE << "prod_em_sp = " << prod_em_sp << endl;
  for (int xbi = 4; xbi < psi_xbp[0].size(); xbi = xbi * 2){
    if      (xbi == bp_i){}
    else {
      int temp_xbi = 0;
      if      (xbi < bp_i){temp_xbi = xbi;}
      else if (xbi > bp_i){temp_xbi = xbi / 2;}
      double prod_em_xbi = psi_xbp[i_a][temp_xbi] * psi_xbp[i_a][bp_a];
      logger << LOG_DEBUG_VERBOSE << "prod_em_xbi = " << prod_em_xbi << endl;
      double prod_sp_xbi = psi_xbp[i_a][temp_xbi] * psi_xbp[i_a][bp_b];
      logger << LOG_DEBUG_VERBOSE << "prod_sp_xbi = " << prod_sp_xbi << endl;
      double prod_perp_xbi = psi_xbp[i_a][temp_xbi] * k_perp;
      logger << LOG_DEBUG_VERBOSE << "prod_perp_xbi = " << prod_perp_xbi << endl;
      psi_xbp[0][xbi] = psi_xbp[i_a][temp_xbi]
        - ((2. * x_i_ab + v_i) * prod_em_xbi + (2. - v_i) * x_i_ab * prod_sp_xbi - x_i_ab * prod_perp_xbi) / ((4. * x_i_ab + v_i - x_i_ab * v_i) * prod_em_sp) * KKt
        + (prod_em_xbi + prod_sp_xbi) / prod_em_sp * K;
      logger << LOG_DEBUG_VERBOSE << "xbp_all[0][xbi] = " << psi_xbp[0][xbi] << endl;

      if (psi_xbp[0][xbi]  != psi_xbp[0][xbi]){
	logger << LOG_DEBUG_VERBOSE << "psi_i_acc = " << psi_i_acc << "   xbi = " << xbi << "   psi_xbp[" << i_a << "][" << temp_xbi << "] = " << psi_xbp[i_a][temp_xbi] << endl;
	logger << LOG_DEBUG_VERBOSE << "K = " << K << endl;
	logger << LOG_DEBUG_VERBOSE << "Kt = " << Kt << endl;
	logger << LOG_DEBUG_VERBOSE << "x_i_ab = " << x_i_ab << endl;
	logger << LOG_DEBUG_VERBOSE << "v_i = " << v_i << endl;
	logger << LOG_DEBUG_VERBOSE << "phi_k_perp = " << phi_k_perp << endl;
	logger << LOG_DEBUG_VERBOSE << "prod_em_sp = " << prod_em_sp << endl;
	logger << LOG_DEBUG_VERBOSE << "prod_em_xbi = " << prod_em_xbi << endl;
	logger << LOG_DEBUG_VERBOSE << "prod_sp_xbi = " << prod_sp_xbi << endl;
	logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << bp_a << "] = " << psi_xbp[i_a][bp_a] << endl;
	logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << bp_b << "] = " << psi_xbp[i_a][bp_b] << endl;
	logger << LOG_DEBUG_VERBOSE << "psi_xbp[" << i_a << "][" << temp_xbi << "] = " << psi_xbp[i_a][temp_xbi] << endl;
	//	exit(1);
	/*
	logger << LOG_DEBUG_VERBOSE << "1st line: " << psi_xbp[i_a][temp_xbi] << endl;
	logger << LOG_DEBUG_VERBOSE << "2nd line: " << - ((2. * x_i_ab + v_i) * prod_em_xbi + (2. - v_i) * x_i_ab * prod_sp_xbi - x_i_ab * prod_perp_xbi) / ((4. * x_i_ab + v_i - x_i_ab * v_i) * prod_em_sp) * KKt << endl;
	logger << LOG_DEBUG_VERBOSE << "3rd line: " << + (prod_em_xbi + prod_sp_xbi) / prod_em_sp * K << endl;
	*/
     }
    }
  }
  for (int xbi = 4; xbi < psi_xbp_all[0].size(); xbi = xbi * 2){
    logger << LOG_DEBUG_VERBOSE << "xbp_all[" << 0 << "][" << xbi << "] = " << psi_xbp_all[0][xbi] << endl;
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ag_psp_RA_group_ai_b(double & sinx_i_ab_min, vector<dipole_set> & dipole, int i_a, phasespace_set & psi, call_generic & generic){
  static Logger logger("ag_psp_RA_group_ai_b");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  //  static int xb_all_out = intpow(2, psi_n_particle + 1) - 4;
  int bp_a = dipole[i_a].binary_R_emitter_1();
  int bp_i = dipole[i_a].binary_R_emitter_2();
  int bp_b = dipole[i_a].binary_R_spectator();
  //  int bpt_ai = dipole[i_a].binary_A_emitter(); // always bpt_ai == bp_a
  //  int bpt_b = dipole[i_a].binary_A_spectator(); // always bpt_b == bp_b



  /*
  double one_minus_x_i_ab_min = 1. - sinx_i_ab_min / psi_xbs[0][0];
  double one_minus_x_i_ab = 2 * psi_xbp[0][bp_i].x0() / psi_xbsqrts[0][0];
  double x_i_ab = 1. - one_minus_x_i_ab;
  double g_x_i_ab = g_propto_pot_mod(one_minus_x_i_ab, 0., one_minus_x_i_ab_min, psi_exp_ai_b_x, psi_map_technical_x)
  */
  double one_minus_x_i_ab_min = 1. - sinx_i_ab_min / psi_xbs[0][0];
  double one_minus_x_i_ab = 2 * psi_xbp[0][bp_i].x0() / psi_xbsqrts[0][0];
  double x_i_ab = 1. - one_minus_x_i_ab;
  double g_x_i_ab;
  double x_i_ab_s_part = x_i_ab * psi_xbs[0][0];






  
  logger << LOG_DEBUG_VERBOSE << "x_i_ab_s_part = " << x_i_ab_s_part << "   sqrt -> " << sqrt(x_i_ab_s_part) << endl;

  for (int i_c = 0; i_c < psi_MC_x_dipole[i_a].g_channel.size(); i_c++){
    if (i_c == 0){
      psi_MC_x_dipole[i_a].g_channel[i_c] = g_propto_pot_mod(one_minus_x_i_ab, 0., one_minus_x_i_ab_min, psi_exp_ai_b_x, psi_map_technical_x);
    }
    else {
      if (psi_MC_x_dipole_mapping[i_a][i_c] < 0){psi_MC_x_dipole[i_a].g_channel[i_c] = psi_xbs[0][0] * psi.g_propagator_Breit_Wigner(x_i_ab_s_part, -psi_MC_x_dipole_mapping[i_a][i_c], sinx_i_ab_min, psi_xbs[0][0]);}
      logger << LOG_DEBUG_VERBOSE << "sinx_i_ab_min = " << setw(23) << setprecision(15) << sinx_i_ab_min << endl;
      logger << LOG_DEBUG_VERBOSE << "x_i_ab_s_part = " << setw(23) << setprecision(15) << x_i_ab_s_part << endl;
      logger << LOG_DEBUG_VERBOSE << "psi_xbs[0][0] = " << setw(23) << setprecision(15) << psi_xbs[0][0] << endl;
      logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole_mapping.size() = " << psi_MC_x_dipole_mapping.size() << endl;
      logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole_mapping[" << i_a << "].size() = " << psi_MC_x_dipole_mapping[i_a].size() << endl;
      logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole.size() = " << psi_MC_x_dipole.size() << endl;
      //      logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].channel = " << psi_MC_x_dipole[i_a].channel << endl;
      //      logger << LOG_DEBUG_VERBOSE << "-psi_MC_x_dipole_mapping[i_a][i_c] = " << setw(23) << setprecision(15) << -psi_MC_x_dipole_mapping[i_a][psi_MC_x_dipole[i_a].channel] << endl;
      //      logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[i_a].g_channel[i_c] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].g_channel[i_c] << endl;
      ///      else if (tau_MC_map[i_c] > 0){psi_MC_x_dipole[i_a].g_channel[i_c] = s_had * g_propagator_vanishing_width(x_i_ab_s_part, M2[tau_MC_map[i_c]], tau_0_s_had, s_had, nuxs);}
    }
  }
  g_x_i_ab = 0.;
  for (int i = 0; i < psi_MC_x_dipole[i_a].g_channel.size(); i++){
    logger << LOG_DEBUG_VERBOSE << "psi_MC_x_dipole[" << i_a << "].alpha[" << i << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].alpha[i] << "   " << "psi_MC_x_dipole[" << i_a << "].g_channel[" << i << "] = " << setw(23) << setprecision(15) << psi_MC_x_dipole[i_a].g_channel[i] << endl;
  }
  for (int i = 0; i < psi_MC_x_dipole[i_a].g_channel.size(); i++){g_x_i_ab += psi_MC_x_dipole[i_a].alpha[i] * psi_MC_x_dipole[i_a].g_channel[i];}
  logger << LOG_DEBUG_VERBOSE << "g_x_i_ab = " << g_x_i_ab << endl;



  double v_i = (psi_xbp[0][bp_i] * psi_xbp[0][bp_a]) / (psi_xbp[0][bp_b] * psi_xbp[0][bp_a]);
  double g_alpha = g_x_i_ab * g_propto_pot_mod(v_i, 0., one_minus_x_i_ab, psi_exp_ai_b_v, psi_map_technical_x) / (pi * (psi_xbp[0][bp_b] * psi_xbp[0][bp_a]));
  //  double g_alpha = g_propto_pot_mod(one_minus_x_i_ab, 0., one_minus_x_i_ab_min, psi_exp_ai_b_x, psi_map_technical_x) * g_propto_pot_mod(v_i, 0., one_minus_x_i_ab, psi_exp_ai_b_v, psi_map_technical_x) / (pi * (psi_xbp[0][bp_b] * psi_xbp[0][bp_a]));
  if (psi_xbs[i_a][0] == 0.){psi_xbs[i_a][0] = x_i_ab * psi_xbs[0][0];}
  if (psi_xbsqrts[i_a][0] == 0.){psi_xbsqrts[i_a][0] = sqrt(psi_xbs[i_a][0]);}
  generic.ag_psp_dipole(i_a, dipole[i_a - 1].sum_channel(), psi);

  for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){psi_MC_g_channel[i] = psi_MC_g_channel[i] * g_alpha;}
  // invert mappings for VAMP implementation
  if (psi_weight_IS == 2 || psi_weight_IS == 4){
    //  static vector<double> inv_r(3);
    vector<double> inv_r(3);
    inv_r[0] = inv_propto_pot(one_minus_x_i_ab, 0., one_minus_x_i_ab_min, psi_exp_ai_b_x, psi_map_technical_x);
    inv_r[1] = inv_propto_pot(v_i, 0., one_minus_x_i_ab, psi_exp_ai_b_v, psi_map_technical_x);
    fourvector k_perp = psi_xbp[0][bp_i] - v_i * psi_xbp[i_a][bp_b] + (one_minus_x_i_ab - v_i) / x_i_ab * psi_xbp[i_a][bp_a];
    fourvector temp_p_aib = psi_xbp[i_a][bp_a] + psi_xbp[i_a][bp_b];
    fourvector temp_p_a_boost = psi_xbp[i_a][bp_a].boost(temp_p_aib);
    k_perp = (k_perp.boost(temp_p_aib)).rotateback_inverse(temp_p_a_boost);
    double phi = atan2(k_perp.x2(),k_perp.x1());
    if (phi < 0){phi += 2 * M_PI;}
    inv_r[2] = inv_phi(phi);
    if (!(inv_r[2] >= 0) || inv_r[2] > 1){
      cout << "inv_r[2] not in [0; 1] in ppeexa03_ag_psp_RA_group_ai_b !   r = " << inv_r[2] <<"; k_perp.x,y,z=" << k_perp.x1() << ", " << k_perp.x2() << ", " << k_perp.x3() << endl;
      if (!(inv_r[2] >= 0)){inv_r[2] = 0.;}
      if (inv_r[2] > 1){inv_r[2] = 1.;}
    }
    if (psi_weight_IS == 2){
      for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){
        double g_IS_temp;
        double g_IS = 1.;
        for (int j = 0; j < 3; j++){
          psi_phasespace_randoms[(i + 1) * 8 - 3 + j]->get_g_IS(inv_r[j], g_IS_temp);
          g_IS *= g_IS_temp;
        }
        psi_MC_g_channel[i] *= g_IS;
      }
    }
    else if (psi_weight_IS == 4){
      double g_IS_temp;
      double g_IS = 1.;
      for (int j = 2; j < 3; j++){ // manually switched of x and z IS
        psi_phasespace_randoms[psi_container_IS_startvalue[i_a][4 + j]]->get_g_IS(inv_r[j], g_IS_temp);
        g_IS *= g_IS_temp;
      }
      for (int i = dipole[i_a - 1].sum_channel(); i < dipole[i_a].sum_channel(); i++){psi_MC_g_channel[i] *= g_IS;}
     }
    //  cout << "reconstr " << i_a << ": " << inv_r[0] << ", " << inv_r[1] << ", " << inv_r[2] << endl;
  }
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
