#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../include/definitions.observable.set.cxx"
void munich::integration_CA_QCD(){
  static Logger logger("munich::integration_CA_QCD");
  logger << LOG_INFO << "called" << endl;

  //  osi.CA_dipole_splitting.resize(4, vector<int> (3, 0));

  psi.initialization_phasespace_born();

  generic.determination_subprocess_psp(0, psi);
  generic.combination_subprocess_psp(0, psi, osi);

  generic.ax_psp_psp(0, psi);
  psi_MC_n_channel = generic.determination_MCchannels_psp(0, psi);
  psi.initialization_mapping_parameter(isi);
  psi.initialization_minimum_tau(isi);
  psi.initialization_minimum_phasespacecut(isi);
  psi.initialization_optimization(isi);
  psi.initialization_filename(isi);

  // generation of optimized xbs limits (including invariant-mass cuts)
  psi.initialization_phasespace_subprocess();
  generic.optimize_minv_psp(psi);
  psi.initialization_phasespace_subprocess_optimization();

  // generation of MC_tau mappings
  generic.ac_tau_psp_psp(0, psi_tau_MC_map, psi);
  if (psi_type_contribution == "RCA"){initialization_fake_dipole_mapping_RT(psi, generic);}
  psi.initialization_phasespace_MC_tau();

  psi.initialization_phasespace_IS();
  psi.initialization_phasespace_IS_CA();
  psi.initialization_MC();

  osi.CA_collinear = &collinear;
  osi.determine_collinear_QCD(psi);

  osi.initialization_CA();
  osi.perform_selection_content_pdf_collinear();

  osi.initialization_TSV();
  osi.initialization_CV();
  osi.initialization_runtime_partonlevel();
  osi.initialization_distribution();
  osi.initialization_integration(psi);

  observable_set save_osi = osi;
  phasespace_set save_psi = psi;
  runresumption_set rsi(osi, psi, save_osi, save_psi);
  
  osi.initialization_LHAPDF();
  osi.initialization_OpenLoops_process(psi);
  generic.phasespacepoint_psp(osi);
  perform_event_selection(osi, generic);
  generic.calculate_dynamic_scale_TSV(0, osi);
  calculate_ME2check_CA_QCD(osi, psi); // some issue in TSV if two variations are based on the same dynnamic scale needs to be solved !!!

  if (psi_n_events_max == 0){osi.int_end = 1;}
  if (osi.user.int_value[osi.user.int_map["rescaling_exponent"]] != 0){psi_hcf = psi_hcf * pow(osi.user.double_value[osi.user.double_map["rescaling_factor"]], osi.user.int_value[osi.user.int_map["rescaling_exponent"]]);}

  if (osi.int_end){osi.output_zero_contribution_complete(psi);}
  osi.initialization_runtime();
  while (osi.int_end == 0){
    psi.calculate_IS();
    generic.ac_psp_psp(0, psi_MC_channel, psi);
    osi.determine_p_parton(psi);
    // replace by proper nan-check !!!
    if (osi.p_parton[0] != osi.p_parton[0]){errorhandling_c_psp(); continue;}
    perform_event_selection(osi, generic);
    if (osi.cut_ps[0] == -1){psi.handling_cut_psp(); continue;}

    if (osi.switch_console_output_tau_0){psi.output_check_tau_0();}
    if (psi_i_acc == psi_n_events_max){osi.int_end = 1;}
    psi.calculate_intial_collinear_z1z2_IS();
    osi.z_coll = psi_z_coll;
    if (osi.switch_output_testpoint){osi.output_testpoint(psi);}
    generic.ag_psp_psp(0, 0, psi);
    psi.calculate_g_tot();
    if (std::isnan(psi_g_tot) || std::isinf(psi_g_tot)){errorhandling_gtot(); continue;} 
    //    if (psi_g_tot != psi_g_tot){errorhandling_gtot(); continue;}

    calculate_ME2_CA_QCD(osi);

    // replace by proper nan-check !!!
    if (osi.CA_ME2_cf != osi.CA_ME2_cf){errorhandling_collinear_me2(); continue;}
    if (std::isinf(psi_g_tot)){psi.handling_cut_psp(); continue;}

    //    psi_i_acc++; // strange position of psi_i_acc++ !!!

    generic.calculate_dynamic_scale(0, osi);
    generic.calculate_dynamic_scale_TSV(0, osi);
    osi.determine_scale();
    osi.determine_scale_CA();

    if (osi.switch_moment){generic.moments(osi);}

    osi.calculate_pdf_LHAPDF_CA_collinear_CV(psi_all_xz_coll_pdf);
    if (osi.switch_TSV){osi.calculate_pdf_LHAPDF_CA_collinear_TSV(psi_all_xz_coll_pdf);}
    //    calculate_pdf_LHAPDF_CA_collinear_CV(psi_all_xz_coll_pdf, osi);
    //    if (osi.switch_TSV){calculate_pdf_LHAPDF_CA_collinear_TSV(psi_all_xz_coll_pdf, osi);}
    osi.calculate_collinear_QCD();
    osi.determine_integrand_CA(psi);
    if (osi.switch_output_maxevent){osi.output_integrand_maximum_CA(psi);}
    if (std::isnan(osi.integrand)){errorhandling_collinear_me2(); continue;}
    osi.determine_psp_weight_TSV(psi);
    osi.determine_psp_weight();
    if (osi.switch_distribution){determine_distribution_complete(osi);}
    static double optimization_modifier = 1.;
    if (osi.user.switch_value[osi.user.switch_map["optimization_modifier"]]){
      optimization_modifier = pow(osi.particle_event[osi.access_object["Vrec"]][0][0].pT, osi.user.switch_value[osi.user.switch_map["optimization_modifier"]]);
      logger << LOG_DEBUG << "optimization_modifier = " << optimization_modifier << endl;
    }   

    psi.psp_MCweight_optimization(osi.integrand, osi.this_psp_weight, osi.this_psp_weight2, optimization_modifier);
    psi.psp_MCweight_optimization_CA(osi.integrand, osi.this_psp_weight, osi.this_psp_weight2);
    psi_i_acc++; // actual position of psi_i_acc++ !!!
    if (psi_i_acc % psi_n_step == 0){rsi.perform_iteration_step();}
    osi.determine_runtime(psi);
  }
  osi.output_finalization_integration(psi);
}
