#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../include/definitions.observable.set.cxx"
void munich::integration_VA_QCD(){
  static Logger logger("munich::integration_VA_QCD");
  logger << LOG_INFO << "called" << endl;

  psi.initialization_phasespace_born();

  generic.determination_subprocess_psp(0, psi);
  generic.combination_subprocess_psp(0, psi, osi);

  //  osi.perform_selection_content_pdf(); // strange position - shift ???

  generic.ax_psp_psp(0, psi);
  psi_MC_n_channel = generic.determination_MCchannels_psp(0, psi);

  // Check if standard VA runs are affected !!!
  //  QCD_selection_phasespace_singularity(psi_RA_singular_region, psi_RA_singular_region_name, psi_RA_singular_region_list, psi);

  psi.initialization_mapping_parameter(isi);
  psi.initialization_minimum_tau(isi);
  psi.initialization_minimum_phasespacecut(isi);
  psi.initialization_optimization(isi);
  psi.initialization_filename(isi);

  // generation of optimized xbs limits (including invariant-mass cuts)
  psi.initialization_phasespace_subprocess();
  generic.optimize_minv_psp(psi);
  psi.initialization_phasespace_subprocess_optimization();

  // generation of MC_tau mappings
  generic.ac_tau_psp_psp(0, psi_tau_MC_map, psi);
  if (psi_type_contribution == "RVA"){initialization_fake_dipole_mapping_RT(psi, generic);}
  psi.initialization_phasespace_MC_tau();

  psi.initialization_phasespace_IS();
  psi.initialization_MC();

  osi.VA_ioperator =& ioperator; // would be the natural position !!!
  osi.determine_ioperator_QCD(psi);

  osi.initialization_VA();
  osi.perform_selection_content_pdf(); // would be the natural position !!!

  osi.initialization_TSV();
  osi.initialization_CV();
  osi.initialization_runtime_partonlevel();
  osi.initialization_distribution();
  osi.initialization_integration(psi);

  observable_set save_osi = osi;
  phasespace_set save_psi = psi;
  runresumption_set rsi(osi, psi, save_osi, save_psi);

  osi.initialization_LHAPDF();
  osi.initialization_OpenLoops_process(psi);
  generic.phasespacepoint_psp(osi);
  calculate_ME2check_VA_QCD(osi);

  if (psi_n_events_max == 0){osi.int_end = 1;}
  if (osi.user.int_value[osi.user.int_map["rescaling_exponent"]] != 0){psi_hcf = psi_hcf * pow(osi.user.double_value[osi.user.double_map["rescaling_factor"]], osi.user.int_value[osi.user.int_map["rescaling_exponent"]]);}

  if (osi.int_end){osi.output_zero_contribution_complete(psi);}
  osi.initialization_runtime();
  while (osi.int_end == 0){
    psi.calculate_IS();
    generic.ac_psp_psp(0, psi_MC_channel, psi);
    osi.determine_p_parton(psi);
    // replace by proper nan-check !!!
    if (osi.p_parton[0] != osi.p_parton[0]){errorhandling_c_psp(); continue;}
    perform_event_selection(osi, generic);
    logger << LOG_DEBUG_VERBOSE << "psi_i_gen = " << psi_i_gen << "   psi_i_acc = " << psi_i_acc << "   psi_i_rej = " << psi_i_rej << "   osi.cut_ps[0] = " << osi.cut_ps[0] << endl;
    if (osi.cut_ps[0] == -1){psi.handling_cut_psp(); continue;}

    if (osi.switch_console_output_tau_0){psi.output_check_tau_0();}
    if (psi_i_acc == psi_n_events_max){osi.int_end = 1;}
    generic.ag_psp_psp(0, 0, psi);
    psi.calculate_g_tot();
    if (std::isnan(psi_g_tot) || std::isinf(psi_g_tot)){errorhandling_gtot(); continue;} // isinf case ???

    generic.calculate_dynamic_scale(0, osi);
    generic.calculate_dynamic_scale_TSV(0, osi);
    osi.determine_scale();

    // to avoid issues with COLLIER in phase-space divergent integration
    /*
    bool temp_cut_technical = false;
    for (int sr = 0; sr < psi_RA_singular_region_list.size(); sr++){
      int x1 = psi_RA_singular_region_list[sr][0];
      int x2 = psi_RA_singular_region_list[sr][1];
      psi_RA_singular_region[x1][x2] = osi.p_parton[0][x1] * osi.p_parton[0][x2] / psi_xbs_all[0][0];
      logger << LOG_DEBUG_VERBOSE << "psi_i_gen = " << psi_i_gen << "   psi_i_acc = " << psi_i_acc << "   psi_i_rej = " << psi_i_rej << "    psi_RA_singular_region[" << x1 << "][" << x2 << "] = " << psi_RA_singular_region[x1][x2] << "   psi_cut_technical = " << psi_cut_technical << endl;
      if (psi_RA_singular_region[x1][x2] < psi_cut_technical){temp_cut_technical = true;}
    }
    if (temp_cut_technical){errorhandling_cut_technical(); continue;}
    */

    calculate_ME2_VA_QCD(osi);

    if (std::isnan(osi.VA_V_ME2) || std::isnan(osi.VA_X_ME2) || std::isnan(osi.VA_I_ME2)){errorhandling_me2(); continue;}
    if (osi.type_contribution == "RVA"){osi.counter_acc_qTcut[osi.cut_ps[0]]++;}
    if (osi.VA_V_ME2 == 0. && osi.switch_VI != 2){errorhandling_OL(); continue;} // maybe better error output in case of RVA contribution !!!

    if (osi.switch_moment){generic.moments(osi);}

    osi.calculate_pdf_LHAPDF_CV();
    osi.calculate_pdf_LHAPDF_TSV();

    osi.determine_integrand_VA(psi);
    osi.determine_psp_weight_TSV(psi);
    osi.determine_psp_weight();
    if (osi.switch_output_maxevent){osi.output_integrand_maximum_VA(psi);}
    if (osi.switch_distribution){determine_distribution_complete(osi);}
    static double optimization_modifier = 1.;
    if (osi.user.switch_value[osi.user.switch_map["optimization_modifier"]]){
      optimization_modifier = pow(osi.particle_event[osi.access_object["Vrec"]][0][0].pT, osi.user.switch_value[osi.user.switch_map["optimization_modifier"]]);
      logger << LOG_DEBUG << "optimization_modifier = " << optimization_modifier << endl;
    }   

    psi.psp_MCweight_optimization(osi.integrand, osi.this_psp_weight, osi.this_psp_weight2, optimization_modifier);
    psi_i_acc++;
    logger << LOG_DEBUG_VERBOSE << "psi_i_gen = " << psi_i_gen << "   psi_i_acc = " << psi_i_acc << "   psi_i_rej = " << psi_i_rej << "   osi.VA_V_ME2 = " << osi.VA_V_ME2 << endl;
    if (psi_i_acc % psi_n_step == 0){rsi.perform_iteration_step();}
    osi.determine_runtime(psi);
  }
  osi.output_finalization_integration(psi);
}
