#pragma once

#include <vector>

using namespace std;

#include "../../classes/header/fourvector.h"
#include "../../classes/header/particle.h"

extern "C" {
	extern struct{
	        double A1UV_in[50],A2UV_in[50],A3UV_in[50],A4UV_in[50],A5UV_in[50],A6UV_in[50],A7UV_in[50],A8UV_in[50],A1DV_in[50],A2DV_in[50],A3DV_in[50],A4DV_in[50],A5DV_in[50],A6DV_in[50],A7DV_in[50],A8DV_in[50],A1US_in[50],A2US_in[50],A3US_in[50],A4US_in[50],A5US_in[50],A6US_in[50],A7US_in[50],A8US_in[50],A1DS_in[50],A2DS_in[50],A3DS_in[50],A4DS_in[50],A5DS_in[50],A6DS_in[50],A7DS_in[50],A8DS_in[50],A1SS_in[50],A2SS_in[50],A3SS_in[50],A4SS_in[50],A5SS_in[50],A6SS_in[50],A7SS_in[50],A8SS_in[50],A1GL_in[50],A2GL_in[50],A3GL_in[50],A4GL_in[50],A5GL_in[50],A6GL_in[50],A7GL_in[50],A8GL_in[50],A1CH_in[50],A2CH_in[50],A3CH_in[50],A4CH_in[50],A5CH_in[50],A6CH_in[50],A7CH_in[50],A8CH_in[50],A1BO_in[50],A2BO_in[50],A3BO_in[50],A4BO_in[50],A5BO_in[50],A6BO_in[50],A7BO_in[50],A8BO_in[50],A1UVp_in[50],A2UVp_in[50],A3UVp_in[50],A4UVp_in[50],A5UVp_in[50],A6UVp_in[50],A7UVp_in[50],A8UVp_in[50],A1DVp_in[50],A2DVp_in[50],A3DVp_in[50],A4DVp_in[50],A5DVp_in[50],A6DVp_in[50],A7DVp_in[50],A8DVp_in[50],A1USp_in[50],A2USp_in[50],A3USp_in[50],A4USp_in[50],A5USp_in[50],A6USp_in[50],A7USp_in[50],A8USp_in[50],A1DSp_in[50],A2DSp_in[50],A3DSp_in[50],A4DSp_in[50],A5DSp_in[50],A6DSp_in[50],A7DSp_in[50],A8DSp_in[50],A1SSp_in[50],A2SSp_in[50],A3SSp_in[50],A4SSp_in[50],A5SSp_in[50],A6SSp_in[50],A7SSp_in[50],A8SSp_in[50],A1GLp_in[50],A2GLp_in[50],A3GLp_in[50],A4GLp_in[50],A5GLp_in[50],A6GLp_in[50],A7GLp_in[50],A8GLp_in[50],A1CHp_in[50],A2CHp_in[50],A3CHp_in[50],A4CHp_in[50],A5CHp_in[50],A6CHp_in[50],A7CHp_in[50],A8CHp_in[50],A1BOp_in[50],A2BOp_in[50],A3BOp_in[50],A4BOp_in[50],A5BOp_in[50],A6BOp_in[50],A7BOp_in[50],A8BOp_in[50];
	} pdfmellin_;
}

extern "C" {
	extern struct{
		int verbose_mode;
	} handling_params_;
}

extern "C" {
	extern struct{
		unsigned char name[63];
		int member,ih1,ih2;
	} pdfhres_;
}

extern "C" {
	extern struct{
		int resorder,pertorder,approxNNLL;
	} resorder_;
}

extern "C" {
	extern struct{
		int gg_initiated,channel,pdf_content_modify;
	} resumchan_;
}

extern "C" {
	extern struct{
		int nf;
	} nf_;
}

extern "C" {
	extern struct{
		double pcf,kcf;
	} lopowers_;
}

extern "C" {
	extern struct{
	        int doinitres,use_preset_PDFfit;
	} flaginitres_;
}

extern "C" {
	extern struct{
		double qt,xtau,q,q2,mur2,muf2,qres2,startscale;
	} somescale_;
}

extern "C" {
	extern struct{
		double md,mu,ms,mc,mbot,mtop,mel,mmu,mtau,higgsmass,hwidth,wmass,wwidth,zmass,zwidth,width,tauwidth,mtausq,mcsq,mbsq;
	} masses_;
}

extern "C" {
	void pdfset_();
}

extern "C" {
	void resumm_(double *resummed,int *gg_initiated,int *channel,double *Msyst,double *ysyst,double *pTsyst,double *Qres,double *muF,double *muR,double *sroot,double *bornfactor,double *H1_in,double *H2_in);
}

extern "C" {
	void init_const_and_coeff_();
}

void ConvertToFortran(char* fstring, std::size_t fstring_len, const char* cstring);
void set_PDF_mellin_coefficients();
void performQTBoost(double qt2,double Q,double y,vector<vector<vector<particle> > > &p);
void performQTBoost_cms(double qt2,double Q,double y,vector<vector<fourvector> > &p);
