      subroutine hzzexact(p,msq)
      implicit none
      include 'types.f'
C----Lowest order matrix element for H production
C----in the heavy quark (mt=Infinity) limit.
C----averaged over initial colours and spins
C     g(-p1)+g(-p2)->H->ZZ->(mu-(p3)+mu+(p4)+e-(p5)+e+(p6))

C    Includes interference contribution in case mu->e

C   LR: Taken from HRES, which likely modifies the qqb->ZZ routines

      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'masses.f'
      include 'ewcouple.f'
      include 'zcouple.f'
      include 'qcdcouple.f'
      include 'interference.f'
      integer:: j,k
      real(dp):: abisq,msq(-nf:nf,-nf:nf),p(mxpart,4),s,shiggs
      real(dp):: dec,decay,gg,Asq,interf,num,den
      real(dp):: mtop,sigmatb,sigmat
c      common/Born/sigmatb,sigmat !LR we shouldn't need this

      s(j,k)=2*(p(j,4)*p(k,4)-p(j,1)*p(k,1)-p(j,2)*p(k,2)-p(j,3)*p(k,3))

c---set msq=0 to initialize
      do j=-nf,nf
      do k=-nf,nf
      msq(j,k)=0d0
      enddo
      enddo

      shiggs=s(3,4)+s(3,5)+s(3,6)+s(4,5)+s(4,6)+s(5,6)
      interf=0d0


      decay=(((l1*l2)**2+(r1*r2)**2)*s(3,5)*s(4,6)
     .  +((r1*l2)**2+(r2*l1)**2)*s(3,6)*s(4,5))


      decay=decay/((s(3,4)-zmass**2)**2+(zmass*zwidth)**2)
      decay=decay/((s(5,6)-zmass**2)**2+(zmass*zwidth)**2)

C     Here only H->ZZ->(34)(56): diagram with (1<->3) accounted for
C     by adding a factor 2

      if(interference.eqv..true.) then

        decay=2*decay


C Interference contribution (check if factor 2 is there !)

        interf=2*((l1*l2)**2+(r1*r2)**2)*s(3,5)*s(4,6)

        num=((s(3,4)-zmass**2)*(s(5,6)-zmass**2)*(s(4,5)-zmass**2)*
     .   (s(3,6)-zmass**2)+(zmass*zwidth)**4+
     .   (zmass*zwidth)**2*(2*zmass**4-zmass**2*
     .   (s(3,4)+s(5,6)+s(4,5)+s(3,6))+s(3,4)*s(3,6)+s(3,4)*s(4,5)+
     .   s(3,6)*s(5,6)+s(4,5)*s(5,6)-s(3,6)*s(4,5)-s(3,4)*s(5,6)))

        den=((s(3,4)-zmass**2)**2+(zmass*zwidth)**2)*
     .   ((s(5,6)-zmass**2)**2+(zmass*zwidth)**2)*
     .   ((s(4,5)-zmass**2)**2+(zmass*zwidth)**2)*
     .   ((s(3,6)-zmass**2)**2+(zmass*zwidth)**2)


       interf=interf*num/den

      endif

      dec=gwsq**3*zmass**2*4d0*xw**2/(one-xw)*
     .      (decay+interf)/((shiggs-hmass**2)**2+(hmass*hwidth)**2)


C     In case of identical particles add 1/4 symmetry factor

      if(interference) dec=dec/4

C  multiplication with the abisq
      Asq=(as/(3d0*pi))**2/vevsq
c      Asq=(as/(3d0*pi))**2/vevsq*sigmatb !LR we shouldn't need this
      gg=0.5d0*V*Asq*shiggs**2

c---calculate propagators
      msq(0,0)=avegg*gg*dec


      return
      end
